unit demo_prj;

interface

function run_demo_prj(prjname:string;stfr,endfr:word):byte;

implementation

uses realtime,threed,loadpcx,gurofill,winapi,mytimer,palete,mycrt,mode256;
const
 maxnobj         = 50;
 maxnfaces       = 10000;
 maxnvertices    = 10000;
 maxnkeys        = 1800;

 lightdist       = 3800; {light source power}
 light_k1        = 1350;
 light_k2        = 5;
 light_k3        = 2;
 dist_i_shr      = 10;  {! ᫨  - 㦭   calccolors}

type
 ColorsArrType  = array [1..maxnvertices] of word;
 VertexArrType  = array [1..maxnvertices,1..3] of integer;
 FacesArrType   = array [1..maxnfaces,1..3] of word;
 NormalsArrType = array [1..maxnfaces,1..3] of integer;
 bmpxyarrtype   = array [1..maxnfaces,1..3] of word;

 {     쥪}
 keyinfotype = record
                 present : boolean;
                   {   ,  ᫥ ௮樥}
                 hide : boolean;
                     {쥪 ⠭}
                 alfa,beta,gama : longint;
                     {㣫 }
                 posx,posy,posz : integer;
                     { 쥪}
               end;

 newkeysarrtype    = array [0..maxnkeys] of word;
                             {X - frame number}

 newkeysdatatype   = array [0..maxnkeys] of
       record
        hide : boolean;
        xpos,ypos,zpos: integer;
        alfa,beta,gama: integer;
       end;


 laga = record
          ofs,seg: word;
        end;

 dist_i_type = array [0..32766] of word;

const
 maxlightdist : longint = lightdist*lightdist;
 w2d_zoom : longint = 256;   {coord:256}
 w2d_posx : integer = 0;
 w2d_posy : integer = 0;
 w2d_posz : integer = 0;
 w2d_selx : integer = 0;
 w2d_sely : integer = 0;
 w2d_selz : integer = 0;
 w2d_x : integer = 0;
 w2d_y : integer = 0;
 w2d_z : integer = 0;

{============================}
{ H ᤢ !}
 w3d : word = 0;
 w3d_alfa : longint = 0;
 w3d_beta : longint = 0;
 w3d_gama : longint = 0;
 w3d_posx : integer = 0;
 w3d_posy : integer = -3000;
 w3d_posz : integer = 0;
{============================}

 curframe : word = 0;
 nobj     : word = 0;
 curnobj  : word = 0;
 step : integer = 10;

 var
 pusht:longint;
  csalias       : word;
  obj_morftype  : array [1..maxnobj] of byte;
  obj_morfnfases: array [1..maxnobj] of byte;
  obj_morffaces : array [1..maxnobj,1..5] of byte;
  msperframe: word;
  c: char;
  obj_names     : array [1..maxnobj] of string[12];
  obj_nfaces    : array [1..maxnobj] of word;
  obj_nvertices : array [1..maxnobj] of word;
  obj_vertices  : array [1..maxnobj] of ^vertexarrtype;
  obj_faces     : array [1..maxnobj] of ^facesarrtype;
  obj_normals   : array [1..maxnobj] of ^normalsarrtype;
  obj_bmpxy     : array [1..maxnobj] of ^bmpxyarrtype;
  obj_texturenum: array [1..maxnobj] of byte;
  obj_keys      : array [0..maxnobj] of ^newkeysarrtype;
  obj_nkeys     : array [0..maxnobj] of word;
  obj_keysdata  : array [0..maxnobj] of ^newkeysdatatype;
         {obj N0 - camera}
  texture_loaded: array [1..10] of boolean;
  texture_p     : array [1..10] of pointer;
  obj_cache     : array [1..maxnobj] of pointer;
  obj_cachedata : array [1..maxnobj] of observertype;
  t: longint;
  poly_3d : array [1..4,1..3] of integer;
  poly_2d : array [1..4,1..2] of integer;
  observer: observertype;
  observer1: observertype;
  rot_alfa,rot_beta,rot_gama,scale: integer;
  status : boolean;
  i: integer;
  palette : array [1..768] of byte;
  palette1 : array [1..768] of byte;
  zbufseg,scrseg: word;

  cut_poly1,cut_poly2: array [1..6,1..3] of integer;
  cut_poly2d : array [1..6,1..2] of integer;
  cut_bmp1,cut_bmp2: array [1..6] of word;
  cut_colors1,cut_colors2: array [1..6] of word;
  cut_n : byte;
  mode:integer;

  s: string;

  dist_i : pointer;
  dist_i_size: longint;
  lightobjnumber : word;
  light : record
         posx,posy,posz: integer;
        end;
  light1 : record
         posx,posy,posz: integer;
        end;
  frame_observer: observertype;

  obj_radius : array [1..maxnobj] of word;

  i_table : pointer;
  light_textureseg: word;
  i_table2seg : word;
  i_table2p: pointer;

 {*******  get_keyinfo ********}
 {===================================}
 { ᤢ !}
 alfa,beta,gama : longint;
 x,y,z: integer;
 x1,y1,z1: integer;
 alfa1,beta1,gama1: integer;
 x2,y2,z2: integer;
 alfa2,beta2,gama2: integer;
 hide: boolean;
 fr1,fr2: word;
 {*********************************}

 frame_vid3d,frame_obj2d,frame_vertex_colors : pointer;

 vsync: real;

 texture_msq : array [1..10] of byte;

  msq_framedata : array [1..10,1..10,1..2] of byte;
  msq_data : array [1..10] of
    record
     nframes,fspeed,fsizex,fsizey,movx,movy: integer;
    end;
 f:file;

{*********************************************************************}
{* Procedures                                                        *}
{*********************************************************************}
{$F+}
procedure line_keyinfo(tw:word; keyinfo1,keyinfo2,keyinfo: pointer); external;
procedure calc_colors(nv: word; vertices,vertext_colors: pointer); external;
procedure getkey_proc1(frame:word;keyinfo:pointer); external;
procedure do_objmorf(t,tmax,nv,nf : word; v1,v2,v,f1,f,bmp1,bmp: pointer); external;
procedure draw_light(sx,sy,ssizex,ssizey,tx,ty,szx,szy,col,z: integer); external;
procedure draw_bmp(sx,sy,ssizex,ssizey,tx,ty,szx,szy,z: integer); external;
procedure prj_copytoscreen; external;
{$L play_prj}
{$F-}

{$F+}
procedure draw_cut_textmap_guro; external;
procedure del_thesame; external;
procedure visible3; external;
{$L drawcutg}
{$F-}

procedure _draw_cut_textmap_guro;
var
 i,j: integer;
label l1;
begin
 fillchar(cut_poly2d,6*4,0);
 draw_cut_textmap_guro;

 del_thesame;

 if cut_n<3 then goto l1;

{ if not visible(addr(cut_poly2d)) then goto l1;}


 asm
  call visible3
  js l1
 end;


 asm
  lea si,cut_poly2d
  mov di,si
  mov ax,ds
  mov es,ax
  mov cl,cut_n
  cld
  mov bx,160
  mov dx,100

  @l1:
  lodsw
  add ax,bx
  js l1
  cmp ax,319
  ja l1
  stosw
  lodsw
  neg ax
  add ax,dx
  js l1
  cmp ax,199
  ja l1
  stosw
  dec cl
  jne @l1
 end;

 {move(cut_poly2d,s_poly2d,5*4);
 move(cut_poly2,s_poly3d,5*6);
 move(cut_bmp2,s_polybmp,5*2);
 move(cut_colors2,s_colors,5*2);}

  asm
    cld
    mov ax,seg s_poly3d
    mov es,ax
    mov ds,ax

    lea si,cut_poly2d
    lea di,s_poly2d
    mov cx,5*2
    rep movsw

    lea si,cut_poly2
    lea di,s_poly3d
    mov cx,5*3
    rep movsw

    lea si,cut_bmp2
    lea di,s_polybmp
    mov cx,5
    rep movsw

    lea si,cut_colors2
    lea di,s_colors
    mov cx,5
    rep movsw
  end;

  case cut_n of
     3: texturemap_guro;
     4: texturemap_guro4;
     5: texturemap_guro5;
     6:  begin
         texturemap_guro5;
         move(cut_poly2d[5],s_poly2d,2*4);
         move(cut_poly2[5],s_poly3d,2*6);
         move(cut_bmp2[5],s_polybmp,2*2);
         move(cut_colors2[5],s_colors,2*2);
         move(cut_poly2d[1],s_poly2d[3],1*4);
         move(cut_poly2[1],s_poly3d[3],1*6);
         move(cut_bmp2[1],s_polybmp[3],1*2);
         move(cut_colors2[1],s_colors[3],1*2);
         texturemap_guro;
        end;
  end;
l1:
end;

function strng(i:longint): string;
var s: string;
begin
str(i,s);
strng:=s;
end;

procedure get_keyinfo(frame:word; obj_nkeys:word;
        obj_keys,obj_keysdata,keyinfo:pointer); assembler;
 asm
  les di,obj_keys
  cld
  mov cx,obj_nkeys
  mov si,word ptr obj_keysdata
  mov ax,frame
  @l2:
  scasw
  jc @l1
  add si,13
  dec cx
  jne @l2

  sub si,13

  @l4:
  push ds
  mov ds,word ptr obj_keysdata+2
  les di,keyinfo
  lodsb
  stosb
  stosb
  db 66h
  mov ax,[si]
  mov bx,[si+4]
  db 66h
  mov es:[di+12],ax
  mov es:[di+12+4],bx
  mov cx,1144
  mov ax,[si+6]
  imul cx
  stosw
  mov ax,dx
  stosw
  mov ax,[si+6+2]
  imul cx
  stosw
  mov ax,dx
  stosw
  mov ax,[si+6+2+2]
  imul cx
  stosw
  mov ax,dx
  stosw
  pop ds
  jmp @l3

  @l1:
  sub di,4
  sub si,13
  mov bx,es:[di]
  cmp ax,bx
  je @l4

  @l5:
  mov fr1,bx
  mov bx,es:[di+2]
  mov fr2,bx
  mov es,word ptr obj_keysdata+2
  mov al,es:[si]
  mov hide,al
  db 66h
  mov ax,es:[si+1]
  db 66h
  mov x1,ax
  db 66h
  mov ax,es:[si+1+4]
  db 66h
  mov z1,ax
  db 66h
  mov ax,es:[si+1+4+4]
  db 66h
  mov beta1,ax
  db 66h
  mov ax,es:[si+1+13]
  db 66h
  mov x2,ax
  db 66h
  mov ax,es:[si+1+13+4]
  db 66h
  mov z2,ax
  db 66h
  mov ax,es:[si+1+13+4+4]
  db 66h
  mov beta2,ax

  push frame
  db 66h
  push word ptr keyinfo
  call getkey_proc1
  @l3:
end;

procedure loadprj(fname: string);
var
 i: integer;
 n: word;
 f: file;
 p: pointer;
 label l1,l2,l3;
begin
 assign(f,fname);
 {$I-}
 reset(f,1);
 {$I+}
 blockread(f,w2d_zoom,4);

 blockread(f,w2d_zoom,4);

 blockread(f,w2d_posx,2);
 blockread(f,w2d_posy,2);
 blockread(f,w2d_posz,2);
 blockread(f,w2d_selx,2);
 blockread(f,w2d_sely,2);
 blockread(f,w2d_selz,2);
 blockread(f,w2d_x,2);
 blockread(f,w2d_y,2);
 blockread(f,w2d_z,2);
 blockread(f,w3d_alfa,2);
 blockread(f,w3d_beta,2);
 blockread(f,w3d_gama,2);
 blockread(f,w3d_posx,2);
 blockread(f,w3d_posy,2);
 blockread(f,w3d_posz,2);

 blockread(f,curframe,2);
 blockread(f,nobj,2);
 blockread(f,curnobj,2);
 blockread(f,mode,2);
 blockread(f,step,2);

 blockread(f,observer,sizeof(observertype));
 blockread(f,rot_alfa,2);
 blockread(f,rot_beta,2);
 blockread(f,rot_gama,2);
 blockread(f,scale,2);
 blockread(f,status,2);
 blockread(f,status,2);
 blockread(f,msperframe,2);

 for i:=1 to nobj do
   begin
    blockread(f,obj_names[i],13);
    blockread(f,obj_nfaces[i],2);
    blockread(f,obj_nvertices[i],2);

    obj_vertices[i]:=globalallocptr(gmem_moveable,obj_nvertices[i]*6);
    obj_faces[i]:=globalallocptr(gmem_moveable,obj_nfaces[i]*6);
    obj_bmpxy[i]:=globalallocptr(gmem_moveable,obj_nfaces[i]*6);

    blockread(f,obj_vertices[i]^,obj_nvertices[i]*6);
    blockread(f,obj_faces[i]^,obj_nfaces[i]*6);
    blockread(f,obj_bmpxy[i]^,obj_nfaces[i]*6);
    blockread(f,obj_texturenum[i],1);
  end;

 for i:=0 to nobj do
  begin
   blockread(f,n,2);
   obj_nkeys[i]:=n;
   obj_keys[i]:=globalallocptr(gmem_moveable,n*2);
   obj_keysdata[i]:=globalallocptr(gmem_moveable,n*13);
   blockread(f,obj_keys[i]^,n*2);
   blockread(f,obj_keysdata[i]^,n*13);
  end;

 blockread(f,texture_loaded,10);
 for i:=1 to 10 do
    if texture_loaded[i] then
     begin
      texture_p[i]:=GlobalAllocPtr(gmem_moveable,65536+32);
      blockread(f,mem[laga(texture_p[i]).seg:0],65535);
      blockread(f,mem[laga(texture_p[i]).seg:65535],1);
     end;

 blockread(f,palette,768);
 i_table:=globalallocptr(gmem_moveable,16384);
 blockread(f,i_table^,16384);
 for i:=1 to nobj do
   if copy(obj_names[i],1,6)='"spark' then goto l2;
 goto l3;
 l2:
 i_table2p:=globalallocptr(gmem_moveable,8192);
 i_table2seg:=laga(i_table2p).seg;
 blockread(f,ptr(i_table2seg,0)^,8192);
 l3:

 blockread(f,texture_msq,10);
 for i:=1 to 10 do
   if texture_msq[i]>0 then
       begin
        blockread(f,msq_data[i],12);
        blockread(f,msq_framedata[i],20);
       end;

 close(f);

l1:
end;

procedure setrealcameradata(frame: word;tw: word);
var
 keyinfo1,keyinfo2: keyinfotype;
begin
 get_keyinfo(frame,obj_nkeys[0],obj_keys[0],obj_keysdata[0],addr(keyinfo1));
 get_keyinfo(frame+1,obj_nkeys[0],obj_keys[0],obj_keysdata[0],addr(keyinfo2));

 line_keyinfo(tw,@keyinfo1,@keyinfo2,@w3d);

end;

procedure setcameradata;
var
 keyinfo: keyinfotype;
begin
 get_keyinfo(curframe,obj_nkeys[0],obj_keys[0],obj_keysdata[0],addr(keyinfo));
 w3d_alfa:=keyinfo.alfa;
 w3d_beta:=keyinfo.beta;
 w3d_gama:=keyinfo.gama;
 w3d_posx:=keyinfo.posx;
 w3d_posy:=keyinfo.posy;
 w3d_posz:=keyinfo.posz;
end;

procedure setframedata;
var
 keyinfo: keyinfotype;
 label l1;
begin
 setcameradata;
 if curnobj=0 then
   begin
    rot_alfa:=0; rot_beta:=0; rot_gama:=0;
    w2d_selx:=0; w2d_sely:=0; w2d_selz:=0;
    goto l1;
   end;
 get_keyinfo(curframe,obj_nkeys[curnobj],obj_keys[curnobj],obj_keysdata[curnobj],addr(keyinfo));
 w2d_selx:=keyinfo.posx;
 w2d_sely:=keyinfo.posy;
 w2d_selz:=keyinfo.posz;
 rot_alfa:=keyinfo.alfa;
 rot_beta:=keyinfo.beta;
 rot_gama:=keyinfo.gama;
 status:=keyinfo.hide;
 l1:
end;
procedure copy_bmp256(x1,y1,sx,sy,x2,y2: byte;tseg: word); assembler;
asm
 push ds
 mov ax,tseg
 mov ds,ax
 mov es,ax

 mov al,x1
 mov ah,y1
 mov si,ax
 mov al,x2
 mov ah,y2
 mov di,ax

 mov dl,sy
 cld

 @l1:
 push si
 push di
 mov cl,sx
 xor ch,ch
 rep movsb
 pop di
 pop si
 add di,256
 add si,256
 dec dl
 jne @l1

 pop ds
end;

procedure act_texture(i,tseg:word);
var
 k: word;
 label l1;
begin
 if texture_msq[i]=0 then goto l1;
 k:=round(bigcounter/vsync*1000/msq_data[i].fspeed) mod msq_data[i].nframes+1;
 if texture_msq[i]=k then goto l1;
 texture_msq[i]:=k;

 copy_bmp256(msq_framedata[i,k,1],msq_framedata[i,k,2],
            msq_data[i].fsizex,msq_data[i].fsizey,
            msq_data[i].movx,msq_data[i].movy,tseg);

 l1:
end;

procedure drawrealobject(n: word;alfa,beta,gama: longint;addx,addy,addz: integer);
type
 obj2dtype = array [1..10000,1..2] of integer;
var
 dist:longint;
 i,j: integer;
 x1,y1,z1,x2,y2,z2,x3,y3,z3 : integer;
 n1,n2,n3,nf,nv: word;
 colr,colr1: word;
 obj_facesni,obj_bmpxyni: pointer;
 pj,pn: pointer;
label l1,l2,l3,l4,l5,l6;

begin
 eye_hx:=300;
 eye_hz:=190;

 i:=obj_texturenum[n];
 if not texture_loaded[i] then goto l6;
 s_bmpseg:=laga(texture_p[i]).seg;

 act_texture(i,s_bmpseg);

 nv:=obj_nvertices[n];
 nf:=obj_nfaces[n];

 observer.alfa_rad:=alfa;
 observer.beta_rad:=beta;
 observer.gama_rad:=gama;
 observer.x:=addx;
 observer.y:=addy;
 observer.z:=addz;

 if n=nobj+1 then goto l4;
{==============================================================
   쥪  p諮 p   -
  ⮬ 砥 p ᪮p㥬 p pp p設
  
 ==============================================================}

{ if obj_cachedata[n].x<>addx then goto l4;
 if obj_cachedata[n].y<>addy then goto l4;
 if obj_cachedata[n].z<>addz then goto l4;
 if obj_cachedata[n].alfa_rad<>alfa then goto l4;
 if obj_cachedata[n].beta_rad<>beta then goto l4;
 if obj_cachedata[n].gama_rad<>gama then goto l4;}

 asm
  lea si,obj_cachedata
  mov ax,n
  dec ax
  {18 = 16+2}
  mov cx,ax
  shl cx,4
  shl ax,1
  add ax,cx
  add si,ax

  mov cx,9
  mov ax,ds
  mov es,ax
  lea di,observer
  cld
  rep cmpsw
  jnz l4
 end;

 fastmove(obj_cache[n],frame_vid3d,nv*6);

 goto l5;

 l4:
 transform2(nv,obj_vertices[n],addr(observer),frame_vid3d);

 if n<>nobj+1 then
   begin
    fastmove(frame_vid3d,obj_cache[n],nv*6);
    obj_cachedata[n]:=observer;
  end;

 l5:

 transform(nv,frame_vid3d,addr(frame_observer),frame_vid3d);
 proectpoints(nv,frame_vid3d,frame_obj2d);

{=========================================
  P뢠 ⥭ᨢ p⥪ᮢ
 =========================================}

 calc_colors(nv,frame_vid3d,frame_vertex_colors);

 obj_facesni:=obj_faces[n];
 obj_bmpxyni:=obj_bmpxy[n];

 for i:=1 to nf do
   begin
    {n1:=obj_faces[n]^[i,1];
    n2:=obj_faces[n]^[i,2];
    n3:=obj_faces[n]^[i,3];}

    {! n1,n2,n3  ᥬp p 㬥  }

    asm
     cld
     les si,obj_facesni
     db 26h
     lodsw
     dec ax
     mov n1,ax
     db 26h
     lodsw
     dec ax
     mov n2,ax
     db 26h
     lodsw
     dec ax
     mov n3,ax
    end;


    {fastmove(@p^[n1],@s_poly3d,6);
    fastmove(@p^[n2],@s_poly3d[2],6);
    fastmove(@p^[n3],@s_poly3d[3],6);}

    asm
     les si,frame_vid3d

     mov bx,n1
     mov cx,bx
     shl bx,2
     add bx,cx
     add bx,cx
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly3d,ax
     mov ax,es:[si+bx+4]
     mov word ptr s_poly3d+4,ax

     mov bx,n2
     mov cx,bx
     shl bx,2
     add bx,cx
     add bx,cx
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly3d+6,ax
     mov ax,es:[si+bx+4]
     mov word ptr s_poly3d+6+4,ax

     mov bx,n3
     mov cx,bx
     shl bx,2
     add bx,cx
     add bx,cx
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly3d+6+6,ax
     mov ax,es:[si+bx+4]
     mov word ptr s_poly3d+6+6+4,ax
    end;


    {===============================================================
     ᫨ Y  p設  50  p㣮쭨  p㥬
     ===============================================================}
    asm
     mov ax,50
     cmp word ptr s_poly3d[2],ax
     jg @l1
     cmp word ptr s_poly3d[6+2],ax
     jg @l1
     cmp word ptr s_poly3d[6+6+2],ax
     jg @l1
     jmp l1
     @l1:
    end;

    {s_colors[1]:=vertex_colors^[n1];
    s_colors[2]:=vertex_colors^[n2];
    s_colors[3]:=vertex_colors^[n3];}
    asm
     les si,frame_vertex_colors

     mov bx,n1
     shl bx,1
     mov ax,es:[si+bx]
     mov word ptr s_colors,ax

     mov bx,n2
     shl bx,1
     mov ax,es:[si+bx]
     mov word ptr s_colors+2,ax

     mov bx,n3
     shl bx,1
     mov ax,es:[si+bx]
     mov word ptr s_colors+4,ax
    end;

   {==========================================
    ᫨ 梥  p設 = 0 -  pᮢ
    ==========================================}

    asm
     db 66h
     xor ax,ax
     db 66h
     cmp word ptr s_colors,ax
     jne @l1
{     cmp word ptr s_colors[2],ax
     jne @l1}
     cmp word ptr s_colors[4],ax
     jne @l1
     jmp l1;
     @l1:
    end;

{   fastmove(@obj2d^[n1],@s_poly2d,4);
    fastmove(@obj2d^[n2],@s_poly2d[2],4);
    fastmove(@obj2d^[n3],@s_poly2d[3],4);}

    asm
     les si,frame_obj2d

     mov bx,n1
     shl bx,2
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly2d,ax

     mov bx,n2
     shl bx,2
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly2d+4,ax

     mov bx,n3
     shl bx,2
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly2d+4+4,ax
    end;

    {move(obj_bmpxyni,s_polybmp,6);}
    asm
     les si,obj_bmpxyni
     db 66h
     mov ax,es:[si]
     db 66h
     mov word ptr s_polybmp,ax
     mov ax,es:[si+4]
     mov word ptr s_polybmp[4],ax
    end;

{    word(s_polybmp[1]):=0;
    word(s_polybmp[2]):=0;
    word(s_polybmp[3]):=0;}

{    s_colors[1]:=$2000;
    s_colors[2]:=$2000;
    s_colors[3]:=$2000;}


    asm
     mov ax,7fffh
     cmp word ptr s_poly2d,ax
     je @l2
     cmp word ptr s_poly2d+4,ax
     je @l2
     cmp word ptr s_poly2d+4+4,ax
     je @l2

     jmp @l3
     @l2:
     jmp l2;
     @l1:
     jmp l1
     @l3:

{     push seg s_poly2d
     push offset s_poly2d
     call visible}

     call visible2
     js @l1
     jnz @l5
     or si,si
     jz @l1
     @l5:

     lea si,s_poly2d
     mov di,si
     mov ax,ds
     mov es,ax
     mov cl,3
     cld
     mov bx,160
     mov dx,100

     @l4:
     lodsw
     add ax,bx
     js @l1
     cmp ax,319
     ja @l1
     stosw

     lodsw
     neg ax
     add ax,dx
     js @l1
     cmp ax,199
     ja @l1
     stosw

     dec cl
     jne @l4
    end;

    texturemap_guro;

    goto l1;
    l2:

    _draw_cut_textmap_guro;
    l1:
    asm
     add word ptr obj_bmpxyni,6
     add word ptr obj_facesni,6
    end;
   end;

 l6:
end;

procedure draw_spark(px,py,pz,col: integer);
var
 d3d: array [1..3] of integer;
 d2d: array [1..2] of integer;
 x,y: integer;
 psx,psz: word;
 ssizex,ssizey: integer;
 label l1;
begin
 psx:=eye_hx;
 psz:=eye_hz;
 eye_hz:=300;
 eye_hx:=420;

 d3d[1]:=px;
 d3d[2]:=py;
 d3d[3]:=pz;
 transform(1,@d3d,@frame_observer,@d3d);
 proectpoints(1,@d3d,@d2d);

 if d2d[1]=$7fff then goto l1;
 if d2d[2]=$7fff then goto l1;

 ssizex:=200*longint(eye_k) div d3d[2];
 ssizey:=140*longint(eye_k) div d3d[2];

 x:=d2d[1]+160-ssizex div 2;
 y:=100-d2d[2]-ssizey div 2;

{ if (ssizex<1) or (ssizey<1) then goto l1;

if x+ssizex<1 then goto l1;
 if x>319 then goto l1;
 if y+ssizey<1 then goto l1;
 if y>199 then goto l1;
 if x<0 then
   begin
    txadd:=-x*tsizex div ssizex;
    inc(ssizex,x);
    inc(tx,txadd);
    dec(tsizex,tx);
    if tsizex<=0 then goto l1;
    x:=0;
   end;
 if x+ssizex>320 then
   begin
    txadd:=ssizex;
    ssizex:=320-x;
    tsizex:=tsizex*ssizex div txadd;
    if tsizex<=0 then goto l1;
   end;
 if y<0 then
   begin
    txadd:=-y*tsizey div ssizey;
    inc(ssizey,y);
    inc(ty,txadd);
    dec(tsizey,ty);
    if tsizey<=0 then goto l1;
    y:=0;
   end;
 if y+ssizey>200 then
   begin
    txadd:=ssizey;
    ssizey:=200-y;
    tsizey:=tsizey*ssizey div txadd;
    if tsizey<=0 then goto l1;
   end;                                   }
 draw_light(x,y,ssizex,ssizey,0,0,80,56,0,d3d[2]);

 l1:
 eye_hx:=psx;
 eye_hz:=psz;
end;


procedure draw_bmp_obj(n,px,py,pz: integer;sx,sy: longint);
var
 d3d: array [1..3] of integer;
 d2d: array [1..2] of integer;
 x,y: integer;
 psx,psz: word;
 i,tx,ty,tsizex,tsizey,ssizex,ssizey: integer;
 label l1;
begin
 psx:=eye_hx;
 psz:=eye_hz;
 eye_hz:=300;
 eye_hx:=420;

 d3d[1]:=px;
 d3d[2]:=py;
 d3d[3]:=pz;
 transform(1,@d3d,@frame_observer,@d3d);
 proectpoints(1,@d3d,@d2d);

{ if d2d[1]=$7fff then goto l1;
 if d2d[2]=$7fff then goto l1;

 tx:=lo(obj_bmpxy[n]^[1,1]);
 ty:=hi(obj_bmpxy[n]^[1,1]);
 tsizex:=lo(obj_bmpxy[n]^[1,3])-tx+1;
 tsizey:=hi(obj_bmpxy[n]^[1,3])-ty+1;

 if (tsizex<1) or (tsizey<1) then goto l1;}

 asm
  mov ax,7fffh
  cmp word ptr d2d,ax
  je l1
  cmp word ptr d2d+2,ax
  je l1

  mov si,n
  dec si
  shl si,2
  les si,dword ptr obj_bmpxy[si]
  mov ax,es:[si]
  xor bx,bx
  xchg ah,bl
  mov tx,ax
  mov ty,bx

  mov cx,es:[si+4]
  xor dx,dx
  xchg dl,ch
  sub cx,ax
  inc cx
  cmp cx,1
  jl l1
  mov tsizex,cx
  sub dx,bx
  inc dx
  cmp dx,1
  jl l1
  mov tsizey,dx
 end;

 ssizex:=(sx*300 shr 16)*57 div d3d[2];
 ssizey:=(sy*300 shr 16)*57 div d3d[2];

{ x:=d2d[1]+160-ssizex div 2;
 y:=100-d2d[2]-ssizey;

 if (ssizex<1) or (ssizey<1) then goto l1;}
 asm
  mov di,ssizex
  cmp di,1
  jl l1
  shr di,1
  neg di
  mov bx,word ptr d2d
  lea bx,[bx+160+di]
  mov x,bx
  mov di,ssizey
  cmp di,1
  jl l1
  mov bx,word ptr d2d+2
  lea bx,[bx-100+di]
  neg bx
  mov y,bx
 end;

 i:=obj_texturenum[n];
 if not texture_loaded[i] then goto l1;
 s_bmpseg:=laga(texture_p[i]).seg;

 act_texture(i,s_bmpseg);

 draw_bmp(x,y,ssizex,ssizey,tx,ty,tsizex,tsizey,d3d[2]);

 l1:
 eye_hx:=psx;
 eye_hz:=psz;
end;

procedure drawrealframe(frame:word;tw: word);
var
 i: integer;
 keyinfo,keyinfo1,keyinfo2 : keyinfotype;
 r,r1,f1,f2: word;
 label l1,l1a,l1b;
begin
 frame_observer.x:=w3d_posx;
 frame_observer.y:=w3d_posy;
 frame_observer.z:=w3d_posz;
 frame_observer.alfa_rad:=w3d_alfa;
 frame_observer.beta_rad:=w3d_beta;
 frame_observer.gama_rad:=w3d_gama;

 get_keyinfo(frame,obj_nkeys[lightobjnumber],obj_keys[lightobjnumber],
        obj_keysdata[lightobjnumber],addr(keyinfo1));

 get_keyinfo(frame+1,obj_nkeys[lightobjnumber],obj_keys[lightobjnumber],
        obj_keysdata[lightobjnumber],addr(keyinfo2));

 line_keyinfo(tw,@keyinfo1,@keyinfo2,@keyinfo);

 if lightobjnumber=0 then
   begin
    light.posx:=0;
    light.posy:=1000;
    light.posz:=0;
    rotate_3d_back(1,@light,@frame_observer,@light1);
    inc(light1.posx,w3d_posx);
    inc(light1.posy,w3d_posy);
    inc(light1.posy,w3d_posz);
   end
       else
   begin
    light1.posx:=keyinfo.posx;
    light1.posy:=keyinfo.posy;
    light1.posz:=keyinfo.posz;

    transform(1,@light1,@frame_observer,@light);
   end;

 for i:=1 to nobj do
   begin
    if obj_morftype[i]>1 then goto l1;

    get_keyinfo(frame,obj_nkeys[i],obj_keys[i],obj_keysdata[i],addr(keyinfo1));

    if keyinfo1.hide then goto l1;
    get_keyinfo(frame+1,obj_nkeys[i],obj_keys[i],obj_keysdata[i],addr(keyinfo2));

    line_keyinfo(tw,@keyinfo1,@keyinfo2,@keyinfo);

    r:=obj_radius[i];

    asm
     mov bx,lightdist
     add bx,r

     mov ax,keyinfo.posy
     sub ax,light1.posy
     jns @l1
     neg ax
     @l1:
     cmp ax,bx
     ja l1

     mov ax,keyinfo.posx
     sub ax,light1.posx
     jns @l1a
     neg ax
     @l1a:
     cmp ax,bx
     ja l1

     mov ax,keyinfo.posz
     sub ax,light1.posz
     jns @l1b
     neg ax
     @l1b:
     cmp ax,bx
     ja l1
    end;

    if obj_morftype[i]=1 then
      begin
       r:=bigcounter mod 70;
       r1:=70 div (2*obj_morfnfases[i]-2);
       f1:=(r div r1) +1;
       r:=r mod r1;
       f2:=f1+1;
       if f1>obj_morfnfases[i] then dec(f1,obj_morfnfases[i]);
       if f2>obj_morfnfases[i] then dec(f2,obj_morfnfases[i]);
       f1:=obj_morffaces[i,f1];
       f2:=obj_morffaces[i,f2];

      do_objmorf(r,r1,obj_nvertices[i],obj_nfaces[i],
            obj_vertices[f1],obj_vertices[f2],
            obj_vertices[nobj+1],
            obj_faces[f1],obj_faces[nobj+1],
            obj_bmpxy[obj_morffaces[i,1]],obj_bmpxy[nobj+1]);

      obj_nvertices[nobj+1]:=obj_nvertices[i];
      obj_nfaces[nobj+1]:=obj_nfaces[i];
      obj_texturenum[nobj+1]:=obj_texturenum[i];

      drawrealobject(nobj+1,keyinfo.alfa,keyinfo.beta,keyinfo.gama,
            keyinfo.posx,keyinfo.posy,keyinfo.posz);
      goto l1;
      end;

    drawrealobject(i,keyinfo.alfa,keyinfo.beta,keyinfo.gama,
            keyinfo.posx,keyinfo.posy,keyinfo.posz);

    l1:
   end;


 {==============================
    drawing bmp's
  ==============================}

 for i:=1 to nobj do
   begin
    if obj_morftype[i]<>4 then goto l1b;

    get_keyinfo(frame,obj_nkeys[i],obj_keys[i],obj_keysdata[i],addr(keyinfo1));

    if keyinfo1.hide then goto l1b;
    get_keyinfo(frame+1,obj_nkeys[i],obj_keys[i],obj_keysdata[i],addr(keyinfo2));

    line_keyinfo(tw,@keyinfo1,@keyinfo2,@keyinfo);

    draw_bmp_obj(i,keyinfo.posx,keyinfo.posy,keyinfo.posz,
           keyinfo.alfa,keyinfo.beta);

    l1b:
   end;
 {==============================
    drawing sparks
  ==============================}

 for i:=1 to nobj do
   begin
    if obj_morftype[i]<>3 then goto l1a;

    get_keyinfo(frame,obj_nkeys[i],obj_keys[i],obj_keysdata[i],addr(keyinfo1));

    if keyinfo1.hide then goto l1a;
    get_keyinfo(frame+1,obj_nkeys[i],obj_keys[i],obj_keysdata[i],addr(keyinfo2));

    line_keyinfo(tw,@keyinfo1,@keyinfo2,@keyinfo);

    draw_spark(keyinfo.posx,keyinfo.posy,keyinfo.posz,obj_texturenum[i]-1);

    l1a:
   end;

end;


procedure realtimemovie(stfr,endfr:word);
var
 j,lastframe: integer;
 i,dist: longint;
 zbufp1,zbufp2,scrbufp1,scrbufp2: pointer;
 f:file;
 tr: word;
 w: word;
 nf,t,t1: longint;
 colr: word;
 s:string;
 startframe: word;
 imn:integer;
 r1,r: integer;
 real_maxnv: word;
 keytime,rframe: real;
 p: pointer;
 re:real;
 l,lastframetime,t8:longint;
 pal_act: byte;
 act2time:longint;
 label l1,l2,l3;
begin
 real_maxnv:=0;
 for i:=1 to nobj do
   if real_maxnv<obj_nvertices[i] then real_maxnv:=obj_nvertices[i];

 dist_i_size:=(longint(lightdist)*lightdist) shr dist_i_shr;

 zbufp1:=GlobalAllocPtr(gmem_moveable,64000+1232);
 zbufp2:=GlobalAllocPtr(gmem_moveable,64000+1232);
 scrbufp1:=GlobalAllocPtr(Gmem_moveable,48384+1232);
 scrbufp2:=GlobalAllocPtr(Gmem_moveable,48384+1232);
 dist_i:=GlobalAllocPtr(Gmem_moveable,dist_i_size*2+4);
 frame_vid3d:=globalallocptr(gmem_moveable,real_maxnv*6);
 frame_obj2d:=globalallocptr(gmem_moveable,real_maxnv*4);
 frame_vertex_colors:=globalallocptr(gmem_moveable,real_maxnv*2);

 p:=globalallocptr(gmem_moveable,256*61);
 light_textureseg:=laga(p).seg;

 loadpcx_raw('light.pcx',ptr(light_textureseg,0));
 asm
  mov cx,256*60
  mov es,light_textureseg
  xor di,di

  @l1:
  shr byte ptr es:[di],3
  inc di
  dec cx
  jne @l1
 end;

 s_zbuf1seg:=laga(zbufp1).seg;
 s_zbuf2seg:=laga(zbufp2).seg;
 s_scrbuf1seg:=laga(scrbufp1).seg;
 s_scrbuf2seg:=laga(scrbufp2).seg;

 for i:=1 to nobj do
   begin
    obj_cachedata[i].alfa_rad:=-100000;
    obj_cache[i]:=globalallocptr(gmem_moveable,obj_nvertices[i]*6);
   end;


 for i:=1 to nobj do
   begin
    r:=0;
    for j:=1 to obj_nvertices[i] do
      begin
       r1:=round(sqrt(sqr(longint(obj_vertices[i]^[j,1]))+
       sqr(longint(obj_vertices[i]^[j,2]))+
       sqr(longint(obj_vertices[i]^[j,3]))));
       if r1>r then r:=r1;
      end;
    obj_radius[i]:=r;
   end;

 lightobjnumber:=0;
 for i:=1 to nobj do
    if obj_names[i]='"light"' then lightobjnumber:=i;

 fillchar(obj_morftype,sizeof(obj_morftype),0);
 t1:=1; nf:=1;
 for i:=1 to nobj do
   if (copy(obj_names[i],1,5)='"morf') and
      (obj_morftype[i]=0)  then
     begin
      s:=copy(obj_names[i],1,6);
      obj_morfnfases[i]:=1;
      obj_morffaces[i,1]:=i;
      obj_morftype[i]:=1;
      t:=obj_nvertices[i];
      if obj_nfaces[i]>nf then nf:=obj_nfaces[i];
      if t>t1 then t1:=t;
      for j:=1 to nobj do
        if(i<>j) and (copy(obj_names[j],1,6)=s) then
          begin
           obj_morftype[j]:=2;
           inc(obj_morfnfases[i]);
           obj_morffaces[i,obj_morfnfases[i]]:=j;
          end;
     end;

 for i:=1 to nobj do
   if (copy(obj_names[i],1,6)='"spark') then obj_morftype[i]:=3;

 for i:=1 to nobj do
   if (copy(obj_names[i],1,4)='"bmp') then obj_morftype[i]:=4;

 obj_vertices[nobj+1]:=globaLALLOCptr(gmem_moveable,t1*6);
 obj_faces[nobj+1]:=globalallocptr(gmem_moveable,nf*6);
 obj_bmpxy[nobj+1]:=globalallocptr(gmem_moveable,nf*6);

 startframe:=stfr;

 assign(f,'lightbl.dat'); reset(f,1);
 blockread(f,dist_i^,dist_i_size*2);
 close(f);

 move(i_table^,mem[s_scrbuf1seg:0],16384);
 move(i_Table^,mem[s_scrbuf2seg:0],16384);

 smartsetmode($13);

 vsync:=msperinc/65536;
 keytime:=msperframe/1000*vsync;

 lastframe:=1;
 for i:=0 to nobj do
      if obj_keys[i]^[obj_nkeys[i]-1]>lastframe then
         lastframe:=obj_keys[i]^[obj_nkeys[i]-1];

 if endfr>0 then lastframe:=endfr;
 setframedata;

 nf:=0;
 t1:=pusht;

 l2:
 act2time:=round(((lastframe-startframe)*keytime)-1.4*vsync)+pusht;
 t:=bigcounter;
 pusht:=t;
 curframe:=startframe;
 pal_act:=0;
 re:=0;
 lastframetime:=0;


 while curframe<=lastframe do
   begin
    if pal_act=0 then
      begin
       fadepalette(@palette,@palette1,round(re));
       if lastframetime<0.9*vsync then waitvertsync;
       setpalette(@palette1);
       re:=(bigcounter-t)/vsync*200;
       if re>255 then
         begin
          setpalette(@palette);
          pal_act:=1;
          re:=255;
          t:=pusht;
         end;
      end;

    l:=bigcounter-act2time;
    if l>0 then
      begin
       re:=255-l/vsync*200;
       if re<0 then re:=0;
       fadepalette(@palette,@palette1,round(re));
       if lastframetime<0.9*vsync then waitvertsync;
       setpalette(@palette1);
      end;

    t8:=bigcounter;

    rframe:=(bigcounter-t1)/keytime;
    curframe:=startframe+round(int(rframe));
    tr:=round(16384*frac(rframe));

    setrealcameradata(curframe,tr);

    initzbuf_prot;

    clearscreen_prot;

    drawrealframe(curframe,tr);

{    copytoscreen_prot;}
    prj_copytoscreen;


    lastframetime:=bigcounter-t8;

    if keypressed then goto l1;
   end;
 l1:
 globalfreeptr(obj_vertices[nobj+1]);
 globalfreeptr(obj_faces[nobj+1]);
 globalfreeptr(obj_bmpxy[nobj+1]);

 GlobalFreePtr(zbufp1);
 GlobalFreePtr(zbufp2);
 GlobalFreePtr(scrbufp1);
 GlobalFreePtr(scrbufp2);
 GlobalFreePtr(frame_vid3d);
 GlobalFreePtr(frame_obj2d);
 GlobalFreePtr(frame_vertex_colors);
 globalfreeptr(dist_i);
 globalfreeptr(p);
 for i:=1 to nobj do
    globalfreeptr(obj_cache[i]);
end;

procedure freeprj;
var
 i: integer;
 label l2,l3;
begin
 globalfreeptr(i_table);
 globalfreeptr(i_table2p);

 for i:=1 to nobj do
   if copy(obj_names[i],1,6)='"spark' then
     begin
      globalfreeptr(i_table2p);
      goto l3;
     end;
 l3:

 for i:=1 to nobj do
   begin
    globalfreeptr(obj_vertices[i]);
    globalfreeptr(obj_faces[i]);
    globalfreeptr(obj_bmpxy[i]);
   end;
 for i:=0 to nobj do
  begin
   globalfreeptr(obj_keys[i]);
   globalfreeptr(obj_keysdata[i]);
  end;
 for i:=1 to 10 do
    if texture_loaded[i] then
     globalfreeptr(texture_p[i]);
end;

{===================================================================}
{ MAIN                                                              }
{===================================================================}
function run_demo_prj(prjname:string;stfr,endfr:word):byte;
begin
 maxlightdist:=lightdist*lightdist;
 w2d_zoom:= 256;
 w2d_posx:= 0;
 w2d_posy:= 0;
 w2d_posz:= 0;
 w2d_selx:= 0;
 w2d_sely:= 0;
 w2d_selz:= 0;
 w2d_x:= 0;
 w2d_y:= 0;
 w2d_z:= 0;
 w3d:= 0;
 w3d_alfa:= 0;
 w3d_beta:= 0;
 w3d_gama:= 0;
 w3d_posx:= 0;
 w3d_posy:= -3000;
 w3d_posz:= 0;
 curframe := 0;
 nobj     := 0;
 curnobj  := 0;
 step := 10;

 pusht:=bigcounter;

 csalias:=cseg+selectorinc;
 loadprj (prjname);
 realtimemovie(stfr,endfr);
 freeprj;
 run_demo_prj:=0;
 if keypressed then run_demo_prj:=1;
 clearkeyb;
end;

begin
end.
