{=================================}
{   Unit HscTpu (c) Hax 10.01.96  }
{=================================}

UNIT hscTPU;

INTERFACE

function hscposition: byte;
function hsctrack: byte;
function hscpattern: byte;
function hscnote(chanel:word): byte;
function hscequalizer(chanel:word): byte;
function hscinstr(chanel:word): byte;
function hscplaying(chanel:word): byte;
procedure hscplay(p:pointer);
procedure hscstop;

IMPLEMENTATION

Var
  OldExit : Pointer;

const
 playing : boolean = false;

{$F+}
procedure hscplayer; external;
{$F-}
{$L hscobj}

{row}
function hscposition: byte; assembler;
asm
 lea si,hscplayer
 mov al,cs:[si+$a0e]
end;

{ ⥪饣 ୠ}
function hsctrack: byte; assembler;
asm
 lea si,hscplayer
 mov al,cs:[si+$a0d]
end;

{ ⥪饣 थ}
function hscpattern: byte; assembler;
asm
 lea si,hscplayer
 mov al,cs:[si+$a0c]
end;

{⥪   }
{chanel in 1..9}
function hscnote(chanel:word): byte; assembler;
asm
 lea si,hscplayer
 add si,chanel
 mov al,cs:[si+$9df-1]
end;

{룠騥 ⮫ ஬ 0..??,  =255 ᫨ ஬ =0}
function hscequalizer(chanel:word): byte; assembler;
asm
 lea si,hscplayer
 add si,chanel
 mov al,cs:[si+$9fa-1]
end;

{⥪騩 㬥  }
function hscinstr(chanel:word): byte; assembler;
asm
 lea si,hscplayer
 add si,chanel
 mov al,cs:[si+$9f1-1]
end;

{=255 ᫨  ⥪祬 row  ,  = 0}
function hscplaying(chanel:word): byte; assembler;
asm
 lea si,hscplayer
 add si,chanel
 mov al,cs:[si+$a03-1]
end;

procedure hscplay(p:pointer); assembler;
asm
 mov playing,true
 les si,p
 mov ah,0
 mov bl,0
 call hscplayer
end;

procedure hscstop; assembler;
 asm
 mov playing,false
 mov ah,2
 call hscplayer
 end;

{$F+}
Procedure MyExit;
begin
 if playing then hscstop;
 ExitProc:=OldExit;
end;
{$F-}

begin
 OldExit:=ExitProc;
 ExitProc:=@MyExit;
end.