unit mousetpu;

INTERFACE

function mouse_reset: boolean;
function mouse_getx: integer;
function mouse_gety: integer;
function mouse_leftb: boolean;
function mouse_rightb: boolean;
procedure mouse_hide;
procedure mouse_show;

IMPLEMENTATION

function mouse_reset: boolean; assembler;
asm
 mov ax,0
 int 33h
 mov dx,ax
 mov al,true
 cmp dx,0ffffh
 je @l1
 mov al,false
 @l1:
end;

function mouse_getx: integer; assembler;
asm
 mov ax,3
 int  33h
 mov ax,cx
end;

function mouse_gety: integer; assembler;
asm
 mov ax,3
 int  33h
 mov ax,dx
end;

function mouse_leftb: boolean; assembler;
asm
 mov ax,3
 int  33h
 mov al,true
 test bx,1
 jnz @l1
 mov al,false
 @l1:
end;

function mouse_rightb: boolean; assembler;
asm
 mov ax,3
 int  33h
 mov al,true
 test bx,2
 jnz @l1
 mov al,false
 @l1:
end;

procedure mouse_hide; assembler;
asm
 mov ax,2
 int  33h
end;

procedure mouse_show; assembler;
asm
 mov ax,1
 int  33h
end;

begin
end.