unit mycrt;

interface

function keypressed:boolean;
function readkey:char;
procedure smartsetmode(n:byte);
procedure clearkeyb;

implementation

function keypressed:boolean;assembler;
asm
 mov es,seg0040
 mov ax,es:[1ah]
 cmp es:[1ch],ax
 je @l1
 mov al,0ffh
 jmp @l2
 @l1:
 mov al,0
 @l2:
end;

procedure clearkeyb;assembler;
asm
 mov es,seg0040
 mov ax,es:[1ah]
 mov es:[1ch],ax
end;

function readkey:char;assembler;
asm
 mov ah,0
 int 16h
end;

procedure smartsetmode(n:byte);assembler;
asm
 mov ah,0fh
 int 10h
 cmp al,n
 je @l1
 mov ah,0
 mov al,n
 int 10h
 @l1:
end;

begin
end.