{*****************************************************************
  Mapping koordinates,  (c) AX

 ଠ 䠩 obe:
  obj_name : string  256
  obj_nvertices  2
  obj_nfaces     2
  obj_vertices   obj_nvertices*6
  obj_faces      obj_nfaces*6
  obj_normals    obj_nfaces*6
  obj_bmpxy      obj_nfaces*6
  end;
*****************************************************************}

uses crt,mode256,loadasc,realtime,loadpcx,gurofill,
   mousetpu,threed,tpalloc,geomlib,pickfile;

const
 texturex: word = 0;
 texturey: word = 0 ;
 curtexturex : word = 0;
 curtexturey : word = 0;
 maxnfaces = 10000;
 maxnvertices  = 10000;
 curface : word = 1;
 curfacev : word =1;
 lightmode : byte = 1;
 step: word = 100;
 selx : integer =0;
 sely : integer = 0;
 selnum: word =0;

type
 obj2darr = array [1..maxnvertices,1..2] of integer;
 bmpxyarr = array [1..maxnfaces,1..3] of word;

var
 vid3d : ^vertexarrtype;
 obj2d : ^obj2darr;
 objnormals : ^vertexarrtype;
 obj_bmpxy : ^bmpxyarr;

 textureseg: word;
 zbufseg: word;
 p: pointer;
 palette : array [0..255,1..3] of byte;
 texturefname: string;
 ascfname : string;
 obj_name: string;

 obj_nfaces,obj_nvertices: word;
 obj_vertices : ^vertexarrtype;
 obj_faces    : ^facesarrtype;

 observer: observertype;

 s: string;
 i,j: integer;

 c: char;

 radius : word;
 curvertex: word;

 mouse_cursor : array [1..10] of byte;
 ascmodeon   : boolean;

 cut_poly1,cut_poly2: array [1..6,1..3] of integer;
 cut_poly2d : array [1..6,1..2] of integer;
 cut_bmp1,cut_bmp2: array [1..6] of word;
 cut_n : byte;

 i_table : pointer;

procedure drawmark(x,y: integer); assembler;
asm
 mov ax,320
 mul y
 add ax,x
 mov di,ax
 mov ax,0a000h
 mov es,ax
 mov al,0ffh
 mov es:[di-320-1],al
 mov es:[di-320],al
 mov es:[di-320+1],al

 mov es:[di-1],al
 mov es:[di+1],al

 mov es:[di+320-1],al
 mov es:[di+320],al
 mov es:[di+320+1],al

 mov es:[di-640],al
 mov es:[di+640],al
 mov es:[di-2],al
 mov es:[di+2],al
end;

{$F+}
procedure draw_cut_textmap_flat; external;
{p楤p 뢠 ⮫쪮    
 p設 室  p p}
{zbufseg,textureseg,
 s_poly3d,s_poly2d,s_polybmp,s_colors}
{$L drawcutf}
procedure del_thesame; external;
{$F-}

procedure _draw_cut_textmap_flat(mark: boolean);
var
 i,j: integer;
label l1,l2;
begin
 fillchar(cut_poly2d,6*4,0);
 if mark then
   if s_poly2d[curfacev,1]<>$7fff then
      drawmark(s_poly2d[curfacev,1]*188 div 320 +224,65-s_poly2d[curfacev,2]*128 div 200);

 draw_cut_textmap_flat;
{ asm
  mov ax,159
  cmp word ptr cut_poly2d[0],ax
  jg l1
  cmp word ptr cut_poly2d[4],ax
  jg l1
  cmp word ptr cut_poly2d[8],ax
  jg l1
  cmp word ptr cut_poly2d[12],ax
  jg l1
  cmp word ptr cut_poly2d[16],ax
  jg l1
  cmp word ptr cut_poly2d[20],ax
  jg l1
  neg ax
  cmp word ptr cut_poly2d[0],ax
  jl l1
  cmp word ptr cut_poly2d[4],ax
  jl l1
  cmp word ptr cut_poly2d[8],ax
  jl l1
  cmp word ptr cut_poly2d[12],ax
  jl l1
  cmp word ptr cut_poly2d[16],ax
  jl l1
  cmp word ptr cut_poly2d[20],ax
  jl l1
  mov ax,99
  cmp word ptr cut_poly2d[0+2],ax
  jg l1
  cmp word ptr cut_poly2d[4+2],ax
  jg l1
  cmp word ptr cut_poly2d[8+2],ax
  jg l1
  cmp word ptr cut_poly2d[12+2],ax
  jg l1
  cmp word ptr cut_poly2d[16+2],ax
  jg l1
  cmp word ptr cut_poly2d[20+2],ax
  jg l1
  neg ax
  cmp word ptr cut_poly2d[0+2],ax
  jl l1
  cmp word ptr cut_poly2d[4+2],ax
  jl l1
  cmp word ptr cut_poly2d[8+2],ax
  jl l1
  cmp word ptr cut_poly2d[12+2],ax
  jl l1
  cmp word ptr cut_poly2d[16+2],ax
  jl l1
  cmp word ptr cut_poly2d[20+2],ax
  jl l1
end;}

 if cut_n<3 then goto l1;
{ proectpoints(cut_n,addr(cut_poly2),addr(cut_poly2d));}

 for i:=1 to cut_n do
  begin
   cut_poly2d[i,1]:=cut_poly2d[i,1]*188 div 320 + 224;
   cut_poly2d[i,2]:=65 - cut_poly2d[i,2]*128 div 200;
  end;

 del_thesame;

 if cut_n<3 then goto l1;

  if visible(addr(cut_poly2d)) then
    case cut_n of
     3: begin
         move(cut_poly2d,s_poly2d,3*4);
         move(cut_poly2,s_poly3d,3*6);
         move(cut_bmp2,s_polybmp,3*2);
         texturemap_guro($a000,zbufseg,textureseg);
        end;
     4: begin
         move(cut_poly2d,s_poly2d,4*4);
         move(cut_poly2,s_poly3d,4*6);
         move(cut_bmp2,s_polybmp,4*2);
         texturemap_guro4($a000,zbufseg,textureseg);
        end;
     5: begin
         move(cut_poly2d,s_poly2d,5*4);
         move(cut_poly2,s_poly3d,5*6);
         move(cut_bmp2,s_polybmp,5*2);
         texturemap_guro5($a000,zbufseg,textureseg);
        end;
     6: begin
         move(cut_poly2d,s_poly2d,5*4);
         move(cut_poly2,s_poly3d,5*6);
         move(cut_bmp2,s_polybmp,5*2);
         texturemap_guro5($a000,zbufseg,textureseg);

         move(cut_poly2d[5],s_poly2d,2*4);
         move(cut_poly2[5],s_poly3d,2*6);
         move(cut_bmp2[5],s_polybmp,2*2);
         move(cut_poly2d[1],s_poly2d[3],1*4);
         move(cut_poly2[1],s_poly3d[3],1*6);
         move(cut_bmp2[1],s_polybmp[3],1*2);
         texturemap_guro($a000,zbufseg,textureseg);
        end;
    end;
 l2:
 if mark then
   for i:=1 to cut_n do
     begin
      j:=i+1; if j>cut_n then j:=1;
      line_brez(cut_poly2d[i,1],cut_poly2d[i,2],
            cut_poly2d[j,1],cut_poly2d[j,2],255,$a000);
     end;

{if mark then
   begin
    gotoxy(1,24);
     for i:=1 to cut_n do
       write('(',cut_poly2d[i,1],',',cut_poly2d[i,2],')');
    write('    ');
   end;}
l1:
end;


procedure displaytexture; assembler;
asm
 mov di,321
 xor si,si
 mov bx,0a000h
 mov dx,128
 cld
 @l2:

 mov cx,64
 @l1:
 mov es,textureseg
 mov al,es:[si]
 mov ah,es:[si+2]

 mov es,bx
 stosw
 add si,4
 dec cx
 jne @l1

 add di,320-128
 add si,256
 dec dx
 jne @l2
end;

procedure calcnormal(norm: pointer);
type
 normalt = array [1..3] of integer;
var
 x1,y1,z1   : integer;
 x21,x31, y21,y31, z21,z31    : longint;
 a,b,c,m : real;
 i,j : word;

begin
 x1:=s_poly3d[1,1];
 y1:=s_poly3d[1,2];
 z1:=s_poly3d[1,3];

 x21:=s_poly3d[2,1]-x1;
 y21:=s_poly3d[2,2]-y1;
 z21:=s_poly3d[2,3]-z1;

 x31:=s_poly3d[3,1]-x1;
 y31:=s_poly3d[3,2]-y1;
 z31:=s_poly3d[3,3]-z1;

 a:= y21*z31 - y31*z21;
 b:= z21*x31 - x21*z31;
 c:= x21*y31 - x31*y21;

 m:=sqrt(sqr(a)+sqr(b)+sqr(c));
if m<>0 then
 begin
  a:=(a*127)/m;
  b:=(b*127)/m;
  c:=(c*127)/m;
 end
   else
     begin
      writeln;
      writeln('------------ normal length = 0 !');
    {  halt;}
     a:=127;
     b:=0;
     c:=0;
     end;
 normalt(norm^)[1]:=round(a);
 normalt(norm^)[2]:=round(b);
 normalt(norm^)[3]:=round(c);
end;

procedure calc_radius;
var
 maxdist : longint;
 upcl:pointer;
begin
 write ('Calculating distances...');

 maxdist:=0;
 upcl:=obj_vertices;
 for j:=1 to obj_nvertices do
      asm
       les si,upcl
       mov ax,es:[si]
       mov di,ax
       imul di
       mov cx,ax
       mov bx,dx

       mov ax,es:[si+2]
       mov di,ax
       imul di
       add cx,ax
       adc bx,dx

       mov ax,es:[si+2+2]
       mov di,ax
       imul di
       add cx,ax
       adc bx,dx

       cmp word ptr maxdist+2,bx
       ja @l1
       jc @l2
       cmp word ptr maxdist,cx
       ja @l1
       @l2:
       mov word ptr maxdist+2,bx
       mov word ptr maxdist,cx
       @l1:
       add word ptr upcl,6
      end;

 writeln('Ok'+#10);
 radius:=round(sqrt(maxdist)*3.2);
end;

procedure loadascobj;
var
 objnames: array [1..23] of string;
 j,i,nnames: word;
 p1,p2,p3: pointer;
 minx,miny,minz,maxx,maxy,maxz: integer;
 upcl: pointer;
 maxdist: longint;
 koef: real;
begin
 loadasclist(ascfname,addr(objnames),nnames,23);
 textmode(3);
 writeln('Select object (Press  "A","B"...');
 for i:=1 to nnames do
   writeln(chr(64+i),': ',objnames[i]);
 i:=ord(upcase(readkey))-64;
 if (i<1) or (i>nnames) then halt;

 obj_name:=objnames[i];

 writeln;

 writeln;
 write('Enter scale koeficien:');
 readln(koef);

 loadascfile(ascfname,obj_name,obj_nfaces,obj_nvertices,
      p1,p2,p3,maxnfaces,maxnvertices,koef);
 obj_faces:=p1;
 obj_vertices:=p2;
 obj_bmpxy:=p3;

 getmem(objnormals,obj_nfaces*6);
{ getmem(obj_bmpxy,obj_nfaces*6);}

{ for i:=1 to obj_nfaces do
   begin
    obj_bmpxy^[i,1]:=0;
    obj_bmpxy^[i,2]:=30;
    obj_bmpxy^[i,3]:=30*256+30;
   end;}

 getmem(vid3d,obj_nvertices*6);
 getmem(obj2d,obj_nvertices*4);

 writeln('Calculating face normals:');
 writeln('===============================');
 for j:=1 to obj_nfaces do
    begin
      write('     Face: ',j,#13);
      move(obj_vertices^[obj_faces^[j,1]],s_poly3d[1],6);
      move(obj_vertices^[obj_faces^[j,2]],s_poly3d[2],6);
      move(obj_vertices^[obj_faces^[j,3]],s_poly3d[3],6);
      calcnormal(addr(objnormals^[j]));
    end;

writeln;
 writeln('Ok'+#10);

 write ('Centering....');

 minx:=32760;
 miny:=32760;
 minz:=32760;
 maxx:=-32760;
 maxy:=-32760;
 maxz:=-32760;

 upcl:=obj_vertices;
    for j:=1 to obj_nvertices do
      asm
       les si,upcl
       mov ax,es:[si]
       cmp ax,maxx
       jl @l1
       mov maxx,ax
       @l1:
       cmp ax,minx
       jg @l2
       mov minx,ax
       @l2:

       mov ax,es:[si+2]
       cmp ax,maxy
       jl @l1a
       mov maxy,ax
       @l1a:
       cmp ax,miny
       jg @l2a
       mov miny,ax
       @l2a:

       mov ax,es:[si+2+2]
       cmp ax,maxz
       jl @l1b
       mov maxz,ax
       @l1b:
       cmp ax,minz
       jg @l2b
       mov minz,ax
       @l2b:

       add word ptr upcl,6
      end;

 minx:=(minx+maxx) div 2;
 miny:=(miny+maxy) div 2;
 minz:=(minz+maxz) div 2;


 upcl:=obj_vertices;
 for j:=1 to obj_nvertices do
      asm
       les si,upcl

       mov ax,minx
       sub es:[si],ax

       mov ax,miny
       sub es:[si+2],ax

       mov ax,minz
       sub es:[si+2+2],ax

       add word ptr upcl,6
      end;

 writeln('Ok'+#10);
 calc_radius;
end;

function mouse_getx1: word; assembler;
asm
 call mouse_getx
 shr ax,1
end;

procedure mousecursor_hide; assembler;
 asm
  lea bx,word ptr mouse_cursor
  mov di,[bx+8]
  mov ax,0a000h
  mov es,ax

  mov al,[bx]
  inc bx
  mov es:[di-2],al

  mov al,[bx]
  inc bx
  mov es:[di-1],al

  mov al,[bx]
  inc bx
  mov es:[di+1],al

  mov al,[bx]
  inc bx
  mov es:[di+2],al

  mov al,[bx]
  inc bx
  mov es:[di-640],al

  mov al,[bx]
  inc bx
  mov es:[di-320],al

  mov al,[bx]
  inc bx
  mov es:[di+320],al

  mov al,[bx]
  inc bx
  mov es:[di+640],al
end;

procedure mousecursor_show;
var
 x,y,mofs: word;
begin
 x:=mouse_getx1;
 y:=mouse_gety;
 mofs:=x+y*320;
 asm
  lea bx,word ptr mouse_cursor
  mov di,mofs
  mov [bx+8],di
  mov ax,0a000h
  mov es,ax

  mov al,es:[di-2]
  mov [bx],al
  inc bx

  mov al,es:[di-1]
  mov [bx],al
  inc bx

  mov al,es:[di+1]
  mov [bx],al
  inc bx

  mov al,es:[di+2]
  mov [bx],al
  inc bx

  mov al,es:[di-640]
  mov [bx],al
  inc bx

  mov al,es:[di-320]
  mov [bx],al
  inc bx

  mov al,es:[di+320]
  mov [bx],al
  inc bx

  mov al,es:[di+640]
  mov [bx],al

  mov al,255
  mov es:[di-2],al
  mov es:[di-1],al
  mov es:[di+1],al
  mov es:[di+2],al
  mov es:[di-320],al
  mov es:[di-640],al
  mov es:[di+320],al
  mov es:[di+640],al
 end;
end;

function mouse_in_size(x,y,sizex,sizey: word): boolean;
begin
 mouse_in_size:=false;
 if (mouse_getx1>=x) and (mouse_getx1<=x+sizex) and
      (mouse_gety>=y) and (mouse_gety<=y+sizey) then
          mouse_in_size:=true;
end;

function mouse_inbmp: boolean;
begin
 mouse_inbmp:=mouse_in_size(1,1,128,128);
end;

function mouse_in3d: boolean;
begin
 mouse_in3d:=mouse_in_size(132,1,320,128);
end;


function rad2grad(l: longint):integer;
begin
 rad2grad:=round(l/65536/pi*180)
end;

procedure bmpline(xy1,xy2: word); assembler;
asm
 mov al,byte ptr xy1
 xor ah,ah
 shr ax,1
 inc ax
 push ax

 mov al,byte ptr xy1+1
 xor ah,ah
 shr ax,1
 inc ax
 push ax

 mov al,byte ptr xy2
 xor ah,ah
 shr ax,1
 inc ax
 push ax

 mov al,byte ptr xy2+1
 xor ah,ah
 shr ax,1
 inc ax
 push ax

 mov ax,255
 push ax
 mov ax,0a000h
 push ax
 call line_brez


end;

procedure draw_object;
var
 i:integer;
 v1,v2,v3: word;
 d: longint;
 label l1,l2;
begin
 initzbuf(zbufseg);
 transform(obj_nvertices,obj_vertices,addr(observer),vid3d);
 proectpoints(obj_nvertices,vid3d,obj2d);

 d:=round(sqrt(sqr(longint(observer.x))+
           sqr(longint(observer.y))+
            sqr(longint(observer.z))));

 kr:=64;
 kd:=63;

 if lightmode=1 then
   begin
     ls_normal[1]:=round(observer.x*127.0/d);
     ls_normal[2]:=round(observer.y*127.0/d);
     ls_normal[3]:=round(observer.z*127.0/d);
   end
         else
   begin
     ls_normal[1]:=42;
     ls_normal[2]:=-110;
     ls_normal[3]:=50;
   end;

 bar(130,1,188,128,0,$a000);
 displaytexture;

 for i:=1 to obj_nfaces do
   begin
    v1:=obj_faces^[i,1];
    v2:=obj_faces^[i,2];
    v3:=obj_faces^[i,3];

    move(vid3d^[v1,1],s_poly3d[1,1],6);
    move(vid3d^[v2,1],s_poly3d[2,1],6);
    move(vid3d^[v3,1],s_poly3d[3,1],6);

    move(obj2d^[v1],s_poly2d[1],4);
    move(obj2d^[v2],s_poly2d[2],4);
    move(obj2d^[v3],s_poly2d[3],4);

    word(s_polybmp[1]):=obj_bmpxy^[i,1];
    word(s_polybmp[2]):=obj_bmpxy^[i,2];
    word(s_polybmp[3]):=obj_bmpxy^[i,3];

    s_colors[1]:=getcolor(addr(objnormals^[i])) div 2;
    s_colors[2]:=s_colors[1];
    s_colors[3]:=s_colors[1];
    s_colors[4]:=s_colors[1];
    s_colors[5]:=s_colors[1];

    if lightmode=3 then
      begin
       s_colors[1]:=$2000;
       s_colors[2]:=$2000;
       s_colors[3]:=$2000;
       s_colors[4]:=$2000;
       s_colors[5]:=$2000;
      end;

    if i=curface then
      begin
       bmpline(word(s_polybmp[1]),word(s_polybmp[2]));
       bmpline(word(s_polybmp[2]),word(s_polybmp[3]));
       bmpline(word(s_polybmp[3]),word(s_polybmp[1]));
       drawmark(1+s_polybmp[curfacev,1] div 2,
                          1+s_polybmp[curfacev,2] div 2);
     end;


    asm
     cmp word ptr s_poly2d,7fffh
     je l2
     cmp word ptr s_poly2d[4],7fffh
     je l2
     cmp word ptr s_poly2d[8],7fffh
     je l2
    end;

    s_poly2d[1,1]:=s_poly2d[1,1]*188 div 320 + 224;
    s_poly2d[2,1]:=s_poly2d[2,1]*188 div 320 + 224;
    s_poly2d[3,1]:=s_poly2d[3,1]*188 div 320 + 224;

    s_poly2d[1,2]:=65 - s_poly2d[1,2]*128 div 200;
    s_poly2d[2,2]:=65 - s_poly2d[2,2]*128 div 200;
    s_poly2d[3,2]:=65 - s_poly2d[3,2]*128 div 200;

    {if visible(addr(s_poly2d)) then}
    asm
     call visible2
     jns l1
    end;
      begin
       texturemap_guro($a000,zbufseg,textureseg);

       if i=curface then
       begin
         line_brez(s_poly2d[1,1],s_poly2d[1,2],
           s_poly2d[2,1],s_poly2d[2,2],255,$a000);
         line_brez(s_poly2d[2,1],s_poly2d[2,2],
           s_poly2d[3,1],s_poly2d[3,2],255,$a000);
         line_brez(s_poly2d[3,1],s_poly2d[3,2],
           s_poly2d[1,1],s_poly2d[1,2],255,$a000);
        drawmark(s_poly2d[curfacev,1],s_poly2d[curfacev,2]);
       end;
      end;
    goto l1;
    l2:
    _draw_cut_textmap_flat(i=curface);
    l1:
   end


end;


procedure save_obe;
var
 f: file;
begin
  gotoxy(1,22); writeln('Filename (without extention):'+#7);
  gotoxy(1,23); writeln('[________________________________]');
  gotoxy(2,23); readln(ascfname);
  ascfname:=ascfname+'.obe';
  gotoxy(1,22); write('                                        ');
  gotoxy(1,23); write('                                        ');
  gotoxy(1,25); write('                                        ');
  gotoxy(1,25); write('"',ascfname,'" - ',obj_name);


  assign(f,ascfname); rewrite(f,1);
  blockwrite(f,obj_name,256);
  blockwrite(f,obj_nvertices,2);
  blockwrite(f,obj_nfaces,2);
  blockwrite(f,obj_vertices^,obj_nvertices*6);
  blockwrite(f,obj_faces^,obj_nfaces*6);
  blockwrite(f,objnormals^,obj_nfaces*6);
  blockwrite(f,obj_bmpxy^,obj_nfaces*6);
  close(f);
end;

procedure load_obe;
var
 f: file;
 i: integer;
begin
  writeln('Loading OBE file "',ascfname,'"');
  assign(f,ascfname); reset(f,1);
  blockread(f,obj_name,256);
  blockread(f,obj_nvertices,2);
  blockread(f,obj_nfaces,2);

  getmem(obj_vertices,obj_nvertices*6);
  getmem(obj_faces,obj_nfaces*6);
  getmem(objnormals,obj_nfaces*6);
  getmem(obj_bmpxy,obj_nfaces*6);
  getmem(vid3d,obj_nvertices*6);
  getmem(obj2d,obj_nvertices*4);

  blockread(f,obj_vertices^,obj_nvertices*6);
  blockread(f,obj_faces^,obj_nfaces*6);
  blockread(f,objnormals^,obj_nfaces*6);
  blockread(f,obj_bmpxy^,obj_nfaces*6);
  close(f);
  writeln('Calculating face normals:');
 writeln('===============================');
 for j:=1 to obj_nfaces do
    begin
      write('     Face: ',j,#13);
      move(obj_vertices^[obj_faces^[j,1]],s_poly3d[1],6);
      move(obj_vertices^[obj_faces^[j,2]],s_poly3d[2],6);
      move(obj_vertices^[obj_faces^[j,3]],s_poly3d[3],6);
      calcnormal(addr(objnormals^[j]));
    end;

  writeln('Ok');
  calc_radius;
end;

function distance(x1,y1,z1,x2,y2,z2: real): real;
begin
 distance:=sqrt(sqr(x2-x1)+sqr(y2-y1)+sqr(z2-z1));
end;

procedure buildtriangle;
var
 n1,n2,n3: word;
 d1,d1t,koef,d2,d2t,d3,d3t : real;
 x,y,x1,y1: word;
 minerr,minerr1: real;
 p1,p2,p3: word;
 label l1;
begin
 p3:=curfacev;

 case p3 of
 1: begin
     p1:=2;
     p2:=3;
    end;
 2: begin
     p1:=3;
     p2:=1;
    end;
 3: begin
     p1:=1;
     p2:=2;
    end;
 end;

 n1:=obj_faces^[curface,p1];
 n2:=obj_faces^[curface,p2];
 n3:=obj_faces^[curface,p3];

 d1:=distance(obj_vertices^[n1,1],obj_vertices^[n1,2],obj_vertices^[n1,3],
     obj_vertices^[n2,1],obj_vertices^[n2,2],obj_vertices^[n2,3]);

 d1t:=distance(lo(obj_bmpxy^[curface,p1]),hi(obj_bmpxy^[curface,p1]),0,
               lo(obj_bmpxy^[curface,p2]),hi(obj_bmpxy^[curface,p2]),0);

  if (d1t=0) or (d1=0) then
    begin
     write(#7);
     goto l1;
    end;

 koef:=d1t/d1;

 d2:=distance(obj_vertices^[n1,1],obj_vertices^[n1,2],obj_vertices^[n1,3],
     obj_vertices^[n3,1],obj_vertices^[n3,2],obj_vertices^[n3,3]);

 d3:=distance(obj_vertices^[n2,1],obj_vertices^[n2,2],obj_vertices^[n2,3],
     obj_vertices^[n3,1],obj_vertices^[n3,2],obj_vertices^[n3,3]);

 d2t:=d2*koef;
 d3t:=d3*koef;

 minerr:=99999999;
 y1:=0; x1:=0;
 for x:=0 to 255 do
 for y:=0 to 255 do
     begin
      minerr1:=
       sqrt(sqr(d2t-distance(lo(obj_bmpxy^[curface,p1]),hi(obj_bmpxy^[curface,p1]),0,
               x,y,0))+
             sqr(d3t-distance(lo(obj_bmpxy^[curface,p2]),hi(obj_bmpxy^[curface,p2]),0,
               x,y,0))+
             distance(lo(obj_bmpxy^[curface,p3]),hi(obj_bmpxy^[curface,p3]),0,
             x,y,0));
     if minerr1<minerr then
       begin
        minerr:=minerr1;
        y1:=y;
        x1:=x;
       end;
     end;

 obj_bmpxy^[curface,p3]:=x1+y1*256;
l1:
end;

procedure linkvertices;
var
 facen,vert,vert1: word;
begin
 for facen:=1 to obj_nfaces do
   if (longint(objnormals^[facen,1])*objnormals^[curface,1]+
     longint(objnormals^[facen,2])*objnormals^[curface,2]+
     longint(objnormals^[facen,3])*objnormals^[curface,3]>128*128-1000) and
     (facen<>curface) then
      for vert:=1 to 3 do
       for vert1:=1 to 3 do
        if obj_faces^[curface,vert]=obj_faces^[facen,vert1] then
         begin
           obj_bmpxy^[facen,vert1]:=obj_bmpxy^[curface,vert];
         end;
end;

procedure quatropset(x,y,tx,ty: word);
var
 col,ofs: word;
 i,j: integer;
begin
 ofs:=x+y*320;
 col:=mem[textureseg:tx+ty*256];
  for i:=0 to 3 do
    for j:=0 to 3 do
     mem[$a000:ofs+i+j*320]:=col;
end;

procedure calcitbl;
var
 k : real;
 c1r,c1b,c1g,c2r,c2b,c2g: integer;
 i,j,m,n,o: word;
 d1,d2,d,dmin: longint;
 decodetbl : array [0..255] of byte;
 p: pointer;
 label l1;

begin
p:=i_table;
for o:=0 to 63 do
begin
 write('Generating "i_table.dat" ',(o*100 div 63):3,'%    ',#13);
 if o<$20 then
    k:=0.2+(1-0.2)*o/$20
          else
    k:=0+(0.3-0)*(o-$20)/$20;

  k:=o/55;

  for i:=0 to 255 do
    begin
      c2r:=round(palette[i,1]*k);
      if c2r>63 then c2r:=63;
      c2g:=round(palette[i,2]*k);
      if c2g>63 then c2g:=63;
      c2b:=round(palette[i,3]*k);
      if c2b>63 then c2b:=63;
     dmin:=999999999;
     for j:=0 to 255 do
       begin
        asm
         mov ax,j
         mov si,ax
         shl ax,1
         add si,ax
         add si,offset palette
         cld

         lodsb
         xor ah,ah
         sub ax,c2r
         imul ax
         mov  cx,30
         mul  cx
         mov word ptr d,ax
         mov word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2g
         imul ax
         mov cx,59
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2b
         imul ax
         mov cx,11
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx
        end;

        if d<dmin then
          begin
           dmin:=d;
           m:=j;
          end;
       end;
     decodetbl[i]:=m;
    end;
 fastmove(@decodetbl,p,256);
 inc(laga(p).ofs,256);
end;
writeln('Generating "i_table.dat"...Ok       ');
end;
procedure assignall;
var
 i,j: integer;
begin
 for i:=1 to obj_nfaces do
   for j:=1 to 3 do
      obj_bmpxy^[i,j]:=texturex+256*texturey;
end;

procedure changeface(direction : integer);
var
 i,j,push:longint;
 v1,v2,v3: word;
 label l1,l2;
begin
 transform(obj_nvertices,obj_vertices,addr(observer),vid3d);
 proectpoints(obj_nvertices,vid3d,obj2d);

 push:=curface;
 j:=0;
 l1:
 inc(j);
 if j>obj_nfaces+10 then
   begin
    curface:=push;
    sound(10000);
    delay(20);
    nosound;
    goto l2;
   end;
 inc(curface,direction);
 if curface<1 then curface:=obj_nfaces;
 if curface>obj_nfaces then curface:=1;

 i:=curface;

 v1:=obj_faces^[i,1];
 v2:=obj_faces^[i,2];
 v3:=obj_faces^[i,3];

 move(obj2d^[v1],s_poly2d[1],4);
 move(obj2d^[v2],s_poly2d[2],4);
 move(obj2d^[v3],s_poly2d[3],4);

 asm
  cmp word ptr s_poly2d,7fffh
  je l1
  cmp word ptr s_poly2d[4],7fffh
  je l1
  cmp word ptr s_poly2d[8],7fffh
  je l1
 end;

 asm
  call visible2
  js l1
  jnz @l1
  or si,si
  jz l1
  @l1:
 end;
l2:
end;

procedure sel_face;
var
 i,j,push:integer;
 v1,v2,v3: word;
 x,y: integer;
 d,dmin: longint;
 vnum : word;
 selnum_: word;
 label l1,l2,l3,l4,l5;
begin
 x:=integer(mouse_getx1-224)*320 div 188;
 y:=integer(65-mouse_gety)*200 div 128;

 if (selx=x) and (sely=y) then inc(selnum);

 if selnum>10 then selnum:=0;

 selx:=x;
 sely:=y;

 transform(obj_nvertices,obj_vertices,addr(observer),vid3d);
 proectpoints(obj_nvertices,vid3d,obj2d);

 push:=curface;

 dmin:=999999999;
 for i:=1 to obj_nvertices do
  begin
   d:=sqr(longint(obj2d^[i,1]-selx))+
                 sqr(longint(obj2d^[i,2]-sely));
   if d<dmin then
     begin
      if obj2d^[i,1]<>$7fff then
        begin
          for j:=1 to obj_nfaces do
            begin
             v1:=obj_faces^[j,1];
             v2:=obj_faces^[j,2];
             v3:=obj_faces^[j,3];
             if (v1<>i) and (v2<>i) and (v3<>i) then goto l4;

             move(obj2d^[v1],s_poly2d[1],4);
             move(obj2d^[v2],s_poly2d[2],4);
             move(obj2d^[v3],s_poly2d[3],4);

             asm
              cmp word ptr s_poly2d,7fffh
              je l4
              cmp word ptr s_poly2d[4],7fffh
              je l4
              cmp word ptr s_poly2d[8],7fffh
              je l4
             end;

             asm
              call visible2
              js l4
              jnz @l1
              or si,si
              jz l4
              @l1:
             end;

             dmin:=d;
             vnum:=i;
             goto l5;
             l4:
            end;
        end;
     end;
   l5:
  end;

 selnum_:=selnum;
 j:=0;
 l3:
 for i:=1 to obj_nfaces do
   begin
    inc(j);
    if j>longint(obj_nfaces)*12 then
      begin
       curface:=push;
       sound(10000);
       delay(20);
       nosound;
       goto l2;
      end;

    v1:=obj_faces^[i,1];
    v2:=obj_faces^[i,2];
    v3:=obj_faces^[i,3];

    if (v1<>vnum) and (v2<>vnum) and (v3<>vnum) then goto l1;

    move(obj2d^[v1],s_poly2d[1],4);
    move(obj2d^[v2],s_poly2d[2],4);
    move(obj2d^[v3],s_poly2d[3],4);

    asm
     cmp word ptr s_poly2d,7fffh
     je l1
     cmp word ptr s_poly2d[4],7fffh
     je l1
     cmp word ptr s_poly2d[8],7fffh
     je l1
    end;

    asm
     call visible2
     js l1
     jnz @l1
     or si,si
     jz l1
     @l1:
    end;

    if selnum_=0 then
      begin
       curface:=i;
       if vnum=v1 then curfacev:=1;
       if vnum=v2 then curfacev:=2;
       if vnum=v3 then curfacev:=3;
       goto l2;
      end;
    dec(selnum_);
    l1:
  end;
 goto l3;
l2:
 while mouse_leftb do ;
end;

procedure split_triangle;
var
 normals : ^vertexarrtype;
 bmpxy : ^bmpxyarr;
 vertices : ^vertexarrtype;
 faces    : ^facesarrtype;
 nv,nf: word;
 i,v1,v2,v3: integer;
 normal : array [1..3] of integer;
begin
 nf:=obj_nfaces;
 nv:=obj_nvertices;

 getmem(vertices,nv*6+6);
 getmem(faces,nf*6+6);
 getmem(bmpxy,nf*6+6);
 getmem(normals,nf*6+6);

 move(obj_vertices^,vertices^,nv*6);
 move(obj_faces^,faces^,nf*6);
 move(obj_bmpxy^,bmpxy^,nf*6);
 move(objnormals^,normals^,nf*6);

 freemem(obj_vertices,nv*6);
 freemem(obj_faces,nf*6);
 freemem(obj_bmpxy,nf*6);
 freemem(objnormals,nf*6);

 v1:=obj_faces^[curface,1];
 v2:=obj_faces^[curface,2];
 v3:=obj_faces^[curface,3];

 move(vertices^[v1],s_poly3d[1],6);
 move(vertices^[v2],s_poly3d[2],6);
 move(vertices^[v3],s_poly3d[3],6);

 move(bmpxy^[curface],s_polybmp[1],2*3);

 move(normals^[curface],normal[1],2*3);

 for i:=curface to nf-1 do
   begin
    move(faces^[i+1],faces^[i],6);
    move(bmpxy^[i+1],bmpxy^[i],6);
    move(normals^[i+1],normals^[i],6);
   end;

 dec(nf);

 getmem(obj_vertices,nv*6);
 getmem(obj_faces,nf*6);
 getmem(obj_bmpxy,nf*6);
 getmem(objnormals,nf*6);

 move(vertices^,obj_vertices^,nv*6);
 move(faces^,obj_faces^,nf*6);
 move(bmpxy^,obj_bmpxy^,nf*6);
 move(normals^,objnormals^,nf*6);

 freemem(faces,nf*6+12);
 freemem(vertices,nv*6+12);
 freemem(bmpxy,nf*6+12);
 freemem(normals,nf*6+12);

 obj_nfaces:=nf;
 obj_nvertices:=nv;
end;

procedure split_face;
var
 faces: ^facesarrtype;
 vertices : ^vertexarrtype;
 normals: ^vertexarrtype;
 bmpxy : ^bmpxyarr;
 nv,nf: word;
 i,j,k: integer;
 d1,d2,d3 : real;
 x,y,z,bmpx,bmpy: longint;

 poly,poly1,poly2: array [1..3] of integer;
 bmppoly,bmppoly1: array [1..3] of word;

 label l1;
begin
 freemem(vid3d,obj_nvertices*6);
 freemem(obj2d,obj_nvertices*4);

 nv:=obj_nvertices+1;
 nf:=obj_nfaces+1;

 getmem(vertices,nv*6);
 getmem(faces,nf*6);
 getmem(normals,nf*6);
 getmem(bmpxy,nf*6);

 move(obj_vertices^,vertices^,obj_nvertices*6);
 move(obj_faces^,faces^,obj_nfaces*6);
 move(objnormals^,normals^,obj_nfaces*6);
 move(obj_bmpxy^,bmpxy^,obj_nfaces*6);

 freemem(obj_vertices,obj_nvertices*6);
 freemem(obj_faces,obj_nfaces*6);
 freemem(objnormals,obj_nfaces*6);
 freemem(obj_bmpxy,obj_nfaces*6);

 move(vertices^[faces^[curface,1]],s_poly3d[1],6);
 move(vertices^[faces^[curface,2]],s_poly3d[2],6);
 move(vertices^[faces^[curface,3]],s_poly3d[3],6);

 d1:=sqr(longint(s_poly3d[1,1]-s_poly3d[2,1]))+
     sqr(longint(s_poly3d[1,2]-s_poly3d[2,2]))+
     sqr(longint(s_poly3d[1,3]-s_poly3d[2,3]));

 d2:=sqr(longint(s_poly3d[2,1]-s_poly3d[3,1]))+
     sqr(longint(s_poly3d[2,2]-s_poly3d[3,2]))+
     sqr(longint(s_poly3d[2,3]-s_poly3d[3,3]));

 d3:=sqr(longint(s_poly3d[1,1]-s_poly3d[3,1]))+
     sqr(longint(s_poly3d[1,2]-s_poly3d[3,2]))+
     sqr(longint(s_poly3d[1,3]-s_poly3d[3,3]));

 if (d1>=d2) and (d1>=d3) then
     begin
      move(faces^[curface],poly,6);
      move(bmpxy^[curface],bmppoly,6);
      goto l1;
     end;

 if (d2>=d1) and (d2>=d3) then
      begin
       move(faces^[curface],poly1,6);
       poly[1]:=poly1[2];
       poly[2]:=poly1[3];
       poly[3]:=poly1[1];
       move(bmpxy^[curface],bmppoly1,6);
       bmppoly[1]:=bmppoly1[2];
       bmppoly[2]:=bmppoly1[3];
       bmppoly[3]:=bmppoly1[1];
       goto l1;
      end;

  move(faces^[curface],poly1,6);
  poly[1]:=poly1[3];
  poly[2]:=poly1[1];
  poly[3]:=poly1[2];
  move(bmpxy^[curface],bmppoly1,6);
  bmppoly[1]:=bmppoly1[3];
  bmppoly[2]:=bmppoly1[1];
  bmppoly[3]:=bmppoly1[2];

 l1:

 move(vertices^[poly[1]],s_poly3d[1],6);
 move(vertices^[poly[2]],s_poly3d[2],6);
 move(vertices^[poly[3]],s_poly3d[3],6);

 x:=s_poly3d[1,1]+(s_poly3d[2,1]-s_poly3d[1,1]) div 2;
 y:=s_poly3d[1,2]+(s_poly3d[2,2]-s_poly3d[1,2]) div 2;
 z:=s_poly3d[1,3]+(s_poly3d[2,3]-s_poly3d[1,3]) div 2;

 bmpx:=lo(bmppoly[1])+(lo(bmppoly[2])-lo(bmppoly[1])) div 2;
 bmpy:=hi(bmppoly[1])+(hi(bmppoly[2])-hi(bmppoly[1])) div 2;

 bmpxy^[nf,1]:=bmpx+bmpy*256;
 bmpxy^[nf,2]:=bmppoly[2];
 bmpxy^[nf,3]:=bmppoly[3];

 bmpxy^[curface,1]:=bmppoly[1];
 bmpxy^[curface,2]:=bmpx+bmpy*256;
 bmpxy^[curface,3]:=bmppoly[3];

 vertices^[nv,1]:=x;
 vertices^[nv,2]:=y;
 vertices^[nv,3]:=z;

 faces^[nf,1]:=nv;
 faces^[nf,2]:=poly[2];
 faces^[nf,3]:=poly[3];

 faces^[curface,1]:=poly[1];
 faces^[curface,2]:=nv;
 faces^[curface,3]:=poly[3];

 move(normals^[curface],normals^[nf],6);

 obj_nvertices:=nv;
 obj_nfaces:=nf;

 getmem(obj_vertices,nv*6);
 getmem(obj_faces,nf*6);
 getmem(objnormals,nf*6);
 getmem(obj_bmpxy,nf*6);

 move(vertices^,obj_vertices^,obj_nvertices*6);
 move(faces^,obj_faces^,obj_nfaces*6);
 move(normals^,objnormals^,obj_nfaces*6);
 move(bmpxy^,obj_bmpxy^,obj_nfaces*6);

 freemem(vertices,nv*6);
 freemem(faces,nf*6);
 freemem(normals,nf*6);
 freemem(bmpxy,nf*6);

 getmem(vid3d,obj_nvertices*6);
 getmem(obj2d,obj_nvertices*4);
end;

      {======================== MAIN ============================}
begin
eye_hx:=300;
eye_hz:=190;

 getdir(0,s);
 if s='C:\BP\PAS' then chdir ('c:\tmp\asc');

 if not mouse_reset
   then
     begin
      writeln('Load mouse driver !');
      halt;
     end;

 hugegetmem(p,65536+32);
 textureseg:=laga(p).seg+1;
 fillchar(mem[textureseg:0],65535,0);

 hugegetmem(p,128000+32);
 zbufseg:=laga(p).seg+1;

 getmem(p,32768+32);
 s_itblseg:=laga(p).seg+1;

 i_table:=ptr(s_itblseg,0);

 {롮 asc/obe}
 textmode(3);
 write('Will load ASC or OBE (press 1 or 2) ?');
 c:=#0;
 while (c<>'1') and (c<>'2') do c:=readkey;
 ascmodeon:=(c='1');


 {롮 asc/obe 䠩}
 if ascmodeon then
   begin
    textmode(3);
    writeln('Select ASC file:');
    ascfname:=FPick('*.asc',$70,$7,10,10,23,true);
    if not picked then halt;
    loadascobj;
   end
       else
   begin
    textmode(3);
    writeln('Select OBE file:');
    ascfname:=FPick('*.obe',$70,$7,10,10,23,true);
    if not picked then halt;
    load_obe;
   end;

 {롮 texture 䠩}
 textmode(3);
 write('Select file with texture:');
 texturefname:=FPick('*.pcx',$70,$7,10,10,23,true);
 if not picked then halt;
 write(#13+'Loading "',texturefname,'"...');

 loadpcx_raw_pal(texturefname,ptr(textureseg,0),addr(palette));

 writeln('Ok'+#10);

 calcitbl;

 mem[textureseg:0]:=100;

 observer.alfa_rad:=0;
 observer.beta_rad:=0;
 observer.gama_rad:=0;

 setgfxmode;
 directvideo:=false;
 setpalette(addr(palette));

 line(0,0,319,0,255,$a000);
 line(0,129,319,129,255,$a000);
 line(0,0,0,129,255,$a000);
 line(129,0,129,129,255,$a000);
 line(319,0,319,129,255,$a000);

 displaytexture;

 textattr:=$70;
 gotoxy(1,24); write('"',texturefname,'"');
 gotoxy(1,25); write('"',ascfname,'" - ',obj_name);

 c:=#1;
 texturex:=lo(obj_bmpxy^[curface,curfacev]);
 texturey:=hi(obj_bmpxy^[curface,curfacev]);

 spherelook(addr(observer),radius);

 repeat


 gotoxy(1,18); write('X:',texturex:3,'  Y:',texturey:3);
 gotoxy(1,20); write('Face: ',curface,'/',curfacev,'    ');
 gotoxy(1,22); write('Step: ',step:3);
 gotoxy(1,21); write('Light: ');
 case lightmode of
  1: write('Direct  ');
  2: write('One-side');
  3: write('Difuse  ');
 end;

 gotoxy(18,18); write('A:',rad2grad(observer.alfa_rad):4,
                      '  B:',rad2grad(observer.beta_rad):4,
                      '  G:',rad2grad(observer.gama_rad):4);
 gotoxy(1,23); write('X:[',observer.x:6,']   Y:[',observer.y:6,']   Z:[',observer.z:6,']');

 quatropset(250,160,texturex,texturey);
 quatropset(254,160,texturex+1,texturey);
 quatropset(246,160,texturex-1,texturey);

 quatropset(250,164,texturex,texturey+1);
 quatropset(254,164,texturex+1,texturey+1);
 quatropset(246,164,texturex-1,texturey+1);

 quatropset(250,156,texturex,texturey-1);
 quatropset(254,156,texturex+1,texturey-1);
 quatropset(246,156,texturex-1,texturey-1);

 line(246,155,257,155,255,$a000);
 line(246,168,257,168,255,$a000);

 line(245,155,245,168,255,$a000);
 line(258,155,258,168,255,$a000);

 if mouse_inbmp then
   begin
    curtexturex:=(mouse_getx1-1)*2;
    curtexturey:=(mouse_gety-1)*2;
    gotoxy(1,19); write('X:',curtexturex:3,'  Y:',curtexturey:3);
   end;

 if mouse_leftb then
   begin
    if mouse_inbmp then
      begin
       texturex:=curtexturex;
       texturey:=curtexturey;
       c:=#1;
      end;
    if mouse_in3d then
      begin
       sel_face;
       c:=#1;
       texturex:=lo(obj_bmpxy^[curface,curfacev]);
       texturey:=hi(obj_bmpxy^[curface,curfacev]);
      end;
   end;

 waitvertsync;
 mousecursor_show;

 obj_bmpxy^[curface,curfacev]:=texturex+texturey*256;

 waitvertsync;
 mousecursor_hide;

 radius:=round(sqrt(sqr(longint(observer.x))+sqr(longint(observer.y))+sqr(longint(observer.z))));

 if keypressed then c:=readkey;
 case upcase(c) of
  '\':split_face;
  'Q': inc(observer.alfa_rad,1144);
  'A': dec(observer.alfa_rad,1144);
  'W': inc(observer.beta_rad,1144);
  'S': dec(observer.beta_rad,1144);
  'E': inc(observer.gama_rad,1144);
  'D': dec(observer.gama_rad,1144);
  'Z': observer.alfa_rad:=0;
  'X': observer.beta_rad:=0;
  'C': observer.gama_rad:=0;
  '/': changeface(1);
  {if curface<obj_nfaces then inc(curface) else curface:=1;}
  '*': changeface(-1);
  {if curface>1 then dec(curface) else curface:=obj_nfaces;}
  '+': if curfacev<3 then inc(curfacev) else curfacev:=1;
  '-': if curfacev>1 then dec(curfacev) else curfacev:=3;
  'L': if lightmode<3 then inc(lightmode) else lightmode:=1;
  ',': begin
        inc(observer.alfa_rad,1144);
        spherelook(addr(observer),radius);
       end;
  '.': begin
        dec(observer.alfa_rad,1144);
        spherelook(addr(observer),radius);
       end;
  'H': inc(observer.x,step);
  'V': inc(observer.y,step);
  'T': inc(observer.z,step);
  'F': dec(observer.x,step);
  'N': dec(observer.y,step);
  'B': dec(observer.z,step);
  '[': dec(step);
  ']': inc(step);
  #13: linkvertices;
  ' ': buildtriangle;
  '`': split_triangle;
 end;

{ curvertex:=obj_faces^[curface,curfacev];}

 texturex:=lo(obj_bmpxy^[curface,curfacev]);
 texturey:=hi(obj_bmpxy^[curface,curfacev]);

  if c=#0 then
      begin
       c:=readkey;
       case c of
        'H': if texturey>0 then dec(texturey);
        'P': if texturey<255 then inc(texturey);
        'K': if texturex>0 then dec(texturex);
        'M': if texturex<255 then inc(texturex);
        '<': save_obe;
        'D': begin
              textmode(3);
              writeln('(c) AX');
              halt;
             end;
        ';': assignall;
        'R': begin
              obj_bmpxy^[curface,1]:=texturex+texturey*256;
              obj_bmpxy^[curface,2]:=texturex+texturey*256;
              obj_bmpxy^[curface,3]:=texturex+texturey*256;
             end;
       end;
      end;


 if (c<>#2) and not keypressed then
 begin
  draw_object;
  c:=#2;
 end;

 until false;
end.