unit p3dlib;

Interface

uses Graph,crt;

Type
  xyz = record
         x,y,z: integer;
        end;

  xy  = record
         x,y : integer;
        end;

Const
  eye_kl  : word = 300;
  eye_hxl : word = 320;
  eye_hzl : word = 200;


Procedure TransformKoordinates(n: word; objects3d: pointer; vid3d: pointer;
      objects2d: pointer; observer: pointer; alfa,beta,gama: integer);
Procedure TransformKoordinates_l(n: word; objects3d: pointer; vid3d: pointer;
      objects2d: pointer; observer: pointer; alfa,beta,gama: integer);
{Procedure Transformcoordinates(n: word; objects3d: pointer; objects2d: pointer; observer: xyz; alfa,beta,gama: integer);
procedure sortballs(n: Word; objects2d: pointer);
procedure drawballs(n : Word; objects2d: pointer);}
Procedure CalcAngels(X,Y,Z: Integer; Observer: XYZ; var alfa,beta: Integer);
Function fcos(alfa: Integer): Integer;
Function fsin(alfa: Integer): Integer;
Function froot(l: longint): word;
procedure drawbars(n: word; obj2d: pointer; colors: pointer);
procedure sortbars_pas(n: word; vid3d: pointer; bars2d: pointer; colors: pointer);
procedure sortbars(n: word; vid3d: pointer; bars2d: pointer; colors: pointer;
      tmtbuf: pointer);
function div32(l1,l2:longint): word;

Implementation

type
  pointertype = record
                 ofs: word;
                 seg: word;
                end;
     lg = record
            ofs: word;
            seg: word;
          end;

 var
  costable : array [0..359] of integer;
  i : word;

{$F+}
Procedure TransFormKoordinates(n: word; objects3d: pointer; vid3d: pointer;
     objects2d: pointer; observer: pointer; alfa,beta,gama: integer); External;
Procedure TransformKoordinates_l(n: word; objects3d: pointer; vid3d: pointer;
      objects2d: pointer; observer: pointer; alfa,beta,gama: integer); External;
Function fcos(alfa: Integer): Integer; External;
Function fsin(alfa: Integer): Integer; External;
Function froot(l: longint): word; External;
procedure sortbars(n: word; vid3d: pointer; bars2d: pointer; colors: pointer;
      tmtbuf: pointer); External;
function div32(l1,l2: longint):word; external;
{$F-}
{$L P3DLIB}

{procedure Transformcoordinates(n: word; objects3d: pointer; objects2d: pointer;  observer: xyz; alfa,beta,gama: integer);
var
 cosalfa,cosbeta,sinalfa,sinbeta : real;
 cosgama,singama                 : real;
 object2d                        : koord2d;
 new3dkoord0,new3dkoord1         : koord3d;
 i                               : word;
 miny                            : word;
 tgalfa0x,tgalfa0z               : real;
 long1,long2                     : longint;

 label l1;

begin
 cosalfa:=cos(alfa/57.29);
 cosbeta:=cos(beta/57.29);
 sinalfa:=sin(alfa/57.29);
 sinbeta:=sin(beta/57.29);
 cosgama:=cos(gama/57.29);
 singama:=sin(gama/57.29);

 cosalfa:=fcos(alfa)/256;
 cosbeta:=fcos(beta)/256;
 sinalfa:=fsin(alfa)/256;
 sinbeta:=fsin(beta)/256;
 cosgama:=fcos(gama)/256;
 singama:=fsin(gama)/256;
 gotoxy(10,10);writeln(alfa,cosalfa);
 gotoxy(10,11);writeln(alfa,cos(alfa/57));

 tgalfa0x:=2*eye_k/eye_hx;
 tgalfa0z:=2*eye_k/eye_hz;


 for i:=0 to (n-1) do
  begin

   move(mem[pointertype(objects3d).seg:pointertype(objects3d).ofs+i*sizeof(koord3d)],new3dkoord0,sizeof(koord3d));

   new3dkoord1.x:=new3dkoord0.x-observer.x;
   new3dkoord1.y:=new3dkoord0.y-observer.y;
   new3dkoord1.z:=new3dkoord0.z-observer.z;
   new3dkoord1.radius:=new3dkoord0.radius;

   new3dkoord0.x:=Round(-new3dkoord1.y*sinalfa+new3dkoord1.x*cosalfa);
   new3dkoord0.y:=Round(new3dkoord1.y*cosalfa+new3dkoord1.x*sinalfa);
   new3dkoord0.z:=new3dkoord1.z;
   new3dkoord0.radius:=new3dkoord1.radius;

   new3dkoord1.z:=Round(-new3dkoord0.y*sinbeta+new3dkoord0.z*cosbeta);
   new3dkoord1.y:=Round(new3dkoord0.y*cosbeta+new3dkoord0.z*sinbeta);
   new3dkoord1.x:=new3dkoord0.x;
   new3dkoord1.radius:=new3dkoord0.radius;

   new3dkoord0.x:=Round(-new3dkoord1.z*singama+new3dkoord1.x*cosgama);
   new3dkoord0.z:=Round(new3dkoord1.z*cosgama+new3dkoord1.x*singama);
   new3dkoord0.y:=new3dkoord1.y;
   new3dkoord0.radius:=new3dkoord1.radius;


   object2d.radius:=maxint;

   miny:=Round(tgalfa0x*abs(new3dkoord0.x));
   if miny=0 then miny:=1;
   if miny>new3dkoord0.y then goto l1;
   miny:=Round(tgalfa0z*abs(new3dkoord0.z));
   if miny=0 then miny:=1;
   if miny>new3dkoord0.y then goto l1;

   object2d.x:=(new3dkoord0.x*eye_k div new3dkoord0.y);
   object2d.y:=(new3dkoord0.z*eye_k div new3dkoord0.y);


   long1:=new3dkoord0.x;
   long2:=sqr(long1);
   long1:=new3dkoord0.y;
   long2:=long2+sqr(long1);
   long1:=new3dkoord0.z;
   long2:=long2+sqr(long1);

   object2d.distance:=round(sqrt(long2));

   if object2d.distance<1 then object2d.distance:=1;
   object2d.radius:=new3dkoord0.radius*eye_k div object2d.distance;
   l1:
   move(object2d,mem[pointertype(objects2d).seg:pointertype(objects2d).ofs+i*sizeof(koord2d)],sizeof(koord2d));
 end;
end;

procedure nTransformKoordinates(n: word; objects3d: pointer; objects2d: pointer; vid3d: pointer;
       observer: xyz; alfa,beta,gama: integer);
var
 cosalfa,cosbeta,sinalfa,sinbeta : real;
 cosgama,singama                 : real;
 object2d                        : koord2d;
 new3dkoord0,new3dkoord1         : koord3d;
 i                               : word;
 miny                            : word;
 tgalfa0x,tgalfa0z               : real;
 long1,long2                     : longint;

 label l1;

begin
 cosalfa:=cos(alfa/57.29);
 cosbeta:=cos(beta/57.29);
 sinalfa:=sin(alfa/57.29);
 sinbeta:=sin(beta/57.29);
 cosgama:=cos(gama/57.29);
 singama:=sin(gama/57.29);

 cosalfa:=fcos(alfa)/256;
 cosbeta:=fcos(beta)/256;
 sinalfa:=fsin(alfa)/256;
 sinbeta:=fsin(beta)/256;
 cosgama:=fcos(gama)/256;
 singama:=fsin(gama)/256;

 tgalfa0x:=2*eye_k/eye_hx;
 tgalfa0z:=2*eye_k/eye_hz;


 for i:=0 to (n-1) do
  begin

   move(mem[pointertype(objects3d).seg:pointertype(objects3d).ofs+i*sizeof(koord3d)],new3dkoord0,sizeof(koord3d));

   new3dkoord1.x:=new3dkoord0.x-observer.x;
   new3dkoord1.y:=new3dkoord0.y-observer.y;
   new3dkoord1.z:=new3dkoord0.z-observer.z;
   new3dkoord1.radius:=new3dkoord0.radius;

   new3dkoord0.x:=Round(-new3dkoord1.y*sinalfa+new3dkoord1.x*cosalfa);
   new3dkoord0.y:=Round(new3dkoord1.y*cosalfa+new3dkoord1.x*sinalfa);
   new3dkoord0.z:=new3dkoord1.z;
   new3dkoord0.radius:=new3dkoord1.radius;

   new3dkoord1.z:=Round(-new3dkoord0.y*sinbeta+new3dkoord0.z*cosbeta);
   new3dkoord1.y:=Round(new3dkoord0.y*cosbeta+new3dkoord0.z*sinbeta);
   new3dkoord1.x:=new3dkoord0.x;
   new3dkoord1.radius:=new3dkoord0.radius;

   new3dkoord0.x:=Round(-new3dkoord1.z*singama+new3dkoord1.x*cosgama);
   new3dkoord0.z:=Round(new3dkoord1.z*cosgama+new3dkoord1.x*singama);
   new3dkoord0.y:=new3dkoord1.y;
   new3dkoord0.radius:=new3dkoord1.radius;

   move(new3dkoord0,mem[pointertype(vid3d).seg:pointertype(vid3d).ofs+i*8],8);

   object2d.radius:=maxint;

   miny:=Round(tgalfa0x*abs(new3dkoord0.x));
   if miny=0 then miny:=1;
   if miny>new3dkoord0.y then goto l1;
   miny:=Round(tgalfa0z*abs(new3dkoord0.z));
   if miny=0 then miny:=1;
   if miny>new3dkoord0.y then goto l1;

   object2d.x:=(new3dkoord0.x*eye_k div new3dkoord0.y);
   object2d.y:=(new3dkoord0.z*eye_k div new3dkoord0.y);


   long1:=new3dkoord0.x;
   long2:=sqr(long1);
   long1:=new3dkoord0.y;
   long2:=long2+sqr(long1);
   long1:=new3dkoord0.z;
   long2:=long2+sqr(long1);

   object2d.distance:=round(sqrt(long2));

   if object2d.distance<1 then object2d.distance:=1;
   object2d.radius:=new3dkoord0.radius*eye_k div object2d.distance;
   l1:
   move(object2d,mem[pointertype(objects2d).seg:pointertype(objects2d).ofs+i*sizeof(koord2d)],sizeof(koord2d));
 end;
end;}

Procedure CalcAngels(X,Y,Z: Integer; Observer: XYZ; var alfa,beta: Integer);
var
dx,dy,dz,ny: integer;
begin
dx:=X-observer.X;
dy:=Y-Observer.Y;
dz:=Z-Observer.Z;
if dy=0 then alfa:=0
        else
         if dy<0 then alfa:=180+Round(57.29*arctan(dx/dy))
                     else alfa:=Round(57.29*arctan(dx/dy));
ny:=round(dy*cos(alfa/57.29)+dx*sin(alfa/57.29));
if ny=0 then beta:=0
        else
         if ny<0 then beta:=180+Round(57.29*arctan(dz/ny))
                     else beta:=Round(57.29*arctan(dz/ny));
end;

function baron(bars3d: pointer;polygon: pointer;i,j: word): byte;
type pol= array [1..100,1..4] of longint;
var
 a,b,c: longint;
 t:real;
 d2:longint;
 k:byte;
 d1:longint;
 s:byte;
 s1,s2,s3: longint;

 label l1,l2,l3;
begin
k:=0; s:=0;
 s1:=pol(polygon^)[i,1];
 s2:=pol(polygon^)[i,2];
 s3:=pol(polygon^)[i,3];
 d1:=pol(polygon^)[i,4];

 l1:
 a:=integer(memw[lg(bars3d).seg:lg(bars3d).ofs+(j-1)*24+k*6]);
 b:=integer(memw[lg(bars3d).seg:lg(bars3d).ofs+(j-1)*24+2+k*6]);
 c:=integer(memw[lg(bars3d).seg:lg(bars3d).ofs+(j-1)*24+4+k*6]);

 d2:=a*s1+b*s2+c*s3;

if d2=0 then goto l3;

 if (d1>0) and (d2<0) then goto l3;
 if (d1<0) and (d2>0) then goto l3;

{ t:=d1/d2;

 if (t>0) and(t<1.0) then inc(s);}

{gotoxy(10,2); write(d1,'   ',abs(d1),'      ');
gotoxy(10,3); write(d2,'   ',abs(d2),'      ');
readln;}

if d1>0 then
   if d1<d2 then inc(s) else
        else
   if d1>d2 then inc(s);

l3:
if (k<3) then
     begin
       inc(k);
       goto l1;
      end;
l2: baron:=s;
end;

procedure sortbars_pas(n: word; vid3d: pointer; bars2d: pointer; colors: pointer);
var
i,j:word;
buf: string[24];
polygon : array [1..100,1..4] of longint;
x1,y1,z1,x2,y2,z2,x3,y3,z3: integer;
x21,x31,y21,y31,z21,z31: longint;
d1,s1,s2,s3: longint;

begin
for i:=1 to n do
  begin
   j:=(i-1)*24;
   x1:=integer(memw[lg(vid3d).seg:lg(vid3d).ofs+j]);
   y1:=integer(memw[lg(vid3d).seg:lg(vid3d).ofs+j+2]);
   z1:=integer(memw[lg(vid3d).seg:lg(vid3d).ofs+j+4]);
   x2:=integer(memw[lg(vid3d).seg:lg(vid3d).ofs+j+6]);
   y2:=integer(memw[lg(vid3d).seg:lg(vid3d).ofs+j+8]);
   z2:=integer(memw[lg(vid3d).seg:lg(vid3d).ofs+j+10]);
   x3:=integer(memw[lg(vid3d).seg:lg(vid3d).ofs+j+12]);
   y3:=integer(memw[lg(vid3d).seg:lg(vid3d).ofs+j+14]);
   z3:=integer(memw[lg(vid3d).seg:lg(vid3d).ofs+j+16]);

   x21:=x2-x1;  x31:=x3-x1;
   y21:=y2-y1;  y31:=y3-y1;
   z21:=z2-z1;  z31:=z3-z1;

   s1:=(y21*z31-y31*z21);
   s2:=(z21*x31-x21*z31);
   s3:=(x21*y31-x31*y21);

   d1:=x1*s1+y1*s2+z1*s3;

   polygon[i,1]:=s1;
   polygon[i,2]:=s2;
   polygon[i,3]:=s3;
   polygon[i,4]:=d1;
  end;

for i:=1 to n do
  for j:=i+1 to n do
     if baron(vid3d,addr(polygon),i,j)>baron(vid3d,addr(polygon),j,i) then
       begin

        move(mem[lg(vid3d).seg:lg(vid3d).ofs+(i-1)*24],buf,24);
        move(mem[lg(vid3d).seg:lg(vid3d).ofs+(j-1)*24],
                  mem[lg(vid3d).seg:lg(vid3d).ofs+(i-1)*24],24);
        move(buf,mem[lg(vid3d).seg:lg(vid3d).ofs+(j-1)*24],24);

        move(mem[lg(bars2d).seg:lg(bars2d).ofs+(i-1)*16],buf,16);
        move(mem[lg(bars2d).seg:lg(bars2d).ofs+(j-1)*16],
           mem[lg(bars2d).seg:lg(bars2d).ofs+(i-1)*16],16);
        move(buf,mem[lg(bars2d).seg:lg(bars2d).ofs+(j-1)*16],16);

        move(mem[lg(colors).seg:lg(colors).ofs+(i-1)*2],buf,2);
        move(mem[lg(colors).seg:lg(colors).ofs+(j-1)*2],
           mem[lg(colors).seg:lg(colors).ofs+(i-1)*2],2);
        move(buf,mem[lg(colors).seg:lg(colors).ofs+(j-1)*2],2);

        move(polygon[i,1],buf,16);
        move(polygon[j,1],polygon[i,1],16);
        move(buf,polygon[j,1],16);

       end;
end;

procedure drawbars(n: word; obj2d: pointer; colors: pointer);
var
pattern : array [1..4,1..2] of integer;
i,j: word;
begin
for i:=0 to n-1 do
 begin
  setfillstyle(solidfill,mem[PointerType(colors).seg:PointerType(colors).ofs+i*2]);
{ setfillstyle(solidfill,0);                                      }
  for j:=0 to 3 do
   begin
    pattern[j+1,1]:=integer(memw[PointerType(obj2d).seg:PointerType(obj2d).ofs+j*4+i*16])+160;
    pattern[j+1,2]:=100-integer(memw[PointerType(obj2d).seg:PointerType(obj2d).ofs+j*4+i*16+2]);
   end;
  fillpoly(4,pattern[1,1]);
 end;
end;

begin
for i:=0 to 359 do costable[i]:=round(cos(i*pi/180)*256);
end.