uses crt,threed,realtime,loadpcx,gurofill,winapi,
  midas,mplayer,mconfig,s3m,timer,palete;
const
 maxnobj         = 50;
 maxnfaces       = 10000;
 maxnvertices    = 10000;
 maxnkeys        = 1800;

type
 ColorsArrType  = array [1..maxnvertices] of word;
 VertexArrType  = array [1..maxnvertices,1..3] of integer;
 FacesArrType   = array [1..maxnfaces,1..3] of word;
 NormalsArrType = array [1..maxnvertices,1..3] of integer;
 keysarrtype    = array [0..maxnkeys] of byte;
                             {0 - nothing}
                             {1 - show obj}
                             {2 - hide obj}
 newkeysarrtype    = array [0..maxnkeys] of word;
                             {X - frame number}

 keysdatatype   = array [0..maxnkeys] of
       record
        xpos,ypos,zpos: integer;
        alfa,beta,gama: integer;
       end;

 {     쥪}
 keyinfotype = record
                 present : boolean;
                   {   ,  ᫥ ௮樥}
                 hide : boolean;
                     {쥪 ⠭}
                 alfa,beta,gama : longint;
                     {㣫 }
                 posx,posy,posz : integer;
                     { 쥪}
               end;

 newkeysdatatype   = array [0..maxnkeys] of
       record
        hide : boolean;
        xpos,ypos,zpos: integer;
        alfa,beta,gama: integer;
       end;

 laga = record
          ofs,seg: word;
        end;

 dist_i_type = array [0..32766] of word;

const
 w2d_zoom : longint = 256;   {coord:256}
 w2d_posx : integer = 0;
 w2d_posy : integer = 0;
 w2d_posz : integer = 0;
 w2d_selx : integer = 0;
 w2d_sely : integer = 0;
 w2d_selz : integer = 0;
 w2d_x : integer = 0;
 w2d_y : integer = 0;
 w2d_z : integer = 0;

{============================}
{ H ᤢ !}
 w3d : word = 0;
 w3d_alfa : longint = 0;
 w3d_beta : longint = 0;
 w3d_gama : longint = 0;
 w3d_posx : integer = 0;
 w3d_posy : integer = -3000;
 w3d_posz : integer = 0;
{============================}

 curframe : word = 0;
 nobj     : word = 0;
 curnobj  : word = 0;
 step : integer = 10;

 light_vector : array [1..3] of integer = (42,-110,50);
 dummy : word =0;

 var
  msperframe    : word;
  exitsave      : pointer;
  c: char;
  obj_names     : array [1..maxnobj] of string[12];
  obj_nfaces    : array [1..maxnobj] of word;
  obj_nvertices : array [1..maxnobj] of word;
  obj_vertices  : array [1..maxnobj] of ^vertexarrtype;
  obj_faces     : array [1..maxnobj] of ^facesarrtype;
  obj_normals   : array [1..maxnobj] of ^normalsarrtype;
  obj_texturenum: array [1..maxnobj] of byte;
  obj_keys      : array [0..maxnobj] of ^newkeysarrtype;
  obj_nkeys     : array [0..maxnobj] of word;
  obj_keysdata  : array [0..maxnobj] of ^newkeysdatatype;
         {obj N0 - camera}
  obj_cache     : array [1..maxnobj] of pointer;
  obj_cachedata : array [1..maxnobj] of observertype;
  t: longint;
  poly_3d : array [1..4,1..3] of integer;
  poly_2d : array [1..4,1..2] of integer;
  observer: observertype;
  observer1: observertype;
  rot_alfa,rot_beta,rot_gama,scale: integer;
  status : boolean;
  i: integer;
  palette : array [1..768] of byte;
  palette1 : array [1..768] of byte;

  cut_poly1,cut_poly2: array [1..7,1..3] of integer;
  cut_poly2d : array [1..7,1..2] of integer;
  cut_colors1,cut_colors2: array [1..7] of word;
  cut_n : byte;
  mode:integer;

  s: string;

{  timercounter: longint;}

  module : PmpModule;
  dist_i : pointer;
  dist_i_size: longint;
  lightobjnumber : word;
  light : record
         alfa,beta,intencity: integer;
        end;
  frame_observer: observertype;
  csalias:word;
  i_table2seg:word;
  light_textureseg:word;

 {*******  get_keyinfo ********}
 {===================================}
 { ᤢ !}
 alfa,beta,gama : longint;
 x,y,z: integer;
 x1,y1,z1: integer;
 alfa1,beta1,gama1: integer;
 x2,y2,z2: integer;
 alfa2,beta2,gama2: integer;
 hide: boolean;
 fr1,fr2: word;
 {*********************************}

 startframe: word;
 poly2dbufseg: word;
 polyzbufseg: word;
 polycolorsbufseg: word;
 polycounter: word;
 bufofs6,bufofs2: word;

 poly2dbufseg32: word;
 polyzbufseg32: word;
 polycolorsbufseg32: word;
 polycounter32: word;

 frame_vid3d : ^vertexarrtype;
 frame_obj2d : pointer;
 frame_vertex_colors : ^colorsarrtype;
 midascounter : longint;


{*********************************************************************}
{* Procedures                                                        *}
{*********************************************************************}

{$F+}
procedure incmidascounter; assembler;
asm
 push ax
 push ds
 mov ax,seg midascounter
 mov ds,ax
 db 66
 inc word ptr midascounter
 pop ds
 pop ax
end;
{$F-}

{$F+}
procedure line_keyinfo(tw:word; keyinfo1,keyinfo2,keyinfo: pointer); external;
procedure calc_colors(nv: word; vertices,vertext_colors: pointer); external;
procedure getkey_proc1(frame:word;keyinfo:pointer); external;
{$L play_prj}
{$F-}

{$F+}
procedure sort_triangles_z; external;
procedure bytesort_triangles_z; external;
{$L play_prg}
{$F-}

{$F+}
procedure draw_cut_guro; external;
procedure del_thesame; external;
procedure visible3; external;
{$L drawcg}
{$F-}

procedure move_tobuf; assembler;
asm
     cld
     lea si,s_poly2d
     mov es,poly2dbufseg
     mov di,bufofs6
     shl di,1
     db 66h
     movsw
     db 66h
     movsw
     db 66h
     movsw

     lea si,s_colors
     mov es,polycolorsbufseg
     mov di,bufofs6
     db 66h
     movsw
     movsw

     mov ax,word ptr s_poly3d+2
     mov bx,word ptr s_poly3d+2+6
     cmp ax,bx
     jl @l1
     mov ax,bx
     @l1:
     mov bx,word ptr s_poly3d+2+6+6
     cmp ax,bx
     jl @l2
     mov ax,bx
     @l2:
     mov es,polyzbufseg
     mov di,bufofs2
     cld
     stosw
     mov bufofs2,di
     add  bufofs6,6
     inc polycounter
end;


procedure _draw_cut_guro;
var
 i,j: integer;
label l1;
begin
{ fillchar(cut_poly2d,6*4,0);}
 draw_cut_guro;

 del_thesame;

 if cut_n<3 then goto l1;

 asm
  call visible3
  js l1
{  jnz @l2
  or si,si
  jz l1
  @l2:}
 end;

 asm
  lea si,cut_poly2d
  mov di,si
  mov ax,ds
  mov es,ax
  mov cl,cut_n
  cld
  mov bx,160
  mov dx,100

  @l1:
  lodsw
  add ax,bx
  js l1
  cmp ax,319
  ja l1
  stosw
  lodsw
  neg ax
  add ax,dx
  js l1
  cmp ax,199
  ja l1
  stosw
  dec cl
  jne @l1
 end;

 fastmove(@cut_poly2,@s_poly3d,3*6);
 fastmove(@cut_poly2d,@s_poly2d,3*4);
 fastmove(@cut_colors2,@s_colors,3*2);
 move_tobuf;

 for i:=4 to cut_n do
    begin
      fastmove(@cut_poly2[i-1],@s_poly3d,2*6);
      fastmove(@cut_poly2d[i-1],@s_poly2d,2*4);
      fastmove(@cut_colors2[i-1],@s_colors,2*2);
      fastmove(@cut_poly2,@s_poly3d[3],6);
      fastmove(@cut_poly2d,@s_poly2d[3],4);
      fastmove(@cut_colors2,@s_colors[3],2);
      move_tobuf;
     end;

l1:
end;

function strng(i:longint): string;
var s: string;
begin
str(i,s);
strng:=s;
end;

{$F+}
procedure myexit;
begin
 exitproc:=exitsave;
 midasStopModule(module);
 midasFreeModule(module);
 midasClose;
 textmode(3);
 while keypressed do readkey;
 writeln('(c) Hax');
end;
{$F-}

procedure get_keyinfo(frame:word; obj_nkeys:word;obj_keys,obj_keysdata,keyinfo:pointer);
var
 i,j: integer;
 b:byte;
 t:real;
 label l1,l2,l3,l4,l5;

begin

 asm
  les di,obj_keys
  cld
  mov cx,obj_nkeys
  mov si,word ptr obj_keysdata
  mov ax,frame
  @l2:
  scasw
  jc @l1
  add si,13
  dec cx
  jne @l2

  sub si,13

  @l4:
  push ds
  mov ds,word ptr obj_keysdata+2
  les di,keyinfo
  lodsb
  stosb
  stosb
  db 66h
  mov ax,[si]
  mov bx,[si+4]
  db 66h
  mov es:[di+12],ax
  mov es:[di+12+4],bx
  mov cx,1144
  mov ax,[si+6]
  imul cx
  stosw
  mov ax,dx
  stosw
  mov ax,[si+6+2]
  imul cx
  stosw
  mov ax,dx
  stosw
  mov ax,[si+6+2+2]
  imul cx
  stosw
  mov ax,dx
  stosw
  pop ds
  jmp @l3

  @l1:
  sub di,4
  sub si,13
  mov bx,es:[di]
  cmp ax,bx
  je @l4

  @l5:
  mov fr1,bx
  mov bx,es:[di+2]
  mov fr2,bx
  mov es,word ptr obj_keysdata+2
  mov al,es:[si]
  mov hide,al
  db 66h
  mov ax,es:[si+1]
  db 66h
  mov x1,ax
  db 66h
  mov ax,es:[si+1+4]
  db 66h
  mov z1,ax
  db 66h
  mov ax,es:[si+1+4+4]
  db 66h
  mov beta1,ax
  db 66h
  mov ax,es:[si+1+13]
  db 66h
  mov x2,ax
  db 66h
  mov ax,es:[si+1+13+4]
  db 66h
  mov z2,ax
  db 66h
  mov ax,es:[si+1+13+4+4]
  db 66h
  mov beta2,ax

  push frame
  db 66h
  push word ptr keyinfo
  call getkey_proc1
  @l3:
 end;

(*
 for i:=0 to obj_nkeys-1 do
   if newkeysarrtype(obj_keys^)[i]>frame then goto l1;


 {  frame>=maxframe  }

 l3:
 keyinfotype(keyinfo^).hide:=newkeysdatatype(obj_keysdata^)[i].hide;
 keyinfotype(keyinfo^).posx:=newkeysdatatype(obj_keysdata^)[i].xpos;
 keyinfotype(keyinfo^).posy:=newkeysdatatype(obj_keysdata^)[i].ypos;
 keyinfotype(keyinfo^).posz:=newkeysdatatype(obj_keysdata^)[i].zpos;
 keyinfotype(keyinfo^).alfa:=longint(newkeysdatatype(obj_keysdata^)[i].alfa)*1144;
 keyinfotype(keyinfo^).beta:=longint(newkeysdatatype(obj_keysdata^)[i].beta)*1144;
 keyinfotype(keyinfo^).gama:=longint(newkeysdatatype(obj_keysdata^)[i].gama)*1144;

 goto l4;

 l1:
 dec(i);
 fr1:=newkeysarrtype(obj_keys^)[i];
 if fr1=frame then goto l3;

 hide:=
 x1:=newkeysdatatype(obj_keysdata^)[i].xpos;
 y1:=newkeysdatatype(obj_keysdata^)[i].ypos;
 z1:=newkeysdatatype(obj_keysdata^)[i].zpos;
 alfa1:=newkeysdatatype(obj_keysdata^)[i].alfa;
 beta1:=newkeysdatatype(obj_keysdata^)[i].beta;
 gama1:=newkeysdatatype(obj_keysdata^)[i].gama;

 inc(i);
 fr2:=newkeysarrtype(obj_keys^)[i];

 x2:=newkeysdatatype(obj_keysdata^)[i].xpos;
 y2:=newkeysdatatype(obj_keysdata^)[i].ypos;
 z2:=newkeysdatatype(obj_keysdata^)[i].zpos;
 alfa2:=newkeysdatatype(obj_keysdata^)[i].alfa;
 beta2:=newkeysdatatype(obj_keysdata^)[i].beta;
 gama2:=newkeysdatatype(obj_keysdata^)[i].gama;

 getkey_proc1(frame,keyinfo);

 l4:*)
end;

procedure loadprj(fname: string);
var
 i,j: integer;
 f: file;
 oldformat:boolean;
 n,m: word;
 keys: ^keysarrtype;
 keysdata: ^keysdatatype;
 b  : byte;
 label l1;
begin
 writeln('Loading project: ',fname);

 assign(f,fname);
 {$I-}
 reset(f,1);
 {$I+}
 if ioresult>0 then
   begin
    writeln('Can`t read file !'+#7);
    halt;
   end;

 writeln('Memory avaible: ',getfreespace(0),' bytes');
 writeln;
 if getfreespace(0)<filesize(f)+30000 then
   begin
    textmode(3);
    writeln('Not Enougth memory.');
    writeln('Press enter to continue.');
    readln;
    halt;
   end;

 blockread(f,w2d_zoom,4);

 if w2d_zoom<>$12340003 then
   begin
     writeln;
     writeln('Not a valid PRG file or old version. Try resave with KEYGURO!');
     writeln('Press enter...');
     readln;
     halt;
   end;
 write('Loading environment variables...');
 blockread(f,startframe,2);
 blockread(f,w2d_zoom,4);
 blockread(f,w2d_posx,2);
 blockread(f,w2d_posy,2);
 blockread(f,w2d_posz,2);
 blockread(f,w2d_selx,2);
 blockread(f,w2d_sely,2);
 blockread(f,w2d_selz,2);
 blockread(f,w2d_x,2);
 blockread(f,w2d_y,2);
 blockread(f,w2d_z,2);
 blockread(f,w3d_alfa,2);
 blockread(f,w3d_beta,2);
 blockread(f,w3d_gama,2);
 blockread(f,w3d_posx,2);
 blockread(f,w3d_posy,2);
 blockread(f,w3d_posz,2);

 blockread(f,curframe,2);
 blockread(f,nobj,2);
 blockread(f,curnobj,2);
 blockread(f,mode,2);
 blockread(f,step,2);

 blockread(f,observer,sizeof(observertype));
 blockread(f,rot_alfa,2);
 blockread(f,rot_beta,2);
 blockread(f,rot_gama,2);
 blockread(f,scale,2);
 blockread(f,status,2);
 blockread(f,msperframe,2);

 writeln('Ok');
 writeln('Loading objects...');
 for i:=1 to nobj do
   begin
    blockread(f,obj_names[i],13);
    writeln('   ',obj_names[i]);
    blockread(f,obj_nfaces[i],2);
    blockread(f,obj_nvertices[i],2);

    getmem(obj_vertices[i],obj_nvertices[i]*6);
    getmem(obj_faces[i],obj_nfaces[i]*6);
    getmem(obj_normals[i],obj_nvertices[i]*6);

    blockread(f,obj_vertices[i]^,obj_nvertices[i]*6);
    blockread(f,obj_faces[i]^,obj_nfaces[i]*6);
    blockread(f,obj_normals[i]^,obj_nvertices[i]*6);
    blockread(f,obj_texturenum[i],1);
  end;

 write('Loading movie keys...');

 for i:=0 to nobj do
  begin
   blockread(f,n,2);
   obj_nkeys[i]:=n;
   getmem(obj_keys[i],n*2);
   getmem(obj_keysdata[i],n*13);
   blockread(f,obj_keys[i]^,n*2);
   blockread(f,obj_keysdata[i]^,n*13);
  end;
 writeln('Ok');

 write('Loading palette...');
 blockread(f,palette,768);
 writeln('Ok');

 close(f);

 writeln;
 writeln('Memory avaible: ',getfreespace(0),' bytes');
l1:
end;

procedure setrealcameradata(frame: word;tw: word);
var
 keyinfo1,keyinfo2: keyinfotype;
begin
 get_keyinfo(frame,obj_nkeys[0],obj_keys[0],obj_keysdata[0],addr(keyinfo1));
 get_keyinfo(frame+1,obj_nkeys[0],obj_keys[0],obj_keysdata[0],addr(keyinfo2));

 line_keyinfo(tw,@keyinfo1,@keyinfo2,@w3d);

end;

procedure setcameradata;
var
 keyinfo: keyinfotype;
begin
 get_keyinfo(curframe,obj_nkeys[0],obj_keys[0],obj_keysdata[0],addr(keyinfo));
 w3d_alfa:=keyinfo.alfa;
 w3d_beta:=keyinfo.beta;
 w3d_gama:=keyinfo.gama;
 w3d_posx:=keyinfo.posx;
 w3d_posy:=keyinfo.posy;
 w3d_posz:=keyinfo.posz;
end;

procedure setframedata;
var
 keyinfo: keyinfotype;
 label l1;
begin
 setcameradata;
 if curnobj=0 then
   begin
    rot_alfa:=0; rot_beta:=0; rot_gama:=0;
    w2d_selx:=0; w2d_sely:=0; w2d_selz:=0;
    goto l1;
   end;
 get_keyinfo(curframe,obj_nkeys[nobj],obj_keys[curnobj],obj_keysdata[curnobj],addr(keyinfo));
 w2d_selx:=keyinfo.posx;
 w2d_sely:=keyinfo.posy;
 w2d_selz:=keyinfo.posz;
 rot_alfa:=keyinfo.alfa;
 rot_beta:=keyinfo.beta;
 rot_gama:=keyinfo.gama;
 status:=keyinfo.hide;
 l1:
end;

procedure drawrealobject(n: word;alfa,beta,gama: longint;addx,addy,addz: integer);
type
 obj2dtype = array [1..10000,1..2] of integer;
var
 dist:longint;
 i,j: integer;
 x1,y1,z1,x2,y2,z2,x3,y3,z3 : integer;
 n1,n2,n3,nf,nv: word;
 colr,colr1: word;
 obj_facesni,obj_bmpxyni: pointer;
 pj,pn: pointer;
 obj_color: word;
label l1,l2,l3,l4,l5,l6;

begin
 eye_hx:=300;
 eye_hz:=190;

 kd:=31;
 kr:=32+obj_texturenum[n]*64;

 nv:=obj_nvertices[n];
 nf:=obj_nfaces[n];

 observer.alfa_rad:=alfa;
 observer.beta_rad:=beta;
 observer.gama_rad:=gama;
 observer.x:=addx;
 observer.y:=addy;
 observer.z:=addz;

{==============================================================
   쥪  p諮 p   -
  ⮬ 砥 p ᪮p㥬 p pp p設
  
 ==============================================================}

{ if obj_cachedata[n].x<>addx then goto l4;
 if obj_cachedata[n].y<>addy then goto l4;
 if obj_cachedata[n].z<>addz then goto l4;
 if obj_cachedata[n].alfa_rad<>alfa then goto l4;
 if obj_cachedata[n].beta_rad<>beta then goto l4;
 if obj_cachedata[n].gama_rad<>gama then goto l4;}

 asm
  lea si,obj_cachedata
  mov ax,n
  dec ax
  {18 = 16+2}
  mov cx,ax
  shl cx,4
  shl ax,1
  add ax,cx
  add si,ax

  mov cx,9
  mov ax,ds
  mov es,ax
  lea di,observer
  cld
  rep cmpsw
  jnz l4
 end;

 fastmove(obj_cache[n],frame_vid3d,nv*6);

 goto l5;

 l4:
 transform2(nv,obj_vertices[n],addr(observer),frame_vid3d);

 fastmove(frame_vid3d,obj_cache[n],nv*6);
 obj_cachedata[n]:=observer;

 l5:

 transform(nv,frame_vid3d,addr(frame_observer),frame_vid3d);
 proectpoints(nv,frame_vid3d,frame_obj2d);

{=========================================
  P뢠 ⥭ᨢ p⥪ᮢ
 =========================================}

{ kr:=32+192;  kd:=31;
 ls_normal[1]:=127;
 ls_normal[2]:=0;
 ls_normal[3]:=0;}
 calccolors(nv,obj_normals[n],frame_vertex_colors);

 obj_facesni:=obj_faces[n];

 for i:=1 to nf do
   begin
    {n1:=obj_faces[n]^[i,1];
    n2:=obj_faces[n]^[i,2];
    n3:=obj_faces[n]^[i,3];}

    {! n1,n2,n3  cᥬp p 㬥  }

    asm
     cld
     les si,obj_facesni
     db 26h
     lodsw
     dec ax
     mov n1,ax
     db 26h
     lodsw
     dec ax
     mov n2,ax
     db 26h
     lodsw
     dec ax
     mov n3,ax
    end;

    {fastmove(@p^[n1],@s_poly3d,6);
    fastmove(@p^[n2],@s_poly3d[2],6);
    fastmove(@p^[n3],@s_poly3d[3],6);}

    asm
     les si,frame_vid3d

     mov bx,n1
     mov cx,bx
     shl bx,2
     add bx,cx
     add bx,cx
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly3d,ax
     mov ax,es:[si+bx+4]
     mov word ptr s_poly3d+4,ax

     mov bx,n2
     mov cx,bx
     shl bx,2
     add bx,cx
     add bx,cx
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly3d+6,ax
     mov ax,es:[si+bx+4]
     mov word ptr s_poly3d+6+4,ax

     mov bx,n3
     mov cx,bx
     shl bx,2
     add bx,cx
     add bx,cx
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly3d+6+6,ax
     mov ax,es:[si+bx+4]
     mov word ptr s_poly3d+6+6+4,ax
    end;

    {s_colors[1]:=vertex_colors^[n1];
    s_colors[2]:=vertex_colors^[n2];
    s_colors[3]:=vertex_colors^[n3];}
    asm
     les si,frame_vertex_colors

     mov bx,n1
     shl bx,1
     mov ax,es:[si+bx]
     mov word ptr s_colors,ax

     mov bx,n2
     shl bx,1
     mov ax,es:[si+bx]
     mov word ptr s_colors+2,ax

     mov bx,n3
     shl bx,1
     mov ax,es:[si+bx]
     mov word ptr s_colors+4,ax
    end;

    {   fastmove(@obj2d^[n1],@s_poly2d,4);
    fastmove(@obj2d^[n2],@s_poly2d[2],4);
    fastmove(@obj2d^[n3],@s_poly2d[3],4);}

    asm
     les si,frame_obj2d

     mov bx,n1
     shl bx,2
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly2d,ax

     mov bx,n2
     shl bx,2
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly2d+4,ax

     mov bx,n3
     shl bx,2
     db 66h
     mov ax,es:[si+bx]
     db 66h
     mov word ptr s_poly2d+4+4,ax
    end;

    asm
     mov ax,7fffh
     cmp word ptr s_poly2d,ax
     je @l2
     cmp word ptr s_poly2d+4,ax
     je @l2
     cmp word ptr s_poly2d+4+4,ax
     je @l2

     jmp @l3
     @l2:
     jmp l2;
     @ll1:
     or si,si
     jne @ll2
     @l1:
     jmp l1
     @l3:

     call visible2
     js @l1
     jz @ll1
     @ll2:

     lea si,s_poly2d
     mov di,si
     mov ax,ds
     mov es,ax
     mov cl,3
     cld
     mov bx,160
     mov dx,100

     @l4:
     lodsw
     add ax,bx
     js @l1
     cmp ax,319
     ja @l1
     stosw

     lodsw
     neg ax
     add ax,dx
     js @l1
     cmp ax,199
     ja @l1
     stosw

     dec cl
     jne @l4
    end;

{    mem[s_scrbuf1seg:s_poly2d[1,1]+s_poly2d[1,2]*320]:=hi(s_colors[1]);
    mem[s_scrbuf1seg:s_poly2d[2,1]+s_poly2d[2,2]*320]:=hi(s_colors[2]);
    mem[s_scrbuf1seg:s_poly2d[3,1]+s_poly2d[3,2]*320]:=hi(s_colors[3]);}

{    guro_simple;}

{    fastmove(@s_poly2d,ptr(poly2dbufseg,bufofs6*2),12);
    fastmove(@s_colors,ptr(polycolorsbufseg,bufofs6),6);}

    asm
     cld
     lea si,s_poly2d
     mov es,poly2dbufseg
     mov di,bufofs6
     shl di,1
     db 66h
     movsw
     db 66h
     movsw
     db 66h
     movsw

     lea si,s_colors
     mov es,polycolorsbufseg
     mov di,bufofs6
     db 66h
     movsw
     movsw
    end;

    asm
     mov ax,word ptr s_poly3d+2
     mov bx,word ptr s_poly3d+2+6
     cmp ax,bx
     jl @l1
     mov ax,bx
     @l1:
     mov bx,word ptr s_poly3d+2+6+6
     cmp ax,bx
     jl @l2
     mov ax,bx
     @l2:
     mov es,polyzbufseg
     mov di,bufofs2
     cld
     stosw
     mov bufofs2,di
    end;

    inc(bufofs6,6);
    inc(polycounter);

    goto l1;
    l2:
    _draw_cut_guro;
    l1:
    asm
     add word ptr obj_facesni,6
    end;
   end;

 l6:
end;

procedure drawrealframe(frame:word;tw: word);
var
 i,j,sortk: integer;
 keyinfo,keyinfo1,keyinfo2 : keyinfotype;
 r,r1: word;
 base_bufofs2,base_bufofs6: word;
 z,zmin:integer;
 label l1;
begin
 polycounter:=0;
 bufofs6:=0;
 bufofs2:=0;

 frame_observer.x:=w3d_posx;
 frame_observer.y:=w3d_posy;
 frame_observer.z:=w3d_posz;
 frame_observer.alfa_rad:=w3d_alfa;
 frame_observer.beta_rad:=w3d_beta;
 frame_observer.gama_rad:=w3d_gama;

 get_keyinfo(frame,obj_nkeys[lightobjnumber],obj_keys[lightobjnumber],
        obj_keysdata[lightobjnumber],addr(keyinfo1));

 get_keyinfo(frame+1,obj_nkeys[lightobjnumber],obj_keys[lightobjnumber],
        obj_keysdata[lightobjnumber],addr(keyinfo2));

 line_keyinfo(tw,@keyinfo1,@keyinfo2,@keyinfo);

 if lightobjnumber=0 then
   begin
    light.alfa:=0;
    light.beta:=0;
    light.intencity:=100;
   end
       else
   begin
    light.alfa:=keyinfo.alfa;
    light.beta:=keyinfo.beta;
    light.intencity:=keyinfo.gama;
   end;

 for i:=1 to nobj do
   begin
    get_keyinfo(frame,obj_nkeys[i],obj_keys[i],obj_keysdata[i],addr(keyinfo1));

    if keyinfo1.hide then goto l1;
    get_keyinfo(frame+1,obj_nkeys[i],obj_keys[i],obj_keysdata[i],addr(keyinfo2));

    line_keyinfo(tw,@keyinfo1,@keyinfo2,@keyinfo);

    drawrealobject(i,keyinfo.alfa,keyinfo.beta,keyinfo.gama,
            keyinfo.posx,keyinfo.posy,keyinfo.posz);

    l1:
   end;

{
 for j:=63 downto 0 do
   begin
    bufofs2:=0;
    bufofs6:=0;
    base_bufofs2:=0;
    base_bufofs6:=0;
    polycounter32:=0;
    zmin:=j*256;

    for i:=1 to polycounter do
      begin
       z:=memw[polyzbufseg:base_bufofs2];

       if z>zmin then
         begin
          fastmove(ptr(poly2dbufseg,base_bufofs6*2),
                   ptr(poly2dbufseg32,bufofs6*2),12);
          fastmove(ptr(polycolorsbufseg,base_bufofs6),
                   ptr(polycolorsbufseg32,bufofs6),6);
          memw[polyzbufseg32:bufofs2]:=z;
          inc(bufofs2,2);
          inc(bufofs6,6);
          inc(polycounter32);
          memw[polyzbufseg:base_bufofs2]:=0;
         end;
       inc(base_bufofs2,2);
       inc(base_bufofs6,6);
      end;
    sort_triangles_z;
   end;
                      }
{ polycounter32:=polycounter;
 poly2dbufseg32:=poly2dbufseg;
 polyzbufseg32:=polyzbufseg;
 polycolorsbufseg32:=polycolorsbufseg;
 sort_triangles_z;}

 bytesort_triangles_z;

end;

procedure realtimemovie;
var
 j,lastframe: integer;
 i,dist: longint;
 scrbufp : pointer;
 poly2dbufp,polyzbufp,polycolorsbufp:  pointer;
 poly2dbufp32,polyzbufp32,polycolorsbufp32:  pointer;
 f:file;
 tr: word;
 nf,t,t1: longint;
 colr: word;
 s:string;
 imn:integer;
 re,re1:real;
 act2time,l:longint;
 pal_act:byte;
 r1,r: integer;
 real_maxnv : word;
 w: word;
 rframe,vsync,keytime : real;
 demo:boolean;
 label l1,l2,l3;
begin
 if getfreespace(0)<64000+16000 then
   begin
    writeln('Not Enougth memory.');
    writeln('Press enter to continue.');
    readln;
    goto l3;
   end;

 real_maxnv:=0;
 for i:=1 to nobj do
   if obj_nvertices[i]>real_maxnv then real_maxnv:=obj_nvertices[i];

 frame_vid3d:=globalallocptr(gmem_moveable,real_maxnv*6);
 frame_obj2d:=globalallocptr(gmem_moveable,real_maxnv*4);
 frame_vertex_colors:=globalallocptr(gmem_moveable,real_maxnv*2);


 scrbufp:=GlobalAllocPtr(Gmem_moveable,64000+32);
 s_scrbuf1seg:=laga(scrbufp).seg;

 poly2dbufp:=GlobalAllocPtr(Gmem_moveable,maxnfaces*12);
 polyzbufp:=GlobalAllocPtr(Gmem_moveable,maxnfaces*2);
 polycolorsbufp:=GlobalAllocPtr(Gmem_moveable,maxnfaces*2);
 poly2dbufseg:=laga(poly2dbufp).seg;
 polyzbufseg:=laga(polyzbufp).seg;
 polycolorsbufseg:=laga(polycolorsbufp).seg;

 poly2dbufp32:=GlobalAllocPtr(Gmem_moveable,maxnfaces*12);
 polyzbufp32:=GlobalAllocPtr(Gmem_moveable,maxnfaces*2);
 polycolorsbufp32:=GlobalAllocPtr(Gmem_moveable,maxnfaces*2);
 poly2dbufseg32:=laga(poly2dbufp32).seg;
 polyzbufseg32:=laga(polyzbufp32).seg;
 polycolorsbufseg32:=laga(polycolorsbufp32).seg;

 fillchar(mem[s_scrbuf1seg:0],64000,0);
 writeln('Memory Avaible: ',maxavail);

 Writeln('Allocating memory for position cache...');
 for i:=1 to nobj do
   begin
    obj_cachedata[i].alfa_rad:=-100000;
    obj_cache[i]:=globalallocptr(gmem_moveable,obj_nvertices[i]*6);
   end;

 lightobjnumber:=0;
 for i:=1 to nobj do
    if obj_names[i]='"light"' then lightobjnumber:=i;

 write('Object "light": ');
 if lightobjnumber>0 then writeln('found') else writeln('not found');

 val(paramstr(2),startframe,imn);
 demo:=false;
 if startframe=10000 then
   begin
    demo:=true;
    startframe:=0;
   end;
 writeln('Start frame: ',startframe);
 writeln('Memory Avaible: ',maxavail);

 asm

  mov ax,13h
  int 10h
 end;

 tmrGetSCRSync(@w);
 vsync:=2386363/w;
 keytime:=msperframe/1000*vsync;
 tmrSyncScr(w,@incmidascounter,nil,nil);

 textattr:=$70;
 directvideo:=false;

 setpalette(addr(palette));

 lastframe:=1;
 for i:=0 to nobj do
      if obj_keys[i]^[obj_nkeys[i]-1]>lastframe then
         lastframe:=obj_keys[i]^[obj_nkeys[i]-1];

 setframedata;

 nf:=0;
 t1:=midascounter;

 l2:
 t:=midascounter;
 curframe:=startframe;
 act2time:=round((lastframe*keytime)-vsync)+midascounter;
 pal_act:=0;
 re:=0;

 while curframe<=lastframe do
   begin
    if pal_act=0 then
      begin
       fadepalette(@palette,@palette1,round(re));
       {waitvertsync;}
       setpalette(@palette1);
       re:=(midascounter-t)/vsync*200;
       if re>255 then
         begin
          setpalette(@palette);
          pal_act:=1;
          re:=255;
         end;
      end;

    l:=midascounter-act2time;
    if l>0 then
      begin
       re:=255-l/vsync*200;
       if re>0 then
         begin
          fadepalette(@palette,@palette1,round(re));
          {waitvertsync;}
          setpalette(@palette1);
         end;
      end;

    rframe:=(midascounter-t)/keytime;
    curframe:=startframe+round(int(rframe));
    tr:=round(16384*frac(rframe));

    setrealcameradata(curframe,tr);

    drawrealframe(curframe,tr);

{    fastmove(ptr(s_scrbuf1seg,0),ptr(sega000,0),64000);
    fillchar(mem[s_scrbuf1seg:0],64000,0);}

{    asm
     push ds
     mov ax,sega000
     mov es,ax
     mov bx,s_scrbuf1seg
     mov ds,bx
     mov cx,16000
     cld
     xor si,si
     xor di,di
     db 66h
     rep movsw
     mov es,bx
     xor di,di
     mov cx,16000
     db 66h
     xor ax,ax
     db 66h
     rep stosw
     pop ds
    end;}

    asm
     push ds
     mov es,sega000
     mov bx,s_scrbuf1seg
     mov ds,bx

     mov dx,188
     mov ax,320*6+10
     cld

     @@l1:
     mov di,ax
     mov si,ax
     mov cx,300
     db 66h
     rep movsw
     add ax,320
     dec dx
     jne @@l1

     mov es,bx
     xor di,di
     mov cx,16000
     db 66h
     xor ax,ax
     db 66h
     rep stosw
     pop ds
    end;

    inc(nf);

    gotoxy(35,1);
    write(startframe+rframe:4:2);
    gotoxy(35,2);
    write(nf*vsync/(midascounter-t1+1):4:2);

    if keypressed then goto l1;
   end;
{ gotoxy(1,25);
 write(' <last frame>');
 delay(3000);}
 if not demo then goto l2;
 l1:
 while keypressed do readkey;

 GlobalFreePtr(frame_vid3d);
 GlobalFreePtr(frame_obj2d);
 GlobalFreePtr(frame_vertex_colors);
 GlobalFreePtr(scrbufp);
 GlobalFreePtr(poly2dbufp);
 GlobalFreePtr(polyzbufp);
 GlobalFreePtr(polycolorsbufp);

 l3:
 textmode(3);
end;

{===================================================================}
{ MAIN                                                              }
{===================================================================}
begin
csalias:=cseg+selectorinc;
 if paramstr(1)='' then
   begin
    writeln;
    writeln('Play_Prg.exe filename.prg [startframe]');
    halt;
   end;
 getdir(0,s);
 if s='C:\BP\PAS' then chdir ('c:\tmp\asc');

  midasSetDefaults;
 midasloadconfig('setup.CFG');

{ midasSDNumber:=4;
 midasSDCard:=1;}

 writeln('Loading "play_prj.s3m"');
 midasInit;
 module := midasLoadModule('play_prj.s3m'+#0, @mpS3M, NIL);
 midasplaymodule(module,0);

 exitsave:=exitproc;
 exitproc:=@myexit;

 directvideo:=false;
 loadprj (paramstr(1));
 realtimemovie;
{ chdir ('c:\bp\pas');}
end.
