		public	installtimer_
		public	deinstalltimer_
		public	setbwpalette256
		public	fastmove
		public	setpalette
		public	inthand

code		segment byte public
		assume	cs:code,ds:data

installtimer_	proc	far
.386
		cli
		in	al,0a1h
		and	al,0feh
		out	0a1h,al

		mov	al,0bh
		out	70h,al
		in	al,71h
		and	al,7fh
		or	al,40h
		push	ax
		mov	al,0bh
		out	70h,al
		pop	ax
		out	71h,al

		mov	al,0ah
		out	70h,al
		in	al,71h
		and	al,80h
		or	al,00100110b
		push	ax
		mov	al,0ah
		out	70h,al
		pop	ax
		out	71h,al
		sti
		ret
installtimer_	endp

deinstalltimer_  proc    far
		cli
		in	al,0a1h
		or	al,1
		out	0a1h,al

		mov	al,0bh
		out	70h,al
		in	al,71h
		and	al,7fh-40h
		push	ax
		mov	al,0bh
		out	70h,al
		pop	ax
		out	71h,al

		sti
		ret
deinstalltimer_ endp

setbwpalette256 proc	far
		xor	bx,bx
		mov	cx,256
sbwl1:
		mov	al,bl
		mov	dx,3c8h
		out	dx,al
		mov	al,bl
		shr	al,2
		mov	dx,3c9h
		out	dx,al
		out	dx,al
		out	dx,al
		inc	bx
		loop	sbwl1
		ret
setbwpalette256 endp

;procedure fastmove(p1,p2: pointer; count: word);
fastmove	proc	far
		push	bp
		mov	bp,sp
		push	ds
		cld
		lds	si,[bp+12]
		les	di,[bp+8]
		mov	cx,[bp+6]
		xor	dx,dx

		shr	cx,1
		adc	dx,dx
		shr	cx,1
		rep	movsd
		adc	cx,cx
		rep	movsw
		mov	cx,dx
		rep	movsb

		pop	ds
		pop	bp
		ret	10
fastmove	endp

;procedure setpalette (pal:pointer);
setpalette	proc	far
		push	bp
		mov	bp,sp
		push	ds

		lds	si,[bp+6]
		mov	cx,256

		mov	dx,3c8h
		xor	ax,ax
		cld
lspl1:
		out	dx,al
		inc	dx
		outsb
		outsb
		outsb
		dec	dx
		inc	ax
		loop	lspl1

		pop	ds
		pop	bp
		ret	4
setpalette	endp

updatepal	proc	far
		push	bp
                mov     bp,maxpalettecounter
		sub	bp,palettecounter

		mov	al,0
		mov	dx,3c8h
		out	dx,al

		lfs	si,oldpalette
		lgs	di,newpalette

		mov	cx,768
lop1:
		mov	ah,gs:[di]
		xor	al,al
		mov	bh,fs:[si]
		xor	bl,bl
		sub	ax,bx
		imul	bp
		mov	bx,maxpalettecounter
		idiv	bx
		mov	al,ah
		add	al,fs:[si]
		mov	dx,3c9h
		out	dx,al

		inc	di
		inc	si
		loop	lop1
		pop	bp
		sti
		ret
updatepal	endp

inthand proc	far
		push	ax
		push	ds

                mov     al,20h
                out     0a0h,al
                out     20h,al
loi1a:
		mov	al,0ch
		out	70h,al
		in	al,71h
		test	al,40h
;                jnz     loi1a

		sti

		mov	ax,seg data
		mov	ds,ax
		add	word ptr timercounter,1
		adc	word ptr timercounter+2,0

                cmp     palettecounter,0
		je	loi1

                inc     laga
                cmp     laga,55
                jne     lop2
		mov	laga,0

lrs3:
                push    bx cx dx si di fs gs

;                cli
                mov     dx,3dah
lr1:
                in      al,dx
                test    al,8
                jne     lr1
lr2:
                in      al,dx
                test    al,8
                je      lr2
;                sti
lr3:
		call	updatepal

                cmp     rbusy,1
		jne	lopi1

		cli
		mov	rbusy,0
		mov	palettecounter,0

                push    newpalette
		call	setpalette
		sti
lopi1:

		pop	gs fs di si dx cx bx

		pop	ds
		pop	ax
		iret
lop2:
		dec	palettecounter
                jnz     loi1

		mov	palettecounter,1
		mov	rbusy,1

loi1:


		pop	ds
		pop	ax
		iret
inthand endp

.286
code		ends

data		segment word public

laga		db	0
		extrn	rbusy: byte
		extrn	timercounter:word

		extrn	oldpalette:dword
		extrn	newpalette:dword
		extrn	palettecounter: word;
		extrn	maxpalettecounter: word;

data		ends
		end