Unit RealTime;

interface

{$IFNDEF DPMI}
uses dos;
var
  timercounter: longint;
{$ENDIF}
var
  palettecounter : word;
  maxpalettecounter: word;
  oldpalette,newpalette : pointer;

{$IFNDEF DPMI}
procedure morfpalette(oldpal,newpal: pointer;count:longint);
{$ELSE}
function timercounter: longint;
{$ENDIF}
procedure setbwpalette256;
procedure fastmove(p1,p2: pointer; count: word);
procedure setpalette(pal:pointer);
procedure getpalette(pal: pointer);

implementation

const
 rbusy : byte = 0;

var

 exitsave:pointer;
 oldint70h : pointer;

{$L realtime}
{$F+}
procedure installtimer_; external;
procedure deinstalltimer_; external;
procedure setbwpalette256; external;
procedure fastmove(p1,p2: pointer; count: word); external;
procedure setpalette(pal:pointer); external;
procedure inthand; external;
{$F-}

{$IFNDEF DPMI}
procedure installtimer;
begin
 getintvec($70,oldint70h);
 setintvec($70,@inthand);
 installtimer_;
end;

procedure deinstalltimer;
begin
 setintvec($70,oldint70h);
 deinstalltimer_;
end;

{$F+}
procedure myexit;
begin
 deinstalltimer;
 exitproc:=exitsave;
end;
{$F-}

procedure morfpalette(oldpal,newpal: pointer;count:longint);
begin
 maxpalettecounter:=count;
 oldpalette:=oldpal;
 newpalette:=newpal;
 setpalette(oldpal);
 palettecounter:=maxpalettecounter;
end;


{$ENDIF}

procedure getpalette(pal:pointer); assembler;
asm
 mov ax,1017h
 xor bx,bx
 les dx,pal
 mov cx,256
 int 10h
end;


{$IFDEF DPMI}
function timercounter: longint;
begin
 timercounter:=longint(ptr(seg0040,$6c)^)*57;
end;
{$ENDIF}


begin
{$IFNDEF DPMI}
 palettecounter:=0;
 maxpalettecounter:=3000;
 exitsave:=exitproc;
 exitproc:=@myexit;
 installtimer;
 timercounter:=0;
{$ENDIF}
end.