;Copyright by AX
;Procedures for Protected Mode
;======================================================================

		public	texturemap_flat
		public	texturemap_flat4
		public	texturemap_flat5
		public	texturemap
		public	initzbuf_prot
		public	copytoscreen_prot
		public	clearscreen_prot
		public	texturemap_guro
		public	texturemap_guro4
		public	texturemap_guro5

		version m520
		locals

code		segment byte public
		assume	cs:code,ds:data
.386

;======================================================================
; MACRO BMP_LINE
; p 맮   gs=csalias
;======================================================================
bmp_line	macro	lab,d_z1,d_z2,d_x1,d_x2,bmp_x1,bmp_x2

d_y1		=	word ptr d_x1+2
d_y2		=	word ptr d_x2+2
bmp_y1		=	byte ptr bmp_x1+1
bmp_y2		=	byte ptr bmp_x2+1

		mov	cx,d_y2
		mov	di,d_y1
		sub	cx,di
		mov	ax,4747h
		jns	bmpl_&lab
		neg	cx
		mov	ax,4f4fh
bmpl_&lab:
		mov	word ptr gs:[bmpl4_&lab-2],ax
		jnz	bmpl11_&lab
		jmp	bmpl10_&lab
bmpl11_&lab:
		movzx	ecx,cx
;ebp - x
;di - y*2
;esi - z
;ecx - count
;bx - bmpy
;dx - bmpx

		mov	ax,d_x2
		mov	bp,d_x1
		sub	ax,bp
		shl	eax,16
		shl	ebp,16
		cdq
		idiv	ecx
		mov	dword ptr gs:[bmpl5_&lab-4],eax

                mov     ax,d_z2
		mov	si,d_z1
		sub	ax,si
		shl	eax,16
		shl	esi,16
		cdq
		idiv	ecx
		mov	dword ptr gs:[bmpl6_&lab-4],eax

		movzx	eax,bmp_y2
		movzx	ebx,bmp_y1
		xchg	ah,al
		xchg	bh,bl
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr gs:[bmpl8_&lab-2],ax

		movzx	eax,bmp_x2
		movzx	edx,bmp_x1
		xchg	ah,al
		xchg	dh,dl
		sub	eax,edx
		cdq
		idiv	ecx
		mov	word ptr gs:[bmpl7_&lab-2],ax
		mov	dh,bmp_x1
		xor	dl,dl

		shl	di,1
		inc	cx
;===================== cycle ================
bmpl9_&lab:

;=== left edge ===
		shld	eax,ebp,16
		cmp	ax,s_leftx[di]
		jnl	bmpl2_&lab

		mov	s_leftx[di],ax

		shld	eax,esi,16
		mov	s_leftz[di],ax

		mov	al,dh
		mov	ah,bh
		mov	s_left_bmpxy[di],ax

		shld	eax,ebp,16
bmpl2_&lab:

;=== right edge ===
		cmp	ax,s_rightx[di]
		jng	bmpl3_&lab

		mov	s_rightx[di],ax

		shld	eax,esi,16
		mov	s_rightz[di],ax

		mov	al,dh
		mov	ah,bh
		mov	s_right_bmpxy[di],ax

bmpl3_&lab:
		inc	di
		inc	di
bmpl4_&lab:
		add	ebp,12345678h
bmpl5_&lab:
		add	esi,12345678h
bmpl6_&lab:
		add	dx,1234h
bmpl7_&lab:
		add	bx,1234h
bmpl8_&lab:
		dec	cx
		jne	bmpl9_&lab
bmpl10_&lab:

ENDM
;======================================================================

;======================================================================
; MACRO BMP_LINE_GURO
; p 맮   gs=csalias
;======================================================================
bmp_line_guro	macro	d_z1,d_z2,d_x1,d_x2,bmp_x1,bmp_x2,d_c1,d_c2
		local	@@bmplg1,@@bmplg2,@@bmplg3,@@bmplg4,@@bmplg5,
		local	@@bmplg6,@@bmplg7,@@bmplg8,@@bmplg9,@@bmplg10
		local	@@bmplg11
		local	@@bmplg_eaxd,@@bmplg_edxd

d_y1		=	word ptr d_x1+2
d_y2		=	word ptr d_x2+2
bmp_y1		=	byte ptr bmp_x1+1
bmp_y2		=	byte ptr bmp_x2+1

		mov	cx,d_y2
		mov	di,d_y1
		sub	cx,di
		mov	ax,4747h
		jns	@@bmplg1
		neg	cx
		mov	ax,4f4fh
@@bmplg1:
		mov	word ptr gs:[@@bmplg2-2],ax
		jnz	@@bmplg3
		jmp	@@bmplg4
@@bmplg3:

		movzx	ecx,cx

		mov	ax,d_x2
		mov	bp,d_x1
		mov	word ptr gs:[@@bmplg_eaxd-4],bp
		sub	ax,bp
		shl	eax,16
		cdq
		idiv	ecx
		mov	word ptr gs:[@@bmplg6-2],ax
		shld	ebp,eax,16
		mov	bx,bp

                mov     ax,d_z2
		mov	si,d_z1
		mov	word ptr gs:[@@bmplg_edxd-4],si
		sub	ax,si
		shl	eax,16
		cdq
		idiv	ecx
		rol	ebp,16
		bt	bx,15
		sbb	ax,0
		mov	bp,ax
		rol	ebp,16
		shr	eax,16
		mov	word ptr gs:[@@bmplg7-4],ax

		movzx	eax,bmp_y2
		movzx	edx,bmp_y1
		xchg	ah,al
		xchg	dh,dl
		shrd	ebx,edx,16
		sub	eax,edx
		cdq
		idiv	ecx
		shrd	esi,eax,16

		movzx	eax,byte ptr bmp_x2
		movzx	edx,byte ptr bmp_x1
		xchg	ah,al
		xchg	dh,dl
		mov	bx,dx
		sub	eax,edx
		cdq
		idiv	ecx
		mov	si,ax
                or      ax,ax
		jns	@@bmplg10
                sub     esi,00010000h
@@bmplg10:

                movzx   eax,word ptr d_c2
		movzx	edx,word ptr d_c1
		mov	word ptr gs:[@@bmplg_edxd-2],dx
		sub	eax,edx
		cdq
		idiv	ecx
		cmp	word ptr gs:[@@bmplg7-4],0
		jns	@@bmplg11
		dec	ax
@@bmplg11:
		mov	word ptr gs:[@@bmplg7-2],ax


		shl	di,1
		add	ecx,80000001h
		add	ebx,00800080h


		add	ecx,80000000h

		mov	eax,80005678h
@@bmplg_eaxd:
		mov	edx,12805678h
@@bmplg_edxd:

;EAX - ZLO  | X
;EBX - Y256 | X256
;ECX - XLO  | count
;EDX - COL256 | Z
;ESI - Y256ad | X256ad
;EBP - ZLOADD | XADD
;l6: XloAdd | 0000
;l7 COL256A | ZADD

;===================== cycle ================
@@bmplg5:

;=== left edge ===
		cmp	s_leftx[di],ax
		jl	@@bmplg8

		mov	s_leftx[di],ax
		mov	s_leftz[di],dx
		mov	byte ptr s_left_bmpxy[di],bh
		rol	ebx,16
		mov	byte ptr s_left_bmpxy[di+1],bh
		rol	ebx,16
		rol	edx,16
		mov	word ptr s_leftc[di],dx
		rol	edx,16
@@bmplg8:

;=== right edge ===
		cmp	s_rightx[di],ax
		jg	@@bmplg9

                mov     s_rightx[di],ax
		mov	s_rightz[di],dx
		mov	byte ptr s_right_bmpxy[di],bh
		rol	ebx,16
		mov	byte ptr s_right_bmpxy[di+1],bh
		rol	ebx,16
		rol	edx,16
		mov	word ptr s_rightc[di],dx
		rol	edx,16
@@bmplg9:
		inc	di
		inc	di
@@bmplg2:
		add	ecx,12340000h
@@bmplg6:
		adc	eax,ebp
		adc	edx,12345678h
@@bmplg7:
		add	ebx,esi

		loop	@@bmplg5
@@bmplg4:

ENDM
;======================================================================

;======================================================================
;MACRO TEXTUREMAP_GURO_BODY
;======================================================================
texturemap_guro_body	macro
		local	@@tml2a,@@tml9a,@@tml11,@@tml2b
		local	@@tml_eaxd,@@tmp_ebxd,@@tml_ecxd,@@tml_edxd,@@tml_esid
		local	@@tml_a,@@tml_b,@@tml_c,@@tml_d,@endy
		local	@@tml2,@@tml12,@@tml9,@@tml2d,@@tml10

		shl	di,1
		mov	cury,di
		shl	ax,1
		mov	word ptr gs:[@@endy-2],ax

		mov	fs,s_bmpseg
		mov	gs,csalias

		mov	ax,di
		mov	bx,s_zbuf1seg
		mov	cx,s_scrbuf1seg

		cmp	ax,200	;y>100?
		jc	@@tml2a

                sub     ax,200
		mov	bx,s_zbuf2seg
		mov	cx,s_scrbuf2seg
@@tml2a:
		shl	ax,5
		mov	si,ax
		shl	ax,2
		add	si,ax

		mov	word ptr gs:[@@tml2b-2],si
		mov	scrseg_d,bx
		mov	es,cx
		jmp	@@tml11

@@tml9a:
		jmp	@@tml9
;============== y cycle ===========
@@tml11:
		mov	bp,s_rightx[di]
		mov	si,s_leftx[di]
		sub	bp,si
		js	@@tml9a

                inc     bp

		movzx	ebp,bp

                movzx   eax,word ptr s_rightc[di]
                movzx   ebx,word ptr s_leftc[di]
                mov     byte ptr gs:[@@tml_edxd-3],bh
                mov     byte ptr gs:[@@tml_ebxd-1],bl
                sub     eax,ebx
                shl     eax,8
                cdq
                idiv    ebp
                mov     word ptr gs:[@@tml_esid-2],ax
                shr     eax,16
                mov     byte ptr gs:[@@tml_b-1],al

                movzx   ax,byte ptr s_right_bmpxy[di]
                movzx   bx,byte ptr s_left_bmpxy[di]
		mov	byte ptr gs:[@@tml_ebxd-4],bl
                sub     ax,bx
		shl	eax,16
                cdq
                idiv    ebp
		mov	word ptr gs:[@@tml_a-2],ax
		shr	eax,16
		mov	byte ptr gs:[@@tml_esid-4],al

		movzx	eax,byte ptr s_right_bmpxy[di+1]
		movzx	ebx,byte ptr s_left_bmpxy[di+1]
		mov	byte ptr gs:[@@tml_ecxd-3],bl
		xchg	ah,al
		xchg	bh,bl
		sub	eax,ebx
		cdq
		idiv	ebp
		mov	cx,ax
		mov	word ptr gs:[@@tml_c-4],ax

		mov	ax,s_rightz[di]
		mov	bx,s_leftz[di]
		mov	word ptr gs:[@@tml_eaxd-4],bx
		sub	ax,bx
		shl	eax,16
		cdq
		idiv	ebp

;  zloadd ⭮⥫쭮 y256add
		bt	cx,15
		sbb	ax,0

		mov	word ptr gs:[@@tml_c-2],ax
		shr	eax,16

		mov	word ptr gs:[@@tml_d-2],ax

;                inc     bp

		xor	edi,edi
		lea	di,[si+1234h]
@@tml2b:

		mov	eax,7fff5678h
@@tml_eaxd:
		mov	ebx,12000012h
@@tml_ebxd:
		mov	ecx,7fff127fh
@@tml_ecxd:
		mov	edx,00001200h
@@tml_edxd:
		mov	esi,12340012h
@@tml_esid:

		mov	ds,scrseg_d

;es - itable+scrbuf
;ds - zbuf
;fs - bitmap
;gs - csalias
;eax - xlo  |  z
;ebx - clo  |  0 x
;ecx - zlo  | y256
;edx - 00   |  c 0
;esi - cload| 0 xadd
;edi - scrpointer
;bp  - counter
;a - xloadd : 0000
;b - cadd
;c - zloadd: y256add
;d - zadd
;=================== x cycle  ================
@@tml2:
		cmp	[edi*2],ax
                jl      @@tml12

		mov	bh,ch
		mov	[edi*2],ax
                mov     dl,fs:[bx]
                mov     dl,es:[edx]

;                mov     dl,dh

;                mov     dl,ah
;                bt      ax,7
;                rcl     dl,1
;                bt      ax,6
;                rcl     dl,1
;                bt      ax,5
;                rcl     dl,1
;                bt      ax,4
;                rcl     dl,1
;                bt      ax,3
;                rcl     dl,1

		mov	es:[di+16384],dl

@@tml12:
		add	eax,12340000h
@@tml_a:
		adc	ebx,esi
		adc	dh,12h
@@tml_b:
		add	ecx,12345678h
@@tml_c:
		adc	ax,1234h
@@tml_d:
		inc	di
		dec	bp
		jne	@@tml2

;=============================================
		mov	ax,seg data
		mov	ds,ax
@@tml9:
		mov	di,cury

		cmp	di,1234h
@@endy:
		je	@@tml10

                inc     di
		inc	di

                cmp     di,200
		jne	@@tml2d
		mov	es,s_scrbuf2seg
		mov	ax,s_zbuf2seg
		mov	scrseg_d,ax
		sub	word ptr gs:[@@tml2b-2],320*100

@@tml2d:
		add	word ptr gs:[@@tml2b-2],320

		mov	cury,di
		jmp	@@tml11
@@tml10:
		pop	bp
		ret
ENDM

;======================================================================
;MACRO TEXTUREMAP_CHECK_Y s_poly2d_ofs
;======================================================================
texturemap_check_y	macro	s_poly2d_ofs
		local	@@tml3,@@tml4

                mov     si,word ptr s_poly2d_ofs
		cmp	si,ax
		jc	@@tml3
		mov	ax,si
@@tml3:
		cmp	si,di
		ja	@@tml4
		mov	di,si
@@tml4:
ENDM

;======================================================================
;MACRO TEXTUREMAP_INIT
;======================================================================
texturemap_init macro

		push	bp
		mov	bp,sp

		mov	gs,csalias

;intitalize leftx&rightx

		mov	ax,ds
		mov	es,ax
		cld

		lea	di,s_leftx
		mov	eax,30003000h
		mov	cx,100
	rep	stosd

                lea     di,s_rightx
		mov	eax,-1
		mov	cx,100
	rep	stosd
ENDM

;======================================================================
;MACRO TEXTUREMAP_FLAT_BODY
;======================================================================
texturemap_flat_body	macro
		local	@@tml2a,@@tml9a,@@tml11,@@x256d,@@tml2b,@@tml2
		local	@@tml2c,@@tml1,@@bxadd,@@zaddlo,@@zaddhi
		local	@@tml9,@@endy,@@tml2d,@@tml10

                shl     di,1
		mov	cury,di
		shl	ax,1
		mov	word ptr gs:[@@endy-2],ax

                mov     al,byte ptr s_colors+1
		mov	byte ptr gs:[offset @@tml2c-1],al

		mov	fs,s_bmpseg
		mov	gs,csalias

		mov	ax,di
		mov	bx,s_zbuf1seg
		mov	cx,s_scrbuf1seg

		cmp	ax,200	;y>100?
		jc	@@tml2a

                sub     ax,200
		mov	bx,s_zbuf2seg
		mov	cx,s_scrbuf2seg
@@tml2a:
		shl	ax,5
		mov	si,ax
		shl	ax,2
		add	si,ax

		mov	word ptr gs:[@@tml2b-2],si
		mov	scrseg_d,cx
		mov	es,bx
		jmp	@@tml11

@@tml9a:
		jmp	@@tml9
;============== y cycle ===========
@@tml11:
		mov	cx,s_rightx[di]
		mov	si,s_leftx[di]
		sub	cx,si
		jng	@@tml9a

		movzx	ecx,cx

                movzx   eax,byte ptr s_right_bmpxy[di]
                movzx   ebx,byte ptr s_left_bmpxy[di]
                xchg    ah,al
                xchg    bh,bl
		mov	word ptr gs:[@@x256d-2],bx	;x256,bx
                sub     eax,ebx
                cdq
                idiv    ecx
		mov	word ptr gs:[@@bxadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di+1]
		movzx	ebx,byte ptr s_left_bmpxy[di+1]
		xchg	ah,al
		xchg	bh,bl
		mov	ebp,7fff0000h
		mov	bp,bx			;y256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr gs:[@@zaddlo-4],ax

		mov	ax,s_rightz[di]
		sub	ax,s_leftz[di]
		shl	eax,16
		cdq
		idiv	ecx
		mov	word ptr gs:[@@zaddlo-2],ax
		shr	eax,16
		mov	word ptr gs:[@@zaddhi-2],ax

		mov	ax,s_leftz[di]
		inc	cx
		mov	dx,1234h	;x256
@@x256d:

		add	si,1234h
@@tml2b:
		mov	di,si
		shl	di,1

		mov	ds,scrseg_d

                add     si,16384

;es:di - zbufptr
;ds:si - scrbuf+itbl
;fs - bitmap
;ax - z
;dx - x256
;ebp - z_lo:y256
;=================== x cycle  ================
@@tml2:
                scasw
                jnl     @@tml1

		mov	bx,bp			;byte ptr y256+1
		mov	bl,dh			;byte ptr x256+1
		mov	es:[di-2],ax		;no AGI
		mov	bl,fs:[bx]
		mov	bh,12h			;byte ptr s_colors+1
@@tml2c:
                mov     bl,[bx]
		mov	[si],bl
@@tml1:
		inc	si
		add	dx,1234h
@@bxadd:
		add	ebp,12345678h
@@zaddlo:
		adc	ax,1234h
@@zaddhi:
		dec	cx
		jne	@@tml2
;=============================================
		mov	ax,seg data
		mov	ds,ax
@@tml9:
		mov	di,cury

		cmp	di,1234h
@@endy:
		je	@@tml10

                inc     di
		inc	di

                cmp     di,200
		jne	@@tml2d
		mov	es,s_zbuf2seg
		mov	ax,s_scrbuf2seg
		mov	scrseg_d,ax
		sub	word ptr gs:[@@tml2b-2],320*100

@@tml2d:
		add	word ptr gs:[@@tml2b-2],320

		mov	cury,di
		jmp	@@tml11
@@tml10:
		pop	bp
		ret
ENDM

;======================================================================
;procedure texturemap_flat;
;⠫    ६
;s_poly3d,s_poly2d,s_polybmp,s_colors,s_scrbufXseg,s_zbufXseg,s_bmpseg
;======================================================================

texturemap_flat proc far

	TEXTUREMAP_INIT

;draw lines to buffer
	BMP_LINE d1pm,s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],\
           s_poly2d[4],s_polybmp[0],s_polybmp[2]
	BMP_LINE e1pm,s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],\
           s_poly2d[8],s_polybmp[2],s_polybmp[4]
	BMP_LINE f1pm,s_poly3d[12+2],s_poly3d[0+2],s_poly2d[8],\
           s_poly2d[0],s_polybmp[4],s_polybmp[0]

		mov	ax,s_poly2d[2]
		mov	di,ax

	TEXTUREMAP_CHECK_Y s_poly2d[4+2]
	TEXTUREMAP_CHECK_Y s_poly2d[8+2]

	TEXTUREMAP_FLAT_BODY

texturemap_flat endp

;======================================================================
;procedure texturemap_flat4;
;⠫    ६
;s_poly3d,s_poly2d,s_polybmp,s_colors,s_scrbufXseg,s_zbufXseg,s_bmpseg
;======================================================================

texturemap_flat4 proc far

		TEXTUREMAP_INIT

;draw lines to buffer
	BMP_LINE d1pm4,s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],\
          s_poly2d[4],s_polybmp[0],s_polybmp[2]
	BMP_LINE e1pm4,s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],\
          s_poly2d[8],s_polybmp[2],s_polybmp[4]
        BMP_LINE f1pm4,s_poly3d[12+2],s_poly3d[18+2],s_poly2d[8],\
          s_poly2d[12],s_polybmp[4],s_polybmp[6]
        BMP_LINE g1pm4,s_poly3d[18+2],s_poly3d[0+2],s_poly2d[12],\
          s_poly2d[0],s_polybmp[6],s_polybmp[0]

		mov	ax,s_poly2d[2]
		mov	di,ax

	TEXTUREMAP_CHECK_Y s_poly2d[4+2]
	TEXTUREMAP_CHECK_Y s_poly2d[8+2]
	TEXTUREMAP_CHECK_Y s_poly2d[12+2]

	TEXTUREMAP_FLAT_BODY

texturemap_flat4 endp

;======================================================================
;procedure texturemap_flat5;
;⠫    ६
;s_poly3d,s_poly2d,s_polybmp,s_colors,s_scrbufXseg,s_zbufXseg,s_bmpseg
;======================================================================

texturemap_flat5 proc far

		TEXTUREMAP_INIT

;draw lines to buffer
	BMP_LINE d1pmb,s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],\
          s_poly2d[4],s_polybmp[0],s_polybmp[2]
	BMP_LINE e1pmb,s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],\
          s_poly2d[8],s_polybmp[2],s_polybmp[4]
        BMP_LINE f1pmb,s_poly3d[12+2],s_poly3d[18+2],s_poly2d[8],\
          s_poly2d[12],s_polybmp[4],s_polybmp[6]
        BMP_LINE g1pmb,s_poly3d[18+2],s_poly3d[24+2],s_poly2d[12],\
          s_poly2d[16],s_polybmp[6],s_polybmp[8]
        BMP_LINE h1pmb,s_poly3d[24+2],s_poly3d[0+2],s_poly2d[16],\
           s_poly2d[0],s_polybmp[8],s_polybmp[0]

		mov	ax,s_poly2d[2]
		mov	di,ax

	TEXTUREMAP_CHECK_Y s_poly2d[4+2]
	TEXTUREMAP_CHECK_Y s_poly2d[8+2]
	TEXTUREMAP_CHECK_Y s_poly2d[12+2]
	TEXTUREMAP_CHECK_Y s_poly2d[16+2]

		TEXTUREMAP_FLAT_BODY

texturemap_flat5 endp


;======================================================================
;procedure texturemap;
;⠫    ६
;s_poly3d,s_poly2d,s_polybmp,s_colors,s_scrbufXseg,s_zbufXseg,s_bmpseg
;======================================================================

texturemap      proc far

	TEXTUREMAP_INIT

;draw lines to buffer
	BMP_LINE d1pmu,s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],\
          s_poly2d[4],s_polybmp[0],s_polybmp[2]
	BMP_LINE e1pmu,s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],\
          s_poly2d[8],s_polybmp[2],s_polybmp[4]
        BMP_LINE f1pmu,s_poly3d[12+2],s_poly3d[0+2],s_poly2d[8],\
          s_poly2d[0],s_polybmp[4],s_polybmp[0]

		mov	ax,s_poly2d[2]
		mov	di,ax

	TEXTUREMAP_CHECK_Y s_poly2d[4+2]
	TEXTUREMAP_CHECK_Y s_poly2d[8+2]

                shl     di,1
		mov	cury,di
		shl	ax,1
		mov	word ptr gs:[@@endy-2],ax

		mov	fs,s_bmpseg
		mov	gs,csalias
		jmp	@@tml11

@@tml9a:
		jmp	@@tml9
;============== y cycle ===========
@@tml11:
		mov	cx,s_rightx[di]
		mov	si,s_leftx[di]
		sub	cx,si
		jng	@@tml9a

		movzx	ecx,cx

                movzx   eax,byte ptr s_right_bmpxy[di]
                movzx   ebx,byte ptr s_left_bmpxy[di]
                xchg    ah,al
                xchg    bh,bl
		mov	word ptr gs:[@@x256d-2],bx	;x256,bx
                sub     eax,ebx
                cdq
                idiv    ecx
		mov	word ptr gs:[@@bxadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di+1]
		movzx	ebx,byte ptr s_left_bmpxy[di+1]
		xchg	ah,al
		xchg	bh,bl
		mov	ebp,7fff0000h
		mov	bp,bx			;y256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr gs:[@@zaddlo-4],ax

		mov	ax,s_rightz[di]
		sub	ax,s_leftz[di]
		shl	eax,16
		cdq
		idiv	ecx
		mov	word ptr gs:[@@zaddlo-2],ax
		shr	eax,16
		mov	word ptr gs:[@@zaddhi-2],ax

		mov	ax,s_leftz[di]
		inc	cx
		mov	dx,1234h	;x256
@@x256d:

;si=y*320 + x = di*160+si
;di=y*640 + x*2 = si*2 ,CF to ES

		cmp	di,200	;y>100?
		jae	@@tml2a

		shl	di,5
		add	si,di
		shl	di,2
		add	si,di

                mov     di,si
		shl	di,1
                mov     es,s_zbuf1seg
		mov	ds,s_scrbuf1seg
		jmp	@@tml2b
@@tml2a:
;=== y>=100
		sub	di,200
		shl	di,5
		add	si,di
		shl	di,2
		add	si,di

                mov     di,si
		shl	di,1
                mov     es,s_zbuf2seg
		mov	ds,s_scrbuf2seg
@@tml2b:
		add	si,16384

;es:di - zbufptr
;ds:si - scrbuf+itbl
;fs - bitmap
;ax - z
;dx - x256
;ebp - z_lo:y256
;=================== x cycle  ================
@@tml2:
                scasw
                jnl     @@tml1

		mov	bx,bp			;byte ptr y256+1
		mov	bl,dh			;byte ptr x256+1
		mov	es:[di-2],ax
		mov	bl,fs:[bx]
;                mov     bh,12h                  ;byte ptr s_colors+1
;@@tml2c:
;                mov     bl,[bx]
		mov	[si],bl
@@tml1:
		inc	si
		add	dx,1234h
@@bxadd:
		add	ebp,12345678h
@@zaddlo:
		adc	ax,1234h
@@zaddhi:
		dec	cx
		jne	@@tml2
;=============================================
		mov	ax,seg data
		mov	ds,ax
@@tml9:
		mov	di,cury
		cmp	di,1234h
@@endy:
		je	@@tml10

                inc     di
		inc	di
		mov	cury,di
		jmp	@@tml11
@@tml10:
		pop	bp
		ret
texturemap      endp

;==============================================
;procedure initzbuf_prot;
;  s_zbuf1seg,s_zbuf2seg;
;==============================================
initzbuf_prot	proc	far
		cld
		mov	cx,16000
		mov	eax,7fff7fffh
		mov	es,s_zbuf1seg
		xor	di,di
		rep	stosd
		mov	es,s_zbuf2seg
		mov	cx,16000
		xor	di,di
		rep	stosd
		ret
initzbuf_prot	endp

;==============================================
;Procedure copytoscreen_prot;
;  s_scrbuf1seg,s_scrbuf2seg
;==============================================
copytoscreen_prot	proc	far
		mov	ax,sega000
		mov	es,ax
		cld
		mov	cx,8000
		xor	di,di
		mov	si,16384
		mov	bx,s_scrbuf2seg
		mov	ds,s_scrbuf1seg
		rep	movsd
		mov	ds,bx
		mov	cx,8000
		mov	si,16384
		rep	movsd
		mov	ax,seg data
		mov	ds,ax
		ret
copytoscreen_prot	endp

;==============================================
;Procedure clearscreen_prot;
;  s_scrbuf1seg,s_scrbuf2seg
;==============================================
clearscreen_prot	proc	far
		cld
		xor	eax,eax
		mov	cx,8000
		mov	di,16384
		mov	es,s_scrbuf1seg
		rep	stosd
		mov	es,s_scrbuf2seg
		mov	cx,8000
		mov	di,16384
		rep	stosd
		ret
clearscreen_prot	endp

;======================================================================
;procedure texturemap_guro;
;⠫    ६
;s_poly3d,s_poly2d,s_polybmp,s_colors,s_scrbufXseg,s_zbufXseg,s_bmpseg
;======================================================================

texturemap_guro proc far

		TEXTUREMAP_INIT

;draw lines to buffer
	BMP_LINE_GURO s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],\
          s_poly2d[4],s_polybmp[0],s_polybmp[2],s_colors[0],s_colors[2]
	BMP_LINE_GURO s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],\
          s_poly2d[8],s_polybmp[2],s_polybmp[4],s_colors[2],s_colors[4]
        BMP_LINE_GURO s_poly3d[12+2],s_poly3d[0+2],s_poly2d[8],\
          s_poly2d[0],s_polybmp[4],s_polybmp[0],s_colors[4],s_colors[0]

		mov	ax,s_poly2d[2]
		mov	di,ax

		TEXTUREMAP_CHECK_Y s_poly2d[4+2]
		TEXTUREMAP_CHECK_Y s_poly2d[8+2]

		TEXTUREMAP_GURO_BODY

texturemap_guro endp

;======================================================================
;procedure texturemap_guro4;
;⠫    ६
;s_poly3d,s_poly2d,s_polybmp,s_colors,s_scrbufXseg,s_zbufXseg,s_bmpseg
;======================================================================

texturemap_guro4 proc far

		TEXTUREMAP_INIT

;draw lines to buffer
        BMP_LINE_GURO s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],\
          s_poly2d[4],s_polybmp[0],s_polybmp[2],s_colors[0],s_colors[2]
        BMP_LINE_GURO s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],\
          s_poly2d[8],s_polybmp[2],s_polybmp[4],s_colors[2],s_colors[4]
        BMP_LINE_GURO s_poly3d[12+2],s_poly3d[18+2],s_poly2d[8],\
          s_poly2d[12],s_polybmp[4],s_polybmp[6],s_colors[4],s_colors[6]
        BMP_LINE_GURO s_poly3d[18+2],s_poly3d[0+2],s_poly2d[12],\
          s_poly2d[0],s_polybmp[6],s_polybmp[0],s_colors[6],s_colors[0]

		mov	ax,s_poly2d[2]
		mov	di,ax

		TEXTUREMAP_CHECK_Y s_poly2d[4+2]
		TEXTUREMAP_CHECK_Y s_poly2d[8+2]
		TEXTUREMAP_CHECK_Y s_poly2d[12+2]

		TEXTUREMAP_GURO_BODY

texturemap_guro4 endp

;======================================================================
;procedure texturemap_guro5;
;⠫    ६
;s_poly3d,s_poly2d,s_polybmp,s_colors,s_scrbufXseg,s_zbufXseg,s_bmpseg
;======================================================================

texturemap_guro5 proc far
		push	bp
		mov	bp,sp

		mov	gs,csalias

;intitalize leftx&rightx

		mov	ax,ds
		mov	es,ax
		cld

		lea	di,s_leftx
		mov	eax,30003000h
		mov	cx,100
	rep	stosd

                lea     di,s_rightx
		mov	eax,-1
		mov	cx,100
	rep	stosd

;draw lines to buffer
	BMP_LINE_GURO s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],s_poly2d[4],s_polybmp[0],s_polybmp[2],s_colors[0],s_colors[2]
	BMP_LINE_GURO s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],s_poly2d[8],s_polybmp[2],s_polybmp[4],s_colors[2],s_colors[4]
        BMP_LINE_GURO s_poly3d[12+2],s_poly3d[18+2],s_poly2d[8],s_poly2d[12],s_polybmp[4],s_polybmp[6],s_colors[4],s_colors[6]
        BMP_LINE_GURO s_poly3d[18+2],s_poly3d[24+2],s_poly2d[12],s_poly2d[16],s_polybmp[6],s_polybmp[8],s_colors[6],s_colors[8]
        BMP_LINE_GURO s_poly3d[24+2],s_poly3d[0+2],s_poly2d[16],s_poly2d[0],s_polybmp[8],s_polybmp[0],s_colors[8],s_colors[0]

		mov	ax,s_poly2d[2]
		mov	di,ax

		TEXTUREMAP_CHECK_Y s_poly2d[4+2]
		TEXTUREMAP_CHECK_Y s_poly2d[8+2]
		TEXTUREMAP_CHECK_Y s_poly2d[12+2]
		TEXTUREMAP_CHECK_Y s_poly2d[16+2]

                TEXTUREMAP_GURO_BODY

texturemap_guro5 endp

.286
code		ends

data		segment word public

		extrn	sega000:word
		extrn	csalias:word
		extrn	selectorinc:word

		extrn	s_poly2d:word
		extrn	s_poly3d:word
		extrn	s_polybmp:byte
		extrn	s_colors: word

		extrn	s_leftx:word
		extrn	s_rightx:word

		extrn	s_leftz:word
		extrn	s_rightz:word

                extrn   s_leftc:word
		extrn	s_rightc:word

		extrn	s_left_bmpxy:word

		extrn	s_right_bmpxy:word

		extrn	s_scrbuf1seg:word
		extrn	s_scrbuf2seg:word
		extrn	s_zbuf1seg:word
		extrn	s_zbuf2seg:word
		extrn	s_bmpseg:word

x256		dw	0
y256		dw	0
cury		dw	0
dcolor		dw	0
d_bmpseg	dw	0
scrseg_d	dw	0

data            ends
		end