unit titres;

interface

procedure run_titres;

implementation

uses winapi,mytimer,palete,mode256,mycrt;

type laga = record
             ofs,seg:word
            end;
var
 f: file;
 titpic: pointer;
 textsz:longint;
 textp: longint;
 textl: word;
 i: word;
 l: longint;
 page : boolean;
 p: pointer;
 c:integer;
 tfreq: real;
 t:longint;
 expect_p: longint;
 palette : array [1..768] of byte;
 palette1 : array [1..768] of byte;
 r:real;
 nmemblks:word;
 memblk: array [1..20] of pointer;
 textseg:word;
 curmemblk: word;

procedure copytoscreen(p:pointer;ofss:word); assembler;
asm
 mov dx,3ceh
 mov ax,0ff08h
 out dx,ax
 mov ax,0005h
 out dx,ax
 mov dx,3c4h
 mov ax,0ff02h
 out dx,ax
 push ds
 mov cx,7000
 mov ax,sega000
 mov es,ax
 mov di,ofss
 lds si,p
 cld
 db 66h
 rep movsw
 pop ds
end;

procedure setvisualpage(ofss:word);assembler;
asm
 mov dx,3dah
 mov ah,8
 @l1:
 in al,dx
 test al,ah
 jne @l1

 mov dx,3d4h
 mov al,12
 mov ah,byte ptr ofss+1
 out dx,ax
 inc al
 mov ah,byte ptr ofss
 out dx,ax

 mov dx,3dah
 mov ah,8
 @l2:
 in al,dx
 test al,ah
 je @l2
end;

procedure waitvertsync; assembler;
asm
 mov dx,3dah
 mov ah,8
 @l1:
 in al,dx
 test al,ah
 jne @l1
 @l2:
 in al,dx
 test al,ah
 je @l2
end;

procedure drawline(scrofs: word; textseg,textofs:word);assembler;
asm
 mov dx,3ceh
 mov ax,0005h
 out dx,ax
 mov dx,3c4h
 mov ax,0ff02h
 out dx,ax

 push ds
 mov di,scrofs
 mov es,textseg
 mov si,textofs
 mov cx,50

 mov ax,sega000
 mov ds,ax

 mov dx,3ceh
 mov al,8
 mov bx,00ffh

 @l1:
 xor ah,ah
 out dx,ax
 mov ah,[di]
 mov byte ptr [di],bh

 mov ah,es:[si]

 out dx,ax
 mov byte ptr [di],bl
 inc si
 inc di
 dec cx
 jne @l1

 pop ds
end;

procedure scrool(ofs1,ofs2:word); assembler;
asm
 mov dx,3ceh
 mov ax,0ff08h
 out dx,ax
 mov ax,0105h
 out dx,ax
 mov dx,3c4h
 mov ax,0ff02h
 out dx,ax

 add ofs1,80+15+67*80
 add ofs2,15+67*80
 mov dx,349-67

 push ds
 mov ax,sega000
 mov ds,ax
 mov es,ax

 cld

 @l1:
 mov si,ofs1
 mov di,ofs2
 mov cx,50
 rep movsb
 add ofs1,80
 add ofs2,80
 dec dx
 jne @l1

 pop ds

 mov dx,3ceh
 mov ax,0005h
 out dx,ax
end;

procedure run_titres;
label l1,l2,l2a;

begin
 assign(f,'titres.bin'); reset(f,1);
 titpic:=globalallocptr(gmem_moveable,28000+300);
 blockread(f,titpic^,28000);
 close(f);

 smartsetmode($10);

 tfreq:=msperinc/65536;

 getpalette(@palette);
 fillchar(palette1,768,0);
 setpalette(@palette1);

 copytoscreen(titpic,28000);
 copytoscreen(titpic,0);
 globalfreeptr(titpic);

 assign(f,'titrtext.bin'); reset(f,1);
 textsz:=filesize(f);
 nmemblks:=1;
 repeat
  memblk[nmemblks]:=globalallocptr(gmem_moveable,28000+300);
  fillchar(memblk[nmemblks]^,28000+200,0);
  blockread(f,memblk[nmemblks]^,28000,c);
  inc(nmemblks);
 until c<28000;
 close(f);

 t:=bigcounter;
 r:=0;

 while r<255 do
  begin
   fadepalette(@palette,@palette1,round(r));
   waitvertsync;
   setpalette(@palette1);
   r:=(bigcounter-t)/tfreq*120;
  end;

 setpalette(@palette);
 textp:=0;
 page:=false;
 curmemblk:=1;
 textseg:=laga(memblk[1]).seg;

 t:=bigcounter;

 while textsz>0 do
   begin
    scrool(0,28000);
    drawline(15+348*80+28000,textseg,textp);

{    l2:
    expect_p:=round((bigcounter-t)/tfreq*70*19);
    if textp>expect_p then goto l2;}

{    waitvertsync;}
    setvisualpage(28000);

    inc(textp,50);
    dec(textsz,50);
    if textp>=28000 then
      begin
       textp:=0;
       inc(curmemblk);
       textseg:=laga(memblk[curmemblk]).seg;
      end;

    scrool(28000,0);
    drawline(15+348*80,textseg,textp);

    {l2a:
    expect_p:=round((bigcounter-t)/tfreq*70*19);
    if textp>expect_p then goto l2a;}

{    waitvertsync;}
    setvisualpage(0);

    inc(textp,50);
    dec(textsz,50);
    if textp>=28000 then
      begin
       textp:=0;
       inc(curmemblk);
       textseg:=laga(memblk[curmemblk]).seg;
      end;

    if keypressed then goto l1;
   end;

 l1:

 clearkeyb;
 for i:=1 to nmemblks do globalfreeptr(memblk[i]);

end;

begin
end.