unit crosfire;

interface

function run_crosfire:byte;

implementation

uses loadpcx,palete,mytimer,mode256,mycrt;
type
 laga= record
  ofs,seg: word;
 end;

 const
  rnddata: longint= $0;

var
 buf1p,buf2p: pointer;
 buf1,buf2: word;
 i,x,y: integer;
 palette : array [0..767] of byte;
 palette1 : array [0..767] of byte;
 f:file;
 coordbuf:pointer;
 buf:pointer;
 bufseg:word;
 npoi:word;
 t,t1:longint;
 re,vfreq:real;

{$F+}
procedure fire_toscreen(i,x,y,sx,sy,firebuf,picbuf,scrbuf:word); external;
{$F-}
{$L crosfire}

procedure fire(buf1,buf2,ofss,sizex,sizey:word); assembler;
asm
 mov es,buf2
 mov ds,buf1
 mov di,ofss
 inc di

 mov dx,sizey
 @l2:
 mov cx,sizex
 push di
 @l1:
 xor ax,ax
 mov al,[di]
 add al,[di+320]
 adc ah,dh
 add al,[di+320-1]
 adc ah,dh
 add al,[di+640]
 adc ah,dh

 shr ax,2
 sub al,4
{ jnc @l3
 xor al,al
 @l3:}
 rcl ah,3
 add al,ah
 stosb
 dec cx
 jne @l1
 pop di
 add di,320
 dec dx
 jne @l2
 mov ax,seg palette
 mov ds,ax
end;

function run_crosfire:byte;
label l1,l2;
begin
 run_crosfire:=1;
 vfreq:=msperinc/65536;

 smartsetmode($13);

 getmem(buf,64000+16);
 bufseg:=laga(buf).seg;
 loadpcx_raw_pal('crosfire.pcx',ptr(bufseg,0),@palette1);

 asm
  mov es,bufseg
  xor di,di
  mov cx,64000
  mov al,80h
  @@l1:
  add es:[di],al
  inc di
  dec cx
  jne @@l1
end;

 move(palette1[0],palette[128*3],128*3);
 move(palette1[128*3],palette[0],128*3);
 fillchar(palette1,768,0);

 setpalette(@palette1);

 getmem(coordbuf,20000);
 t:=bigcounter;

 assign(f,'crosfire.fir');reset(f,1);
 npoi:=filesize(f) div 2;
 blockread(f,coordbuf^,npoi*2);
 close(f);

 getmem(buf1p,64016);
 getmem(buf2p,64016);
 buf1:=laga(buf1p).seg;
 buf2:=laga(buf2p).seg;

 fillchar(mem[buf1:0],64000,0);
 fillchar(mem[buf2:0],64000,0);
 move(mem[bufseg:0],mem[sega000:0],64000);

l1:
 t1:=bigcounter;

 fire(buf1,buf2,124+31*320,68,107);
{ fire(buf1,buf2,100+115*320,26,34);
 fire(buf1,buf2,210+122*320,26,34);
 fire(buf1,buf2,70+152*320,26,34);}

 fire_toscreen(7,124,31,68,107,buf2,bufseg,sega000);
{ fire_toscreen(7,100,115,26,34,buf2,bufseg,sega000);
 fire_toscreen(7,210,122,26,34,buf2,bufseg,sega000);
 fire_toscreen(7,70,152,26,34,buf2,bufseg,sega000);}

 re:=(bigcounter-t)/vfreq*100;
 if re<255 then
   begin
    fadepalette(@palette,@palette1,round(re));
    waitvertsync;
    setpalette(@palette1);
   end;

 if re>700 then
   begin
    re:=re-700;
    if re>255 then
      begin
       run_crosfire:=0;
       goto l2;
      end;
    fadepalette(@palette,@palette1,round(255-re));
    waitvertsync;
    setpalette(@palette1);
   end;

{ for l:=0 to 64000 do
    if mem[buf2:l]>7 then mem[sega000:l]:=mem[buf2:l]
                    else mem[sega000:l]:=mem[bufseg:l];}

 i:=buf1;
 buf1:=buf2;
 buf2:=i;

 asm
  push bp
  push ds
  mov es,buf1
  mov si,word ptr rnddata
  mov di,word ptr rnddata+2
  mov cx,200
  mov bp,npoi

  mov ds,word ptr coordbuf+2

  @l1:
  MOV BX,di
  add bh,bl
  add bx,si
  inc si
  MOV di,bX

  mov ax,bx
  xor dx,dx
  div bp
  mov bx,dx

  shl bx,1
  mov bx,[bx]
  mov byte ptr es:[bx],130

  dec cx
  jne @l1
  pop ds
  pop bp
  mov word ptr rnddata,si
  mov word ptr rnddata+2,di
 end;

 while (bigcounter-t1)/vfreq<0.02 do waitvertsync;

 if not keypressed then goto l1;
 clearkeyb;
 l2:
 freemem(buf1p,64016);
 freemem(buf2p,64016);
 freemem(coordbuf,20000);
 freemem(buf,64016);
end;


begin
end.
