uses
  WinApi;
const
 readbufsize = 16384;
 minencount = 16;
 hextable:string = '0123456789ABCDEF';

var
  P: Pointer;
  readbuf: pointer;
  fsize,bufofs: longint;
  f:file;
  count: integer;
  encount:word;
  ofsadd: longint;
  ft:text;

{$F+}
 procedure encountrep; external;
 procedure movetobuf; external;
{$F-}
{$L findrep}

procedure SetSelectorLimit(Selector: Word; Limit: Longint); assembler;
asm
 MOV BX,Selector
 MOV DX,Limit.Word[0]
 MOV CX,Limit.Word[2]
 MOV AX,0008H
 INT 31H
end;

{procedure movetobuf; assembler;
asm
 push ds
 mov es,word ptr p+2
 db 66h
 mov di,word ptr bufofs
 db 66h
 xor cx,cx
 mov cx,count
 jcxz @l1
 db 66h
 xor si,si
 lds si,readbuf
 cld

 rep
 db 66h,67h
 movsb

 @l1:

 pop ds
end;
 }
procedure hex(var l :longint; dv: longint; var s:string);
begin
 s:=s+hextable[1+(l div dv)];
 l:=l mod dv;
end;

function longtohex(l:longint): string;
var
 s: string;
begin
 s:='';
 hex(l,longint(65536)*256*16,s);
 hex(l,longint(65536)*256,s);
 hex(l,longint(65536)*16,s);
 hex(l,longint(65536),s);
 hex(l,longint(256)*16,s);
 hex(l,256,s);
 hex(l,16,s);
 hex(l,1,s);
 longtohex:=s;
end;

label l1;
begin
  readbuf:=globalallocptr(gmem_fixed,readbufsize);
  assign(f,paramstr(1)); reset(f,1);
  fsize:=filesize(f);
  P := GlobalAllocPtr (GMem_Fixed, fsize);
  SetSelectorLimit (Seg (P^),fsize-1);

  writeln(longtohex(fsize));

  write('Loading file');
  bufofs:=0;
  repeat
   blockread(f,readbuf^,readbufsize,count);
   write('.');
   movetobuf;
   inc(bufofs,count);
  until eof(f);
  writeln;
  write('Searching');
  assign(ft,'find.rep'); rewrite(ft);

  for bufofs:=0 to fsize-1000 do
    begin
     ofsadd:=2;
     encountrep;
     if encount>0 then goto l1;
     ofsadd:=4;
     encountrep;
     if encount>0 then goto l1;
     for ofsadd:=32 downto 3 do
       begin
        encountrep;
        if encount>minencount then
          begin
           write(ft,longtohex(bufofs));
           write(ft,':        ');
           write(ft,longtohex(ofsadd));
           write(ft,' (');
           write(ft,encount);
           writeln(ft,')');
           inc(bufofs,encount*ofsadd);
           write('.');
           goto l1;
          end;
         end;
        l1:
       end;


  close(ft);
  close(f);
  globalfreeptr(p);
  globalfreeptr(readbuf);
end.
