uses crt,threed,dos,realtime,geomlib,gurofill,mode256;

type
 pointertype = record
                ofs,seg : word;
               end;
 zbufarrtype = array [0..99,0..319] of integer;
 laga    = record
              lo,hi: integer;
             end;
 vid3d    = array [1..650,1..4,1..3] of integer;

const
 maxnpoints = 2000;
 maxnpolys = maxnpoints div 4;

var
 observer : observertype;
 observer1: observertype;
 f        : file;
 poly3d   : array [1..maxnpolys,1..4,1..3] of integer;
 poly2d   : array [1..maxnpolys,1..4,1..2] of integer;
 vid3dp   : pointer;
 normals  : array [1..maxnpolys,1..3] of integer;
 normals_p : array [1..maxnpolys,1..4,1..3] of integer;
 normals_p1: array [1..maxnpolys,1..4,1..3] of integer;
 colors_p : array [1..maxnpolys,1..4] of word;
 i,x,y    : integer;
 bufseg   : word;
 zbufseg  : word;
 p        : pointer;
 npolys   : word;
 poly_3d  : array [1..4,1..3] of integer;
 oldt       : longint;

procedure fillpoly4_zbuf_y100_goro(poly3d,poly2d: pointer;
    color1,color2,color3,color4: byte;scrseg,zbufseg: word);

type
 scrarr = array [0..99,0..319] of byte;

var
 x,z_,c_     : integer;
 dz,itr,dc   : integer;
 z,zadd      : longint;
 c           : word;
 cadd        : integer;
 y,y1,y2     : word;
 y20,scrofs : word;
 y40,zbufofs: word;



label l1;
begin
move(poly3d^,s_poly3d,4*6);
move(poly2d^,s_poly2d,4*4);

if (s_poly2d[1,1]=maxint) or
   (s_poly2d[2,1]=maxint) or
   (s_poly2d[3,1]=maxint) or
   (s_poly2d[4,1]=maxint) then goto l1;

inc(s_poly2d[1,1],160);
inc(s_poly2d[2,1],160);
inc(s_poly2d[3,1],160);
inc(s_poly2d[4,1],160);

s_poly2d[1,2]:=50-s_poly2d[1,2] div 2;
s_poly2d[2,2]:=50-s_poly2d[2,2] div 2;
s_poly2d[3,2]:=50-s_poly2d[3,2] div 2;
s_poly2d[4,2]:=50-s_poly2d[4,2] div 2;

stosword(addr(s_leftx),320,100);
stosword(addr(s_rightx),$ffff,100);

bufline(s_poly2d[1,1],s_poly2d[1,2],s_poly3d[1,2],
           s_poly2d[2,1],s_poly2d[2,2],s_poly3d[2,2],color1,color2);
bufline(s_poly2d[2,1],s_poly2d[2,2],s_poly3d[2,2],
           s_poly2d[3,1],s_poly2d[3,2],s_poly3d[3,2],color2,color3);
bufline(s_poly2d[3,1],s_poly2d[3,2],s_poly3d[3,2],
           s_poly2d[4,1],s_poly2d[4,2],s_poly3d[4,2],color3,color4);
bufline(s_poly2d[4,1],s_poly2d[4,2],s_poly3d[4,2],
           s_poly2d[1,1],s_poly2d[1,2],s_poly3d[1,2],color4,color1);

y1:=s_poly2d[1,2];
if s_poly2d[2,2]<y1 then y1:=s_poly2d[2,2];
if s_poly2d[3,2]<y1 then y1:=s_poly2d[3,2];
if s_poly2d[4,2]<y1 then y1:=s_poly2d[4,2];

y2:=s_poly2d[1,2];
if s_poly2d[2,2]>y2 then y2:=s_poly2d[2,2];
if s_poly2d[3,2]>y2 then y2:=s_poly2d[3,2];
if s_poly2d[4,2]>y2 then y2:=s_poly2d[4,2];

{for y:=y1 to y2 do
  if s_leftx[y]<s_rightx[y] then
   begin
    dz:=s_rightz[y]-s_leftz[y];
    dc:=integer(s_rightc[y])-integer(s_leftc[y]);
    itr:=s_rightx[y]-s_leftx[y];
    z:=longint(s_leftz[y]) shl 16;
    c:=s_leftc[y];
    zadd:=longint(dz) shl 16 div itr;
    cadd:=dc div itr;

    for x:=s_leftx[y] to s_rightx[y] do
      begin
       z_:=laga(z).hi;
       c_:=hi(c);
       if (z_>0) and (z_<zbufarrtype(ptr(zbufseg,0)^)[y,x]) then
          begin
           scrarr(ptr(bufseg,0)^)[y,x]:=c_;
           zbufarrtype(ptr(zbufseg,0)^)[y,x]:=z_;
          end;
       inc(z,zadd);
       inc(c,cadd);
      end;

   end;}

 y20:=20*y1+bufseg;
 y40:=40*y1+zbufseg;

 for y:=y1 to y2 do
  if s_leftx[y]<s_rightx[y] then
   begin
    dz:=s_rightz[y]-s_leftz[y];
    dc:=integer(s_rightc[y])-integer(s_leftc[y]);
    itr:=s_rightx[y]-s_leftx[y];
    z:=longint(s_leftz[y]) shl 16;
    c:=s_leftc[y];
    zadd:=longint(dz) shl 16 div itr;
    cadd:=dc div itr;
    scrofs:=s_leftx[y];
    zbufofs:=s_leftx[y]*2;


    for x:=s_leftx[y] to s_rightx[y] do
      begin
       z_:=laga(z).hi;
       c_:=hi(c);
       if z_<integer(memw[y40:zbufofs]) then
          begin
           mem[y20:scrofs]:=c_;
           memw[y40:zbufofs]:=z_;
          end;
       inc(z,zadd);
       inc(c,cadd);
       inc(scrofs);
       inc(zbufofs,2);
      end;
  inc(y20,20);
  inc(y40,40);
 end;

l1:
end;

procedure calcnormal(norm: pointer);
type
 normalt = array [1..4] of integer;
var
 x1,y1,z1   : integer;
 x21,x31, y21,y31, z21,z31    : longint;
 a,b,c,h,m  : real;
 i,j : word;

begin
 x1:=poly_3d[1,1];
 y1:=poly_3d[1,2];
 z1:=poly_3d[1,3];

 x21:=poly_3d[2,1]-x1;
 y21:=poly_3d[2,2]-y1;
 z21:=poly_3d[2,3]-z1;

 x31:=poly_3d[3,1]-x1;
 y31:=poly_3d[3,2]-y1;
 z31:=poly_3d[3,3]-z1;

 a:= y21*z31 - y31*z21;
 b:= z21*x31 - x21*z31;
 c:= x21*y31 - x31*y21;
{ h:= x1*a + y1*b + z1*c;}

 m:=sqrt(sqr(a)+sqr(b)+sqr(c));
if m<>0 then
 begin
 a:=a*64/m;
 b:=b*64/m;
 c:=c*64/m;
end;
 normalt(norm^)[1]:=round(a);
 normalt(norm^)[2]:=round(b);
 normalt(norm^)[3]:=round(c);
{ normalt(norm^)[4]:=h;}

end;

procedure calcnormals(n:word; polys: pointer);
type
 polyst = array [1..1000,1..4,1..3] of integer;
var
 i: integer;
begin
 for i:=1 to n do
   begin
     move(addr(polyst(polys^)[i])^,addr(poly_3d)^,4*3*2);
     calcnormal(addr(normals[i]));
   end;
end;

function visible_p (poly: pointer): boolean;
var
 poly2d: array [1..4,1..2] of integer;
begin
 move(poly^,poly2d,sizeof(poly2d));
 if poly2d[1,1]*poly2d[2,2]+
    poly2d[1,2]*poly2d[3,1]+
    poly2d[2,1]*poly2d[3,2]-
    poly2d[3,1]*poly2d[2,2]-
    poly2d[2,1]*poly2d[1,2]-
    poly2d[1,1]*poly2d[3,2]<0 then
       visible_p:=true
            else
             visible_p:=false;
end;

procedure calcnormals_p;
var
 a,b,c : longint;
 n     : byte;
 i,j,k,m  : integer;

begin
 for i:=1 to npolys do
    for j:=1 to 4 do
      begin
      a:=0;  b:=0;  c:=0; n:=0;

        for k:=1 to npolys do
          for m:=1 to 4 do
           if ((poly3d[i,j,1]=poly3d[k,m,1]) and
              (poly3d[i,j,2]=poly3d[k,m,2]) and
              (poly3d[i,j,3]=poly3d[k,m,3])) then
            begin
             inc(a,normals[k,1]);
             inc(b,normals[k,2]);
             inc(c,normals[k,3]);
             inc(n);
            end;
        normals_p[i,j,1]:=a div n;
        normals_p[i,j,2]:=b div n;
        normals_p[i,j,3]:=c div n;
      end;
end;

function getcolor_p(p:pointer): word;
var
 normal : array [1..3] of integer;
 cos : longint;
 cos1: real;
begin
 move(p^,normal,sizeof(normal));
 cos:=(longint(normal[1])*63+longint(normal[2])*10);
 getcolor_p:=kr*256+kd*cos div 16;
end;

{$F+}
procedure bufline_p(x1,y1,z1,x2,y2,z2: integer;c1,c2: byte);
var
 dx,dy,dz,dc     : integer;
 absdx,absdy     : word;
 xadd,yadd,zadd  : longint;
 itr             : word;
 x,y,z           : longint;
 i               : word;
 x_,y_,z_        : integer;
 c               : word;
 cadd            : integer;

 label l1;
begin
 dx:=x2-x1;  dy:=y2-y1; dz:=z2-z1; dc:=integer(c2)-integer(c1);

 absdx:=abs(dx);
 absdy:=abs(dy);

 if absdx>absdy then itr:=absdx else itr:=absdy;

 if itr=0 then goto l1;
 xadd:=longint(dx) shl 16 div itr;
 yadd:=longint(dy) shl 16 div itr;
 zadd:=longint(dz) shl 16 div itr;
 cadd:=longint(dc) shl 8 div itr;

 x:=longint(x1) shl 16;
 y:=longint(y1) shl 16;
 z:=longint(z1) shl 16;
 c:=longint(c1) shl 8;

 for i:=1 to itr do
    begin
     x_:=laga(x).hi;
     y_:=laga(y).hi;
{     if (y_>=0) and (y_<=99) then}
{       begin}
        z_:=laga(z).hi;
        {scrarr(ptr($a000,0)^)[y_,x_]:=255;}
        if x_<s_leftx[y_] then
             begin
               s_leftx[y_]:=x_;
               s_leftz[y_]:=z_;
               s_leftc[y_]:=c;
             end;
        if x_>s_rightx[y_] then
             begin
               s_rightx[y_]:=x_;
               s_rightz[y_]:=z_;
               s_rightc[y_]:=c;
             end;
{       end;}
     inc(x,xadd);
     inc(y,yadd);
     inc(z,zadd);
     inc(c,cadd);
    end;
 l1:
end;
{$F-}

begin
directvideo:=false;
getmem(vid3dp,sizeof(vid3d));
directvideo:=false;

assign(f,'laga'); reset(f,1);
blockread(f,poly3d,15);
blockread(f,npolys,2);
npolys:=npolys div 4;
blockread(f,poly3d,6+6);
blockread(f,poly3d,npolys*24);
close(f);

getmem(p,64000+16);
zbufseg:=pointertype(p).seg+1;
getmem(p,64000+16);

getmem(p,64000+16);
bufseg:=pointertype(p).seg+1;
{bufseg:=$a000;}

setgfxmode;
setbwpalette256;

 kr:=127;
 kd:=100;
 eye_k:=800;

observer.alfa_rad:=0;
observer.beta_rad:=0;
observer.gama_rad:=0;

 calcnormals(npolys,addr(poly3d));
 calcnormals_p;

repeat
 SphereLook (addr(Observer),2800);

 observer1:=observer;
 observer1.x:=0;
 observer1.y:=0;
 observer1.z:=0;

  oldt:=timercounter;

 transform(npolys*4,addr(poly3d),addr(observer),vid3dp);
 transform(npolys*4,addr(normals_p),addr(observer1),addr(normals_p1));
 proectpoints(npolys*4,vid3dp,addr(poly2d));

 stosword(ptr(zbufseg,0),32000,320*100);
 stosword(ptr(zbufseg+4000,0),32000,320*100);

 stosword(ptr(bufseg,0),$1010,32000);

  for i:=1 to npolys do
   begin
    colors_p[i,1]:=getcolor(addr(normals_p1[i,1]));
    colors_p[i,2]:=getcolor(addr(normals_p1[i,2]));
    colors_p[i,3]:=getcolor(addr(normals_p1[i,3]));
    colors_p[i,4]:=getcolor(addr(normals_p1[i,4]));
   end;


 for i:=1 to npolys do
 if not visible_p(addr(poly2d[i])) then
    fillpoly4_zbuf_guro(
        addr(vid3d(vid3dp^)[i]),addr(poly2d[i]),
         colors_p[i,1],colors_p[i,2],
         colors_p[i,3],colors_p[i,4],
             bufseg,zbufseg);

 movedwords(ptr(bufseg,0),ptr($a000,0),16000);

 textattr:=$FF;
 gotoxy(1,1); writeln((timercounter-oldt),'  ');

 IncAngles(addr(observer),1144*1,1144*2,1144*1);

 Normalise (addr(Observer));
until keypressed;

textmode(3);
writeln('Guro shading with Z-bufer !  (160x100)');
writeln('Shading procedure writeln on Pascal.');
writeln('(C) Lout Roman');

end.