{$M 8000,0,655355}

uses crt,threed,dos,realtime,geomlib,gurofill,mode256;

type
 pointertype = record
                ofs,seg : word;
               end;
 zbufarrtype = array [0..99,0..319] of integer;
 laga    = record
              lo,hi: integer;
             end;
 vid3d    = array [1..1000,1..3] of integer;

const

 maxnpoints    = 3205;
 maxnpolys     = maxnpoints div 4;
 maxnnewpoints = 800;


var
 observer   : observertype;
 observer1  : observertype;
 f          : file;
 points3d   : array [1..maxnnewpoints,1..3] of integer;
 points2d   : array [1..maxnnewpoints,1..2] of integer;
 cross_ref  : array [1..maxnpoints] of word;
 vid3dp     : pointer;
 normals_p  : array [1..maxnpoints,1..3] of integer;
 normals_p1 : pointer;
 colors_p   : array [1..maxnpoints] of word;
 i,x,y      : integer;
 bufseg     : word;
 zbufseg    : word;
 p          : pointer;
 npolys     : word;
 npoints    : word;
 new_npoints: word;
 poly_3d    : array [1..4,1..3] of integer;
 poly_2d    : array [1..4,1..2] of integer;
 colors4    : array [1..4] of word;
 oldt       : longint;
 first      : boolean;

procedure fillpoly4_zbuf_y100_goro(poly3d,poly2d: pointer;
    color1,color2,color3,color4: byte;scrseg,zbufseg: word);

type
 scrarr = array [0..99,0..319] of byte;

var
 x,z_,c_     : integer;
 dz,itr,dc   : integer;
 z,zadd      : longint;
 c           : word;
 cadd        : integer;
 y,y1,y2     : word;
 y20,scrofs : word;
 y40,zbufofs: word;

label l1;
begin
move(poly3d^,s_poly3d,4*6);
move(poly2d^,s_poly2d,4*4);

if (s_poly2d[1,1]=maxint) or
   (s_poly2d[2,1]=maxint) or
   (s_poly2d[3,1]=maxint) or
   (s_poly2d[4,1]=maxint) then goto l1;

inc(s_poly2d[1,1],160);
inc(s_poly2d[2,1],160);
inc(s_poly2d[3,1],160);
inc(s_poly2d[4,1],160);

s_poly2d[1,2]:=50-s_poly2d[1,2] div 2;
s_poly2d[2,2]:=50-s_poly2d[2,2] div 2;
s_poly2d[3,2]:=50-s_poly2d[3,2] div 2;
s_poly2d[4,2]:=50-s_poly2d[4,2] div 2;

stosword(addr(s_leftx),320,100);
stosword(addr(s_rightx),$ffff,100);

bufline(s_poly2d[1,1],s_poly2d[1,2],s_poly3d[1,2],
           s_poly2d[2,1],s_poly2d[2,2],s_poly3d[2,2],color1,color2);
bufline(s_poly2d[2,1],s_poly2d[2,2],s_poly3d[2,2],
           s_poly2d[3,1],s_poly2d[3,2],s_poly3d[3,2],color2,color3);
bufline(s_poly2d[3,1],s_poly2d[3,2],s_poly3d[3,2],
           s_poly2d[4,1],s_poly2d[4,2],s_poly3d[4,2],color3,color4);
bufline(s_poly2d[4,1],s_poly2d[4,2],s_poly3d[4,2],
           s_poly2d[1,1],s_poly2d[1,2],s_poly3d[1,2],color4,color1);

y1:=s_poly2d[1,2];
if s_poly2d[2,2]<y1 then y1:=s_poly2d[2,2];
if s_poly2d[3,2]<y1 then y1:=s_poly2d[3,2];
if s_poly2d[4,2]<y1 then y1:=s_poly2d[4,2];

y2:=s_poly2d[1,2];
if s_poly2d[2,2]>y2 then y2:=s_poly2d[2,2];
if s_poly2d[3,2]>y2 then y2:=s_poly2d[3,2];
if s_poly2d[4,2]>y2 then y2:=s_poly2d[4,2];

{for y:=y1 to y2 do
  if s_leftx[y]<s_rightx[y] then
   begin
    dz:=s_rightz[y]-s_leftz[y];
    dc:=integer(s_rightc[y])-integer(s_leftc[y]);
    itr:=s_rightx[y]-s_leftx[y];
    z:=longint(s_leftz[y]) shl 16;
    c:=s_leftc[y];
    zadd:=longint(dz) shl 16 div itr;
    cadd:=dc div itr;

    for x:=s_leftx[y] to s_rightx[y] do
      begin
       z_:=laga(z).hi;
       c_:=hi(c);
       if (z_>0) and (z_<zbufarrtype(ptr(zbufseg,0)^)[y,x]) then
          begin
           scrarr(ptr(bufseg,0)^)[y,x]:=c_;
           zbufarrtype(ptr(zbufseg,0)^)[y,x]:=z_;
          end;
       inc(z,zadd);
       inc(c,cadd);
      end;

   end;}

 y20:=20*y1+bufseg;
 y40:=40*y1+zbufseg;

 for y:=y1 to y2 do
  if s_leftx[y]<s_rightx[y] then
   begin
    dz:=s_rightz[y]-s_leftz[y];
    dc:=integer(s_rightc[y])-integer(s_leftc[y]);
    itr:=s_rightx[y]-s_leftx[y];
    z:=longint(s_leftz[y]) shl 16;
    c:=s_leftc[y];
    zadd:=longint(dz) shl 16 div itr;
    cadd:=dc div itr;
    scrofs:=s_leftx[y];
    zbufofs:=s_leftx[y]*2;


    for x:=s_leftx[y] to s_rightx[y] do
      begin
       z_:=laga(z).hi;
       c_:=hi(c);
       if z_<integer(memw[y40:zbufofs]) then
          begin
           mem[y20:scrofs]:=c_;
           memw[y40:zbufofs]:=z_;
          end;
       inc(z,zadd);
       inc(c,cadd);
       inc(scrofs);
       inc(zbufofs,2);
      end;
  inc(y20,20);
  inc(y40,40);
 end;

l1:
end;

function visible_p (poly: pointer): boolean;
var
 poly2d: array [1..4,1..2] of integer;
begin
 move(poly^,poly2d,sizeof(poly2d));
 if poly2d[1,1]*poly2d[2,2]+
    poly2d[1,2]*poly2d[3,1]+
    poly2d[2,1]*poly2d[3,2]-
    poly2d[3,1]*poly2d[2,2]-
    poly2d[2,1]*poly2d[1,2]-
    poly2d[1,1]*poly2d[3,2]<0 then
       visible_p:=true
            else
             visible_p:=false;
end;

function getcolor_p(p:pointer): word;
var
 normal : array [1..3] of integer;
 cos : longint;
 cos1: real;
begin
 move(p^,normal,sizeof(normal));
 cos:=(longint(normal[1])*63+longint(normal[2])*10);
 getcolor_p:=kr*256+kd*cos div 16;
end;

{$F+}
procedure bufline_p(x1,y1,z1,x2,y2,z2: integer;c1,c2: byte);
var
 dx,dy,dz,dc     : integer;
 absdx,absdy     : word;
 xadd,yadd,zadd  : longint;
 itr             : word;
 x,y,z           : longint;
 i               : word;
 x_,y_,z_        : integer;
 c               : word;
 cadd            : integer;

 label l1;
begin
 dx:=x2-x1;  dy:=y2-y1; dz:=z2-z1; dc:=integer(c2)-integer(c1);

 absdx:=abs(dx);
 absdy:=abs(dy);

 if absdx>absdy then itr:=absdx else itr:=absdy;

 if itr=0 then goto l1;
 xadd:=longint(dx) shl 16 div itr;
 yadd:=longint(dy) shl 16 div itr;
 zadd:=longint(dz) shl 16 div itr;
 cadd:=longint(dc) shl 8 div itr;

 x:=longint(x1) shl 16;
 y:=longint(y1) shl 16;
 z:=longint(z1) shl 16;
 c:=longint(c1) shl 8;

 for i:=1 to itr do
    begin
     x_:=laga(x).hi;
     y_:=laga(y).hi;
{     if (y_>=0) and (y_<=99) then}
{       begin}
        z_:=laga(z).hi;
        {scrarr(ptr($a000,0)^)[y_,x_]:=255;}
        if x_<s_leftx[y_] then
             begin
               s_leftx[y_]:=x_;
               s_leftz[y_]:=z_;
               s_leftc[y_]:=c;
             end;
        if x_>s_rightx[y_] then
             begin
               s_rightx[y_]:=x_;
               s_rightz[y_]:=z_;
               s_rightc[y_]:=c;
             end;
{       end;}
     inc(x,xadd);
     inc(y,yadd);
     inc(z,zadd);
     inc(c,cadd);
    end;
 l1:
end;
{$F-}

procedure unpackpoly_p(n: word;
     vid3dp,points2d,cross_ref,colors_p,poly_3d,poly_2d,colors4: pointer);
type
 points2dt = array [1..1000,1..2] of integer;
 colorst   = array [1..4] of word;
 cft       = array [1..1000] of word;
 laga   = record
           ofs,seg: word;
          end;
var
 n1: word;
 cf : array [1..4] of word;
begin
 n1:=(n-1)*4+1;
 move(cft(cross_ref^)[n1],cf,2*4);

 move(vid3d(vid3dp^)[cf[1]],poly_3d^,6);
 inc(laga(poly_3d).ofs,6);
 move(vid3d(vid3dp^)[cf[2]],poly_3d^,6);
 inc(laga(poly_3d).ofs,6);
 move(vid3d(vid3dp^)[cf[3]],poly_3d^,6);
 inc(laga(poly_3d).ofs,6);
 move(vid3d(vid3dp^)[cf[4]],poly_3d^,6);

  move(points2dt(points2d^)[cf[1]],poly_2d^,4);
  inc(laga(poly_2d).ofs,4);
  move(points2dt(points2d^)[cf[2]],poly_2d^,4);
  inc(laga(poly_2d).ofs,4);
  move(points2dt(points2d^)[cf[3]],poly_2d^,4);
  inc(laga(poly_2d).ofs,4);
  move(points2dt(points2d^)[cf[4]],poly_2d^,4);

 move(colorst(colors_p^)[n1],colors4^,4*2)
end;

begin
directvideo:=false;
getmem(vid3dp,maxnnewpoints*6);
getmem(normals_p1,maxnpoints*6);
directvideo:=false;

assign(f,'laga.3pk'); reset(f,1);
blockread(f,npoints,2);
blockread(f,new_npoints,2);
blockread(f,points3d,new_npoints*6);
blockread(f,cross_ref,npoints*2);
blockread(f,normals_p,npoints*6);
close(f);

npolys:=npoints div 4;

getmem(p,64000+16);
zbufseg:=pointertype(p).seg+1;
getmem(p,64000+16);

getmem(p,64000+16);
bufseg:=pointertype(p).seg+1;

setgfxmode;
setbwpalette256;

 kr:=127;
 kd:=120;
 eye_k:=800;
 eye_hz:=198;
 ls_normal[1]:=-63;
 ls_normal[2]:=10;
 ls_normal[3]:=0;

observer.alfa_rad:=0;
observer.beta_rad:=0;
observer.gama_rad:=0;

first:=true;

repeat
 SphereLook_p (addr(Observer),4500);

 observer1:=observer;
 observer1.x:=0;
 observer1.y:=0;
 observer1.z:=0;

  oldt:=timercounter;

 transform(new_npoints,addr(points3d),addr(observer),vid3dp);
 transform(npoints,addr(normals_p),addr(observer1),normals_p1);
 proectpoints(new_npoints,vid3dp,addr(points2d));

 stosword(ptr(zbufseg,0),32000,320*100);
 stosword(ptr(zbufseg+4000,0),32000,320*100);

 stosword(ptr(bufseg,0),$1010,32000);

 calccolors(npoints,normals_p1,addr(colors_p));

 for i:=1 to npolys do
  begin
   unpackpoly(i,vid3dp,addr(points2d),addr(cross_ref),addr(colors_p),
         addr(poly_3d),addr(poly_2d),addr(colors4));
   if visible(addr(poly_2d)) then
      fillpoly4_zbuf_guro(
          addr(poly_3d),addr(poly_2d),
           colors4[1],colors4[2],
           colors4[3],colors4[4],
               bufseg,zbufseg);
  end;

 movedwords(ptr(bufseg,0),ptr($a000,0),16000);

 if first then
   begin
    oldt:=timercounter;
    while timercounter-oldt<3000 do ;
    first:=false;
   end;

 textattr:=$FF;
 gotoxy(1,1); writeln((timercounter-oldt),'  ');

 IncAngles(addr(observer),1144*5,1144*2,1144*0);

until keypressed;

textmode(3);
writeln('Guro shading with Z-bufer !  (320x200)');
writeln('(C) Lout Roman');

end.