uses dos,winapi,graph,mousetpu,crt,threed,realtime,{pickfile,}
         loadpcx,gurofill,myfpick,prj_tpu;
const
 maxnobj         = 80;
 maxnfaces       = 10000;
 maxnvertices    = 10000;
 maxnkeys        = 1800;

type
 VertexArrType  = array [1..maxnvertices,1..3] of integer;
 FacesArrType   = array [1..maxnfaces,1..3] of word;
 NormalsArrType = array [1..maxnfaces,1..3] of integer;
 bmpxyarrtype   = array [1..maxnfaces,1..3] of word;
 keysarrtype    = array [0..maxnkeys] of byte;
                             {0 - nothing}
                             {1 - show obj}
                             {2 - hide obj}
 keysdatatype   = array [0..maxnkeys] of
       record
        xpos,ypos,zpos: integer;
        alfa,beta,gama: integer;
       end;

 oldkeysarrtype    = array [0..500] of byte;
                             {0 - nothing}
                             {1 - show obj}
                             {2 - hide obj}
 oldkeysdatatype   = array [0..500] of
       record
        xpos,ypos,zpos: integer;
        alfa,beta,gama: integer;
       end;

 {     쥪}
 keyinfotype = record
                 present : boolean;
                   {   ,  ᫥ ௮樥}
                 hide : boolean;
                     {쥪 ⠭}
                 alfa,beta,gama : integer;
                     {㣫 }
                 posx,posy,posz : integer;
                     { 쥪}
               end;

 newkeysarrtype    = array [0..maxnkeys] of word;

 newkeysdatatype   = array [0..maxnkeys] of
       record
        hide : boolean;
        xpos,ypos,zpos: integer;
        alfa,beta,gama: integer;
       end;

 laga = record
          ofs,seg: word;
        end;

const
 msperframe : word = 500;
 w2d_zoom : longint = 256;   {coord:256}
 w2d_posx : integer = 0;
 w2d_posy : integer = 0;
 w2d_posz : integer = 0;
 w2d_selx : integer = 0;
 w2d_sely : integer = 0;
 w2d_selz : integer = 0;
 w2d_x : integer = 0;
 w2d_y : integer = 0;
 w2d_z : integer = 0;

 w3d_alfa : integer = 0;
 w3d_beta : integer = 0;
 w3d_gama : integer = 0;
 w3d_posx : integer = 0;
 w3d_posy : integer = -3000;
 w3d_posz : integer = 0;

 curframe : word = 0;
 nobj     : word = 0;
 curnobj  : word = 0;
 startframe : integer =0;
 mode     : word = 0;     {0 - nothing}
                          {1 - file menu}
                          {2 - editobj menu}
                          {4 - moviekey menu}
                          {5 - lookmovie menu}

 step : integer = 10;

 texture_msq : array [1..10] of byte = (0,0,0,0,0,0,0,0,0,0);

 var
  msq_framedata : array [1..10,1..10,1..2] of byte;
  msq_data : array [1..10] of
    record
     nframes,fspeed,fsizex,fsizey,movx,movy: integer;
    end;
  c: char;
  obj_names     : array [1..maxnobj] of string[12];
  obj_nfaces    : array [1..maxnobj] of word;
  obj_nvertices : array [1..maxnobj] of word;
  obj_vertices  : array [1..maxnobj] of ^vertexarrtype;
  obj_faces     : array [1..maxnobj] of ^facesarrtype;
  obj_normals   : array [1..maxnobj] of ^normalsarrtype;
  obj_bmpxy     : array [1..maxnobj] of ^bmpxyarrtype;
  obj_texturenum: array [1..maxnobj] of byte;
  obj_keys      : array [0..maxnobj] of ^keysarrtype;
  obj_keysdata  : array [0..maxnobj] of ^keysdatatype;
         {obj N0 - camera}
  texture_loaded: array [1..10] of boolean;
  texture_p     : array [1..10] of pointer;
  t: longint;
  poly_3d : array [1..4,1..3] of integer;
  poly_2d : array [1..4,1..2] of integer;
  observer: observertype;
  rot_alfa,rot_beta,rot_gama,scale: integer;
  status : boolean;
  i: integer;
  palette : array [1..768] of byte;
{  palette1: array [0..255,1..3] of byte;}

  zbufseg,scrseg: word;

  s: string;

  i_table : pointer;
  i_table2 : pointer;

{*********************************************************************}
{* Procedures                                                        *}
{*********************************************************************}

procedure line_w3d(x1,y1,x2,y2: integer);
begin
 setviewport(320,250,620,459,true);
 asm
 mov bx,240
 mov cx,270
 mov ax,x1
 imul bx
 mov al,ah
 mov ah,dl
 add ax,150
 push ax

 mov ax,y1
 imul cx
 mov al,ah
 mov ah,dl
 neg ax
 add ax,105
 push ax

 mov ax,x2
 imul bx
 mov al,ah
 mov ah,dl
 add ax,150
 push ax

 mov ax,y2
 imul cx
 mov al,ah
 mov ah,dl
 neg ax
 add ax,105
 push ax

 call line

 end;
 setviewport(0,0,639,479,true);
end;

procedure _draw_cut_textmap_guro_notreal;
var
 i,j: integer;
label l1;
begin
 fillchar(cut_poly2d,6*4,0);
 draw_cut_textmap_flat;

 del_thesame;

 if cut_n<3 then goto l1;

 if not visible(addr(cut_poly2d)) then goto l1;

  case cut_n of
     3: begin
         line_w3d(cut_poly2d[1,1],cut_poly2d[1,2],cut_poly2d[2,1],cut_poly2d[2,2]);
         line_w3d(cut_poly2d[2,1],cut_poly2d[2,2],cut_poly2d[3,1],cut_poly2d[3,2]);
         line_w3d(cut_poly2d[3,1],cut_poly2d[3,2],cut_poly2d[1,1],cut_poly2d[1,2]);
        end;
     4: begin
         line_w3d(cut_poly2d[1,1],cut_poly2d[1,2],cut_poly2d[2,1],cut_poly2d[2,2]);
         line_w3d(cut_poly2d[2,1],cut_poly2d[2,2],cut_poly2d[3,1],cut_poly2d[3,2]);
         line_w3d(cut_poly2d[3,1],cut_poly2d[3,2],cut_poly2d[4,1],cut_poly2d[4,2]);
         line_w3d(cut_poly2d[4,1],cut_poly2d[4,2],cut_poly2d[1,1],cut_poly2d[1,2]);
        end;
     5: begin
         line_w3d(cut_poly2d[1,1],cut_poly2d[1,2],cut_poly2d[2,1],cut_poly2d[2,2]);
         line_w3d(cut_poly2d[2,1],cut_poly2d[2,2],cut_poly2d[3,1],cut_poly2d[3,2]);
         line_w3d(cut_poly2d[3,1],cut_poly2d[3,2],cut_poly2d[4,1],cut_poly2d[4,2]);
         line_w3d(cut_poly2d[4,1],cut_poly2d[4,2],cut_poly2d[5,1],cut_poly2d[5,2]);
         line_w3d(cut_poly2d[5,1],cut_poly2d[5,2],cut_poly2d[1,1],cut_poly2d[1,2]);
        end;
     6: begin
         line_w3d(cut_poly2d[1,1],cut_poly2d[1,2],cut_poly2d[2,1],cut_poly2d[2,2]);
         line_w3d(cut_poly2d[2,1],cut_poly2d[2,2],cut_poly2d[3,1],cut_poly2d[3,2]);
         line_w3d(cut_poly2d[3,1],cut_poly2d[3,2],cut_poly2d[4,1],cut_poly2d[4,2]);
         line_w3d(cut_poly2d[4,1],cut_poly2d[4,2],cut_poly2d[5,1],cut_poly2d[5,2]);
         line_w3d(cut_poly2d[5,1],cut_poly2d[5,2],cut_poly2d[6,1],cut_poly2d[6,2]);
         line_w3d(cut_poly2d[6,1],cut_poly2d[6,2],cut_poly2d[1,1],cut_poly2d[1,2]);
        end;
  end;
l1:
end;

function strng(i:longint): string;
var s: string;
begin
str(i,s);
strng:=s;
end;

procedure setgfxmode480;
var
 gd,gm: integer;
begin
 registerbgidriver(addr(gd_egavga));
 gd:=vga; gm:=1;
 initgraph(gd,gm,'');
 setgraphmode(vgahi);
end;

procedure myexit;
begin
 mouse_reset;
 textmode(3);
 while keypressed do readkey;
 writeln('(c) Hax');
 halt;
end;

procedure my_bar(x1,y1,x2,y2: word);
begin
 setcolor(15);
 setfillstyle(solidfill,0);
 bar(x1,y1,x2,y2);
 line(x1,y1,x2,y1);
 line(x1,y2,x2,y2);
 line(x1,y1,x1,y2);
 line(x2,y1,x2,y2);
end;

procedure line_w2d(x1,y1,z1,x2,y2,z2: integer);
begin
 setviewport(20,20,300,229,true);
 asm
 mov bx,word ptr w2d_zoom
 mov ax,x1
 add ax,w2d_posx
 imul bx
 mov al,ah
 mov ah,dl
 add ax,160-20
 push ax

 mov ax,y1
 add ax,w2d_posy
 imul bx
 mov al,ah
 mov ah,dl
 neg ax
 add ax,125-20
 push ax

 mov ax,x2
 add ax,w2d_posx
 imul bx
 mov al,ah
 mov ah,dl
 add ax,160-20
 push ax

 mov ax,y2
 add ax,w2d_posy
 imul bx
 mov al,ah
 mov ah,dl
 neg ax
 add ax,125-20
 push ax

 call line

 end;
 setviewport(20,250,300,459,true);
 asm
 mov bx,word ptr w2d_zoom
 mov ax,x1
 add ax,w2d_posx
 imul bx
 mov al,ah
 mov ah,dl
 add ax,160-20
 push ax

 mov ax,z1
 add ax,w2d_posz
 imul bx
 mov al,ah
 mov ah,dl
 neg ax
 add ax,355-250
 push ax

 mov ax,x2
 add ax,w2d_posx
 imul bx
 mov al,ah
 mov ah,dl
 add ax,160-20
 push ax

 mov ax,z2
 add ax,w2d_posz
 imul bx
 mov al,ah
 mov ah,dl
 neg ax
 add ax,355-250
 push ax

 call line

 end;
 setviewport(0,0,639,479,true);
end;


function mouse_in(x1,y1,x2,y2: integer): boolean; assembler;
asm
 call mouse_getx
 cmp ax,x1
 jl @l1
 cmp ax,x2
 jg @l1
 call mouse_gety
 cmp ax,y1
 jl @l1
 cmp ax,y2
 jg @l1
 mov al,true
 jmp @l2
 @l1:
 mov al,false
 @l2:
end;

procedure w2d_cursor(x1,y1,z1,rad,color: integer);
begin
 setviewport(20,20,300,229,true);
 setcolor(color);
 asm
 mov bx,word ptr w2d_zoom
 mov ax,x1
 add ax,w2d_posx
 imul bx
 mov al,ah
 mov ah,dl
 add ax,160-20
 push ax

 mov ax,y1
 add ax,w2d_posy
 imul bx
 mov al,ah
 mov ah,dl
 neg ax
 add ax,125-20
 push ax

 push rad
 call circle

 end;
 setviewport(20,250,300,459,true);
 asm
 mov bx,word ptr w2d_zoom
 mov ax,x1
 add ax,w2d_posx
 imul bx
 mov al,ah
 mov ah,dl
 add ax,160-20
 push ax

 mov ax,z1
 add ax,w2d_posz
 imul bx
 mov al,ah
 mov ah,dl
 neg ax
 add ax,355-250
 push ax

 push rad

 call circle

 end;
 setviewport(0,0,639,479,true);
 setcolor(15);
end;

procedure camera_2d_cursor;
var
 x1,y1: integer;
begin
 setviewport(20,20,300,229,true);
 setcolor(15);
 asm
 mov bx,word ptr w2d_zoom
 mov ax,w3d_posx
 add ax,w2d_posx
 imul bx
 mov al,ah
 mov ah,dl
 add ax,160-20
 mov x1,ax
 push ax

 mov ax,w3d_posy
 add ax,w2d_posy
 imul bx
 mov al,ah
 mov ah,dl
 neg ax
 add ax,125-20
 mov y1,ax
 push ax

 push 2
 call circle
 end;

 line(x1,y1,round(x1+8*sin(w3d_alfa*pi/180)),round(y1-8*cos(w3d_alfa*pi/180)));

 setviewport(20,250,300,459,true);
 asm
 mov bx,word ptr w2d_zoom
 mov ax,w3d_posx
 add ax,w2d_posx
 imul bx
 mov al,ah
 mov ah,dl
 add ax,160-20
 mov x1,ax
 push ax

 mov ax,w3d_posz
 add ax,w2d_posz
 imul bx
 mov al,ah
 mov ah,dl
 neg ax
 add ax,355-250
 mov y1,ax
 push ax

 push 2
 call circle
 end;

 line(x1-6,round(y1-8*sin(w3d_beta*pi/180)),x1+6,round(y1-8*sin(w3d_beta*pi/180)));

 setviewport(0,0,639,479,true);
 setcolor(15);
end;

function mouse_inw1: boolean; assembler;
asm
 push 20
 push 20
 push 300
 push 229
 call mouse_in
end;

function mouse_inw2: boolean; assembler;
asm
 push 20
 push 250
 push 300
 push 459
 call mouse_in
end;

function mouse_incenter: boolean; assembler;
asm
 push 25
 push 11
 push 240
 push 11+8
 call mouse_in
end;

function mouse_inzoom: boolean; assembler;
asm
 push 280
 push 11
 push 280+30
 push 11+10
 call mouse_in
end;

function mouse_inalfa: boolean; assembler;
asm
 push 320
 push 461
 push 320+30
 push 461+10
 call mouse_in
end;

function mouse_inbeta: boolean; assembler;
asm
 push 320+80
 push 461
 push 320+80+10
 push 461+10
 call mouse_in
end;

function mouse_ingama: boolean; assembler;
asm
 push 320+160
 push 461
 push 320+10+160
 push 461+10
 call mouse_in
end;

function mouse_instatus: boolean; assembler;
asm
 push 320
 push 160
 push 320+30
 push 160+10
 call mouse_in
end;

function mouse_inrotalfa: boolean; assembler;
asm
 push 320
 push 170
 push 320+30
 push 170+10
 call mouse_in
end;

function mouse_inrotbeta: boolean; assembler;
asm
 push 320+80
 push 170
 push 320+80+10
 push 170+10
 call mouse_in
end;

function mouse_inrotgama: boolean; assembler;
asm
 push 320+160
 push 170
 push 320+10+160
 push 170+10
 call mouse_in
end;

function mouse_inw3dx: boolean; assembler;
asm
 push 320
 push 241
 push 320+10
 push 241+10
 call mouse_in
end;

function mouse_inw3dy: boolean; assembler;
asm
 push 320+80
 push 241
 push 320+10+80
 push 241+10
 call mouse_in
end;

function mouse_inw3dz: boolean; assembler;
asm
 push 320+170
 push 241
 push 320+10+170
 push 241+10
 call mouse_in
end;

function mouse_inexit: boolean; assembler;
asm
 push 320
 push 60
 push 320+30
 push 60+10
 call mouse_in
end;

function mouse_inframe: boolean; assembler;
asm
 push 320
 push 231
 push 320+30
 push 231+10
 call mouse_in
end;

function mouse_inmenufile: boolean; assembler;
asm
 push 320
 push 20
 push 320+30
 push 20+10
 call mouse_in
end;

function mouse_inmenuedit: boolean; assembler;
asm
 push 320
 push 20+10
 push 320+30
 push 20+10+10
 call mouse_in
end;

function mouse_inmenukey: boolean; assembler;
asm
 push 320
 push 20+10+10
 push 320+30
 push 20+10+10+10
 call mouse_in
end;

function mouse_inmuviekey: boolean; assembler;
asm
 push 320
 push 20+10+10+10
 push 320+30
 push 20+10+10+10+10
 call mouse_in
end;

function mouse_insubmenu1: boolean; assembler;
asm
 push 320+10
 push 80+10
 push 320+10+30
 push 80+10+10
 call mouse_in
end;

function mouse_insubmenu2: boolean; assembler;
asm
 push 320+10
 push 80+20
 push 320+10+30
 push 80+20+10
 call mouse_in
end;

function mouse_insubmenu3: boolean; assembler;
asm
 push 320+10
 push 80+30
 push 320+10+30
 push 80+30+10
 call mouse_in
end;

function mouse_insubmenu4: boolean; assembler;
asm
 push 320+10
 push 80+40
 push 320+10+30
 push 80+40+10
 call mouse_in
end;

function mouse_insubmenu5: boolean; assembler;
asm
 push 320+10
 push 80+50
 push 320+10+30
 push 80+50+10
 call mouse_in
end;

function mouse_insubmenu6: boolean; assembler;
asm
 push 320+10
 push 80+60
 push 320+10+30
 push 80+60+10
 call mouse_in
end;

function mouse_insubmenu7: boolean; assembler;
asm
 push 320+10
 push 80+70
 push 320+10+30
 push 80+70+10
 call mouse_in
end;

function mouse_insubmenu8: boolean; assembler;
asm
 push 320+10
 push 80+80
 push 320+10+30
 push 80+80+10
 call mouse_in
end;

function mouse_insubmenu9: boolean; assembler;
asm
 push 320+10
 push 80+90
 push 320+10+30
 push 80+90+10
 call mouse_in
end;

function mouse_incurnobj: boolean; assembler;
asm
 push 320+80
 push 231
 push 320+80+30
 push 231+8
 call mouse_in
end;

function mouse_inscale: boolean; assembler;
asm
 push 320
 push 180
 push 320+40
 push 180+8
 call mouse_in
end;

function mouse_incolor: boolean; assembler;
asm
 push 320+160
 push 180
 push 320+160+40
 push 180+8
 call mouse_in
end;

function mouse_inshading: boolean; assembler;
asm
 push 320
 push 190
 push 320+40
 push 190+8
 call mouse_in
end;

function mouse_inrot: boolean; assembler;
asm
 push 320+230
 push 461
 push 320+230+20
 push 461+10
 call mouse_in
end;

function mouse_inset: boolean; assembler;
asm
 push 320+270
 push 461
 push 320+270+20
 push 461+10
 call mouse_in
end;

function mouse_insetcamera: boolean; assembler;
asm
 push 325
 push 255
 push 330
 push 260
 call mouse_in
end;

function mouse_intextnum: boolean; assembler;
asm
 push 320
 push 160
 push 330
 push 170
 call mouse_in
end;

procedure update_mouse_pos;
begin
setcolor(15);
 setfillstyle(solidfill,0);
 bar(180,231,290,231+8);
 bar(20,461,290,461+8);

 if mouse_inw1 then
       begin
        w2d_x:=(longint(mouse_getx-160)*256 div w2d_zoom) - w2d_posx;
        w2d_y:=(longint(125-mouse_gety)*256 div w2d_zoom) - w2d_posy;
        outtextxy(180,231,'('+strng(w2d_x)+','+strng(w2d_y)+')');
       end;

 if mouse_inw2 then
       begin
        w2d_x:=(longint(mouse_getx-160)*256 div w2d_zoom) - w2d_posx;
        w2d_z:=(longint(355-mouse_gety)*256 div w2d_zoom) - w2d_posz;
        outtextxy(180,461,'('+strng(w2d_x)+','+strng(w2d_z)+')');
       end;

 outtextxy(25,461,'('+strng(w2d_selx)+
       ','+strng(w2d_sely)+','+strng(w2d_selz)+')');
end;

procedure sel_pos;
begin
 if mouse_inw1 then
       begin
        w2d_selx:=w2d_x;
        w2d_sely:=w2d_y;
       end;

 if mouse_inw2 then
       begin
        w2d_selx:=w2d_x;
        w2d_selz:=w2d_z;
       end;
end;

procedure write_file_menu;
begin
 setcolor(10);
 outtextxy(320,20,'File');
 outtextxy(320+150,80+10,'Memory avaible:');
 outtextxy(320+150,80+20,strng(maxavail)+' bytes');

 setcolor(15);
 outtextxy(320+10,80+10,'LoadPrj');
 outtextxy(320+10,80+20,'SavePrj');
 outtextxy(320+10,80+30,'LoadObj');
 outtextxy(320+10,80+40,'UnloadObj');
 outtextxy(320+10,80+50,'Load Texture');
 outtextxy(320+10,80+60,'Unload Texture');
 outtextxy(320+10,80+70,'View Texture');
 outtextxy(320+10,80+80,'Load Palette');
 outtextxy(320+10,80+90,'Load MSQ');
end;

procedure write_edit_menu;
begin
 setcolor(10);
 outtextxy(320,20+10,'EditObj');
 setcolor(15);
 outtextxy(320+10,80+10,'Perform');
 if curnobj>0 then outtextxy(320,160,'Texture number:'+strng(obj_texturenum[curnobj]));
 outtextxy(320,170,'A:'+strng(rot_alfa));
 outtextxy(320+80,170,'B:'+strng(rot_beta));
 outtextxy(320+160,170,'G:'+strng(rot_gama));
 outtextxy(320,180,'Scale: '+strng(scale));
end;

procedure write_key_menu;
begin
 setcolor(10);
 outtextxy(320,20+20,'MovieKey');
 setcolor(15);
 outtextxy(320+10,80+10,'Add key');
 outtextxy(320+10,80+20,'Remove key');
 outtextxy(320+10,80+30,'Insert key');
 outtextxy(320+10,80+40,'Delete key');
 outtextxy(320+10,80+50,'Delete to end');
 outtextxy(320+10,80+60,'Rotate camera');
 outtextxy(320+10,80+70,'Rotate object');
 outtextxy(320,160,'Status:');
 if status then outtextxy(380,160,'Hide') else outtextxy(380,160,'Show');
 outtextxy(320,170,'A:'+strng(rot_alfa));
 outtextxy(320+80,170,'B:'+strng(rot_beta));
 outtextxy(320+160,170,'G:'+strng(rot_gama));
end;

procedure write_movie_menu;
begin
 setcolor(10);
 outtextxy(320,20+30,'LookMovie');
 setcolor(15);
 outtextxy(320+10,80+10,'Realtime');
 outtextxy(320+10,80+20,'Show motion');
 outtextxy(320,170,'Startframe:'+strng(startframe));
 outtextxy(320,180,'mS per key:'+strng(msperframe));
end;

procedure drawobject(n: word);
var
 i,j: integer;
 x1,y1,z1,x2,y2,z2,x3,y3,z3 : integer;
label l1,l2;
begin

 s_polybmp[1,1]:=0; s_polybmp[1,2]:=0;
 s_polybmp[2,1]:=0; s_polybmp[2,2]:=128;
 s_polybmp[3,1]:=128; s_polybmp[3,2]:=128;

 observer.x:=w3d_posx;
 observer.y:=w3d_posy;
 observer.z:=w3d_posz;
 observer.alfa_rad:=round(w3d_alfa*pi/180*65536);
 observer.beta_rad:=round(w3d_beta*pi/180*65536);
 observer.gama_rad:=round(w3d_gama*pi/180*65536);

 j:=obj_nfaces[n];
 for i:=1 to j do
   begin
    move(obj_vertices[n]^[obj_faces[n]^[i,1],1],poly_3d,6);
    move(obj_vertices[n]^[obj_faces[n]^[i,2],1],poly_3d[2],6);
    move(obj_vertices[n]^[obj_faces[n]^[i,3],1],poly_3d[3],6);

    transform(3,addr(poly_3d),addr(observer),addr(s_poly3d));
    proectpoints(3,addr(s_poly3d),addr(poly_2d));

    line_w2d(poly_3d[1,1],poly_3d[1,2],poly_3d[1,3],
       poly_3d[2,1],poly_3d[2,2],poly_3d[2,3]);
    line_w2d(poly_3d[2,1],poly_3d[2,2],poly_3d[2,3],
       poly_3d[3,1],poly_3d[3,2],poly_3d[3,3]);
    line_w2d(poly_3d[1,1],poly_3d[1,2],poly_3d[1,3],
       poly_3d[3,1],poly_3d[3,2],poly_3d[3,3]);

    asm
     mov ax,7fffh
     cmp ax,word ptr poly_2d
     je l2
     cmp ax,word ptr poly_2d+4
     je l2
     cmp ax,word ptr poly_2d+4+4
     je l2

     push seg poly_2d
     push offset poly_2d
     call visible
     cmp al,false
     je l1
    end;
    line_w3d(poly_2d[1,1],poly_2d[1,2],poly_2d[2,1],poly_2d[2,2]);
    line_w3d(poly_2d[2,1],poly_2d[2,2],poly_2d[3,1],poly_2d[3,2]);
    line_w3d(poly_2d[3,1],poly_2d[3,2],poly_2d[1,1],poly_2d[1,2]);
    goto l1;
    l2:
    _draw_cut_textmap_guro_notreal;
    l1:
   end;
end;

procedure drawrotscaleobject(n: word;x,y,z,alfa,beta,gama,scale,c,addx,addy,addz: integer);
var
 i,j: integer;
 x1,y1,z1,x2,y2,z2,x3,y3,z3 : integer;
 vid3d: array [1..3,1..3] of integer;
 p1,p: ^vertexarrtype;
label l1,l2;
begin
 setcolor(c);

 s_polybmp[1,1]:=0; s_polybmp[1,2]:=0;
 s_polybmp[2,1]:=0; s_polybmp[2,2]:=128;
 s_polybmp[3,1]:=128; s_polybmp[3,2]:=128;

 observer.x:=x;
 observer.y:=y;
 observer.z:=z;
 observer.alfa_rad:=round(alfa*pi/180*65536);
 observer.beta_rad:=round(beta*pi/180*65536);
 observer.gama_rad:=round(gama*pi/180*65536);

 getmem(p,obj_nvertices[n]*6);
 transform(obj_nvertices[n],obj_vertices[n],addr(observer),p);

 j:=obj_nvertices[n];
 p1:=p;
 for i:=1 to j do
    asm
     les si,p1
     mov bx,scale

     mov ax,es:[si]
     imul bx
     mov al,ah
     mov ah,dl
     add ax,addx
     mov es:[si],ax

     mov ax,es:[si+2]
     imul bx
     mov al,ah
     mov ah,dl
     add ax,addy
     mov es:[si+2],ax

     mov ax,es:[si+4]
     imul bx
     mov al,ah
     mov ah,dl
     add ax,addz
     mov es:[si+4],ax

     add word ptr p1,6
   end;

 observer.x:=w3d_posx;
 observer.y:=w3d_posy;
 observer.z:=w3d_posz;
 observer.alfa_rad:=round(w3d_alfa*pi/180*65536);
 observer.beta_rad:=round(w3d_beta*pi/180*65536);
 observer.gama_rad:=round(w3d_gama*pi/180*65536);

 j:=obj_nfaces[n];
 for i:=1 to j do
   begin
    move(p^[obj_faces[n]^[i,1],1],poly_3d,6);
    move(p^[obj_faces[n]^[i,2],1],poly_3d[2],6);
    move(p^[obj_faces[n]^[i,3],1],poly_3d[3],6);

    transform(3,addr(poly_3d),addr(observer),addr(s_poly3d));
    proectpoints(3,addr(s_poly3d),addr(s_poly2d));

    line_w2d(poly_3d[1,1],poly_3d[1,2],poly_3d[1,3],
       poly_3d[2,1],poly_3d[2,2],poly_3d[2,3]);
    line_w2d(poly_3d[2,1],poly_3d[2,2],poly_3d[2,3],
       poly_3d[3,1],poly_3d[3,2],poly_3d[3,3]);
    line_w2d(poly_3d[1,1],poly_3d[1,2],poly_3d[1,3],
       poly_3d[3,1],poly_3d[3,2],poly_3d[3,3]);

    asm
     mov ax,7fffh
     cmp ax,word ptr s_poly2d
     je l2
     cmp ax,word ptr s_poly2d+4
     je l2
     cmp ax,word ptr s_poly2d+4+4
     je l2

     push seg s_poly2d
     push offset s_poly2d
     call visible
     cmp al,false
     je l1
    end;
     line_w3d(s_poly2d[1,1],s_poly2d[1,2],s_poly2d[2,1],s_poly2d[2,2]);
     line_w3d(s_poly2d[2,1],s_poly2d[2,2],s_poly2d[3,1],s_poly2d[3,2]);
     line_w3d(s_poly2d[3,1],s_poly2d[3,2],s_poly2d[1,1],s_poly2d[1,2]);
    goto l1;
    l2:
    _draw_cut_textmap_guro_notreal;
    l1:
   end;
 setcolor(15);
 freemem(p,obj_nvertices[n]*6);
end;

procedure do_obj_rot_scale(n: word; x,y,z,alfa,beta,gama,scale: integer);
var
 i,j: integer;
 p1,p: ^vertexarrtype;
label l1;
begin
 observer.x:=x;
 observer.y:=y;
 observer.z:=z;
 observer.alfa_rad:=round(alfa*pi/180*65536);
 observer.beta_rad:=round(beta*pi/180*65536);
 observer.gama_rad:=round(gama*pi/180*65536);

 getmem(p,obj_nvertices[n]*6);
 transform(obj_nvertices[n],obj_vertices[n],addr(observer),p);
 rotate_3d(obj_nfaces[n],obj_normals[n],addr(observer),obj_normals[n]);
 j:=obj_nvertices[n];
 p1:=p;
 for i:=1 to j do
    asm
     les si,p1
     mov bx,scale

     mov ax,es:[si]
     imul bx
     mov al,ah
     mov ah,dl
     mov es:[si],ax

     mov ax,es:[si+2]
     imul bx
     mov al,ah
     mov ah,dl
     mov es:[si+2],ax

     mov ax,es:[si+4]
     imul bx
     mov al,ah
     mov ah,dl
     mov es:[si+4],ax

     add word ptr p1,6
   end;

 move(p^,obj_vertices[n]^,obj_nvertices[n]*6);
 freemem(p,obj_nvertices[n]*6);
end;

procedure get_keyinfo(frame:word; obj_keys,obj_keysdata,keyinfo:pointer);
var
 i,j: integer;
 hide: boolean;
 x,y,z,x1,y1,z1,x2,y2,z2: integer;
 alfa,beta,gama,alfa1,beta1,gama1,alfa2,beta2,gama2: integer;
 b:byte;
 fr1,fr2: word;
 t:real;
 tw: word;

 label l1,l2,l3;

begin
 b:=keysarrtype(obj_keys^)[frame];
 if b>0 then
          begin
{           keyinfotype(keyinfo^).present:=true;}
           if (b and 1)>0 then hide:=false;
           if (b and 2)>0 then hide:=true;
           x:=keysdatatype(obj_keysdata^)[frame].xpos;
           y:=keysdatatype(obj_keysdata^)[frame].ypos;
           z:=keysdatatype(obj_keysdata^)[frame].zpos;
           alfa:=keysdatatype(obj_keysdata^)[frame].alfa;
           beta:=keysdatatype(obj_keysdata^)[frame].beta;
           gama:=keysdatatype(obj_keysdata^)[frame].gama;
          end
           else
    begin
{      keyinfotype(keyinfo^).present:=false;}
      asm
       xor ax,ax
       mov x1,ax
       mov x,ax
       mov y1,ax
       mov y,ax
       mov z1,ax
       mov z,ax
       mov alfa1,ax
       mov alfa,ax
       mov beta1,ax
       mov beta,ax
       mov gama1,ax
       mov gama,ax
       mov fr1,ax
       mov hide,true
      end;
      if frame=0 then goto l2;

      j:=frame;
      while j>=0 do
         begin
          b:=keysarrtype(obj_keys^)[j];
          if b>0 then
            begin
             fr1:=j;
             if (b and 1)>0 then hide:=false;
             if (b and 2)>0 then hide:=true;
             x1:=keysdatatype(obj_keysdata^)[j].xpos;
             y1:=keysdatatype(obj_keysdata^)[j].ypos;
             z1:=keysdatatype(obj_keysdata^)[j].zpos;
             alfa1:=keysdatatype(obj_keysdata^)[j].alfa;
             beta1:=keysdatatype(obj_keysdata^)[j].beta;
             gama1:=keysdatatype(obj_keysdata^)[j].gama;
             goto l1;
            end;
          dec(j);
         end;
      l1:
      x2:=x1;  y2:=y1;  z2:=z1;
      alfa2:=alfa1; beta2:=beta1;  gama2:=gama1;
      j:=frame;  fr2:=fr1;
      while j<=maxnkeys do
         begin
          b:=keysarrtype(obj_keys^)[j];
          if b>0 then
            begin
             fr2:=j;
             x2:=keysdatatype(obj_keysdata^)[j].xpos;
             y2:=keysdatatype(obj_keysdata^)[j].ypos;
             z2:=keysdatatype(obj_keysdata^)[j].zpos;
             alfa2:=keysdatatype(obj_keysdata^)[j].alfa;
             beta2:=keysdatatype(obj_keysdata^)[j].beta;
             gama2:=keysdatatype(obj_keysdata^)[j].gama;
             goto l3;
            end;
          inc(j);
         end;
      l3:
      if fr2<>fr1 then t:=(frame-fr1)/(fr2-fr1) else t:=0;
 {      tw:=round(t*16384);}
      alfa:=round((alfa2-alfa1)*t+alfa1);
      beta:=round((beta2-beta1)*t+beta1);
      gama:=round((gama2-gama1)*t+gama1);
      x:=round((x2-x1)*t+x1);
      y:=round((y2-y1)*t+y1);
      z:=round((z2-z1)*t+z1);
      (*
      asm
       xor ax,ax
       mov bx,fr1
       cmp fr2,bx
       je @l1
       mov dx,frame
       mov si,fr1
       sub dx,si
       xor ax,ax
       sar dx,1
       rcr ax,1
       sar dx,1
       rcr ax,1
       mov bx,fr2
       sub bx,si
       idiv bx
       @l1:
       mov di,ax

       mov si,word ptr alfa1
       mov ax,word ptr alfa2
       sub ax,si
       imul di
       shl ax,1
       rcl dx,1
       shl ax,1
       rcl dx,1
       add dx,si
       mov word ptr alfa,dx

       mov si,word ptr beta1
       mov ax,word ptr beta2
       sub ax,si
       imul di
       shl ax,1
       rcl dx,1
       shl ax,1
       rcl dx,1
       add dx,si
       mov word ptr beta,dx

       mov si,word ptr gama1
       mov ax,word ptr gama2
       sub ax,si
       imul di
       shl ax,1
       rcl dx,1
       shl ax,1
       rcl dx,1
       add dx,si
       mov word ptr gama,dx

       mov si,word ptr x1
       mov ax,word ptr x2
       sub ax,si
       imul di
       shl ax,1
       rcl dx,1
       shl ax,1
       rcl dx,1
       add dx,si
       mov word ptr x,dx

       mov si,word ptr y1
       mov ax,word ptr y2
       sub ax,si
       imul di
       shl ax,1
       rcl dx,1
       shl ax,1
       rcl dx,1
       add dx,si
       mov word ptr y,dx

       mov si,word ptr z1
       mov ax,word ptr z2
       sub ax,si
       imul di
       shl ax,1
       rcl dx,1
       shl ax,1
       rcl dx,1
       add dx,si
       mov word ptr z,dx
      end;*)

    end;

 l2:
 b:=keysarrtype(obj_keys^)[frame];

{ if b>0 then keyinfotype(keyinfo^).present:=true
        else keyinfotype(keyinfo^).present:=false;

 keyinfotype(keyinfo^).hide:=hide;
 keyinfotype(keyinfo^).posx:=x;
 keyinfotype(keyinfo^).posy:=y;
 keyinfotype(keyinfo^).posz:=z;
 keyinfotype(keyinfo^).alfa:=alfa;
 keyinfotype(keyinfo^).beta:=beta;
 keyinfotype(keyinfo^).gama:=gama;}
 asm
  les di,keyinfo
  cld
  mov al,true
  cmp b,0
  je @l1
  mov al,false
  @l1:
  mov ah,hide
  stosw
  mov ax,alfa
  stosw
  mov ax,beta
  stosw
  mov ax,gama
  stosw
  mov ax,x
  stosw
  mov ax,y
  stosw
  mov ax,z
  stosw
 end;
end;

procedure drawframe(frame:word);
var
 i: integer;
 b:byte;
 keyinfo : keyinfotype;

begin
 for i:=1 to nobj do
   begin
    get_keyinfo(frame,obj_keys[i],obj_keysdata[i],addr(keyinfo));
    if keyinfo.present then b:=15 else b:=10;

    if not keyinfo.hide then
         drawrotscaleobject(i,0,0,0,keyinfo.alfa,keyinfo.beta,keyinfo.gama,
            256,b,keyinfo.posx,keyinfo.posy,keyinfo.posz);

    if i=curnobj then
         drawrotscaleobject(i,0,0,0,rot_alfa,rot_beta,rot_gama,
            256,b div 4,w2d_selx,w2d_sely,w2d_selz);
   end;
 setcolor(15);
end;

function camera_ok: boolean;
begin
 camera_ok:=(obj_keysdata[0]^[curframe].xpos=w3d_posx) and
            (obj_keysdata[0]^[curframe].ypos=w3d_posy) and
            (obj_keysdata[0]^[curframe].zpos=w3d_posz) and
            (obj_keysdata[0]^[curframe].alfa=w3d_alfa) and
            (obj_keysdata[0]^[curframe].beta=w3d_beta) and
            (obj_keysdata[0]^[curframe].gama=w3d_gama);
end;

procedure draw_empty_screen;
var
 dist: longint;
begin
 mouse_hide;
 setcolor(15);
 line(0,0,639,0);
 line(0,479,639,479);
 line(0,0,0,479);
 line(639,0,639,479);

 my_bar(20,20,300,229);

 my_bar(20,250,300,459);

 my_bar(320,250,620,459);
 setcolor(9);
 putpixel(470,355,15);
 setcolor(15);

 outtextxy(10,20,'Y');
 outtextxy(10,250,'Z');
 outtextxy(292,231,'X');
 outtextxy(292,461,'X');

 bar(25,11,310,11+8);

 outtextxy(25,11,'Center X:'+strng(-w2d_posx)+
       ',Y:'+strng(-w2d_posy)+',Z:'+strng(-w2d_posz));
 outtextxy(280,11,strng(w2d_zoom));


 bar(320,20,620,249);
 outtextxy(320,20,'File');
 outtextxy(320,20+10,'EditObj');
 outtextxy(320,20+20,'MovieKey');
 outtextxy(320,20+30,'LookMovie');
 outtextxy(320,20+40,'Exit');

 bar(320,461,620,461+8);
 outtextxy(320,461,'A:'+strng(w3d_alfa));
 outtextxy(320+80,461,'B:'+strng(w3d_beta));
 outtextxy(320+160,461,'G:'+strng(w3d_gama));
 outtextxy(320+230,461,'Rot');
 outtextxy(320+270,461,'Set');

 outtextxy(320,241,'X:'+strng(w3d_posx));
 outtextxy(320+80,241,'Y:'+strng(w3d_posy));
 outtextxy(320+170,241,'Z:'+strng(w3d_posz));

 outtextxy(320,231,'Frame:'+strng(curframe));

 outtextxy(320+80,231,'CurNobj:'+strng(curnobj));
 if (curnobj>0) and (nobj<>0) then outtextxy(320,221,
         'ObjName: '+obj_names[curnobj]+' (F:'+
          strng(obj_nfaces[curnobj])+',V:'+
          strng(obj_nvertices[curnobj])+')');
 outtextxy(320+170,231,'Nobj:'+strng(nobj));
 outtextxy(320+240,231,'Step:'+strng(step));

 dist:=round(sqrt(sqr(longint(w2d_selx)-w3d_posx)+
                  sqr(longint(w2d_sely)-w3d_posy)+
                  sqr(longint(w2d_selz)-w3d_posz)));

 outtextxy(320+240,241,'D:'+strng(dist));

 update_mouse_pos;

 case mode of
  1: write_file_menu;
  4: begin
      write_key_menu;
      drawframe(curframe);
      setfillstyle(solidfill,9);
      if camera_ok then setfillstyle(solidfill,15);
      if obj_keys[0]^[curframe]>0 then bar(325,255,330,260)
                                  else my_bar(325,255,330,260);
     end;
  5: write_movie_menu;
  2: begin
      write_edit_menu;
      if curnobj>0 then
        begin
         drawobject(curnobj);
         drawrotscaleobject(curnobj,0,0,0,rot_alfa,rot_beta,rot_gama,scale,
            8,w2d_selx,w2d_sely,w2d_selz);
        end;
     end;
 end;

 w2d_cursor(0,0,0,2,9);

 w2d_cursor(w2d_selx,w2d_sely,w2d_selz,2,10);

 camera_2d_cursor;

 mouse_show;
end;

procedure waitvertsync; assembler;
asm
 mov dx,3dah
 @l1:
 in al,dx
 mov ah,8
 test al,ah
 jz @l1
 @l1a:
 in al,dx
 test al,ah
 jnz @l1a
 @l1b:
 in al,dx
 test al,ah
 jz @l1b
end;

procedure sel_center;
begin
 if mouse_inw1 then
       begin
        w2d_posx:=-w2d_x;
        w2d_posy:=-w2d_y;
       end;

 if mouse_inw2 then
       begin
        w2d_posx:=-w2d_x;
        w2d_posz:=-w2d_z;
       end;
 draw_empty_screen;
end;

procedure loadobject;
var
 fname: string;
 i,j,k: integer;
 f: file;
 nobj_: word;
 new : boolean;
 s:string;
 label l1,l2,l3,l4;
begin
 mouse_hide;
 textmode(3);
 writeln('Loading object from OBE file');
 writeln('----------------------------------------');
 writeln('Select OBE file:');
 fname:=fpick('*.obe');
 if not picked then goto l1;

 writeln('Memory avaible: ',maxavail,' bytes');

  writeln('Loading OBE file "',fname,'"');
  assign(f,fname); reset(f,1);
  blockread(f,fname,256);

  new:=true;
  for i:=1 to nobj do
   if fname=obj_names[i] then
     begin
      writeln;
      writeln('Found object with the same name.');
      writeln('Would you like to:');
      writeln('(O)vervrite it');
      writeln('(R)ename current object');
      writeln('(Esc) Cansel');
      write  ('?');
      c:=#0;
      while (c<>'O') and (c<>'R') and (c<>#27) do c:=upcase(readkey);
      writeln;
      if c=#27 then
        begin
         close(f);
         goto l1;
        end;
      if c='R' then
        begin
         j:=1;
         l3:
         str(j,s);
         for k:=1 to nobj do
            if copy(fname,1,length(fname)-1)+s+'"'=obj_names[k] then
              begin
               inc(j);
               goto l3;
              end;
         fname:=copy(fname,1,length(fname)-1)+s+'"';
         writeln('Object renamed to ',fname);
         goto l4;
        end;
      writeln('Overwriting object in memory with same name !');
      nobj_:=i;
      new:=false;
      freemem(obj_vertices[nobj_],obj_nvertices[nobj_]*6);
      freemem(obj_faces[nobj_],obj_nfaces[nobj_]*6);
      freemem(obj_normals[nobj_],obj_nfaces[nobj_]*6);
      freemem(obj_bmpxy[nobj_],obj_nfaces[nobj_]*6);
      goto l2;
     end;

 l4:
 inc(nobj);
 nobj_:=nobj;

 l2:
  obj_names[nobj_]:=fname;
  blockread(f,obj_nvertices[nobj_],2);
  blockread(f,obj_nfaces[nobj_],2);

  getmem(obj_vertices[nobj_],obj_nvertices[nobj_]*6);
  getmem(obj_faces[nobj_],obj_nfaces[nobj_]*6);
  getmem(obj_normals[nobj_],obj_nfaces[nobj_]*6);
  getmem(obj_bmpxy[nobj_],obj_nfaces[nobj_]*6);

  blockread(f,obj_vertices[nobj_]^,obj_nvertices[nobj_]*6);
  blockread(f,obj_faces[nobj_]^,obj_nfaces[nobj_]*6);
  blockread(f,obj_normals[nobj_]^,obj_nfaces[nobj_]*6);
  blockread(f,obj_bmpxy[nobj_]^,obj_nfaces[nobj_]*6);
  close(f);
  writeln('Ok');

  if new then
    begin
     i:=nobj;
     getmem(obj_keys[i],sizeof(keysarrtype));
     getmem(obj_keysdata[i],sizeof(keysdatatype));
     fillchar(obj_keys[i]^,sizeof(keysarrtype),0);
     fillchar(obj_keysdata[i]^,sizeof(keysdatatype),0);
    end;

  writeln;
  writeln('Memory avaible: ',maxavail,' bytes');
  writeln;
  write('Enter texture number for object: ');
  readln(obj_texturenum[nobj_]);

l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure loadtexture;
var
 fname: string;
 i: integer;
 f: file;
 label l1;
begin
 mouse_hide;
 textmode(3);

 writeln('Loading texture');
 writeln('-----------------------------------',#10);

 writeln('Select 256-color 256x256 PCX file:');
 fname:=fpick('*.pcx');
 if not picked then goto l1;

 write('Enter number [1..10] (0 - cansel):'); readln(i);
 if (i<1) or (i>10) then goto l1;

 if texture_loaded[i] then globalfreePtr(texture_p[i]);
 texture_loaded[i]:=false;

 texture_p[i]:=globalallocptr(gmem_moveable,65536+32);

 if texture_p[i]=nil then
   begin
    writeln('Insufficient memory');
    readln;
    goto l1;
   end;

 texture_loaded[i]:=true;

 writeln('Loading PCX file "',fname,'"');

 loadpcx_raw(fname,ptr(laga(texture_p[i]).seg,0));

 writeln('Ok');

l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure unloadtexture;
var
 fname: string;
 i: integer;
 f: file;
 label l1;
begin
 mouse_hide;
 textmode(3);

 writeln('Unloading texture');
 writeln('-----------------------------------');
 write('Now in memory textures: ');
 for i:=1 to 10 do
   if texture_loaded[i] then write(i,',');
 writeln(#8,' ',#10);

 write('Enter texture number [1..10] (0 - cansel):'); readln(i);
 if (i<1) or (i>10) then goto l1;

 if texture_loaded[i] then globalfreeptr(texture_p[i]);
 texture_loaded[i]:=false;

l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure displaytexture(textureseg: word); assembler;
asm
 mov di,321
 xor si,si
 mov bx,sega000
 mov dx,128
 cld
 @l2:

 mov cx,64
 @l1:
 mov es,textureseg
 mov al,es:[si]
 mov ah,es:[si+2]

 mov es,bx
 stosw
 add si,4
 dec cx
 jne @l1

 add di,320-128
 add si,256
 dec dx
 jne @l2
end;


procedure viewtexture;
var
 fname: string;
 i: integer;
 f: file;
 x,y: word;
 ofs,c: word;
 label l1;
begin
 mouse_hide;
 textmode(3);

 writeln('Viewing texture');
 writeln('-----------------------------------');
 write('Now in memory textures: [');
 for i:=1 to 10 do
   if texture_loaded[i] then write(i,',');
 writeln(#8,']',#10);

 write('Enter texture number [1..10] (0 - cansel):'); readln(i);
 if (i<1) or (i>10) then goto l1;

 asm
  mov ax,13h
  int 10h
 end;

 textattr:=$70;
 directvideo:=false;

 for x:=0 to 129 do
   begin
    mem[sega000:x]:=255;
    mem[sega000:x+129*320]:=255;
    mem[sega000:x*320]:=255;
    mem[sega000:x*320+129]:=255;
   end;

 setpalette(addr(palette));
 if texture_loaded[i] then
         displaytexture(laga(texture_p[i]).seg);

 gotoxy(19,1); write('---- Palette ----');

 for y:=0 to 7 do
   for x:=0 to 31 do
     begin
      ofs:=10*320+150+y*320*4+x*4;
      c:=y+x*8;
      c:=c+c*256;
      memw[sega000:ofs]:=c;
      memw[sega000:ofs+2]:=c;

      memw[sega000:ofs+320]:=c;
      memw[sega000:ofs+320+2]:=c;

      memw[sega000:ofs+640]:=c;
      memw[sega000:ofs+640++2]:=c;

      memw[sega000:ofs+960]:=c;
      memw[sega000:ofs+960+2]:=c;
     end;

 gotoxy(1,24); write(' - Press Enter to continue -'); readln;

l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure saveprj(s:string);
var
 fname: string;
 i,j: integer;
 f: file;
 l: longint;
 keys : ^keysarrtype;
 keysdata : ^keysdatatype;
 okeys : ^newkeysarrtype;
 okeysdata : ^newkeysdatatype;
 n,m:word;
 b:byte;
 label l1,l2,l3,l2a,l3a;
begin
 if s<>'' then
   begin
    fname:=s;
    goto l2;
   end;

 mouse_hide;
 textmode(3);

 writeln('Saving project');
 writeln('-----------------------------------');
 write('Enter file name (Without extention; empty - cansel): '); readln(fname);
 writeln;
 if fname='' then goto l1;

 fname:=fname+'.prj';
 l2:

 assign(f,fname);
 {$I-}
 rewrite(f,1);
 {$I+}
 if ioresult>0 then
   begin
    writeln(#7);
    writeln('Error: can`t create file "'+fname+'"');
    writeln('Press Enter.');
    readln;
    goto l1;
   end;
 write('Saving environment variables...');
 l:=$12350003;
 blockwrite(f,l,4);
 blockwrite(f,w2d_zoom,4);
 blockwrite(f,w2d_posx,2);
 blockwrite(f,w2d_posy,2);
 blockwrite(f,w2d_posz,2);
 blockwrite(f,w2d_selx,2);
 blockwrite(f,w2d_sely,2);
 blockwrite(f,w2d_selz,2);
 blockwrite(f,w2d_x,2);
 blockwrite(f,w2d_y,2);
 blockwrite(f,w2d_z,2);
 blockwrite(f,w3d_alfa,2);
 blockwrite(f,w3d_beta,2);
 blockwrite(f,w3d_gama,2);
 blockwrite(f,w3d_posx,2);
 blockwrite(f,w3d_posy,2);
 blockwrite(f,w3d_posz,2);

 blockwrite(f,curframe,2);
 blockwrite(f,nobj,2);
 blockwrite(f,curnobj,2);
 blockwrite(f,mode,2);
 blockwrite(f,step,2);

 blockwrite(f,observer,sizeof(observertype));
 blockwrite(f,rot_alfa,2);
 blockwrite(f,rot_beta,2);
 blockwrite(f,rot_gama,2);
 blockwrite(f,scale,2);
 blockwrite(f, status,2);
 blockwrite(f,startframe,2);
 blockwrite(f,msperframe,2);

 writeln('Ok');
 writeln('Saving objects...');
 for i:=1 to nobj do
   begin
    writeln('   ',obj_names[i]);
    blockwrite(f,obj_names[i],13);
    blockwrite(f,obj_nfaces[i],2);
    blockwrite(f,obj_nvertices[i],2);
    blockwrite(f,obj_vertices[i]^,obj_nvertices[i]*6);
    blockwrite(f,obj_faces[i]^,obj_nfaces[i]*6);
{    blockwrite(f,obj_normals[i]^,obj_nfaces[i]*6);}
    blockwrite(f,obj_bmpxy[i]^,obj_nfaces[i]*6);
    blockwrite(f,obj_texturenum[i],1);
  end;

 getmem(keys,sizeof(keysarrtype));
 getmem(keysdata,sizeof(keysdatatype));

 write('Saving movie keys...');
 for i:=0 to nobj do
  begin
   move(obj_keys[i]^,keys^,sizeof(keysarrtype));
   move(obj_keysdata[i]^,keysdata^,sizeof(keysdatatype));
   n:=1;
   for j:=1 to 1800 do
     if keys^[j]>0 then inc(n);

   blockwrite(f,n,2);
   getmem(okeys,n*2);
   getmem(okeysdata,n*13);

   if keys^[0]=0 then
     begin
      keys^[0]:=2;
      keysdata^[0].alfa:=0;
      keysdata^[0].beta:=0;
      keysdata^[0].gama:=0;
      keysdata^[0].xpos:=0;
      keysdata^[0].ypos:=0;
      keysdata^[0].zpos:=0;
     end;

   m:=0;
   for j:=0 to 1800 do
    begin
     b:=keys^[j];
     if b>0 then
         begin
           okeys^[m]:=j;
           if (b and 1)>0 then okeysdata^[m].hide:=false;
           if (b and 2)>0 then okeysdata^[m].hide:=true;

           okeysdata^[m].xpos:=keysdata^[j].xpos;
           okeysdata^[m].ypos:=keysdata^[j].ypos;
           okeysdata^[m].zpos:=keysdata^[j].zpos;
           okeysdata^[m].alfa:=keysdata^[j].alfa;
           okeysdata^[m].beta:=keysdata^[j].beta;
           okeysdata^[m].gama:=keysdata^[j].gama;
           inc(m);
         end;
    end;
   blockwrite(f,okeys^,n*2);
   blockwrite(f,okeysdata^,n*13);
   freemem(okeys,n*2);
   freemem(okeysdata,n*13);
  end;

 freemem(keys,sizeof(keysarrtype));
 freemem(keysdata,sizeof(keysdatatype));
 writeln('Ok');

 write('Saving textures...');
 blockwrite(f,texture_loaded,10);
 for i:=1 to 10 do
    if texture_loaded[i] then
      begin
       blockwrite(f,mem[laga(texture_p[i]).seg:0],65535);
       blockwrite(f,mem[laga(texture_p[i]).seg:65535],1);
      end;
 writeln('Ok');

 write('Saving palette...');
 blockwrite(f,palette,768);
 blockwrite(f,i_table^,16384);
 for i:=1 to nobj do
   if copy(obj_names[i],1,6)='"spark' then goto l2a;
 goto l3a;
 l2a:
 blockwrite(f,i_table2^,8192);
 l3a:
 blockwrite(f,texture_msq,10);
 for i:=1 to 10 do
        if texture_msq[i]>0 then
           begin
            blockwrite(f,msq_data[i],12);
            blockwrite(f,msq_framedata[i],20);
           end;
 writeln('Ok');
 close(f);
 writeln;
 writeln('Memory avaible: ',maxavail, ' bytes');

 if s<>'' then goto l3;

 writeln;
 writeln('Press Enter to continue.'); readln;

l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;

l3:
end;

procedure calcitbl;
var
 k : real;
 c1r,c1b,c1g,c2r,c2b,c2g: integer;
 i,j,m,n,o: word;
 d1,d2,d,dmin: longint;
 decodetbl : array [0..255] of byte;
 p: pointer;
 label l1;

begin
p:=i_table;
for o:=0 to 63 do
begin
 write('Generating "i_table.dat" ',(o*100 div 63):3,'%    ',#13);
 if o<$20 then
    k:=0.2+(1-0.2)*o/$20
          else
    k:=0+(0.3-0)*(o-$20)/$20;

  k:=o/55;

  for i:=0 to 255 do
    begin
      c2r:=round(palette[i*3+1]*k);
      if c2r>63 then c2r:=63;
      c2g:=round(palette[i*3+2]*k);
      if c2g>63 then c2g:=63;
      c2b:=round(palette[i*3+3]*k);
      if c2b>63 then c2b:=63;
     dmin:=999999999;
     for j:=0 to 255 do
       begin
        asm
         mov ax,j
         mov si,ax
         shl ax,1
         add si,ax
         add si,offset palette
         cld

         lodsb
         xor ah,ah
         sub ax,c2r
         imul ax
         mov  cx,30
         mul  cx
         mov word ptr d,ax
         mov word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2g
         imul ax
         mov cx,59
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2b
         imul ax
         mov cx,11
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx
        end;

        if d<dmin then
          begin
           dmin:=d;
           m:=j;
          end;
       end;
     decodetbl[i]:=m;
    end;
 fastmove(@decodetbl,p,256);
 inc(laga(p).ofs,256);
end;
writeln('Generating "i_table.dat"...Ok       ');
end;

procedure calc_itable2;
var
 k,k1 : real;
 c1r,c1b,c1g,c2r,c2b,c2g: integer;
 i,j,m,n,o: word;
 d1,d2,d,dmin: longint;
 decodetbl : array [0..255] of byte;
 p:pointer;
 label l1;

begin
p:=i_table2;
for o:=0 to 31 do
begin
 write('Generating "i_table2.dat" ',(o*100 div 31):3,'%    ',#13);
  k:=(31-o)/31;
  k1:=o/31;
  k:=1;

  for i:=0 to 255 do
    begin
      c2r:=round(palette[i*3+1]*k+63*k1);
      if c2r>63 then c2r:=63;
      c2g:=round(palette[i*3+2]*k+63*k1);
      if c2g>63 then c2g:=63;
      c2b:=round(palette[i*3+3]*k+63*k1);
      if c2b>63 then c2b:=63;
     dmin:=999999999;
     for j:=0 to 255 do
       begin
        asm
         mov ax,j
         mov si,ax
         shl ax,1
         add si,ax
         add si,offset palette
         cld

         lodsb
         xor ah,ah
         sub ax,c2r
         imul ax
         mov  cx,30
         mul  cx
         mov word ptr d,ax
         mov word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2g
         imul ax
         mov cx,59
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2b
         imul ax
         mov cx,11
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx
        end;

        if d<dmin then
          begin
           dmin:=d;
           m:=j;
          end;
       end;
     decodetbl[i]:=m;
    end;
 fastmove(@decodetbl,p,256);
 inc(laga(p).ofs,256);
end;
writeln('Generating "i_table2.dat"...Ok       ');
end;

procedure loadprj;
var
 fname: string;
 i,j,k: integer;
 f: file;
 format: longint;
 l: longint;
 n: word;
 okeys : ^newkeysarrtype;
 okeysdata: ^newkeysdatatype;
 label l1,l2,l3;
begin
 mouse_hide;
 textmode(3);

 writeln('Loading project');
 writeln('-----------------------------------');

 writeln('Select project file:');
 fname:=fpick('*.prj');
 if not picked then goto l1;

 assign(f,fname);
 {$I-}
 reset(f,1);
 {$I+}
 if ioresult>0 then goto l1;

 write('Unloading all data...');

 for i:=1 to 10 do
   if texture_loaded[i] then globalfreeptr(texture_p[i]);

 for i:=1 to nobj do
   begin
    freemem(obj_vertices[i],obj_nvertices[i]*6);
    freemem(obj_faces[i],obj_nfaces[i]*6);
    freemem(obj_normals[i],obj_nfaces[i]*6);
    freemem(obj_bmpxy[i],obj_nfaces[i]*6);
  end;

 for i:=0 to nobj do
  begin
   freemem(obj_keys[i],sizeof(keysarrtype));
   freemem(obj_keysdata[i],sizeof(keysdatatype));
  end;
 writeln('Ok');
 writeln('Memory avaible: ',maxavail,' bytes');
 writeln;
 blockread(f,w2d_zoom,4);

 if (w2d_zoom<>$12340001) and (w2d_zoom<>$12350003) then
   begin
    writeln('Not valid PRJ file. Press any key.');
    readkey;
    goto l1;
   end;

 format:=w2d_zoom;
 blockread(f,w2d_zoom,4);
 write('Loading environment variables...');
 blockread(f,w2d_posx,2);
 blockread(f,w2d_posy,2);
 blockread(f,w2d_posz,2);
 blockread(f,w2d_selx,2);
 blockread(f,w2d_sely,2);
 blockread(f,w2d_selz,2);
 blockread(f,w2d_x,2);
 blockread(f,w2d_y,2);
 blockread(f,w2d_z,2);
 blockread(f,w3d_alfa,2);
 blockread(f,w3d_beta,2);
 blockread(f,w3d_gama,2);
 blockread(f,w3d_posx,2);
 blockread(f,w3d_posy,2);
 blockread(f,w3d_posz,2);

 blockread(f,curframe,2);
 blockread(f,nobj,2);
 blockread(f,curnobj,2);
 blockread(f,mode,2);
 blockread(f,step,2);

 blockread(f,observer,sizeof(observertype));
 blockread(f,rot_alfa,2);
 blockread(f,rot_beta,2);
 blockread(f,rot_gama,2);
 blockread(f,scale,2);
 blockread(f,status,2);
 if format=$12350003 then  blockread(f,startframe,2) else startframe:=0;
 if format=$12350003 then  blockread(f,msperframe,2) else msperframe:=500;

 writeln('Ok');

 writeln('Loading objects...');
 for i:=1 to nobj do
   begin
    blockread(f,obj_names[i],13);
    writeln('   ',obj_names[i]);
    blockread(f,obj_nfaces[i],2);
    blockread(f,obj_nvertices[i],2);

    getmem(obj_vertices[i],obj_nvertices[i]*6);
    getmem(obj_faces[i],obj_nfaces[i]*6);
    getmem(obj_normals[i],obj_nfaces[i]*6);
    getmem(obj_bmpxy[i],obj_nfaces[i]*6);

    blockread(f,obj_vertices[i]^,obj_nvertices[i]*6);
    blockread(f,obj_faces[i]^,obj_nfaces[i]*6);
    if format=$12340001 then blockread(f,obj_normals[i]^,obj_nfaces[i]*6);
    blockread(f,obj_bmpxy[i]^,obj_nfaces[i]*6);
    blockread(f,obj_texturenum[i],1);
  end;

 write('Loading movie keys...');
 for i:=0 to nobj do
  begin
   getmem(obj_keys[i],sizeof(keysarrtype));
   getmem(obj_keysdata[i],sizeof(keysdatatype));
   fillchar(obj_keys[i]^,sizeof(keysarrtype),0);
   fillchar(obj_keysdata[i]^,sizeof(keysdatatype),0);

   if format=$12340001 then
     begin
      blockread(f,obj_keys[i]^,sizeof(keysarrtype));
      blockread(f,obj_keysdata[i]^,sizeof(keysdatatype));
     end
                       else
     begin
      blockread(f,n,2);
      getmem(okeys,n*2);
      getmem(okeysdata,n*13);
      blockread(f,okeys^,n*2);
      blockread(f,okeysdata^,n*13);
      for j:=0 to n-1 do
        begin
         k:=1;
         if okeysdata^[j].hide then k:=2;
         obj_keys[i]^[okeys^[j]]:=k;
         obj_keysdata[i]^[okeys^[j]].alfa:=okeysdata^[j].alfa;
         obj_keysdata[i]^[okeys^[j]].beta:=okeysdata^[j].beta;
         obj_keysdata[i]^[okeys^[j]].gama:=okeysdata^[j].gama;
         obj_keysdata[i]^[okeys^[j]].xpos:=okeysdata^[j].xpos;
         obj_keysdata[i]^[okeys^[j]].ypos:=okeysdata^[j].ypos;
         obj_keysdata[i]^[okeys^[j]].zpos:=okeysdata^[j].zpos;
        end;
      freemem(okeys,n*2);
      freemem(okeysdata,n*13);
     end;
  end;
 writeln('Ok');

 write('Loading textures...');
 blockread(f,texture_loaded,10);
 for i:=1 to 10 do
    if texture_loaded[i] then
     begin
      texture_p[i]:=globalallocptr(gmem_moveable,65536+32);
      if texture_p[i]=nil then
       begin
        writeln('Insufficient memory');
        readln;
        close(f);
       halt;
      end;
      blockread(f,mem[laga(texture_p[i]).seg:0],65535);
      blockread(f,mem[laga(texture_p[i]).seg:65535],1);
     end;

 writeln('Ok');

 writeln('Loading palette...');
 if format=$12350003 then
     begin
      blockread(f,palette,768);
      blockread(f,i_table^,16384);
     for i:=1 to nobj do
      if copy(obj_names[i],1,6)='"spark' then goto l2;
     goto l3;
     l2:
     blockread(f,i_table2^,8192);
     l3:
     end
                    else
     begin
      loadpcx_pal('universl.pcx',@palette);
      calcitbl;
      calc_itable2;
     end;

 if eof(f) then
   fillchar(texture_msq,10,0)
           else
    begin
     blockread(f,texture_msq,10);
     for i:=1 to 10 do
        if texture_msq[i]>0 then
           begin
            blockread(f,msq_data[i],12);
            blockread(f,msq_framedata[i],20);
           end;
    end;
 close(f);
 writeln('Ok');

 writeln;
 writeln('Memory avaible: ',maxavail,' bytes');
 writeln;
 writeln('Press Enter to continue.'); readln;
l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure set_center;
var
 p: pointer;
 i: integer;
 label l1;
begin
if (curnobj=0) or (nobj=0) then goto l1;
 p:=obj_vertices[curnobj];
 i:=obj_nvertices[curnobj];
 asm
  mov cx,i
  les si,p

  @l1:
  mov ax,w2d_selx
  add es:[si],ax
  inc si
  inc si

  mov ax,w2d_sely
  add es:[si],ax
  inc si
  inc si

  mov ax,w2d_selz
  add es:[si],ax
  inc si
  inc si
  loop @l1
  xor ax,ax
  mov w2d_selx,ax
  mov w2d_sely,ax
  mov w2d_selz,ax
 end;
 l1:
end;

procedure w3d_rot(a:integer);
var
 rad: longint;
begin
 rad:=round(sqrt(sqr(longint(w3d_posx-w2d_selx))+
  sqr(longint(w3d_posy-w2d_sely))+
  sqr(longint(w3d_posz-w2d_selz))));
 inc(w3d_alfa,a);
 observer.alfa_rad:=round(w3d_alfa*pi/180*65536);
 observer.beta_rad:=round(w3d_beta*pi/180*65536);
 observer.gama_rad:=round(w3d_gama*pi/180*65536);
 spherelook(addr(observer),rad);
 w3d_posx:=observer.x+w2d_selx;
 w3d_posy:=observer.y+w2d_sely;
 w3d_posz:=observer.z+w2d_selz;
end;

procedure setcameradata;
var
 keyinfo: keyinfotype;
begin
 get_keyinfo(curframe,obj_keys[0],obj_keysdata[0],addr(keyinfo));
 w3d_alfa:=keyinfo.alfa;
 w3d_beta:=keyinfo.beta;
 w3d_gama:=keyinfo.gama;
 w3d_posx:=keyinfo.posx;
 w3d_posy:=keyinfo.posy;
 w3d_posz:=keyinfo.posz;
end;

procedure setcameralastkey;
var
 keyinfo: keyinfotype;
 i,j: integer;
begin
 j:=1;
 for i:=1 to curframe do if obj_keys[0]^[i]>0 then j:=i;
 get_keyinfo(j,obj_keys[0],obj_keysdata[0],addr(keyinfo));
 w3d_alfa:=keyinfo.alfa;
 w3d_beta:=keyinfo.beta;
 w3d_gama:=keyinfo.gama;
 w3d_posx:=keyinfo.posx;
 w3d_posy:=keyinfo.posy;
 w3d_posz:=keyinfo.posz;
end;


procedure setframedata;
var
 keyinfo: keyinfotype;
 label l1;
begin
 setcameradata;
 if curnobj=0 then
   begin
    rot_alfa:=0; rot_beta:=0; rot_gama:=0;
    w2d_selx:=0; w2d_sely:=0; w2d_selz:=0;
    goto l1;
   end;
 get_keyinfo(curframe,obj_keys[curnobj],obj_keysdata[curnobj],addr(keyinfo));
 w2d_selx:=keyinfo.posx;
 w2d_sely:=keyinfo.posy;
 w2d_selz:=keyinfo.posz;
 rot_alfa:=keyinfo.alfa;
 rot_beta:=keyinfo.beta;
 rot_gama:=keyinfo.gama;
 status:=keyinfo.hide;
 l1:
end;

procedure delete_keys_toend;
var
 i:integer;
begin
 for i:=curframe+1 to maxnkeys do obj_keys[curnobj]^[i]:=0;
 setframedata;
end;

procedure setobjlastkey;
var
 keyinfo: keyinfotype;
 i,j: integer;
 label l1;
begin
 if curnobj=0 then goto l1;

 j:=1;
 for i:=1 to curframe do if obj_keys[curnobj]^[i]>0 then j:=i;

 get_keyinfo(j,obj_keys[curnobj],obj_keysdata[curnobj],addr(keyinfo));
 w2d_selx:=keyinfo.posx;
 w2d_sely:=keyinfo.posy;
 w2d_selz:=keyinfo.posz;
 rot_alfa:=keyinfo.alfa;
 rot_beta:=keyinfo.beta;
 rot_gama:=keyinfo.gama;
 status:=keyinfo.hide;
 l1:
end;

procedure removekey(n,frame: word);
label l1;
begin
 if n=0 then goto l1;
 obj_keys[n]^[frame]:=0;
 setframedata;
l1:
end;

procedure setkey(n,frame: word; hide:boolean; x,y,z,alfa,beta,gama: integer);
var
 b: byte;
 label l1;
begin
 if n=0 then goto l1;
 b:=1; if hide then b:=2;
 obj_keys[n]^[frame]:=b;
 obj_keysdata[n]^[frame].xpos:=x;
 obj_keysdata[n]^[frame].ypos:=y;
 obj_keysdata[n]^[frame].zpos:=z;
 obj_keysdata[n]^[frame].alfa:=alfa;
 obj_keysdata[n]^[frame].beta:=beta;
 obj_keysdata[n]^[frame].gama:=gama;
 l1:
end;

procedure showmotion;
var
 pcurnobj,i,j,lastframe: integer;
 t: longint;
 label l1,l2;
begin
 while mouse_leftb do;
 pcurnobj:=curnobj;
 curnobj:=0;

 lastframe:=1;
 for i:=0 to nobj do
   for curframe:=0 to maxnkeys do
      if (obj_keys[i]^[curframe]>0) and (curframe>lastframe) then
           lastframe:=curframe;

 setframedata;

 l2:
 for curframe:=startframe to lastframe do
   begin
    t:=timercounter;
    draw_empty_screen;
    setcameradata;

    setcolor(10);
    outtextxy(320,190,'Press Left button to stop');
    setcolor(15);

    drawframe(curframe);
    repeat
     if mouse_leftb then goto l1;
     if keypressed then goto l1;
    until timercounter-t>600;
   end;
 delay(3000);
 goto l2;
 l1:

 while keypressed do readkey;

 draw_empty_screen;
 while mouse_leftb do;
 curnobj:=pcurnobj;
end;

procedure realtimemovie;
var
 f: file;
label l1;
begin
 while mouse_leftb do;

 mouse_hide;

 textattr:=$70;
 directvideo:=false;
 if maxavail<128000+64000+16000+37768+200 then
   begin
    textmode(3);
    writeln('Not Enougth memory.');
    writeln('Press enter to continue.');
    readln;
    goto l1;
   end;

 textmode(3);
 saveprj('$$tmp$$.prj');

 swapvectors;
 exec('play_prj.exe','$$tmp$$.prj '+strng(startframe));
 swapvectors;

 assign(f,'$$tmp$$.prj'); erase(f);

 if doserror>0 then
   begin
     writeln('Doserror=',doserror);
     writeln('File play_prj.exe not found or not enougth memory.');
     writeln('Press Enter.');
     readln;
   end;

l1:
 while mouse_leftb do;
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure setcamerakey;
begin
 obj_keys[0]^[curframe]:=1;
 obj_keysdata[0]^[curframe].xpos:=w3d_posx;
 obj_keysdata[0]^[curframe].ypos:=w3d_posy;
 obj_keysdata[0]^[curframe].zpos:=w3d_posz;
 obj_keysdata[0]^[curframe].alfa:=w3d_alfa;
 obj_keysdata[0]^[curframe].beta:=w3d_beta;
 obj_keysdata[0]^[curframe].gama:=w3d_gama;
end;

procedure deletecamerakey;
begin
 if curframe<>0 then obj_keys[0]^[curframe]:=0;
end;

procedure calcnormal(norm: pointer);
type
 normalt = array [1..3] of integer;
var
 x1,y1,z1   : integer;
 x21,x31, y21,y31, z21,z31    : longint;
 a,b,c,m : real;
 i,j : word;

begin
 x1:=poly_3d[1,1];
 y1:=poly_3d[1,2];
 z1:=poly_3d[1,3];

 x21:=poly_3d[2,1]-x1;
 y21:=poly_3d[2,2]-y1;
 z21:=poly_3d[2,3]-z1;

 x31:=poly_3d[3,1]-x1;
 y31:=poly_3d[3,2]-y1;
 z31:=poly_3d[3,3]-z1;

 a:= y21*z31 - y31*z21;
 b:= z21*x31 - x21*z31;
 c:= x21*y31 - x31*y21;

 m:=sqrt(sqr(a)+sqr(b)+sqr(c));
if m<>0 then
 begin
  a:=(a*127)/m;
  b:=(b*127)/m;
  c:=(c*127)/m;
 end
   else
     begin
      writeln;
      writeln('------------ normal length = 0 !');
    {  halt;}
     a:=127;
     b:=0;
     c:=0;
     end;
 normalt(norm^)[1]:=round(a);
 normalt(norm^)[2]:=round(b);
 normalt(norm^)[3]:=round(c);
end;

procedure insertkey;
var
  i: integer;
  label l1;
begin
 if (curnobj=0) and (curframe=0) then
  begin
   write(#7);
   goto l1;
  end;
 for i:=maxnkeys downto curframe+1 do
   begin
    obj_keys[curnobj]^[i]:=obj_keys[curnobj]^[i-1];
    obj_keysdata[curnobj]^[i]:=obj_keysdata[curnobj]^[i-1];
   end;
 obj_keys[curnobj]^[curframe]:=0;
 setframedata;
 l1:
end;

procedure g_insertkey;
var
  i,j: integer;
  label l1;
begin
 for j:=0 to nobj do
  begin
   if (j=0) and (curframe=0) then goto l1;
   for i:=maxnkeys downto curframe+1 do
     begin
      obj_keys[j]^[i]:=obj_keys[j]^[i-1];
      obj_keysdata[j]^[i]:=obj_keysdata[j]^[i-1];
     end;
   obj_keys[j]^[curframe]:=0;
   l1:
  end;
 setframedata;
end;

procedure deletekey;
var
  i: integer;
  label l1;
begin
 if (curnobj=0) and (curframe=0) then
  begin
   write(#7);
   goto l1;
  end;
 for i:=curframe to maxnkeys-1 do
   begin
    obj_keys[curnobj]^[i]:=obj_keys[curnobj]^[i+1];
    obj_keysdata[curnobj]^[i]:=obj_keysdata[curnobj]^[i+1];
   end;
 obj_keys[curnobj]^[maxnkeys]:=0;
 setframedata;
 l1:
end;

procedure g_deletekey;
var
  i,j: integer;
  label l1;
begin
 for j:=0 to nobj do
  begin
   if (j=0) and (curframe=0) then goto l1;
   for i:=curframe to maxnkeys-1 do
     begin
      obj_keys[j]^[i]:=obj_keys[j]^[i+1];
      obj_keysdata[j]^[i]:=obj_keysdata[j]^[i+1];
     end;
   obj_keys[j]^[maxnkeys]:=0;
   l1:
  end;
 setframedata;
end;

procedure unloadobject;
var
 n,i: word;
 c:char;
 label l1;
begin

 mouse_hide;
 textmode(3);
 writeln('Select object to delete,ESC - cansel');
 writeln('--------------------------------------------');

 for i:=1 to nobj do
   writeln(chr(i+64)+': ',obj_names[i]);

 c:=readkey;

 n:=ord(upcase(c))-64;
 if (n<1) or (n>nobj) then goto l1;

 i:=n;
 freemem(obj_vertices[i],obj_nvertices[i]*6);
 freemem(obj_faces[i],obj_nfaces[i]*6);
 freemem(obj_normals[i],obj_nfaces[i]*6);
 freemem(obj_bmpxy[i],obj_nfaces[i]*6);
 freemem(obj_keys[i],sizeof(keysarrtype));
 freemem(obj_keysdata[i],sizeof(keysdatatype));

 for i:=n to nobj-1 do
   begin
    obj_vertices[i]:=obj_vertices[i+1];
    obj_faces[i]:=obj_faces[i+1];
    obj_normals[i]:=obj_normals[i+1];
    obj_bmpxy[i]:=obj_bmpxy[i+1];
    obj_keys[i]:=obj_keys[i+1];
    obj_keysdata[i]:=obj_keysdata[i+1];

    obj_names[i]:=obj_names[i+1];
    obj_nfaces[i]:=obj_nfaces[i+1];
    obj_nvertices[i]:=obj_nvertices[i+1];
    obj_texturenum[i]:=obj_texturenum[i+1];
   end;

  dec(nobj);
  if curnobj>nobj then curnobj:=nobj;
 l1:

 mouse_show;
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;


procedure loadpalette;
var
 fname: string;
 i: integer;
 f: file;
 label l1;
begin
 mouse_hide;
 textmode(3);

 writeln('Loading palette');
 writeln('-----------------------------------',#10);

 writeln('Select 256-color PCX file:');
 fname:=fpick('*.pcx');
 if not picked then goto l1;

 loadpcx_pal(fname,@palette);
 writeln;
 calcitbl;
 calc_itable2;
l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure rotate_camera;
var
 rad,alfa,alfaadd,rad2,radadd,rtime: real;
 rkeys,i: integer;
 label l1;
begin
 mouse_hide;
 textmode(3);
 writeln('Camera rotating tool');
 writeln('---------------------------------------');
 writeln('* entering 0 will cansel operation');
 writeln;
 write('Enter rotating time (mS): ');
 readln(rtime);
 if rtime=0 then goto l1;
 rkeys:=round(rtime/msperframe);
 if rkeys=0 then rkeys:=1;
 writeln(' * It"s will be ',rkeys,' keys.');
 write('Enter rotate angle (degrees): ');
 readln(alfa);
 if alfa=0 then goto l1;
 alfaadd:=alfa/rkeys;
 writeln(' * It"s will be ',alfaadd:3:1,' degrees per key.');
 rad:=sqrt(sqr(longint(w3d_posx-w2d_selx))+
  sqr(longint(w3d_posy-w2d_sely))+
  sqr(longint(w3d_posz-w2d_selz)));
 writeln('First radius is ',rad:5:1);
 write('Enter last radius: ');
 readln(rad2);
 radadd:=(rad2-rad)/rkeys;

 dec(rkeys);
 alfa:=w3d_alfa;
 i:=curframe;
 for curframe:=i+1 to i+1+rkeys do
   begin
    alfa:=alfa+alfaadd;
    rad:=rad+radadd;
    w3d_alfa:=round(alfa);
    observer.alfa_rad:=round(alfa*pi/180*65536);
    observer.beta_rad:=round(w3d_beta*pi/180*65536);
    observer.gama_rad:=round(w3d_gama*pi/180*65536);
    spherelook(addr(observer),round(rad));
    w3d_posx:=observer.x+w2d_selx;
    w3d_posy:=observer.y+w2d_sely;
    w3d_posz:=observer.z+w2d_selz;
    setcamerakey;
  end;
l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure rotate_object;
var
 rad,alfa,alfaadd,rad2,radadd,rtime: real;
 rkeys,i: integer;
 cx,cy: integer;
 x1,y1,z,zadd,z2,x,y,rad1:real;
 label l1;
begin
 mouse_hide;
 textmode(3);
 writeln('Object rotating tool (gorizontal)');
 writeln('---------------------------------------');
 writeln('* entering 0 will cansel operation');
 writeln;
 write('Enter rotating time (mS): ');
 readln(rtime);
 rkeys:=round(rtime/msperframe);
 if rkeys=0 then rkeys:=1;
 writeln(' * It"s will be ',rkeys,' keys.');
 if rtime=0 then goto l1;
 write('Enter rotate angle (degrees): ');
 readln(alfa);
 if alfa=0 then goto l1;
 alfaadd:=alfa/rkeys;
 writeln(' * It"s will be ',alfaadd:3:1,' degrees per key.');
 writeln('Enter rotating center: ');
 write('X: ');
 readln(cx);
 write('Y: ');
 readln(cy);
 rad:=sqrt(sqr(longint(cx-w2d_selx))+
  sqr(longint(cy-w2d_sely)));
 writeln('First radius is ',rad:5:1);
 write('Enter last radius: ');
 readln(rad2);
 radadd:=(rad2-rad)/rkeys;

 z:=w2d_selz;
 writeln('First Z is:',z:5:1);
 write('Enter last Z: ');
 readln(z2);
 zadd:=(z2-z)/rkeys;

 rad1:=rad;
 dec(rkeys);
 alfa:=0;
 i:=curframe;
 x:=w2d_selx-cx;
 y:=w2d_sely-cy;

 for curframe:=i+1 to i+1+rkeys do
   begin
    alfa:=alfa+alfaadd;
    rad:=rad+radadd;
    z:=z+zadd;

    x1:=x*cos(alfa*pi/180)+y*sin(alfa*pi/180);
    y1:=y*cos(alfa*pi/180)-x*sin(alfa*pi/180);

    w2d_selx:=round(x1*rad/rad1+cx);
    w2d_sely:=round(y1*rad/rad1+cy);
    w2d_selz:=round(z);

    setkey(curnobj,curframe,status,w2d_selx,w2d_sely,w2d_selz,rot_alfa,rot_beta,rot_gama);
  end;
l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure optimize_obj;
var
 i,j: integer;
 vp : ^vertexarrtype;
 fp: ^facesarrtype;
 bp : ^bmpxyarrtype;
 nv,nf: word;
 a,b,c,d,goptim,optim,optim2,goptim2: word;
 l: longint;
 label l1,l2,l3,l4,l5,l6,l7;
begin
 mouse_hide;
 textmode(3);

 getmem(vp,maxnvertices*6);
 getmem(fp,maxnfaces*6);
 getmem(bp,maxnfaces*6);

 writeln('Optimizing objects');
 writeln('-----------------------------------',#10);

 goptim:=0; goptim2:=0;

 for i:=1 to nobj do
  if copy(obj_names[i],1,5)<>'"morf' then
   begin
    optim:=0;
    optim2:=0;
    nv:=obj_nvertices[i];
    nf:=obj_nfaces[i];
    fastmove(obj_vertices[i],vp,nv*6);
    fastmove(obj_faces[i],fp,nf*6);
    fastmove(obj_bmpxy[i],bp,nf*6);
    freemem(obj_vertices[i],nv*6);
    freemem(obj_normals[i],nf*6);
    freemem(obj_faces[i],nf*6);
    freemem(obj_bmpxy[i],nf*6);
    write(obj_names[i],': ');

    write('       ');
    l2:
    write(#8,#8,#8,#8,#8,#8,#8,'V:',nv:5);
    if nv=1 then goto l7;
    for a:=1 to nv do
      for  b :=a+1 to nv do
          begin
           l:=sqr(longint(vp^[a,1])-vp^[b,1])+
              sqr(longint(vp^[a,2])-vp^[b,2])+
              sqr(longint(vp^[a,3])-vp^[b,3]);
           if l<=4 then
             begin
              for c:=b+1 to nv do fastmove(@vp^[c],@vp^[c-1],6);
              for c:=1 to nf do
                for d:=1 to 3 do
                  begin
                   if fp^[c,d]=b then fp^[c,d]:=a;
                   if fp^[c,d]>b then dec(fp^[c,d]);
                  end;
              inc(optim);
              inc(goptim);
              dec(nv);
              goto l2;
             end;
          end;
    l7:
    write(',        ');
    l3:
    write(#8,#8,#8,#8,#8,#8,#8,'F:',nf:5);

    if nf=1 then goto l4;
    for c:=1 to nf do
      if (fp^[c,1]=fp^[c,2]) or
         (fp^[c,1]=fp^[c,3]) or
         (fp^[c,2]=fp^[c,3]) then
      begin
       for d:=c+1 to nf do fastmove(@fp^[d],@fp^[d-1],6);
       for d:=c+1 to nf do fastmove(@bp^[d],@bp^[d-1],6);
       dec(nf);
       inc(optim2);
       inc(goptim2);
       goto l3;
      end;

    l4:

    l6:
    for a:=1 to nv do
      begin
       for  b:=1 to nf do
        begin
         if fp^[b,1]=a then goto l5;
         if fp^[b,2]=a then goto l5;
         if fp^[b,3]=a then goto l5;
        end;
       for c:=a+1 to nv do fastmove(@vp^[c],@vp^[c-1],6);
       for c:=1 to nf do
         for d:=1 to 3 do
               if fp^[c,d]>a then dec(fp^[c,d]);
       inc(optim);
       inc(goptim);
       dec(nv);
       goto l6;
       l5:
      end;
    obj_nvertices[i]:=nv;
    getmem(obj_vertices[i],nv*6);
    fastmove(vp,obj_vertices[i],nv*6);
    getmem(obj_faces[i],nf*6);
    fastmove(fp,obj_faces[i],nf*6);
    getmem(obj_bmpxy[i],nf*6);
    fastmove(bp,obj_bmpxy[i],nf*6);
    obj_nfaces[i]:=nf;

    writeln('  -  ',optim,',',optim2);

    getmem(obj_normals[i],obj_nfaces[i]*6);

    for c:=1 to obj_nfaces[i] do
     begin
      fastmove(@obj_vertices[i]^[obj_faces[i]^[c,1]],@poly_3d[1],6);
      fastmove(@obj_vertices[i]^[obj_faces[i]^[c,2]],@poly_3d[2],6);
      fastmove(@obj_vertices[i]^[obj_faces[i]^[c,3]],@poly_3d[3],6);
      calcnormal(@obj_normals[i]^[c]);
     end;
   end;

 writeln('-----------------------');
 writeln(goptim,',',goptim2);
 readln;
l1:

 freemem(vp,maxnvertices*6);
 freemem(fp,maxnfaces*6);
 freemem(bp,maxnfaces*6);

 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure saveobject;
var
 fname: string;
 nobj_,i,j,k: integer;
 s:string;
 c:char;
 f:file;
 label l1,l2,l3,l4;
begin
 mouse_hide;
 textmode(3);
 writeln('Saving object to OBE file');
 writeln('----------------------------------------');
 writeln;
 writeln('Select object: ');
 for i:=1 to nobj do
   writeln(chr(i+64)+': ',obj_names[i]);

 c:=readkey;

 nobj_:=ord(upcase(c))-64;
 if (nobj_<1) or (nobj_>nobj) then goto l1;

 write('Enter name (without extention):');
 readln(fname);
 fname:=fname+'.obe';

 assign(f,fname); rewrite(f,1);
 fname:=obj_names[nobj_];
 blockwrite(f,fname,256);
 blockwrite(f,obj_nvertices[nobj_],2);
 blockwrite(f,obj_nfaces[nobj_],2);
 blockwrite(f,obj_vertices[nobj_]^,obj_nvertices[nobj_]*6);
 blockwrite(f,obj_faces[nobj_]^,obj_nfaces[nobj_]*6);
 blockwrite(f,obj_normals[nobj_]^,obj_nfaces[nobj_]*6);
 blockwrite(f,obj_bmpxy[nobj_]^,obj_nfaces[nobj_]*6);
 close(f);

l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure set_light;
var
 i: integer;
 lon: integer;
 keyinfo:keyinfotype;
 frame_observer: observertype;
 light : record
          posx,posy,posz: integer;
         end;
 label l1;
begin
 lon:=-1;
 for i:=1 to nobj do
   if copy(obj_names[i],1,6)='"light' then lon:=i;

 if lon=-1 then goto l1;


 for i:=0 to maxnkeys-2 do
   begin
    get_keyinfo(i,obj_keys[0],obj_keysdata[0],@keyinfo);
    if not keyinfo.present then
      begin
       frame_observer.x:=keyinfo.posx;
       frame_observer.y:=keyinfo.posy;
       frame_observer.z:=keyinfo.posz;
       frame_observer.alfa_rad:=longint(keyinfo.alfa)*1144;
       frame_observer.beta_rad:=longint(keyinfo.beta)*1144;
       frame_observer.gama_rad:=longint(keyinfo.gama)*1144;

       light.posx:=0;
       light.posy:=1000;
       light.posz:=0;
       rotate_3d_back(1,@light,@frame_observer,@light);

       setkey(lon,i,true,light.posx+keyinfo.posx,light.posy+keyinfo.posy,
       light.posz+keyinfo.posz,0,0,0);
      end
         else
         obj_keys[lon]^[i]:=0;
   end;


 l1:
end;

procedure load_msq;
var
 fname:string;
 f:file;
 tn:word;
 label l1;
begin
 mouse_hide;
 textmode(3);

 writeln('Loading Movie seqence');
 writeln('-----------------------------------');
 write('Now in memory: [');
 for tn:=1 to 10 do if texture_msq[tn]>0 then write(tn,',');
 writeln(']');
 write('Apply to texture [1..10]: ');
 readln(tn);
 if (tn<1) or (tn>10) then goto l1;

 texture_msq[tn]:=0;

 writeln('Select MSQ file:');
 writeln('ESC - unload');
 fname:=fpick('*.msq');
 if not picked then goto l1;

 texture_msq[tn]:=1;

 assign(f,fname); reset(f,1);
 blockread(f,msq_data[tn],12);
 blockread(f,msq_framedata[tn],10*2);
 close(f);
 gotoxy(1,22); write('Ok                               ');
l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure savekeys;
var
 fname:string;
 f:file;
 nobj_:word;
 frame1,frame2: integer;
 c:char;
 label l1;
begin
 mouse_hide;
 textmode(3);

 writeln('Saving Movie keys');
 writeln('-----------------------------------');

 writeln('Select object: ');
 writeln('Space - camera');
 for i:=1 to nobj do
   writeln(chr(i+64)+': ',obj_names[i]);

 c:=readkey;

 nobj_:=ord(upcase(c))-64;
 if c=' ' then nobj_:=0;
 if (nobj_<0) or (nobj_>nobj) then goto l1;

 write('First frame:');
 readln(frame1);
 if frame1<0 then goto l1;

 write('Last frame:');
 readln(frame2);
 if frame2<0 then goto l1;
 if frame2<frame1 then goto l1;

 dec(frame2,frame1-1);

 write('Enter name (without extention):');
 readln(fname);
 fname:=fname+'.key';

 assign(f,fname); rewrite(f,1);
 blockwrite(f,frame2,2);
 blockwrite(f,obj_keys[nobj_]^[frame1],frame2);
 blockwrite(f,obj_keysdata[nobj_]^[frame1],frame2*12);
 close(f);
l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

procedure loadkeys;
var
 fname:string;
 f:file;
 nobj_:word;
 frame1,frame2: integer;
 c:char;
 label l1;
begin
 mouse_hide;
 textmode(3);

 writeln('Loading Movie keys');
 writeln('-----------------------------------');

 writeln('Select object: ');
 writeln('Space - camera');
 for i:=1 to nobj do
   writeln(chr(i+64)+': ',obj_names[i]);

 c:=readkey;

 nobj_:=ord(upcase(c))-64;
 if c=' ' then nobj_:=0;
 if (nobj_<0) or (nobj_>nobj) then goto l1;

 write('First frame:');
 readln(frame1);
 if frame1<0 then goto l1;

 write('Enter name (without extention):');
 readln(fname);
 fname:=fname+'.key';

 assign(f,fname); reset(f,1);
 blockread(f,frame2,2);
 blockread(f,obj_keys[nobj_]^[frame1],frame2);
 blockread(f,obj_keysdata[nobj_]^[frame1],frame2*12);
 close(f);
l1:
 setgraphmode(vgahi);
 mouse_show;
 draw_empty_screen;
end;

{===================================================================}
{ MAIN                                                              }
{===================================================================}
begin
 getdir(0,s);
 if s='C:\BP\PAS' then chdir ('c:\tmp\asc');

 eye_hx:=300;
 eye_hz:=190;

 directvideo:=false;

 getmem(obj_keys[0],sizeof(keysarrtype));
 getmem(obj_keysdata[0],sizeof(keysdatatype));
 fillchar(obj_keys[0]^,sizeof(keysarrtype),0);
 fillchar(obj_keysdata[0]^,sizeof(keysdatatype),0);
 obj_keys[0]^[0]:=1;
 obj_keysdata[0]^[0].xpos:=0;
 obj_keysdata[0]^[0].ypos:=-3000;
 obj_keysdata[0]^[0].zpos:=0;
 obj_keysdata[0]^[0].alfa:=0;
 obj_keysdata[0]^[0].beta:=0;
 obj_keysdata[0]^[0].gama:=0;

 getmem(i_table,16384);
 getmem(i_table2,8192);

 for i:=1 to 10 do texture_loaded[i]:=false;
 for i:=1 to maxnobj do obj_texturenum[i]:=1;

 loadpcx_pal('universl.pcx',addr(palette));

 setgfxmode480;

 if not mouse_reset then
    begin
     textmode(3);
     writeln('Please load mouse driver !');
     halt;
    end;
 mouse_show;

 draw_empty_screen;

 repeat

 t:=timercounter;
 waitvertsync;

 update_mouse_pos;

 {=============================================}
 {  Left button                                }
 {=============================================}
 if mouse_leftb then
   begin
     if (mouse_inw1 or mouse_inw2) then  sel_pos;
     if mouse_inset then
          begin
           w3d_posx:=w2d_selx;
           w3d_posy:=w2d_sely;
           w3d_posz:=w2d_selz;
          end;
     if mouse_inzoom then if w2d_zoom<2048 then
                           w2d_zoom:=w2d_zoom*2;
     if mouse_incurnobj then
             begin
              if curnobj<nobj then inc(curnobj);
              if mode=4 then setframedata;
             end;
     if mouse_inalfa then inc(w3d_alfa,step);
     if mouse_inbeta then inc(w3d_beta,step);
     if mouse_ingama then inc(w3d_gama,step);
     if mouse_inrot then w3d_rot(step);
     if mouse_inw3dx then inc(w3d_posx,step);
     if mouse_inw3dy then inc(w3d_posy,step);
     if mouse_inw3dz then inc(w3d_posz,step);
     if mouse_inframe then
       begin
        inc(curframe);
        if mode=4 then setframedata;
       end;
     if mouse_inmenufile then mode:=1;
     if mouse_inmenuedit then
       begin
        rot_alfa:=0; rot_beta:=0; rot_gama:=0;
        w2d_selx:=0; w2d_sely:=0; w2d_selz:=0;
        scale:=256;
        mode:=2;
       end;
     if mouse_inmenukey  then
       begin
        mode:=4;
        setframedata;
       end;
     if mouse_inmuviekey  then mode:=5;
     if mode=1 then
       begin
        if mouse_insubmenu3 then loadobject;
        if mouse_insubmenu4 then  unloadobject;
        if mouse_insubmenu5 then loadtexture;
        if mouse_insubmenu6 then unloadtexture;
        if mouse_insubmenu7 then viewtexture;
        if mouse_insubmenu2 then saveprj('');
        if mouse_insubmenu1 then loadprj;
        if mouse_insubmenu8 then loadpalette;
        if mouse_insubmenu9 then load_msq;
       end;
     if mouse_inexit then myexit;

     if (mode=7) or (mode=4) or (mode=2) then
       begin
        if mouse_inrotalfa then inc(rot_alfa,step);
        if mouse_inrotbeta then inc(rot_beta,step);
        if mouse_inrotgama then inc(rot_gama,step);
       end;
     if mode=4 then
       begin
        if mouse_insubmenu1 then
           setkey(curnobj,curframe,status,w2d_selx,w2d_sely,w2d_selz,rot_alfa,rot_beta,rot_gama);
        if mouse_insubmenu2 then
           removekey(curnobj,curframe);
        if mouse_instatus then status:=not status;
        if mouse_insubmenu3 then insertkey;
        if mouse_insubmenu4 then deletekey;
        if mouse_insetcamera then setcamerakey;
        if mouse_insubmenu5 then delete_keys_toend;
        if mouse_insubmenu6 then rotate_camera;
        if mouse_insubmenu7 then rotate_object;
       end;
     if mode=2 then
      begin
       if (mouse_insubmenu1) and (curnobj>0) then
        begin
         do_obj_rot_scale(curnobj,0,0,0,
             rot_alfa,rot_beta,rot_gama,scale);
         set_center;
         rot_alfa:=0; rot_beta:=0; rot_gama:=0;
         w2d_selx:=0; w2d_sely:=0; w2d_selz:=0;
         scale:=256;
        end;
        if mouse_inscale then inc(scale,step);
        if mouse_intextnum then inc(obj_texturenum[curnobj]);
   end;
     if (mode=5) and (mouse_inrotalfa) then inc(startframe,step);
     if (mode=5) and (mouse_inscale) then inc(msperframe,step);
     if (mode=5) and mouse_insubmenu2 then showmotion;
     if (mode=5) and mouse_insubmenu1 then realtimemovie;
   end;

 {=============================================}
 {  Right button                               }
 {=============================================}
 if mouse_rightb then
     begin
      if (mouse_inw1 or mouse_inw2) then sel_center;
      if mouse_inzoom then if w2d_zoom>2 then
                         w2d_zoom:=w2d_zoom div 2;
     if mouse_incurnobj then
           begin
            if curnobj>0 then dec(curnobj);
            if mode=4 then setframedata;
           end;
      if mouse_incenter then
         begin
          w2d_posx:=0;
          w2d_posy:=0;
          w2d_posz:=0;
         end;
     if mouse_inalfa then dec(w3d_alfa,step);
     if mouse_inbeta then dec(w3d_beta,step);
     if mouse_ingama then dec(w3d_gama,step);
     if mouse_inrot then w3d_rot(-step);
     if mouse_inw3dx then dec(w3d_posx,step);
     if mouse_inw3dy then dec(w3d_posy,step);
     if mouse_inw3dz then dec(w3d_posz,step);
     if mouse_inframe then
       begin
        if curframe<>0 then dec(curframe);
        if mode=4 then setframedata;
       end;
     if (mode=7) or (mode=4) or(mode=2) then
       begin
        if mouse_inrotalfa then dec(rot_alfa,step);
        if mouse_inrotbeta then dec(rot_beta,step);
        if mouse_inrotgama then dec(rot_gama,step);
       end;
     if (mode=2) then
       begin
        if mouse_inscale then dec(scale,step);
        if mouse_intextnum then
              if obj_texturenum[curnobj]>1 then dec(obj_texturenum[curnobj]);
       end;
     if mode=4 then
       begin
        if mouse_insubmenu3 then g_insertkey;
        if mouse_insubmenu4 then g_deletekey;
        if mouse_insetcamera then deletecamerakey;
       end;
     if (mode=5) and (mouse_inrotalfa) then dec(startframe,step);
     if (mode=5) and (mouse_inscale) then dec(msperframe,step);
     end;

 if startframe<0 then startframe:=0;
 if msperframe<100 then msperframe:=10;

 if scale<0 then scale:=0;
 if scale>4096 then scale:=4096;

 c:=#1;
 if keypressed then c:=readkey;
 case upcase(c) of
 '?': optimize_obj;
 'Q': inc(rot_alfa,step);
 'A': dec(rot_alfa,step);
 'Z': rot_alfa:=0;
 'W': inc(rot_beta,step);
 'S': dec(rot_beta,step);
 'X': rot_beta:=0;
 'E': inc(rot_gama,step);
 'D': dec(rot_gama,step);
 'C': rot_gama:=0;

 'U': inc(w3d_alfa,step);
 'J': dec(w3d_alfa,step);
 'M': w3d_alfa:=0;
 'I': inc(w3d_beta,step);
 'K': dec(w3d_beta,step);
 ',': w3d_beta:=0;
 'O': inc(w3d_gama,step);
 'L': dec(w3d_gama,step);
 '.': w3d_gama:=0;

 ';': w3d_rot(step);
 #39: w3d_rot(-step);
 '+': if step<100 then inc(step);
 '-': if step>0 then dec(step);
 '1'..'9' : step:=(ord(c)-ord('0'))*10;
 '0': step:=1;
 '=': step:=300;
 '/': setobjlastkey;
 '*': setcameralastkey;
 ']': begin
       inc(curframe);
       if mode=4 then setframedata;
      end;
 '[': begin
       if curframe<>0 then dec(curframe);
       if mode=4 then setframedata;
      end;
  '~': begin
        mode:=5;
        showmotion;
       end;
  '`': realtimemovie;
  '|':set_light;
 #0: begin
      c:=readkey;
      case c of
       #60: saveprj('');
       #61: loadprj;
       #105: unloadobject;
       #106: loadobject;
       #107: begin
              rot_alfa:=0; rot_beta:=0; rot_gama:=0;
              w2d_selx:=0; w2d_sely:=0; w2d_selz:=0;
              scale:=256;
              mode:=2;
             end;
       #108: saveobject;
       #109: savekeys;
       #110: loadkeys;
       #85: unloadtexture;
       #86: loadtexture;
       #87: viewtexture;
       #45: myexit;
       #72: begin
             if curnobj<nobj then inc(curnobj);
             if mode=4 then setframedata;
             end;
       #80: begin
             if curnobj>0 then dec(curnobj);
             if mode=4 then setframedata;
            end;
       #77: begin
             if curframe<maxnkeys then inc(curframe);
             if mode=4 then setframedata;
           end;
       #75: begin
             if curframe<>0 then dec(curframe);
             if mode=4 then setframedata;
            end;
       #73: begin
             if curframe<maxnkeys then inc(curframe,10) else curframe:=maxnkeys;
             if mode=4 then setframedata;
           end;
       #81: begin
             if curframe>10 then dec(curframe,10) else curframe:=0;
             if mode=4 then setframedata;
            end;
       #71: begin
             curframe:=0;
             if mode=4 then setframedata;
            end;
      end;
     end;
 end;

 if mouse_leftb or mouse_rightb or (c<>#1) then draw_empty_screen;

{ while timercounter-t<30 do;}

 while mouse_rightb do;
 while mouse_leftb do;

 until false;
end.


                       ---=== Keyframe ===---

嬥୮ ࠭⢮:
  x ࠢ ࠢ, z , y .
 alfa - 饭  ਧ⠫쭮 ᪮ (xy)
 beta - 饭  ⨪쭮 ᪮ (zx)
 gama - -"-   ७

࠭:
  ᫥ -   ᢥ
  ᫥ -   ᯥ।
  ᫥ -   

 筮  /ࠢ ⮭ 誨  ࢮ 㪢
 ᫮ 㢥稢/㬥蠥 ࠬ

 ⮢ 㦮祪 뢠  業 ࠭⢠
 (ࠢ ⮭ ।   ࠭)
  㦮祪 -   - ⠭  㦭 
 ࠭⢠ ﬨ  ⮭   
  p㦮祪  p 砥 p.    - ᫨
   p㦪,  p ᬮp  -  p.

 Center - 뢠,  窥 ࠭⢠ ᮮ⢥
     業  (᫨   ᫮ ࠢ ⮭,  ३  0,0,0)
 ࠢ center - scale - 㢥祭 ࠦ   (256 - 1:1)

 न  ᫥ - न 

 Frame -  ⥪饣 
 curboj -  ⥪饣 쥪
 nobj - - 쥪⮢  
 step - 蠣,    㣫/न  ⨨
        ⮭   㪢 ᫮

   :
  A,B,G - 㣫 ७
  Rot -    ୥  窨,  ன 室
          㤥 ᬮ    (ࠢ/ ⮭)
  Set - ⠢ p   pp⢠,  室 pp
  X,Y,Z -    ࠭⢥

:
 q,w,e - 㢥祭 㣫  쥪 (alfa,beta,gama)
 a,s,d - 㬥襭 -"-
 z,x,c - 㫥 -"-

 u,i,o     - 㢥祭 㣫 ७ 
 j,k,l     - 㬥襭 -"-
 m,",","." - 㫥 -"-
 ";","'"   - 饭     ਧ⠫쭮
             ᪮ (ᬮਬ  )

 Left,Right   - 㬥襭/㢥祭  ⥪饣 
 Home      - ⥪騩 p = 0
 Up,Down   - 롮  쥪

 +,-   - 㢥祭/㬥襭 step
 0     - step=1
 1..9  - step = 10..90
 =     - step = 300

 `     - Look movie (Realtime)
 ~     - look movie (show motion)

 F2    - save project
   뢠 __ pp
 F3    - load project
 ALT+F2 - unload object
 ALT+F3 - load object
 ALT+F4 - edit object
 ALT+F5 - save object (!)
 ALT+F6 - save keys
 ALT+F7 - load keys - p㧨/  祩 쥪
 SHIFT+F2 - unload texture
 SHIFT+F3 - load texture
 SHIFT+F4 - view texture
 ALT+X   - 室

㧪 쥪:
 File/LoadObj - 뢮   롮 OBE 䠩.
  H  "Enter texture number for object" 㦭  ᫮
  1..10 -  ⥪  ,  ᯮ 쥪
  (  祩 1..10 㦠   Load Texture)

㧪 ⥪
 File/Load Texture
    - 256-color  PCX 256x256 - , ᯮ짮
    objedit'. H  Enter number 㦭  ᫮ 1..10 -
   祩,   㦠 ⥪.

㧪 ⥪
 File/Unload Texture
   ᢮ , ⮩ ⥪ன

ᬮ ⥪
 File/View Texture
   ᬮ ⥪. ᫥ ᬮ - Enter.

஢ 쥪
 EditObj
  H㦥  롮 業 쥪,   (ਬ -  
  業 㦭   ⠢)

   梥⮬  ⥪饥 ﭨ 쥪,
  p - , ஥ ᥩ ⠢
  A,B,C - 㣫  쥪
  Scale - 㢥祭 쥪 (256 - 1:1)
  Texture number -  ⥪,  ᯮ 쥪
  ।   । 業 쥪   ,
   ன 室 
  쥪 頥  ᢮ 業 (ࠪ᪨ -  )
  H  perform -  ࠭  쥪 ⠭
  ⥪騬.
  Scale     3D Studio,   .

஢ 䨫쬠
 MovieKey

 롨ࠥ 㦭 . 롨ࠥ 쥪.
 Status - ﭨ 쥪  ⮬  (/)
 A,B,G -  쥪   業
  -  業 쥪
 / 梥⮬ ࠦ ⥪饥 ﭨ  쥪
 ( -  ࠦ).  -  ⥪饬   key
   쥪.
 -/ᨭ 梥⮬ ࠦ ࠭  쥪.
 - -  key.
 add key - ⠭ ࠭  쥪  key.
   孥 㣫   ⨪.  梥 -
    ।  . ⮩ -  ।.
  梥 - key ,  ࠭   ⫨砥
  ⮣, ஥ । key
 ⠭      -
  ⮭  ⨪ ( camera key - ࠢ).

 न, 㣫 ௮ **, ⮬ 㦭  
  keys.

 Add Key - ⠢ 
 Remove key - p key
 Insert key - ⠢ *⮩* key (p p)
 Delete key - 㤠 key (ᦠ p)
 Insert,delete - ᫨   ⮭,  ⮫쪮  ⥪饣
 쥪, ᫨ p -    쥪⮢  p

ᬮ 
 LookMovie/show motion
 뢠 ஢ ।஢  3   訬 㧠
  

H p:
 p p⠥  Protected Mode !!!!!
  ,   p㦠 _pﭮ_ ⥪p

  StarFrame   look movie - p,  p 
 뢠 䨫

 p ᪥ play_prj p play_prj.s3m

 / - ⠢ 쥪  ᫥ ,  p 
      ᫥騥 

 * - ⠢ p  ᫥ ,  p 
      ᫥騥 

 Ms per key - ᥪ㭤  1 key - ᪮p 䨫쬠

 "|" - ⠢ 쥪 light p p   p ( p
       砥,  쥪 light  p㦥)
