uses crt,mode256,loadpcx,realtime;

type
 laga = record
    ofs,seg: word;
        end;
var
 palette1: array [0..255,1..3] of byte;
 bufseg: word;
 p: pointer;
 k : real;
 c1r,c1b,c1g,c2r,c2b,c2g: integer;
 ofs: word;
 i,j,m,n,o: word;
 d,dmin: longint;

 decodetbl : array [0..255] of byte;
 f: file;

 label l1;
begin
 getmem(p,64000+32);
 bufseg:=laga(p).seg+1;

 setgfxmode;


 loadpcx_raw_pal('c:\tmp\asc\universl.pcx',ptr(bufseg,0),addr(palette1));


 assign(f,'c:\tmp\asc\i_table.dat'); rewrite(f,1);

 setgfxmode;
 setpalette(addr(palette1));
 move(mem[bufseg:0],mem[$a000:0],64000);

for o:=0 to 63 do
begin
 if o<$20 then
    k:=0.2+(1-0.2)*o/$20
          else
    k:=0+(0.6-0)*(o-$20)/$20;

  for i:=0 to 255 do
    begin
    if o<$20 then
     begin
      c2r:=round(palette1[i,1]*k);
      if c2r>63 then c2r:=63;
      c2g:=round(palette1[i,2]*k);
      if c2g>63 then c2g:=63;
      c2b:=round(palette1[i,3]*k);
      if c2b>63 then c2b:=63;
     end
      else
     begin
      c2r:=round(palette1[i,1]+(63-palette1[i,1])*k);
      if c2r>63 then c2r:=63;
      c2g:=round(palette1[i,2]+(63-palette1[i,2])*k);
      if c2g>63 then c2g:=63;
      c2b:=round(palette1[i,3]+(63-palette1[i,3])*k);
      if c2b>63 then c2b:=63;
     end;

     dmin:=999999999;
     for j:=0 to 255 do
       begin
        asm
         mov ax,j
         mov si,ax
         shl ax,1
         add si,ax
         add si,offset palette1
         cld

         lodsb
         xor ah,ah
         sub ax,c2r
         imul ax
         mov  cx,30
         mul  cx
         mov word ptr d,ax
         mov word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2g
         imul ax
         mov cx,59
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2b
         imul ax
         mov cx,11
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx
        end;

        if d<dmin then
          begin
           dmin:=d;
           m:=j;
          end;
       end;
     decodetbl[i]:=m;
    end;

 if keypressed then halt;

 asm
  lea bx,decodetbl
  xor di,di
  cld
  mov cx,32000
  mov dx,0a000h
  mov si,bufseg

  @l1:
  mov es,si
  mov al,es:[di]
  xlat
  mov es,dx
  stosb
  mov es,si
  mov al,es:[di]
  xlat
  mov es,dx
  stosb
  dec cx
  jne @l1
 end;
   gotoxy(1,1); write(k:1:3);
 blockwrite(f,decodetbl,256);
end;


close(f);
end.