uses crt,loadpcx,realtime,winapi,mode256,mousetpu,gurofill;

type
 laga = record
   ofs,seg: word;
  end;

  triangle_type = array [1..3,1..2] of integer;

var
 buf1p,buf2p: pointer;
 buf1seg,buf2seg: word;
 buf3p,buf4p: pointer;
 buf3seg,buf4seg: word;
 palette: array [0..768] of byte;
 mtime: word;
 i,j: integer;

 triangles : array [1..50] of triangle_type;
 triangles_v : array [1..50,1..3] of word;
 ntriangles : word;
 points : array [1..150,1..2] of integer;
 points2: array [1..150,1..2] of integer;
 npoints : word;
 c: char;
 col : byte;
 mode,x,y: integer;

function timercounter1: longint;
begin
 timercounter1:=longint(ptr(seg0040,$6c)^);
end;

{$F+}
procedure calc_morph_phase(seg1,seg2,scrseg: word; phase:byte); external;
{$F-}
{$L Morph}

function crossing(line1,line2: pointer): Boolean;
{ ===============================================================
   TRUE, ᫨ १ lie1  line2 ᥪ.
  ===============================================================}
type
 line2d = array [1..2,1..2] of integer;
var
 A1,A2,B1,B2,C1,C2,D1,D2,S1,S2 :longint;
 DM1,DM2,DM3: longint;
 t1,t2 : real;

label l1,l2;

begin
{ if (line2d(line1^)[1,1]=line2d(line2^)[1,1]) and
    (line2d(line1^)[1,2]=line2d(line2^)[1,2]) and
    (line2d(line1^)[2,1]=line2d(line2^)[2,1]) and
    (line2d(line1^)[2,2]=line2d(line2^)[2,2]) then goto l2;}
{ if (line2d(line1^)[1,1]=line2d(line2^)[2,1]) and
    (line2d(line1^)[1,2]=line2d(line2^)[2,2]) and
    (line2d(line1^)[2,1]=line2d(line2^)[1,1]) and
    (line2d(line1^)[2,2]=line2d(line2^)[1,2]) then goto l2;}

 asm
  les si,line1
  mov ax,es:[si]
  mov bx,es:[si+2]
  mov cx,es:[si+4]
  mov dx,es:[si+6]

  les si,line2
  cmp ax,es:[si]
  jne @l1
  cmp bx,es:[si+2]
  jne @l1
  cmp cx,es:[si+4]
  jne @l1
  cmp dx,es:[si+6]
  jne @l1
  jmp l2
  @l1:

  cmp cx,es:[si]
  jne @l1a
  cmp dx,es:[si+2]
  jne @l1a
  cmp ax,es:[si+4]
  jne @l1a
  cmp bx,es:[si+6]
  jne @l1a
  jmp l2
  @l1a:
 end;

{================================================================
   뢠 ࠢﬨ

 / x1 = A1 + B1*t1      / x2 = A2 + B2*t2
 \ y1 = C1 + D1*t1      \ y2 = C2 + D2*t2

  

    A = X1   B = X2 - X1   (१ ᮥ 窨 (X1,Y1),(X2,Y2)
    C = Y1   D = Y2 - Y1

  祭 ࠬ t  窨 祭   
  ⥬ ࠢ

   / A1 + B1*t1 = A2 + B2*t2
   \ C1 + D1*t1 = C2 + D2*t2

   蠥 ⥬:

   / B1*t1 - B2*t2 = A2 - A1
   \ D1*t1 - D2*t2 = C2 - C1

     S1 = A2 - A1
     S2 = C2 - C1

           | B1  -B2 |
     DM1 = |         | = -D2*B1 + D1*B2
           | D1  -D2 |

     ᫨ DM1 = 0 㤥   祭 ,    
       १ ࠫ  室   אַ 
     ᮢ.

           | S1  -B2 |
     DM2 = |         | = -S1*D2 + S2*B2
           | S2  -D2 |

           | B1   S1 |
     DM3 = |         | = S2*B1 - S1*D1
           | D1   S2 |

           DM2             DM3
     t1 = -----      t2 = -----
           DM1             DM1

     ᫨ (t1=>0)  (t1<=1)  (t2>=0)  (t2<=1)  १ ᥪ.
      न 窨 祭:

     Xc = A1 + B1*t1
     Yc = C1 + D1*t1

 ==========================================================================}

 A1:=line2d(line1^)[1,1];
 A2:=line2d(line2^)[1,1];
 C1:=line2d(line1^)[1,2];
 C2:=line2d(line2^)[1,2];

 B1:=line2d(line1^)[2,1]-line2d(line1^)[1,1];
 B2:=line2d(line2^)[2,1]-line2d(line2^)[1,1];
 D1:=line2d(line1^)[2,2]-line2d(line1^)[1,2];
 D2:=line2d(line2^)[2,2]-line2d(line2^)[1,2];


 S1:=A2 - A1;
 S2:=C2 - C1;

 DM1 := -D2*B1 + D1*B2;

 if abs(DM1)<0.00001 then
    begin
     l2:
     crossing:=False;
     goto l1;
    end;

 DM2 := -S1*D2 + S2*B2;
 DM3 :=  S2*B1 - S1*D1;

 t1 := DM2/DM1;

 if (t1<0.001) or (t1>0.999) then goto l2;

 t2 := DM3/DM1;

 if (t2<0) or (t2>1) then goto l2;

 crossing:=true;

l1:
end;

function inbar(poly: pointer; point: pointer): boolean;
{==============================================================
  TRUE ᫨ 窠   p㣮쭨 poly.
 ==============================================================}
type xy = record
           x,y: integer;
          end;
type
 poly4 = array [1..4] of xy;
var
 count: integer;
 m,n,m1,n1 : longint;
 mn1,nm1: longint;
 label l1;
begin
 inbar :=false;

{ for m:=1 to 3 do
   if (poly4(poly^)[m].x=poly4(point^)[1].x) and
      (poly4(poly^)[m].y=poly4(point^)[1].y) then
         goto l1;

 asm
  les si,point
  mov bx,es:[si]
  mov di,es:[si+2]

  les si,poly

  cmp bx,es:[si]
  jne @l1
  cmp di,es:[si+2]
  jne @l1
  jmp l1
  @l1:

  cmp bx,es:[si+4]
  jne @l1a
  cmp di,es:[si+2+4]
  jne @l1a
  jmp l1
  @l1a:

  cmp bx,es:[si+4+4]
  jne @l1b
  cmp di,es:[si+2+4+4]
  jne @l1b
  jmp l1
  @l1b:
 end;

 count:=0;
 {m:=poly4(poly^)[2].x-poly4(poly^)[1].x;
 n:=poly4(poly^)[2].y-poly4(poly^)[1].y;

 m1:=poly4(point^)[1].x-poly4(poly^)[1].x;
 n1:=poly4(point^)[1].y-poly4(poly^)[1].y;

 if m*n1-n*m1>=0 then inc(count) else dec(count);}

 asm
  les si,poly
  mov bx,es:[si]
  mov di,es:[si+2]

  mov ax,es:[si+4]
  sub ax,bx
  mov word ptr m,ax

  mov ax,es:[si+4+2]
  sub ax,di
  mov word ptr n,ax

  les si,point
  mov ax,es:[si+2]
  sub ax,di
  imul word ptr m
  mov word ptr mn1,ax
  mov word ptr mn1+2,dx

  mov ax,es:[si]
  sub ax,bx
  imul word ptr n
  sub word ptr mn1,ax
  sbb word ptr mn1+2,dx
 end;

 if mn1>=0 then inc(count) else dec(count);

{ m:=poly4(poly^)[3].x-poly4(poly^)[2].x;
 n:=poly4(poly^)[3].y-poly4(poly^)[2].y;

 m1:=poly4(point^)[1].x-poly4(poly^)[2].x;
 n1:=poly4(point^)[1].y-poly4(poly^)[2].y;

 if m*n1-n*m1>=0 then inc(count) else dec(count);}

  asm
  les si,poly
  mov bx,es:[si+4]
  mov di,es:[si+2+4]

  mov ax,es:[si+4+4]
  sub ax,bx
  mov word ptr m,ax

  mov ax,es:[si+4+2+4]
  sub ax,di
  mov word ptr n,ax

  les si,point
  mov ax,es:[si+2]
  sub ax,di
  imul word ptr m
  mov word ptr mn1,ax
  mov word ptr mn1+2,dx

  mov ax,es:[si]
  sub ax,bx
  imul word ptr n
  sub word ptr mn1,ax
  sbb word ptr mn1+2,dx
 end;

 if mn1>=0 then inc(count) else dec(count);


{ m:=poly4(poly^)[1].x-poly4(poly^)[3].x;
 n:=poly4(poly^)[1].y-poly4(poly^)[3].y;

 m1:=poly4(point^)[1].x-poly4(poly^)[3].x;
 n1:=poly4(point^)[1].y-poly4(poly^)[3].y;

 if m*n1-n*m1>0 then inc(count) else dec(count);}

  asm
  les si,poly
  mov bx,es:[si+4+4]
  mov di,es:[si+2+4+4]

  mov ax,es:[si+4+4+4]
  sub ax,bx
  mov word ptr m,ax

  mov ax,es:[si+4+2+4+4]
  sub ax,di
  mov word ptr n,ax

  les si,point
  mov ax,es:[si+2]
  sub ax,di
  imul word ptr m
  mov word ptr mn1,ax
  mov word ptr mn1+2,dx

  mov ax,es:[si]
  sub ax,bx
  imul word ptr n
  sub word ptr mn1,ax
  sbb word ptr mn1+2,dx
 end;

 if mn1>=0 then inc(count) else dec(count);

 if abs(count)=3 then inbar:=true else inbaR:=false;
 l1:
end;

function crossbars(poly1,poly2: pointer): Boolean;
{===========================================================
   True, ᫨ p㣮쭨 poly1  poly2  騥 窨
 ===========================================================}
var
 i,j: integer;
 polyd1,polyd2 : array [1..4,1..2] of integer;

 label l1;

begin
crossbars:=true;

move(poly1^,addr(polyd1)^,2*2*3);
move(poly2^,addr(polyd2)^,2*2*3);

polyd1[4]:=polyd1[1];
polyd2[4]:=polyd2[1];

if inbar(addr(polyd1),addr(polyd2[1])) then goto l1;
if inbar(addr(polyd1),addr(polyd2[2])) then goto l1;
if inbar(addr(polyd1),addr(polyd2[3])) then goto l1;

if inbar(addr(polyd2),addr(polyd1[1])) then goto l1;
if inbar(addr(polyd2),addr(polyd1[2])) then goto l1;
if inbar(addr(polyd2),addr(polyd1[3])) then goto l1;

for i:=1 to 3 do
  for j:=1 to 3 do
    if crossing(addr(polyd1[i]),addr(polyd2[j])) then goto l1;

crossbars:=false;
l1:
end;

procedure draw_triangle(p: pointer; c: byte);
var
 tr : ^triangle_type;
begin
 tr:=p;
 line_brez(tr^[1,1],tr^[1,2],tr^[2,1],tr^[2,2],c,sega000);
 line_brez(tr^[2,1],tr^[2,2],tr^[3,1],tr^[3,2],c,sega000);
 line_brez(tr^[3,1],tr^[3,2],tr^[1,1],tr^[1,2],c,sega000);
end;

function distance(p: pointer;ofs1,ofs2: word): longint;
var
 l: longint;
begin
 asm
  les si,p
  mov di,si
  add si,ofs1
  add di,ofs2
  mov ax,es:[di]
  sub ax,es:[si]
  mov bx,ax
  imul bx
  mov word ptr l,ax
  mov word ptr l+2,dx

  mov ax,es:[di+2]
  sub ax,es:[si+2]
  mov bx,ax
  imul bx
  add word ptr l,ax
  adc word ptr l+2,dx
 end;
{ distance:=round(sqrt(l));}
distance:=l;
end;


function square(p: pointer): longint;
begin
 square:=distance(p,0,4)+
         distance(p,4,8)+
         distance(p,8,0);
end;

procedure show_triangles(c:byte);
var
 i: integer;
begin
gotoxy(10,10); write(ntriangles);
 for i:=1 to ntriangles do
   draw_triangle(@triangles[i],c);
end;

procedure do_split;
var
 x,i,j,k,o: integer;
 tr : triangle_type;
 trmin : triangle_type;
 trmin_v: array [1..3] of integer;
 have : boolean;
 sm,squaretrmin,l: longint;
 label l1,l2,l3;
begin
 ntriangles:=0;
 sm:=-1;

 l3:
  gotoxy(1,21);
  for i:=1 to npoints do write('');
  gotoxy(1,21);

 have:=false;
 for i:=npoints downto 1 do
  begin
   write('');
   for j:=i-1 downto 1 do
     for k:=j-1 downto 1 do
       begin
{        if (i=j) or (j=k) or (i=k) then goto l2;}
{        asm
         mov ax,i
         mov bx,j
         mov cx,k
         cmp ax,bx
         je l2
         cmp ax,cx
         je l2
         cmp bx,cx
         je l2
        end;}

        move(points[i],tr[1],4);
        move(points[j],tr[2],4);
        move(points[k],tr[3],4);

        for x:=1 to ntriangles do
           if (triangles_v[x,1]=i) and
              (triangles_v[x,2]=j) and
              (triangles_v[x,3]=k) then goto l1;

        l:=square(@tr);
        if (i<5) or (j<5) or (k<5) then l:=l*10;

        if l<sm then goto l1;
        if have then
            if l>squaretrmin then goto l1;

        for x:=1 to ntriangles do
           if crossbars(@tr,@triangles[x]) then goto l1;

        have:=true;
        move(tr,trmin,3*4);
        trmin_v[1]:=i;
        trmin_v[2]:=j;
        trmin_v[3]:=k;
        squaretrmin:=l;

        l1:
        l2:
       end;
    end;

sm:=squaretrmin;
gotoxy(1,22);
for i:=1 to ntriangles do write('');
if keypressed then halt;

if have then
  begin
{  clearvga(sega000);}
   draw_triangle(@trmin,255);
{   write('enter');
   readln;}
   inc(ntriangles);
   move(trmin,triangles[ntriangles],4*3);
   move(trmin_v,triangles_v[ntriangles],3*2);
   goto l3;
  end;
end;


procedure show_pcx4(bufseg,ofs: word); assembler;
asm
 push ds
 mov ax,sega000
 mov es,ax
 mov ds,bufseg
 cld
 xor si,si
 mov di,ofs

 mov dx,64

 @l2:
 mov cx,128
 @l1:
 lodsw
 stosb
 dec cx
 jne @l1

 add di,320-128
 add si,256
 dec dx
 jne @l2


 pop ds
end;

procedure show_pcx(bufseg,ofs: word); assembler;
asm
 push ds
 mov ax,sega000
 mov es,ax
 mov ds,bufseg
 cld
 xor si,si
 mov di,ofs

 mov dx,128

 @l2:
 mov cx,128
 rep movsw
 add di,320-256
 dec dx
 jne @l2


 pop ds
end;

function getcolor(x,y: integer): byte; assembler;
asm
 mov ax,sega000
 mov es,ax

 mov ax,320
 mul y
 add ax,x
 mov di,ax
 mov al,es:[di]
end;

procedure show_morph(once: boolean);
var
 i,j,k,l: integer;
 t: longint;
 points_m: array [1..150,1..2] of integer;
 tr1,tr2: triangle_type;
 label l1,l2,l3;
begin
 do_split;

 clearvga(sega000);

 show_triangles(255);
 delay(1000);
 clearvga(sega000);

 l3:
 show_pcx(buf1seg,0);
 delay(1000);

 t:=timercounter1;
 repeat
 i:=round((timercounter1-t)*128/(18.2*mtime));
 if i>127 then i:=127;
 if keypressed then goto l2;

 k:=i;
 for j:=1 to npoints do
   begin
    points_m[j,1]:=points[j,1]+longint(points2[j,1]-points[j,1])*k div 128;
    points_m[j,2]:=points[j,2]+longint(points2[j,2]-points[j,2])*k div 128;
   end;

 for j:=1 to ntriangles do
   begin
    move(points_m[triangles_v[j,1]],s_poly2d[1],4);
    move(points_m[triangles_v[j,2]],s_poly2d[2],4);
    move(points_m[triangles_v[j,3]],s_poly2d[3],4);
    for l:=1 to 3 do
     begin
      s_polybmp[l,1]:=points2[triangles_v[j,l],1];
      s_polybmp[l,2]:=points2[triangles_v[j,l],2];
     end;
     s_scrbuf1seg:=buf4seg;
     s_bmpseg:=buf2seg;
     texturemap_simple;
   end;

 for j:=1 to npoints do
   begin
    points_m[j,1]:=points[j,1]+longint(points2[j,1]-points[j,1])*i div 128;
    points_m[j,2]:=points[j,2]+longint(points2[j,2]-points[j,2])*i div 128;
   end;

 for j:=1 to ntriangles do
   begin
    move(points_m[triangles_v[j,1]],s_poly2d[1],4);
    move(points_m[triangles_v[j,2]],s_poly2d[2],4);
    move(points_m[triangles_v[j,3]],s_poly2d[3],4);

    for l:=1 to 3 do
     begin
      s_polybmp[l,1]:=points[triangles_v[j,l],1];
      s_polybmp[l,2]:=points[triangles_v[j,l],2];
     end;
     s_scrbuf1seg:=buf3seg;
     s_bmpseg:=buf1seg;
     texturemap_simple
   end;

 calc_morph_phase(buf3seg,buf4seg,sega000,i*2);
{ move(mem[buf3seg:0],mem[sega000:0],320*150);}
 waitvertsync;
{ waitvertsync;
 waitvertsync; }

 if i=127 then goto l1;
 until false;
l1:
 show_pcx(buf2seg,0);
delay(1000);
if not once then goto l3;
l2:
while keypressed do readkey;
end;

procedure savedata;
var
 ft: text;
begin
 assign(ft,'morfdata.txt'); append(ft);
 writeln(ft,'----------------');
 writeln(ft,paramstr(1));
 writeln(ft,paramstr(2));
 writeln(ft,npoints);
 for i:=1 to npoints do
   begin
    writeln(ft,points[i,1]);
    writeln(ft,points[i,2]);
    writeln(ft,points2[i,1]);
    writeln(ft,points2[i,2]);
   end;
 close(ft);
end;

procedure morffromfile;
var
 ft: text;
 s: string;
 fname1,fname2: string;
 label l1,l2,l3;
begin
l1:
 assign(ft,'morfdata.txt'); reset(ft);
 l3:
 readln(ft,s);
 if s<>'----------------' then
   begin
    close(ft);
    goto l1;
   end;

 readln(ft,fname1);
 readln(ft,fname2);
 readln(ft,npoints);
 for i:=1 to npoints do
   begin
    readln(ft,points[i,1]);
    readln(ft,points[i,2]);
    readln(ft,points2[i,1]);
    readln(ft,points2[i,2]);
{    readln(ft,s);
    writeln(s);
    readln(ft,s);
    writeln(s);
    readln(ft,s);
    writeln(s);
    readln(ft,s);
    writeln(s);}
   end;

 loadpcx_raw_pal(fname1,ptr(buf1seg,0),@palette);
 loadpcx_raw(fname2,ptr(buf2seg,0));

 show_pcx(buf1seg,0);
 setpalette(@palette);

{ readln;}
 show_morph(false);
 if keypressed then halt;
 goto l3;
l2:
close(ft);
end;


label l1,l2,l3;

begin
 chdir('e:\arc\new_jpg');

 buf1p:=globalallocptr(gmem_moveable,256*256);
 buf2p:=globalallocptr(gmem_moveable,256*256);
 buf1seg:=laga(buf1p).seg;
 buf2seg:=laga(buf2p).seg;

 buf3p:=globalallocptr(gmem_moveable,256*256);
 buf4p:=globalallocptr(gmem_moveable,256*256);
 buf3seg:=laga(buf3p).seg;
 buf4seg:=laga(buf4p).seg;

 clearvga(buf3seg);
 clearvga(buf4seg);

 asm
  mov ax,13h
  int 10h
 end;

 loadpcx_raw_pal('e:\arc\new_jpg\car1.pcx',ptr(buf1seg,0),@palette);
 loadpcx_raw('e:\arc\new_jpg\car4.pcx',ptr(buf2seg,0));

{ loadpcx_raw_pal(paramstr(1),ptr(buf1seg,0),@palette);
 loadpcx_raw(paramstr(2),ptr(buf2seg,0));}

 setpalette(@palette);

{ do_morph(buf1seg,buf2seg,sega000);
 readln;
 }

 points[1,1]:=0;    points[1,2]:=0;
 points[2,1]:=255;  points[2,2]:=0;
 points[3,1]:=255;  points[3,2]:=127;
 points[4,1]:=0;    points[4,2]:=127;

 move(points,points2,4*4);
 npoints:=4;
 mouse_reset;
 mtime:=5;

 l3:
 clearvga(sega000);
 show_pcx4(buf1seg,0);
 show_pcx4(buf2seg,160);

 for i:=1 to npoints do
   begin
     quadropset(points[i,1]div 2,points[i,2] div 2,255,sega000);
     quadropset(160+points2[i,1]div 2,points2[i,2] div 2,255,sega000);
   end;

 textattr:=$70;
 mode:=1;

 repeat

  gotoxy(1,15); write('Npoints: ',npoints:3);
  gotoxy(1,16); write('Mtime: ',mtime:3);

  gotoxy(1,14);
  if mode=1 then
     write('Click on left image ')
            else
     write('Click on right image');

  x:=mouse_getx div 2;
  y:=mouse_gety;

  col:=getcolor(x,y);
  pset(x,y,255,sega000);
  waitvertsync;
  waitvertsync;
  waitvertsync;
  pset(x,y,col,sega000);

  if mouse_leftb then
    begin
     quadropset(x,y,255,sega000);
     while mouse_leftb do;
     if mode=1 then
        begin
         if (x>128) or (y>64) then
           begin
            write(#7);
            goto l2;
           end;
         points[npoints+1,1]:=x*2;
         points[npoints+1,2]:=y*2;
         mode:=2;
         goto l2;
        end;

     if mode=2 then
        begin
         if (x<128) or (y>64) or (x>160+128) then
           begin
            mode:=1;
            write(#7);
            goto l2;
           end;
         points2[npoints+1,1]:=(x-160)*2;
         points2[npoints+1,2]:=y*2;
         inc(npoints);
         mode:=1;
         goto l2;
        end;

     l2:
    end;

  if keypressed then
   begin
    c:=readkey;
     case c of
      #27: goto l1;
      #13: if npoints>4 then
            begin
             show_morph(false);
             goto l3;
            end;
      '+': inc (mtime);
      '-': dec (mtime);
      'c','C': begin
                npoints:=4;
                 goto l3;
               end;
      's','S': savedata;
      'd','D': begin
                if npoints>4 then dec(npoints);
                goto l3;
               end;
      'f','F': morffromfile;
     end;
   end;

 until false;

 l1:
 textmode(3);

 globalfreeptr(buf2p);
 globalfreeptr(buf1p);
 globalfreeptr(buf3p);
 globalfreeptr(buf4p);
end.