uses crt,loadpcx;

type
 laga = record
    ofs,seg: word;
        end;

 const
  directory : string='c:\tmp\asc\';

  var
 palette1: array [0..255,1..3] of byte;

procedure calcitbl;
var
 k : real;
 c1r,c1b,c1g,c2r,c2b,c2g: integer;
 i,j,m,n,o: word;
 d1,d2,d,dmin: longint;
 decodetbl : array [0..255] of byte;
 f: file;
 label l1;

begin
 write('l;;');

 loadpcx_pal(directory+'universl.pcx',addr(palette1));
 assign(f,directory+'i_table.dat'); rewrite(f,1);

for o:=0 to 63 do
begin
 write('Generating "i_table.dat" ',(o*100 div 63):3,'%    ',#13);
 if o<$20 then
    k:=0.2+(1-0.2)*o/$20
          else
    k:=0+(0.3-0)*(o-$20)/$20;

  k:=o/55;

  for i:=0 to 255 do
    begin
      c2r:=round(palette1[i,1]*k);
      if c2r>63 then c2r:=63;
      c2g:=round(palette1[i,2]*k);
      if c2g>63 then c2g:=63;
      c2b:=round(palette1[i,3]*k);
      if c2b>63 then c2b:=63;
     dmin:=999999999;
     for j:=0 to 255 do
       begin
        asm
         mov ax,j
         mov si,ax
         shl ax,1
         add si,ax
         add si,offset palette1
         cld

         lodsb
         xor ah,ah
         sub ax,c2r
         imul ax
         mov  cx,30
         mul  cx
         mov word ptr d,ax
         mov word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2g
         imul ax
         mov cx,59
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2b
         imul ax
         mov cx,11
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx
        end;

        if d<dmin then
          begin
           dmin:=d;
           m:=j;
          end;
       end;
     decodetbl[i]:=m;
    end;
 blockwrite(f,decodetbl,256);
end;
writeln('Generating "i_table.dat"...Ok       ');
close(f);
end;

begin
calcitbl;
end.

