code		segment byte	public
		assume	cs:code,ds:data

		public	fsin
		public	fcos
		public	froot
		public	transformkoordinates
                public  transformkoordinates_l
		public	sortbars
		public	div32

div32	proc	far
		push	bp
		mov	bp,sp
		mov	ax,[bp+10]
		mov	dx,[bp+12]
		mov	bx,[bp+6]
		mov	cx,[bp+8]
		call	div32_16
		pop	bp
		ret	8
div32	endp

transformkoordinates	proc	far
;Procedure TransFormKoordinates (n: Word; Objects3d: Pointer; Vid3d: Pointer;
;      Objects2d: Pointer; Observer: XYZ; alfa,beta,gama: Integer);

pushes		=	0
pushbp		=	pushes+2
puship		=	pushbp+2
pushcs		=	puship+2
gama		=	pushcs+2
beta		=	gama+2
alfa		=	beta+2
observerofs	=	alfa+2
observerseg	=	observerofs+2
objects2dofs	=	observerseg+2
objects2dseg	=	objects2dofs+2
vid3dofs	=	objects2dseg+2
vid3dseg	=	vid3dofs+2
objects3dofs	=	vid3dseg+2
objects3dseg	=	objects3dofs+2
n		=	objects3dseg+2

		push	bp
		push	es
		mov	bp,sp

		mov	es,[bp+observerseg]
		mov	si,[bp+observerofs]
		mov	ax,es:[si]
		mov	observerx,ax
		mov	ax,es:[si+2]
		mov	observery,ax
		mov	ax,es:[si+4]
		mov	observerz,ax

		push	[bp+alfa]
		push	cs
		call	internl1
		mov	cosalfa,ax

		push	[bp+beta]
		push	cs
		call	internl1
		mov	cosbeta,ax

		push	[bp+gama]
		push	cs
		call	internl1
		mov	cosgama,ax

		push	[bp+alfa]
		push	cs
		call	internl2
		mov	sinalfa,ax

		push	[bp+beta]
		push	cs
		call	internl2
		mov	sinbeta,ax

		push	[bp+gama]
		push	cs
		call	internl2
		mov	singama,ax

		mov	ah,byte ptr eye_kl
		mov	dl,byte ptr eye_kl+1
		xor	al,al
		xor	dh,dh
		shl	ax,1
		rcl	dx,1
		mov	si,ax
		mov	di,dx
		div	word ptr eye_hxl
		mov	tgalfa0x,ax

		mov	ax,si
		mov	dx,di
		div	word ptr eye_hzl
		mov	tgalfa0z,ax

		mov	ax,[bp+vid3dofs]
		mov	pushofs,ax

		mov	si,[bp+objects3dofs]
		mov	di,[bp+objects2dofs]

l3d9:		mov	es,[bp+objects3dseg]

		mov	ax,es:[si]
		sub	ax,observerx
		mov	new3dkoord0,ax

		mov	ax,es:[si+2]
		sub	ax,observery
		mov	new3dkoord0+2,ax

		mov	ax,es:[si+4]
		sub	ax,observerz
		mov	new3dkoord0+4,ax

;x=-y*sin(alfa) + x*cos(alfa)
		mov	ax,new3dkoord0+2
		neg	ax
		imul	word ptr sinalfa

		mov	cx,dx
		mov	bx,ax

		mov	ax,new3dkoord0
		imul	word ptr cosalfa
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord1,ax

;y:=y*cos(alfa) + x*sin(alfa)
		mov	ax,word ptr new3dkoord0+2
		imul	word ptr cosalfa

		mov	cx,dx
		mov	bx,ax

		mov	ax,new3dkoord0
		imul	word ptr sinalfa
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord1+2,ax

;z=z
		mov	ax,word ptr new3dkoord0+4
		mov	word ptr new3dkoord1+4,ax

;z=-y*sin(beta)  + z*cos(beta)
		mov	ax,word ptr new3dkoord1+2
		neg	ax
		imul	word ptr sinbeta
		mov	bx,ax
		mov	cx,dx

		mov	ax,word ptr new3dkoord1+4
		imul	word ptr cosbeta
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord0+4,ax

;y=y*cos(beta) + z*sin(beta)
		mov	ax,word ptr new3dkoord1+2
		imul	word ptr cosbeta
		mov	bx,ax
		mov	cx,dx

		mov	ax,word ptr new3dkoord1+4
		imul	word ptr sinbeta
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord0+2,ax

;x=x
		mov	ax,word ptr new3dkoord1
		mov	word ptr new3dkoord0,ax

;x=-z*sin(gama) + x*cos(gama)
		mov	ax,word ptr new3dkoord0+4
		neg	ax
		imul	word ptr singama
		mov	bx,ax
		mov	cx,dx

		mov	ax,word ptr new3dkoord0
		imul	word ptr cosgama
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord1,ax

;z=z*cos(gama) + x*sin(gama)
		mov	ax,word ptr new3dkoord0+4
		imul	word ptr cosgama
		mov	bx,ax
		mov	cx,dx

		mov	ax,word ptr new3dkoord0
		imul	word ptr singama
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord1+4,ax

;y=y
		mov	ax,word ptr new3dkoord0+2
		mov	word ptr new3dkoord1+2,ax

;x2d=maxint;
		mov	word ptr object2d,7fffh

;miny=tgalfa0z*abs(x)
		mov	ax,word ptr new3dkoord1
		or	ax,ax
		jns	l3d1
		neg	ax
l3d1:		mul	word ptr tgalfa0x
		mov	al,ah
		mov	ah,dl
		or	ax,ax
		jnz	l3d2
		inc	ax
l3d2:
		cmp	ax,word ptr new3dkoord1+2
		jl	l3d3
                jmp     l3d4
l3d3:
;miny=tgalfa0z*abs(z)
		mov	ax,word ptr new3dkoord1+4
		or	ax,ax
		jns	l3d5
		neg	ax
l3d5:
		mul	word ptr tgalfa0z
		mov	al,ah
		mov	ah,dl
		or	ax,ax
		jnz	l3d6
		inc	ax
l3d6:
		cmp	ax,word ptr new3dkoord1+2
		jl	l3d7
                jmp     l3d4
l3d7:

;object2d.x=x*eye_k div y
		mov	ax,word ptr new3dkoord1
		imul	word ptr eye_kl
		idiv	word ptr new3dkoord1+2
		mov	word ptr object2d,ax

;object2d.y=z*eye_k div y
		mov	ax,word ptr new3dkoord1+4
		imul	word ptr eye_kl
		idiv	word ptr new3dkoord1+2
		mov	word ptr object2d+2,ax

l3d4:		mov	es,[bp+objects2dseg]
		cld
		mov	ax,word ptr object2d
		stos	word ptr [di]
		mov	ax,word ptr object2d+2
		stos	word ptr [di]

		push	di
		mov	di,pushofs
		mov	es,[bp+vid3dseg]
		mov	ax,new3dkoord1
		stos	word ptr [di]
		mov	ax,new3dkoord1+2
		stos	word ptr [di]
		mov	ax,new3dkoord1+4
		stos	word ptr [di]
		mov	pushofs,di
		pop	di

		add	si,6

		dec	word ptr [bp+n]
		jz	l3d8
		jmp	l3d9
l3d8:		pop	es
		pop	bp
		ret	24
transformkoordinates	endp

transformkoordinates_l	proc	far
;Procedure TransFormKoordinates_l (n: Word; Objects3d: Pointer; Vid3d: Pointer;
;      Objects2d: Pointer; Observer: XYZ; alfa,beta,gama: Integer);

pushes		=	0
pushbp		=	pushes+2
puship		=	pushbp+2
pushcs		=	puship+2
gama		=	pushcs+2
beta		=	gama+2
alfa		=	beta+2
observerofs	=	alfa+2
observerseg	=	observerofs+2
objects2dofs	=	observerseg+2
objects2dseg	=	objects2dofs+2
vid3dofs	=	objects2dseg+2
vid3dseg	=	vid3dofs+2
objects3dofs	=	vid3dseg+2
objects3dseg	=	objects3dofs+2
n		=	objects3dseg+2

		push	bp
		push	es
		mov	bp,sp

;                mov     es,[bp+observerseg]
;                mov     si,[bp+observerofs]
		les	si,[bp+observerofs]

		mov	ax,es:[si]
		mov	observerx,ax
		mov	ax,es:[si+2]
		mov	observery,ax
		mov	ax,es:[si+4]
		mov	observerz,ax

		push	[bp+alfa]
		push	cs
		call	internl1
		mov	cosalfa,ax

		push	[bp+beta]
		push	cs
		call	internl1
		mov	cosbeta,ax

		push	[bp+gama]
		push	cs
		call	internl1
		mov	cosgama,ax

		push	[bp+alfa]
		push	cs
		call	internl2
		mov	sinalfa,ax

		push	[bp+beta]
		push	cs
		call	internl2
		mov	sinbeta,ax

		push	[bp+gama]
		push	cs
		call	internl2
		mov	singama,ax

		mov	ah,byte ptr eye_kl
		mov	dl,byte ptr eye_kl+1
		xor	al,al
		xor	dh,dh
		shl	ax,1
		rcl	dx,1
		mov	si,ax
		mov	di,dx
		div	word ptr eye_hxl
		mov	tgalfa0x,ax

		mov	ax,si
		mov	dx,di
		div	word ptr eye_hzl
		mov	tgalfa0z,ax

		mov	ax,[bp+vid3dofs]
		mov	pushofs,ax

		mov	si,[bp+objects3dofs]
		mov	di,[bp+objects2dofs]
		mov	word ptr k3dofs,0

l3d9l:		mov	es,[bp+objects3dseg]

		mov	ax,es:[si]
		sub	ax,observerx
		mov	new3dkoord0,ax

		mov	ax,es:[si+2]
		sub	ax,observery
		mov	new3dkoord0+2,ax

		mov	ax,es:[si+4]
		sub	ax,observerz
		mov	new3dkoord0+4,ax

;x=-y*sin(alfa) + x*cos(alfa)
		mov	ax,new3dkoord0+2
		neg	ax
		imul	word ptr sinalfa

		mov	cx,dx
		mov	bx,ax

		mov	ax,new3dkoord0
		imul	word ptr cosalfa
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord1,ax

;y:=y*cos(alfa) + x*sin(alfa)
		mov	ax,word ptr new3dkoord0+2
		imul	word ptr cosalfa

		mov	cx,dx
		mov	bx,ax

		mov	ax,new3dkoord0
		imul	word ptr sinalfa
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord1+2,ax

;z=z
		mov	ax,word ptr new3dkoord0+4
		mov	word ptr new3dkoord1+4,ax

;z=-y*sin(beta)  + z*cos(beta)
		mov	ax,word ptr new3dkoord1+2
		neg	ax
		imul	word ptr sinbeta
		mov	bx,ax
		mov	cx,dx

		mov	ax,word ptr new3dkoord1+4
		imul	word ptr cosbeta
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord0+4,ax

;y=y*cos(beta) + z*sin(beta)
		mov	ax,word ptr new3dkoord1+2
		imul	word ptr cosbeta
		mov	bx,ax
		mov	cx,dx

		mov	ax,word ptr new3dkoord1+4
		imul	word ptr sinbeta
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord0+2,ax

;x=x
		mov	ax,word ptr new3dkoord1
		mov	word ptr new3dkoord0,ax

;x=-z*sin(gama) + x*cos(gama)
		mov	ax,word ptr new3dkoord0+4
		neg	ax
		imul	word ptr singama
		mov	bx,ax
		mov	cx,dx

		mov	ax,word ptr new3dkoord0
		imul	word ptr cosgama
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord1,ax

;z=z*cos(gama) + x*sin(gama)
		mov	ax,word ptr new3dkoord0+4
		imul	word ptr cosgama
		mov	bx,ax
		mov	cx,dx

		mov	ax,word ptr new3dkoord0
		imul	word ptr singama
		add	ax,bx
		adc	dx,cx
		call	ishr8
		mov	word ptr new3dkoord1+4,ax

;y=y
		mov	ax,word ptr new3dkoord0+2
		mov	word ptr new3dkoord1+2,ax

		push	si
		push	di

		cmp	word ptr k3dofs,0
		jne	lki1

		inc	word ptr k3dofs

		mov	ax,new3dkoord1
		mov	new3dkoord2,ax
		mov	ax,new3dkoord1+2
		mov	new3dkoord2+2,ax
		mov	ax,new3dkoord1+4
		mov	new3dkoord2+4,ax
		jmp	lki2
lki1:
		mov	word ptr k3dofs,offset new3dkoord

;miny:=abs(x1)*tgalfa0x shr 8
		mov	ax,new3dkoord2
		or	ax,ax
		jns	lki3
		neg	ax
lki3:		mul	word ptr tgalfa0x
		mov	al,ah
		mov	ah,dl
		cmp	ax,new3dkoord2+2
                jnl     lki4

		mov	ax,new3dkoord2
		mov	new3dkoord,ax
		mov	ax,new3dkoord2+2
		mov	new3dkoord+2,ax
		mov	ax,new3dkoord2+4
		mov	new3dkoord+4,ax
		add	word ptr k3dofs,6
lki4:
;miny:=abs(x2)*tgalfa0x
		mov	ax,new3dkoord1
		or	ax,ax
		jns	lki5
		neg	ax
lki5:		mul	word ptr tgalfa0x
		mov	al,ah
		mov	ah,dl
		cmp	ax,new3dkoord1+2
                jnl     lki6

		mov	bx,k3dofs
		mov	ax,new3dkoord1
		mov	[bx],ax
		inc	bx
		inc	bx
		mov	ax,new3dkoord1+2
		mov	[bx],ax
		inc	bx
		inc	bx
		mov	ax,new3dkoord1+4
		mov	[bx],ax
		inc	bx
		inc	bx
		mov	k3dofs,bx
		cmp	bx,offset new3dkoord+12
		jne	lki6

		jmp	lki7
lki6:
;x2x1=x2-x1
		mov	ax,new3dkoord1
		sub	ax,new3dkoord2
		mov	x2x1,ax
;y2y1=y2-y1
		mov	ax,new3dkoord1+2
		sub	ax,new3dkoord2+2
		mov	y2y1,ax
;z2z1=z2-z1
		mov	ax,new3dkoord1+4
		sub	ax,new3dkoord2+4
		mov	z2z1,ax

;l=2*k*x2x1+eye_hx*y2y1
                mov     ax,eye_kl
		shl	ax,1
		imul	word ptr x2x1
		mov	cx,dx
		mov	bx,ax

		mov	ax,eye_hxl
		imul	word ptr y2y1
		add	bx,ax
		adc	cx,dx

;if l=0 goto l2
		or	cx,cx
		jne	lki9
		or	bx,bx
		jne	lki9

		jmp	lki8
lki9:
		mov	longint0,bx
		mov	longint0+2,cx

;lo1=-(2*k*x1+eye_hx*y1)*256
		mov	ax,eye_kl
		shl	ax,1
		imul	word ptr new3dkoord2
		mov	cx,dx
		mov	bx,ax

		mov	ax,eye_hxl
		imul	word ptr new3dkoord2+2
		add	bx,ax
		adc	cx,dx
;㬭  -256
		or	cx,cx
		jns	lki18

		not	bx
		neg	cx
		add	bx,1
		adc	cx,-1
		mov	ch,cl
		mov	cl,bh
		mov	bh,bl
		xor	bl,bl
		jmp	lki19

lki18:		mov	ch,cl
		mov	cl,bh
		mov	bh,bl
		xor	bl,bl
		not	bx
		neg	cx
		add	bx,1
		adc	cx,-1
lki19:

		mov	longint1,bx
		mov	longint1+2,cx

;if lo1>0 and l<0 then goto l2
		test	word ptr longint1+2,8000h
		jnz	lki10
		test	word ptr longint0+2,8000h
		jz	lki10

		jmp	lki8
lki10:
;if lo1<0 and l>0 then goto l2
		test	word ptr longint1+2,8000h
		jz	lki11
		test	word ptr longint0+2,8000h
		jnz	lki11

		jmp	lki8
lki11:
;lo1:=abs(lo1)
		test	word ptr longint1+2,8000h
		jz	lki12

		not	word ptr longint1
		neg	word ptr longint1+2
		add	word ptr longint1,1
		adc	word ptr longint1+2,-1
lki12:
;l:=abs(l)
                test    word ptr longint0+2,8000h
		jz	lki13

		not	word ptr longint0
		neg	word ptr longint0+2
		add	word ptr longint0,1
		adc	word ptr longint0+2,-1
lki13:
;if lo1<l then goto l2
		mov	dx,longint1+2
		mov	ax,longint1
		cmp	dx,longint0+2
		jc	lki14
		ja	lki15
		cmp	ax,longint0
		jnc	lki15

lki14:		jmp	lki8
lki15:
;if lo1> l shl 8 then goto l2
		xor	bl,bl
		mov	bh,byte ptr longint0
		mov	cx,word ptr longint0+1
		cmp	dx,cx
		ja	lki16
		jc	lki17
		cmp	ax,bx
		jna	lki17

lki16:		jmp	lki8
lki17:
;l:=div32(lo1,l)
		mov	bx,longint0
		mov	cx,longint0+2
		call	div32_16

		mov	si,ax
		mov	bx,k3dofs
;x:=x1+l*x2x1 shr 8
		imul	word ptr x2x1
		call	ishr8
		add	ax,word ptr new3dkoord2
		mov	[bx],ax
		inc	bx
		inc	bx
;y:=y1+l*y2y1 shr 8
		mov	ax,si
		imul	word ptr y2y1
		call	ishr8
		add	ax,word ptr new3dkoord2+2
		mov	[bx],ax
		inc	bx
		inc	bx
;z:=z1+l*z2z1 shr 8
		mov	ax,si
		imul	word ptr z2z1
		call	ishr8
		add	ax,new3dkoord2+4
		mov	[bx],ax
		inc	bx
		inc	bx

		test	word ptr [bx-4],8000h
		jz	lki20
		sub	bx,6
lki20:
		mov	k3dofs,bx
		cmp	bx,offset new3dkoord+12
		jne	lki21

		jmp	lki7
lki21:
lki8:

;l=2*k*x2x1-eye_hx*y2y1
                mov     ax,eye_kl
		shl	ax,1
		imul	word ptr x2x1
		mov	cx,dx
		mov	bx,ax

		mov	ax,eye_hxl
		imul	word ptr y2y1
		sub	bx,ax
		sbb	cx,dx

;if l=0 goto l3
		or	cx,cx
		jne	lki9a
		or	bx,bx
		jne	lki9a

		jmp	lki8a
lki9a:
		mov	longint0,bx
		mov	longint0+2,cx

;lo1=-(2*k*x1-eye_hx*y1)*256
		mov	ax,eye_kl
		shl	ax,1
		imul	word ptr new3dkoord2
		mov	cx,dx
		mov	bx,ax

		mov	ax,eye_hxl
		imul	word ptr new3dkoord2+2
		sub	bx,ax
		sbb	cx,dx
;㬭  -256
		or	cx,cx
		jns	lki18a

		not	bx
		neg	cx
		add	bx,1
		adc	cx,-1
		mov	ch,cl
		mov	cl,bh
		mov	bh,bl
		xor	bl,bl
		jmp	lki19a

lki18a:
		mov	ch,cl
		mov	cl,bh
		mov	bh,bl
		xor	bl,bl
		not	bx
		neg	cx
		add	bx,1
		adc	cx,-1
lki19a:
		mov	longint1,bx
		mov	longint1+2,cx

;if lo1>0 and l<0 then goto l2
		test	word ptr longint1+2,8000h
		jnz	lki10a
		test	word ptr longint0+2,8000h
		jz	lki10a

		jmp	lki8a
lki10a:
;if lo1<0 and l>0 then goto l2
		test	word ptr longint1+2,8000h
		jz	lki11a
		test	word ptr longint0+2,8000h
		jnz	lki11a

		jmp	lki8a
lki11a:
;lo1:=abs(lo1)
		test	word ptr longint1+2,8000h
		jz	lki12a

		not	word ptr longint1
		neg	word ptr longint1+2
		add	word ptr longint1,1
		adc	word ptr longint1+2,-1
lki12a:
;l:=abs(l)
                test    word ptr longint0+2,8000h
		jz	lki13a

		not	word ptr longint0
		neg	word ptr longint0+2
		add	word ptr longint0,1
		adc	word ptr longint0+2,-1
lki13a:
;if lo1<l then goto l2
		mov	dx,longint1+2
		mov	ax,longint1
		cmp	dx,longint0+2
		jc	lki14a
		ja	lki15a
		cmp	ax,longint0
		jnc	lki15a

lki14a: jmp	lki8a
lki15a:
;if lo1> l shl 8 then goto l2
		xor	bl,bl
		mov	bh,byte ptr longint0
		mov	cx,word ptr longint0+1
		cmp	dx,cx
		ja	lki16a
		jc	lki17a
		cmp	ax,bx
		jna	lki17a

lki16a:	 jmp	lki8a
lki17a:
;l:=div32(lo1,l)
		mov	bx,longint0
		mov	cx,longint0+2
		call	div32_16

		mov	si,ax
		mov	bx,k3dofs
;x:=x1+l*x2x1 shr 8
		imul	word ptr x2x1
		call	ishr8
		add	ax,word ptr new3dkoord2
		mov	[bx],ax
		inc	bx
		inc	bx
;y:=y1+l*y2y1 shr 8
		mov	ax,si
		imul	word ptr y2y1
		call	ishr8
		add	ax,word ptr new3dkoord2+2
		mov	[bx],ax
		inc	bx
		inc	bx
;z:=z1+l*z2z1 shr 8
		mov	ax,si
		imul	word ptr z2z1
		call	ishr8
		add	ax,new3dkoord2+4
		mov	[bx],ax
		inc	bx
		inc	bx

		test	word ptr [bx-4],8000h
		jz	lki20a
		sub	bx,6
lki20a:
		cmp	bx,offset new3dkoord+12
		jne	lki21a

		jmp	lki7
lki21a:
lki8a:
		pop	di
		mov	es,[bp+objects2dseg]
		mov	word ptr es:[di],7fffh
		add	di,8
		push	di
		mov	word ptr k3dofs,0
		jmp	lki2

lki7:

		mov	ax,ds
		mov	es,ax

		lea	si,new3dkoord
		lea	di,new3dkoord2

		mov	cx,6
		cld
	rep	movs	word ptr [di],[si]

		mov	word ptr k3dofs,offset new3dkoord

;miny:=abs(z1)*tgalfa0z shr 8
		mov	ax,new3dkoord2+4
		or	ax,ax
		jns	lki3z
		neg	ax
lki3z:		mul	word ptr tgalfa0z
		mov	al,ah
		mov	ah,dl
		cmp	ax,new3dkoord2+2
                jnl     lki4z

		mov	ax,new3dkoord2
		mov	new3dkoord,ax
		mov	ax,new3dkoord2+2
		mov	new3dkoord+2,ax
		mov	ax,new3dkoord2+4
		mov	new3dkoord+4,ax
		add	word ptr k3dofs,6
lki4z:
;miny:=abs(z2)*tgalfa0z
		mov	ax,new3dkoord1+4
		or	ax,ax
		jns	lki5z
		neg	ax
lki5z:		mul	word ptr tgalfa0z
		mov	al,ah
		mov	ah,dl
		cmp	ax,new3dkoord1+2
                jnl     lki6z

		mov	bx,k3dofs
		mov	ax,new3dkoord1
		mov	[bx],ax
		inc	bx
		inc	bx
		mov	ax,new3dkoord1+2
		mov	[bx],ax
		inc	bx
		inc	bx
		mov	ax,new3dkoord1+4
		mov	[bx],ax
		inc	bx
		inc	bx
		mov	k3dofs,bx
		cmp	bx,offset new3dkoord+12
		jne	lki6z

		jmp	lki7z
lki6z:
;x2x1=x2-x1
		mov	ax,new3dkoord1
		sub	ax,new3dkoord2
		mov	x2x1,ax
;y2y1=y2-y1
		mov	ax,new3dkoord1+2
		sub	ax,new3dkoord2+2
		mov	y2y1,ax
;z2z1=z2-z1
		mov	ax,new3dkoord1+4
		sub	ax,new3dkoord2+4
		mov	z2z1,ax

;l=2*k*z2z1+eye_hz*y2y1
                mov     ax,eye_kl
		shl	ax,1
		imul	word ptr z2z1
		mov	cx,dx
		mov	bx,ax

		mov	ax,eye_hzl
		imul	word ptr y2y1
		add	bx,ax
		adc	cx,dx

;if l=0 goto l2
		or	cx,cx
		jne	lki9z
		or	bx,bx
		jne	lki9z

		jmp	lki8z
lki9z:
		mov	longint0,bx
		mov	longint0+2,cx

;lo1=-(2*k*z1+eye_hz*y1)*256
		mov	ax,eye_kl
		shl	ax,1
		imul	word ptr new3dkoord2+4
		mov	cx,dx
		mov	bx,ax

		mov	ax,eye_hzl
		imul	word ptr new3dkoord2+2
		add	bx,ax
		adc	cx,dx
;㬭  -256
		or	cx,cx
		jns	lki18z

		not	bx
		neg	cx
		add	bx,1
		adc	cx,-1
		mov	ch,cl
		mov	cl,bh
		mov	bh,bl
		xor	bl,bl
		jmp	lki19z

lki18z:	mov	ch,cl
		mov	cl,bh
		mov	bh,bl
		xor	bl,bl
		not	bx
		neg	cx
		add	bx,1
		adc	cx,-1
lki19z:

		mov	longint1,bx
		mov	longint1+2,cx

;if lo1>0 and l<0 then goto l2
		test	word ptr longint1+2,8000h
		jnz	lki10z
		test	word ptr longint0+2,8000h
		jz	lki10z

		jmp	lki8z
lki10z:
;if lo1<0 and l>0 then goto l2
		test	word ptr longint1+2,8000h
		jz	lki11z
		test	word ptr longint0+2,8000h
		jnz	lki11z

		jmp	lki8z
lki11z:
;lo1:=abs(lo1)
		test	word ptr longint1+2,8000h
		jz	lki12z

		not	word ptr longint1
		neg	word ptr longint1+2
		add	word ptr longint1,1
		adc	word ptr longint1+2,-1
lki12z:
;l:=abs(l)
                test    word ptr longint0+2,8000h
		jz	lki13z

		not	word ptr longint0
		neg	word ptr longint0+2
		add	word ptr longint0,1
		adc	word ptr longint0+2,-1
lki13z:
;if lo1<l then goto l2
		mov	dx,longint1+2
		mov	ax,longint1
		cmp	dx,longint0+2
		jc	lki14z
		ja	lki15z
		cmp	ax,longint0
		jnc	lki15z

lki14z:	 jmp	lki8z
lki15z:
;if lo1> l shl 8 then goto l2
		xor	bl,bl
		mov	bh,byte ptr longint0
		mov	cx,word ptr longint0+1
		cmp	dx,cx
		ja	lki16z
		jc	lki17z
		cmp	ax,bx
		jna	lki17z

lki16z:	 jmp	lki8z
lki17z:
;l:=div32(lo1,l)
		mov	bx,longint0
		mov	cx,longint0+2
		call	div32_16

		mov	si,ax
		mov	bx,k3dofs
;x:=x1+l*x2x1 shr 8
		imul	word ptr x2x1
		call	ishr8
		add	ax,word ptr new3dkoord2
		mov	[bx],ax
		inc	bx
		inc	bx
;y:=y1+l*y2y1 shr 8
		mov	ax,si
		imul	word ptr y2y1
		call	ishr8
		add	ax,word ptr new3dkoord2+2
		mov	[bx],ax
		inc	bx
		inc	bx
;z:=z1+l*z2z1 shr 8
		mov	ax,si
		imul	word ptr z2z1
		call	ishr8
		add	ax,new3dkoord2+4
		mov	[bx],ax
		inc	bx
		inc	bx

		test	word ptr [bx-4],8000h
		jz	lki20z
		sub	bx,6
lki20z:
		mov	k3dofs,bx
		cmp	bx,offset new3dkoord+12
		jne	lki21z

		jmp	lki7z
lki21z:
lki8z:

;l=2*k*z2z1-eye_hz*y2y1
                mov     ax,eye_kl
		shl	ax,1
		imul	word ptr z2z1
		mov	cx,dx
		mov	bx,ax

		mov	ax,eye_hzl
		imul	word ptr y2y1
		sub	bx,ax
		sbb	cx,dx

;if l=0 goto l3
		or	cx,cx
		jne	lki9az
		or	bx,bx
		jne	lki9az

		jmp	lki8az
lki9az:
		mov	longint0,bx
		mov	longint0+2,cx

;lo1=-(2*k*z1-eye_hz*y1)*256
		mov	ax,eye_kl
		shl	ax,1
		imul	word ptr new3dkoord2+4
		mov	cx,dx
		mov	bx,ax

		mov	ax,eye_hzl
		imul	word ptr new3dkoord2+2
		sub	bx,ax
		sbb	cx,dx
;㬭  -256
		or	cx,cx
		jns	lki18az

		not	bx
		neg	cx
		add	bx,1
		adc	cx,-1
		mov	ch,cl
		mov	cl,bh
		mov	bh,bl
		xor	bl,bl
		jmp	lki19az

lki18az:
		mov	ch,cl
		mov	cl,bh
		mov	bh,bl
		xor	bl,bl
		not	bx
		neg	cx
		add	bx,1
		adc	cx,-1
lki19az:
		mov	longint1,bx
		mov	longint1+2,cx

;if lo1>0 and l<0 then goto l2
		test	word ptr longint1+2,8000h
		jnz	lki10az
		test	word ptr longint0+2,8000h
		jz	lki10az

		jmp	lki8az
lki10az:
;if lo1<0 and l>0 then goto l2
		test	word ptr longint1+2,8000h
		jz	lki11az
		test	word ptr longint0+2,8000h
		jnz	lki11az

		jmp	lki8az
lki11az:
;lo1:=abs(lo1)
		test	word ptr longint1+2,8000h
		jz	lki12az

		not	word ptr longint1
		neg	word ptr longint1+2
		add	word ptr longint1,1
		adc	word ptr longint1+2,-1
lki12az:
;l:=abs(l)
                test    word ptr longint0+2,8000h
		jz	lki13az

		not	word ptr longint0
		neg	word ptr longint0+2
		add	word ptr longint0,1
		adc	word ptr longint0+2,-1
lki13az:
;if lo1<l then goto l2
		mov	dx,longint1+2
		mov	ax,longint1
		cmp	dx,longint0+2
		jc	lki14az
		ja	lki15az
		cmp	ax,longint0
		jnc	lki15az

lki14az: jmp	lki8az
lki15az:
;if lo1> l shl 8 then goto l2
		xor	bl,bl
		mov	bh,byte ptr longint0
		mov	cx,word ptr longint0+1
		cmp	dx,cx
		ja	lki16az
		jc	lki17az
		cmp	ax,bx
		jna	lki17az

lki16az: jmp	lki8az
lki17az:
;l:=div32(lo1,l)
		mov	bx,longint0
		mov	cx,longint0+2
		call	div32_16

		mov	si,ax
		mov	bx,k3dofs
;x:=x1+l*x2x1 shr 8
		imul	word ptr x2x1
		call	ishr8
		add	ax,word ptr new3dkoord2
		mov	[bx],ax
		inc	bx
		inc	bx
;y:=y1+l*y2y1 shr 8
		mov	ax,si
		imul	word ptr y2y1
		call	ishr8
		add	ax,word ptr new3dkoord2+2
		mov	[bx],ax
		inc	bx
		inc	bx
;z:=z1+l*z2z1 shr 8
		mov	ax,si
		imul	word ptr z2z1
		call	ishr8
		add	ax,new3dkoord2+4
		mov	[bx],ax
		inc	bx
		inc	bx

		test	word ptr [bx-4],8000h
		jz	lki20az
		sub	bx,6
lki20az:
		cmp	bx,offset new3dkoord+12
		jne	lki21az

		jmp	lki7z
lki21az:
lki8az:
		pop	di
		mov	es,[bp+objects2dseg]
		mov	word ptr es:[di],7fffh
		add	di,8
		push	di
		mov	word ptr k3dofs,0
		jmp	lki2

lki7z:
		mov	word ptr k3dofs,0

		pop	di
		pop	si

		mov	es,[bp+objects2dseg]
		cld
;2dx:=eye_k*x div y
		cmp	word ptr new3dkoord+2,0
		je	lki22

		mov	ax,new3dkoord
		imul	word ptr eye_kl
		idiv	word ptr new3dkoord+2
		stos	word ptr [di]
;2dy:=eye_k*z div y
		mov	ax,new3dkoord+4
		imul	word ptr eye_kl
		idiv	word ptr new3dkoord+2
		stos	word ptr [di]
		jmp	lki23
lki22:
		xor	ax,ax
		stos	word ptr [di]
		stos	word ptr [di]
lki23:
		cmp	word ptr new3dkoord+6+2,0
		je	lki24
;2dx:=eye_k*x div y
		mov	ax,new3dkoord+6
		imul	word ptr eye_kl
		idiv	word ptr new3dkoord+6+2
		stos	word ptr [di]

;2dy:=eye_k*z div y
		mov	ax,new3dkoord+6+4
		imul	word ptr eye_kl
		idiv	word ptr new3dkoord+6+2
		stos	word ptr [di]

		jmp	lki25
lki24:
		xor	ax,ax
		stos	word ptr [di]
		stos	word ptr [di]
lki25:

lki26:
                cld
		push	di
		mov	di,pushofs
		mov	es,[bp+vid3dseg]
		mov	ax,new3dkoord1
		stos	word ptr [di]
		mov	ax,new3dkoord1+2
		stos	word ptr [di]
		mov	ax,new3dkoord1+4
		stos	word ptr [di]
		mov	pushofs,di
		pop	di

		add	si,6

		dec	word ptr [bp+n]
		jz	l3d8l
		jmp	l3d9l
l3d8l:		pop	es
		pop	bp
		ret	24

lki2:		pop	di
		pop	si
		jmp	lki26
transformkoordinates_l	endp



;internl2:
fsin		proc	far
		push	bp
		mov	bp,sp

		mov	ax,[bp+6]	;ax = alfa;
		xor	di,di		;znak ="+"

		or	ax,ax		;while alfa<0 do begin
		jns	fsinl1		;alfa:=alfa+360;
fsinl2:
		add	ax,360		;end;
		js	fsinl2
fsinl1:
		cmp	ax,180		;if alfa>180 then begin
		jc	fsinl3		;alfa:=alfa-180; znak:=-znak;
		sub	ax,180		;end;
		xor	di,1
fsinl3:
		cmp	ax,90
		jna	fsinl5
		mov	cx,90
		sub	cx,ax
		push	di
		push	cx
		push	cs
		call	internl1
		pop	di

		test	di,1
		jz	fsinl6
                neg     ax
fsinl6:
		pop	bp
		ret	2

fsinl5:
		mov	ah,al
		xor	al,al
		xor	dx,dx		;dx:ax = alfa*256

		mov	bx,57
		div	bx		;ax = alfa*256/57

		mov	bx,ax
		mov	cx,ax

		mul	bx		;dx:ax = (alfa/57)^2*65536

		mov	al,ah
		mov	ah,dl		;ax = (alfa/57)^2*256

		mov	bp,ax

                mul     bx              ;dx:ax = (alfa/57)^3*65536

                mov     al,ah
                mov     ah,dl           ;ax = (alfa/57)^3*256

		mov	si,ax

		mov	bl,6
		div	bl
		xor	ah,ah		;ax = (alfa/57)^3/6 * 256

		sub	cx,ax

		mov	ax,si
		mul	bp		;dx:ax = (alfa/57)^5 * 65535

		mov	al,ah
		mov	ah,dl		;ax = (alfa/57)^5 * 256

		mov	si,ax

		mov	bl,120
		div	bl
		xor	ah,ah		;ax = (alfa/57)^5/120 * 256

		add	cx,ax

		mov	ax,si
		mul	bp		;dx:ax = (alfa/57)^7*65535

		mov	al,ah
		mov	ah,dl		;ax = (alfa/57)^7 * 256

		xor	dx,dx
		mov	bx,5040
		div	bx		;ax = (alfa/57)^7/5040 * 256

		sub	cx,ax

		mov	ax,cx
		test	di,1
		jz	fsinl4
		neg	ax
fsinl4:
		pop	bp
		ret	2
fsin		endp

;internl1:
fcos		proc	far
		push	bp
		mov	bp,sp
		mov	ax,[bp+6]	;ax=alfa
		xor	di,di		;znak="+"

		or	ax,ax		;if alfa<0 then alfa:=-alfa;
                jns     fcosl1
		neg	ax
fcosl1:
		cmp	ax,180		;while alfa>180 do begin
		jc	fcosl2		;alfa:=alfa-180; znak:=-znak;
		xor	di,1		;end
		sub	ax,180
		jmp	fcosl1

fcosl2:
		cmp	ax,90
		jna	fcosl4
		mov	cx,90
		sub	cx,ax
		push	di
		push	cx
		push	cs
		call	internl2
		pop	di

		test	di,1
		jz	fcosl5
		neg	ax
fcosl5:
		pop	bp
		ret	2
fcosl4:
		mov	ah,al
		xor	al,al		;ax=alfa*256
		xor	dx,dx

		mov	bx,57
		div	bx		;ax = alfa/57 * 256

		mov	bx,ax
		mul	bx		;dx:ax = (alfa/57)^2 * 65535

		mov	al,ah
		mov	ah,dl		;ax = (alfa/57)^2 * 256

		mov	bp,ax

		shr	ax,1		; ax = (alfa/57)^2/2 * 256

		mov	cx,100h
		sub	cx,ax

		mov	ax,bp
		mul	bp		;dx:ax = (alfa/57)^4 * 65535

		mov	al,ah
		mov	ah,dl		;ax = (alfa/57)^4*256

		mov	si,ax

		mov	bl,24
		div	bl
		xor	ah,ah		;ax = (alfa/57)^4/24*256

		add	cx,ax

		mov	ax,si
		mul	bp		;dx:ax = (alfa/57)^6 * 65535

		mov	al,ah
		mov	ah,dl		;ax = (alfa/57)^6 * 256

		xor	dx,dx
		mov	bx,720
		div	bx		;ax = (alfa/57)^6/720 * 256

		sub	cx,ax

		mov	ax,cx
		test	di,1
		jz	fcosl3
		neg	ax
fcosl3:
		pop	bp
		ret	2
fcos		endp

internl3:
froot		proc	far
		push	bp
		mov	bp,sp

		mov	di,[bp+8]
		mov	si,[bp+6]	;di:si = x

		or	dx,dx
		jne	lfroot1
		or	ax,ax
		jne	lfroot1
		pop	bp
		ret	4
lfroot1:
;bx    - x
;di:si - x^2
;cx    - dodanok
		xor	di,di
		mov	si,1
		mov	bx,1
		mov	cx,1
lfroot4:
		cmp	di,dx
		ja	lfroot2
		jc	lfroot3
		cmp	si,ax
		jnc	lfroot2
lfroot3:
		inc	bx
		inc	cx
		inc	cx
		add	si,cx
		adc	di,0
		jmp	lfroot4

lfroot2:	mov	ax,bx
		pop	bp
		ret	4
froot		endp

imul32:
pimul32 proc
;di:si*cx  =  si:bx

		test	di,8000h
		jz	iml1
                neg     ax
                adc     dx,0
                neg     dx
		neg	cx
iml1:
		mov	ax,si
		imul	cx
		mov	bx,ax
		mov	si,dx
		mov	ax,di
		imul	cx
		add	si,ax
		ret
pimul32 endp

iimul32 proc
		xor	bx,bx
		xor	dx,dx

iml2:		add	bx,si
		adc	dx,di
		loop	iml2

		mov	si,dx
                ret
iimul32 endp


sortbars	proc	far
;Procedure SortBars(n: word; vid3d: pointer; bars2d: pointer; colors: pointer;
;         tmtbuf: pointer);
pushes		=	0
pushbp		=	pushes+2
pushcs		=	pushbp+2
puship		=	pushcs+2
tmtbufofs	=	puship+2
tmtbufseg	=	tmtbufofs+2
colorsofs	=	tmtbufseg+2
colorsseg	=	colorsofs+2
bars2dofs	=	colorsseg+2
bars2dseg	=	bars2dofs+2
vid3dofs	=	bars2dseg+2
vid3dseg	=	vid3dofs+2
n		=	vid3dseg+2

		push	bp
		push	es
		mov	bp,sp

		mov	ax,[bp+n]
		mov	tmtn,ax

		mov	si,[bp+vid3dofs]
		mov	di,[bp+tmtbufofs]

                cld

sbrl2:		mov	es,[bp+vid3dseg]

		mov	ax,es:[si]	;x1
		mov	x1,ax
		mov	bx,es:[si+6]	;x2
		mov	cx,es:[si+12]	;x3
		sub	bx,ax
		sub	cx,ax
		mov	x21,bx
		mov	x31,cx

		mov	ax,es:[si+2]	;y1
		mov	y1,ax
		mov	bx,es:[si+8]	;y2
		mov	cx,es:[si+14]	;y3
		sub	bx,ax
		sub	cx,ax
		mov	y21,bx
		mov	y31,cx

		mov	ax,es:[si+4]	;z1
		mov	z1,ax
		mov	bx,es:[si+10]	;z2
		mov	cx,es:[si+16]	;z3
		sub	bx,ax
		sub	cx,ax
		mov	z21,bx
		mov	z31,cx

		mov	es,[bp+tmtbufseg]
;s1:=y21*z31-y31*z21
		mov	ax,y21
		imul	word ptr z31
		mov	cx,dx
		mov	bx,ax
		mov	ax,y31
		imul	word ptr z21
		sub	bx,ax
		sbb	cx,dx
		mov	ax,bx
		stos	word ptr [di]
		mov	ax,cx
		stos	word ptr [di]

;s2:=z21*x31-x21*z31
		mov	ax,z21
		imul	word ptr x31
		mov	bx,ax
		mov	cx,dx
		mov	ax,x21
		imul	word ptr z31
		sub	bx,ax
		sbb	cx,dx
		mov	ax,bx
		stos	word ptr [di]
		mov	ax,cx
		stos	word ptr [di]

;s3:=x21*y31-x31*y21
		mov	ax,x21
		imul	word ptr y31
		mov	bx,ax
		mov	cx,dx
		mov	ax,x31
		imul	word ptr y21
		sub	bx,ax
		sbb	cx,dx
		mov	ax,bx
		stos	word ptr [di]
		mov	ax,cx
		stos	word ptr [di]

;d1:=x1*s1+y1*s2+z1*s3
		push	si
		push	di
		mov	bx,di
		mov	di,es:[bx-10]	;di:si = s1
		mov	si,es:[bx-12]
		mov	cx,x1
		call	imul32
		mov	d1_lo,bx
		mov	d1_hi,si
		pop	di
		pop	si

		push	si
		push	di
		mov	bx,di
		mov	di,es:[bx-6]	;di:si = s2
		mov	si,es:[bx-8]
		mov	cx,y1
		call	imul32
		add	d1_lo,bx
		adc	d1_hi,si
		pop	di
		pop	si

		push	si
		push	di
		mov	bx,di
		mov	di,es:[bx-2]
		mov	si,es:[bx-4]
		mov	cx,z1
		call	imul32
		add	d1_lo,bx
		adc	d1_hi,si
		pop	di
		pop	si

		mov	ax,d1_lo
		stos	word ptr [di]
		mov	ax,d1_hi
		stos	word ptr [di]

		dec	word ptr tmtn
		jz	sbrl1
		jmp	sbrl2

sbrl1:
		dec	word ptr [bp+n]

		mov	word ptr fori,0

sbrl6:		mov	ax,fori
		cmp	ax,[bp+n]
		ja	sbrl7

		inc	ax
		mov	word ptr forj,ax

sbrl5:		mov	ax,forj
                cmp     ax,[bp+n]
		ja	sbrl3

		mov	ax,fori
		shl	ax,1
		shl	ax,1
		shl	ax,1
		shl	ax,1
		add	ax,[bp+tmtbufofs]
		mov	ofsfirst,ax
		mov	ax,forj
		shl	ax,1
		shl	ax,1
		shl	ax,1
		mov	bx,ax
		shl	ax,1
		add	ax,bx
		add	ax,[bp+vid3dofs]
		mov	ofssecond,ax
		call	baron

		mov	ax,baronres
		push	ax

		mov	ax,forj
		shl	ax,1
		shl	ax,1
		shl	ax,1
		shl	ax,1
		add	ax,[bp+tmtbufofs]
		mov	ofsfirst,ax
		mov	ax,fori
		shl	ax,1
		shl	ax,1
		shl	ax,1
		mov	bx,ax
		shl	ax,1
		add	ax,bx
		add	ax,[bp+vid3dofs]
		mov	ofssecond,ax
		call	baron
		pop	ax
		cmp	ax,baronres
		jna	sbrl4
;swaping..
		call	swapdata

sbrl4:		inc	word ptr forj
		jmp	sbrl5

sbrl3:		inc	word ptr fori
		jmp	sbrl6
sbrl7:
		pop	es
		pop	bp
		ret	18
sortbars	endp

baron		proc
		mov	byte ptr scounter,0
		mov	word ptr baronres,0
baronl8:
;d2:=a*s1+b*s2+c*s3
                mov     es,[bp+tmtbufseg]
		mov	bx,ofsfirst
		mov	di,es:[bx+2]	;di:si = s1
		mov	si,es:[bx]
		mov	es,[bp+vid3dseg]
		mov	bx,ofssecond
		mov	cx,es:[bx]	;cx=a
		call	imul32
		mov	d2_lo,bx
		mov	d2_hi,si

		mov	es,[bp+tmtbufseg]
		mov	bx,ofsfirst
		mov	di,es:[bx+6]	;di:si = s2
		mov	si,es:[bx+4]
		mov	es,[bp+vid3dofs]
		mov	bx,ofssecond
		mov	cx,es:[bx+2]	;cx = b
		call	imul32
		add	d2_lo,bx
		adc	d2_hi,si

		mov	es,[bp+tmtbufofs]
		mov	bx,ofsfirst
		mov	di,es:[bx+10]
		mov	si,es:[bx+8]
		mov	es,[bp+vid3dseg]
		mov	bx,ofssecond
		mov	cx,es:[bx+4]
		call	imul32
		add	d2_lo,bx
		adc	d2_hi,si

		mov	es,[bp+tmtbufseg]
		mov	bx,ofsfirst

		cmp	word ptr d2_lo,0
		jne	baronl1
		cmp	word ptr d2_hi,0
		jne	baronl1
		jmp	baronl2
baronl1:
		test	word ptr d2_hi,8000h
		jz	baronl3
		test	word ptr es:[bx+12+2],8000h
		jnz	baronl4
		jmp	baronl2
baronl3:
		test	word ptr es:[bx+12+2],8000h
		jz	baronl4
		jmp	baronl2

baronl4:	test	d2_hi,8000h
		jz	baronl5
;negative
		mov	ax,d2_hi
		cmp	ax,es:[bx+12+2]
		jc	baronl6
		ja	baronl2
		mov	ax,d2_lo
		cmp	ax,es:[bx+12]
		jc	baronl6
		jmp	baronl2
baronl5:
;positive
		mov	ax,d2_hi
		cmp	ax,es:[bx+12+2]
		ja	baronl6
		jc	baronl2
		mov	ax,d2_lo
		cmp	ax,es:[bx+12]
		ja	baronl6
		jmp	baronl2
baronl6:
		inc	word ptr baronres
baronl2:
		add	word ptr ofssecond,6
		inc	byte ptr scounter
		cmp	byte ptr scounter,4
		ja	baronl7
		jmp	baronl8
baronl7:
		ret
baron		endp

swapdata	proc
		cld
;swaping vid3d
		mov	ax,fori
		shl	ax,1
		shl	ax,1
		shl	ax,1
		mov	bx,ax
		shl	ax,1
		add	ax,bx
		add	ax,[bp+vid3dofs]
		mov	ofsfirst,ax
		mov	ax,forj
		shl	ax,1
		shl	ax,1
		shl	ax,1
		mov	bx,ax
		shl	ax,1
		add	ax,bx
		add	ax,[bp+vid3dofs]
		mov	ofssecond,ax

		mov	si,ofsfirst
		lea	di,swapbuf
		mov	ax,seg data
		mov	es,ax
		mov	ds,[bp+vid3dseg]
		mov	cx,12
	rep	movs	word ptr [di],[si]

		mov	ax,seg data
		mov	ds,ax
		mov	si,ofssecond
		mov	di,ofsfirst
		mov	ax,[bp+vid3dseg]
		mov	ds,ax
		mov	es,ax
		mov	cx,12
	rep	movs	word ptr [di],[si]

		mov	ax,seg data
		mov	ds,ax
		lea	si,swapbuf
		mov	di,ofssecond
		mov	cx,12
	rep	movs	word ptr [di],[si]

;swaping bars2d
		mov	ax,fori
		shl	ax,1
		shl	ax,1
		shl	ax,1
		shl	ax,1
		add	ax,[bp+bars2dofs]
		mov	ofsfirst,ax
		mov	ax,forj
		shl	ax,1
		shl	ax,1
		shl	ax,1
		shl	ax,1
		add	ax,[bp+bars2dofs]
		mov	ofssecond,ax

		lea	di,swapbuf
		mov	si,ofsfirst
		mov	ax,seg data
		mov	es,ax
		mov	ds,[bp+bars2dseg]
		mov	cx,8
	rep	movs	word ptr [di],[si]

		mov	ax,seg data
		mov	ds,ax
		mov	si,ofssecond
		mov	di,ofsfirst
		mov	ax,[bp+bars2dseg]
		mov	ds,ax
		mov	es,ax
		mov	cx,8
	rep	movs	word ptr [di],[si]

		mov	ax,seg data
		mov	ds,ax
		lea	si,swapbuf
		mov	di,ofssecond
		mov	cx,8
	rep	movs	word ptr [di],[si]

;swaping colors
                mov     ax,fori
		shl	ax,1
		add	ax,[bp+colorsofs]
		mov	ofsfirst,ax
		mov	ax,forj
		shl	ax,1
		add	ax,[bp+colorsofs]
		mov	ofssecond,ax

		mov	si,ofsfirst
		lea	di,swapbuf
		mov	ax,seg data
		mov	es,ax
		mov	ds,[bp+colorsseg]
		movs	word ptr [di],[si]

		mov	ax,seg data
		mov	ds,ax
		mov	si,ofssecond
		mov	di,ofsfirst
		mov	ax,[bp+colorsseg]
		mov	ds,ax
		mov	es,ax
		movs	word ptr [di],[si]

		mov	ax,seg data
		mov	ds,ax
		lea	si,swapbuf
		mov	di,ofssecond
		movs	word ptr [di],[si]

;swaping tmtbuf
		mov	ax,fori
		shl	ax,1
		shl	ax,1
		shl	ax,1
		shl	ax,1
		add	ax,[bp+tmtbufofs]
		mov	ofsfirst,ax
		mov	ax,forj
		shl	ax,1
		shl	ax,1
		shl	ax,1
		shl	ax,1
		add	ax,[bp+tmtbufofs]
		mov	ofssecond,ax

		mov	si,ofsfirst
		lea	di,swapbuf
		mov	ax,seg data
		mov	es,ax
		mov	ds,[bp+tmtbufseg]
		mov	cx,8
	rep	movs	word ptr [di],[si]

		mov	ax,seg data
		mov	ds,ax
		mov	si,ofssecond
		mov	di,ofsfirst
		mov	ax,[bp+tmtbufseg]
		mov	ds,ax
		mov	es,ax
		mov	cx,8
	rep	movs	word ptr [di],[si]

		mov	ax,seg data
		mov	ds,ax
		lea	si,swapbuf
		mov	di,ofssecond
		mov	cx,8
	rep	movs	word ptr [di],[si]

		ret
swapdata	endp

div32_16	proc
;ax=dx:ax/cx:bx
		or	cx,cx
		jne	dvl4

		div	bx
		ret

dvl4:
		xor	di,di
dvl3:
		cmp	dx,cx
		jc	dvl1
		ja	dvl2
		cmp	ax,bx
		jc	dvl1
dvl2:
		sub	ax,bx
		sbb	dx,cx
		inc	di
		jmp	dvl3

dvl1:
		mov	ax,di
		ret
div32_16	endp

ishr8		proc
		or	dx,dx
		jns	lsh1

		not	ax
		neg	dx
		add	ax,1
		adc	dx,-1
		mov	al,ah
		mov	ah,dl
		not	ax
		neg	dx
		add	ax,1
		adc	dx,-1
		ret

lsh1:           mov     al,ah
		mov	ah,dl
		ret
ishr8		endp

internl1:
_fcos		proc	far
		push	bx
		mov	bx,sp
		mov	bx,ss:[bx+6]
l_fc2:
		or	bx,bx
		jns	l_fc1
		add	bx,360
		jmp	l_fc2
l_fc1:
		cmp	bx,360
		jc	l_fc3
		sub	bx,360
		jmp	l_fc1
l_fc3:
		shl	bx,1
		mov	ax,costable[bx]
		pop	bx
		ret	2
_fcos		endp

internl2:
_fsin		proc	far
		push	bx
		mov	bx,sp
		mov	bx,ss:[bx+6]
		sub	bx,90
		push	bx
		push	cs
		call	internl1
		pop	bx
		ret	2
_fsin		endp

code		ends

data		segment word	public

		extrn	eye_kl:word
		extrn	eye_hxl:word
		extrn	eye_hzl:word
		extrn	costable:word

scounter:
observerx	dw	0
observery	dw	0
observerz	dw	0

x1:
d2_lo:
new3dkoord0	dw	0
d2_hi:
y1:		dw	0
z1:		dw	0

new3dkoord2	dw	0,0,0
new3dkoord1	dw	0,0,0

d1_lo:
ofsfirst:
object2d	dw	0
ofssecond:
d1_hi:		dw	0

x21:
cosalfa dw	0
x31:
cosbeta dw	0
y21:
cosgama dw	0
y31:
sinalfa dw	0
z21:
sinbeta dw	0
z31:
singama dw	0

tmtn:
fori:
tgalfa0x	dw	0
forj:
tgalfa0z	dw	0

baronres:
pushofs dw	0

k3dofs		dw	0
new3dkoord	dw	0,0,0,0,0,0

x2x1		dw	0
y2y1		dw	0
z2z1		dw	0

longint0	dw	0,0
longint1	dw	0,0

swapbuf db 24 dup(0)

data		ends
		end