		public	sort_triangles_z
		public	bytesort_triangles_z

		version m520
		locals

code		segment dword public
		assume	cs:code,ds:data

.386
;procedure sort_triangles_z
sort_triangles_z proc	far
		push	bp
		mov	ax,polycounter32
		mov	cyclecounter,ax
                dec     ax
                mov     sortk,ax
		call	internal_proc1
		pop	bp
		ret
sort_triangles_z endp

internal_proc1	proc
                xor     ax,ax
                mov     base_bufofs2,ax
                mov     base_bufofs6,ax

                mov     es,polyzbufseg32
                mov     fs,poly2dbufseg32
                mov     gs,polycolorsbufseg32

@@l4:
		mov	di,base_bufofs6
                mov     si,di
                shl     si,1

                lods    dword ptr fs:[si]
                mov     dword ptr s_poly2d,eax
                lods    dword ptr fs:[si]
                mov     dword ptr s_poly2d+4,eax
		mov	eax,fs:[si]
                mov     dword ptr s_poly2d+4+4,eax

                mov     si,di
                lods    dword ptr gs:[si]
                mov     dword ptr s_colors,eax
		mov	ax,gs:[si]
                mov     word ptr s_colors+4,ax

                mov     si,base_bufofs2
		lods	word ptr es:[si]
		mov	bx,ax
		mov	di,si

                mov     cx,sortk
                jcxz    @@l1

                align   4
@@l3:
                scas    word ptr es:[di]
                jnl     @@l2

                mov     ax,es:[di-2]
                mov     si,di
@@l2:
		dec	cx
                jne    @@l3
@@l1:

                dec     si
                dec     si
		mov	es:[si],bx

		mov	di,si
		add	di,si
		add	di,si

                mov     si,di
                shl     si,1

		mov	eax,dword ptr s_poly2d
		xchg	eax,fs:[si]
		mov	dword ptr s_poly2d,eax
		mov	eax,dword ptr s_poly2d+4
		xchg	eax,fs:[si+4]
		mov	dword ptr s_poly2d+4,eax
		mov	eax,dword ptr s_poly2d+4+4
		xchg	eax,fs:[si+4+4]
		mov	dword ptr s_poly2d+4+4,eax

                mov     si,di
		mov	eax,dword ptr s_colors
		xchg	eax,gs:[si]
		mov	dword ptr s_colors,eax
		mov	ax,word ptr s_colors+4
		xchg	ax,gs:[si+4]
		mov	s_colors+4,ax

                add     base_bufofs2,2
                add     base_bufofs6,6

                dec     sortk

                call    guro_simple
                mov     es,polyzbufseg32
;   guro_simple   FS
;                mov     fs,poly2dbufseg32
                mov     gs,polycolorsbufseg32

                dec     cyclecounter
                jne     @@l4

                ret
internal_proc1  endp

;procedure bytesort_triangles_z;
bytesort_triangles_z	proc	far
			push	bp

;室 minz  maxz

			mov	cx,polycounter
			or	cx,cx
			je	@@l6
			mov	ds,polyzbufseg
			xor	si,si
			cld
			mov	di,-1
			mov	dx,32700

@@l9:
			lodsw
			cmp	ax,di
			jng	@@l7
			mov	di,ax
@@l7:
			cmp	ax,dx
			jnl	@@l8
			mov	dx,ax
@@l8:
			dec	cx
			jne	@@l9

			mov	ax,seg	data
			mov	ds,ax

			mov	minz,di
			mov	minz_3d,dx
			sub	di,dx

			mov	ax,di
			xor	dx,dx
			mov	bx,32
			div	bx
			inc	ax
			mov	minzdec,ax
			sub	minz,ax

@@l3:
			cld
                        mov     ax,minz
			mov	es,polyzbufseg
			mov	cx,polycounter
			xor	di,di
			xor	si,si
			xor	ebx,ebx
			xor	ebp,ebp

			align	4
@@l2:
			scasw
			jg	@@l1

                        mov     fs,polyzbufseg32
			xor	dx,dx
			xchg	dx,es:[di-2]
			mov	fs:[si],dx
			inc	si
			inc	si

			mov	fs,poly2dbufseg
			mov	gs,poly2dbufseg32
			mov	edx,fs:[ebp*2]
			mov	gs:[ebx*2],edx
			mov	edx,fs:[ebp*2+4]
			mov	gs:[ebx*2+4],edx
			mov	edx,fs:[ebp*2+8]
			mov	gs:[ebx*2+8],edx

			mov	fs,polycolorsbufseg
			mov	gs,polycolorsbufseg32
			mov	edx,fs:[bp]
			mov	gs:[bx],edx
			mov	dx,fs:[bp+4]
			mov	gs:[bx+4],dx

                        add     bx,6

@@l1:
			add	bp,6
			dec	cx
			jne	@@l2

			shr	si,1
			jz	@@l4
			mov	cyclecounter,si
			dec	si
			mov	sortk,si

                        call    internal_proc1
@@l4:
			mov	ax,minz
			cmp	ax,minz_3d
			je	@@l6
			sub	ax,minzdec
			cmp	ax,minz_3d
			jnl	@@l10
			mov	ax,minz_3d
@@l10:
			mov	minz,ax
                        jmp     @@l3
@@l6:
			pop	bp
			ret
bytesort_triangles_z    endp

                extrn   guro_simple:far


.286
code		ends

data		segment word public

                extrn   s_colors:word
                extrn   s_poly2d:word

                extrn   poly2dbufseg32:word
                extrn   polyzbufseg32:word
                extrn   polycolorsbufseg32:word
                extrn   polycounter32:word

                extrn   poly2dbufseg:word
                extrn   polyzbufseg:word
                extrn   polycolorsbufseg:word
                extrn   polycounter:word


sortk		dw	0
base_bufofs2	dw	0
base_bufofs6	dw	0
bufofs2 dw	0
cyclecounter	dw	0
minz		dw	0
minz_3d	 dw	0
minzdec	 dw	0

data		ends
		end
