uses crt;

type
 laga = record
   ofs,seg:word
 end;

const
 tmax: word = 0;
var
 xp,yp : array [0..10000] of integer;
 outarr : array [0..199] of integer;
 c     : char;
 i     : integer;
 ymax  : integer;
 fname : string;
 f : text;

function getspline(p: pointer; t: longint; tmax: word): LongInt;
type
 intar = array [0..30000] of integer;
var
 ti,xp0,xp1,xp2,xp3,xp4,xp5: longint;
 tr,x01,x12,x23,x34,x45,x012,x123,x234,x345,x0123,x1234,x2345,x01234,x12345,x012345: real;

begin
if (tmax<3) or (t<0) or (laga(t).seg>tmax) then
  begin
   directvideo:=false;
   writeln('invalid parameters');
   halt;
  end;

ti:=laga(t).seg;

if (ti<2) then xp0:=intar(p^)[0]
          else xp0:=intar(p^)[ti-2];

if (ti<1) then xp1:=intar(p^)[0]
          else xp1:=intar(p^)[ti-1];

xp2:=intar(p^)[ti];

if (ti+1>tmax) then xp3:=intar(p^)[tmax]
               else xp3:=intar(p^)[ti+1];

if (ti+2>tmax) then xp4:=intar(p^)[tmax]
               else xp4:=intar(p^)[ti+2];

if (ti+3>tmax) then xp5:=intar(p^)[tmax]
               else xp5:=intar(p^)[ti+3];

laga(t).seg:=2;

tr:=t/65536;

x01:=(tr*xp1-(tr-1)*xp0);
x12:=((tr-1)*xp2-(tr-2)*xp1);
x23:=((tr-2)*xp3-(tr-3)*xp2);
x34:=((tr-3)*xp4-(tr-4)*xp3);
x45:=((tr-4)*xp5-(tr-5)*xp4);

x012:=(tr*x12-(tr-2)*x01)/2;
x123:=((tr-1)*x23-(tr-3)*x12)/2;
x234:=((tr-2)*x34-(tr-4)*x23)/2;
x345:=((tr-3)*x45-(tr-5)*x34)/2;

x0123:=(tr*x123-(tr-3)*x012)/3;
x1234:=((tr-1)*x234-(tr-4)*x123)/3;
x2345:=((tr-2)*x345-(tr-5)*x234)/3;

x01234:=(tr*x1234-(tr-4)*x0123)/4;
x12345:=((tr-1)*x2345-(tr-5)*x1234)/4;

x012345:=(tr*x12345-(tr-5)*x01234)/5;

getspline:=round(x012345*65536);
end;

{$L mode256}
{$F+}
procedure line(x1,y1,x2,y2:integer;color: byte; backbuf:word); external;
procedure line1(x1,y1,x2,y2:integer;color: byte; backbuf:word); external;
procedure SetGfxMode;  {⠭ ० ࠭ 13h} External;
procedure SetTxtMode;    {⠭ ० ࠭ 3} External;
procedure GorLine(y,x1,x2: Integer; Color: Byte; Seg: Word); External;
procedure fillf(x1,x2,x3,x4,y1,y2: Integer; Color: Byte; BufSeg: Word); External;
procedure CopyToScreen(bufseg: Word); External;
procedure CopyToScreenShadow(bufseg,shadowseg: Word); External;
procedure ShowPicBar(bar: pointer; screenseg: word;
     picx,picy,piclenx,picleny,picseg: word); External;
procedure pset(x,y: integer;color:byte;seg:word); external;
procedure doblepset(x,y: integer;color:byte;seg:word); external;
procedure Quadropset(x,y: integer;color:byte;seg:word); external;
procedure BlockQuadropset(nobj: word; block:pointer;color:byte;seg:word); external;
procedure clearvga(seg:word); external;
procedure fillpoly4; external;
{$F-}

label l1;

begin
setgfxmode;
directvideo:=false;


xp[0]:=0; yp[0]:=199;

l1:
clearvga($a000);

repeat

line(0,0,199,0,145,$a000);
line(0,199,199,199,145,$a000);
line(0,0,0,199,145,$a000);
line(199,0,199,199,145,$a000);
line(0,100,199,100,145,$a000);
line(100,0,100,199,145,$a000);

for i:=0 to tmax  do
  begin
   pset(xp[i]+1,yp[i],15,$a000);
   pset(xp[i]-1,yp[i],15,$a000);
   pset(xp[i],yp[i]+1,15,$a000);
   pset(xp[i],yp[i]-1,15,$a000);
  end;

   pset(xp[tmax]+2,yp[tmax],15,$a000);
   pset(xp[tmax]-2,yp[tmax],15,$a000);
   pset(xp[tmax],yp[tmax]+2,15,$a000);
   pset(xp[tmax],yp[tmax]-2,15,$a000);

gotoxy(27,2); write(xp[tmax]:3,',',199-yp[tmax]:3);
c:=readkey;

for i:=0 to tmax  do
  begin
   pset(xp[i]+1,yp[i],0,$a000);
   pset(xp[i]-1,yp[i],0,$a000);
   pset(xp[i],yp[i]+1,0,$a000);
   pset(xp[i],yp[i]-1,0,$a000);
  end;

   pset(xp[tmax]+2,yp[tmax],0,$a000);
   pset(xp[tmax]-2,yp[tmax],0,$a000);
   pset(xp[tmax],yp[tmax]+2,0,$a000);
   pset(xp[tmax],yp[tmax]-2,0,$a000);

case c of
'H': dec(yp[tmax],1);
'P': inc(yp[tmax],1);
'K': dec(xp[tmax],1);
'M': inc(xp[tmax],1);
'q' : halt;
#13: begin
      inc(tmax);
      xp[tmax]:=xp[tmax-1];
      yp[tmax]:=yp[tmax-1];
     end;
end;
while xp[tmax]>199 do dec(xp[tmax],200);
while yp[tmax]>199 do dec(yp[tmax],200);
while xp[tmax]<0 do inc(xp[tmax],200);
while yp[tmax]<0 do inc(yp[tmax],200);
until c='g';

if tmax>0 then dec(tmax);

for i:=0 to tmax  do
  begin
   pset(xp[i]+1,yp[i],15,$a000);
   pset(xp[i]-1,yp[i],15,$a000);
   pset(xp[i],yp[i]+1,15,$a000);
   pset(xp[i],yp[i]-1,15,$a000);
  end;

for i:=0 to tmax*100 do
  pset(round(getspline(addr(xp),round(i/100*65536),tmax)/65536),
       round(getspline(addr(yp),round(i/100*65536),tmax)/65536),15,$a000);

gotoxy(27,1); write('Enter - accept');

c:=readkey;

if c<>#13 then goto l1;

for i:=0 to 199 do outarr[i]:=0;

gotoxy(27,1); write('Wait...       ');

for i:=0 to tmax*100 do
  outarr[round(getspline(addr(xp),round(i/100*65536),tmax)/65536)]:=
   199-round(getspline(addr(yp),round(i/100*65536),tmax)/65536);

clearvga($a000);

for i:=0 to 199 do pset(i,199-outarr[i],15,$a000);


gotoxy(27,1); write('FName:'); readln(fname);

assign(f,fname); rewrite(f);
write(f,'sppar : array [0..18] of integer = (');

for i:=0 to 199 do
  begin
   if i mod 10=0 then
     begin
      write(f,outarr[i]);
      if i<>190 then write(f,',');
     end;
  end;
writeln(f,');');

close(f);

end.
