;Copyright by AX
;======================================================================

                public  texturemap
		public	texturemap_guro
		public	texturemap_guro4
		public	texturemap_guro5
		public	texturemap_flat
		public	texturemap_flat4
		public	texturemap_flat5

		version m520
		locals

code		segment byte public
		assume	cs:code,ds:data
.386

;======================================================================
; MACRO BMP_LINE
;======================================================================
bmp_line	macro	lab,d_z1,d_z2,d_x1,d_x2,bmp_x1,bmp_x2

d_y1		=	word ptr d_x1+2
d_y2		=	word ptr d_x2+2
bmp_y1		=	byte ptr bmp_x1+1
bmp_y2		=	byte ptr bmp_x2+1

		mov	cx,d_y2
		mov	di,d_y1
		sub	cx,di
		mov	ax,4747h
		jns	bmpl_&lab
		neg	cx
		mov	ax,4f4fh
bmpl_&lab:
		mov	word ptr cs:[bmpl4_&lab-2],ax
		jnz	bmpl11_&lab
		jmp	bmpl10_&lab
bmpl11_&lab:
		movzx	ecx,cx
;ebp - x
;di - y*2
;esi - z
;ecx - count
;bx - bmpy
;dx - bmpx

		mov	ax,d_x2
		mov	bp,d_x1
		sub	ax,bp
		shl	eax,16
		shl	ebp,16
		cdq
		idiv	ecx
		mov	dword ptr cs:[bmpl5_&lab-4],eax

                mov     ax,d_z2
		mov	si,d_z1
		sub	ax,si
		shl	eax,16
		shl	esi,16
		cdq
		idiv	ecx
		mov	dword ptr cs:[bmpl6_&lab-4],eax

		movzx	eax,bmp_y2
		movzx	ebx,bmp_y1
		xchg	ah,al
		xchg	bh,bl
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[bmpl8_&lab-2],ax

		movzx	eax,bmp_x2
		movzx	edx,bmp_x1
		xchg	ah,al
		xchg	dh,dl
		sub	eax,edx
		cdq
		idiv	ecx
		mov	word ptr cs:[bmpl7_&lab-2],ax
		mov	dh,bmp_x1
		xor	dl,dl

		shl	di,1
		inc	cx
;===================== cycle ================
bmpl9_&lab:

;=== left edge ===
		shld	eax,ebp,16
		cmp	ax,s_leftx[di]
		jnl	bmpl2_&lab

		mov	s_leftx[di],ax

		shld	eax,esi,16
		mov	s_leftz[di],ax

		mov	al,dh
		mov	ah,bh
		mov	s_left_bmpxy[di],ax

		shld	eax,ebp,16
bmpl2_&lab:

;=== right edge ===
		cmp	ax,s_rightx[di]
		jng	bmpl3_&lab

		mov	s_rightx[di],ax

		shld	eax,esi,16
		mov	s_rightz[di],ax

		mov	al,dh
		mov	ah,bh
		mov	s_right_bmpxy[di],ax

bmpl3_&lab:
		inc	di
		inc	di
bmpl4_&lab:
		add	ebp,12345678h
bmpl5_&lab:
		add	esi,12345678h
bmpl6_&lab:
		add	dx,1234h
bmpl7_&lab:
		add	bx,1234h
bmpl8_&lab:
		dec	cx
		jne	bmpl9_&lab
bmpl10_&lab:

endm

;======================================================================
;procedure texturemap(scrbuf,zbufseg,bmpbuf: word)
;======================================================================

texturemap	proc	far

bmpbuf          =       6
zbufseg =	8
scrbuf		=	10

		push	bp
		mov	bp,sp

;intitalize leftx&rightx

		mov	ax,ds
		mov	es,ax
		cld

		lea	di,s_leftx
		mov	eax,30003000h
		mov	cx,100
	rep	stosd

                lea     di,s_rightx
		mov	eax,-1
		mov	cx,100
	rep	stosd

;draw lines to buffer
		push	bp
	bmp_line a,s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],s_poly2d[4],s_polybmp[0],s_polybmp[2]
	bmp_line b,s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],s_poly2d[8],s_polybmp[2],s_polybmp[4]
	bmp_line c,s_poly3d[12+2],s_poly3d[0+2],s_poly2d[8],s_poly2d[0],s_polybmp[4],s_polybmp[0]
		pop	bp

		mov	ax,s_poly2d[2]
		mov	di,ax
		mov	si,s_poly2d[4+2]
		cmp	si,ax
		jc	tml3
		mov	ax,si
tml3:
		cmp	si,di
		ja	tml4
		mov	di,si
tml4:
		mov	si,s_poly2d[8+2]
		cmp	si,ax
		jc	tml5
		mov	ax,si
tml5:
		cmp	si,di
		ja	tml6
		mov	di,si
tml6:
		shl	di,1
		mov	cury,di
		shl	ax,1
		mov	word ptr cs:[endy-2],ax

		mov	bx,di
		mov	si,di
		shl	bx,1
		shl	si,3
		lea	ax,[bx+si]
		add	ax,[bp+scrbuf]
		mov	gs,ax

		lea	ax,[bx+si]
		shl	ax,1
		add	ax,[bp+zbufseg]
		mov	es,ax

		mov	fs,[bp+bmpbuf]

;============== y cycle ===========
tml11:
		mov	cx,s_rightx[di]
		mov	si,s_leftx[di]
		sub	cx,si
		jg	tml7

                jmp     tml9
tml7:
		movzx	ecx,cx

		movzx	eax,byte ptr s_right_bmpxy[di]
		movzx	ebx,byte ptr s_left_bmpxy[di]
		xchg	ah,al
		xchg	bh,bl
		mov	x256,bx
		sub	ax,bx
		cwd
		idiv	cx
		mov	word ptr cs:[bxadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di+1]
		movzx	ebx,byte ptr s_left_bmpxy[di+1]
		xchg	ah,al
		xchg	bh,bl
		mov	y256,bx
		sub	eax,ebx
		cwd
		idiv	cx
		mov	word ptr cs:[byadd-2],ax

		mov	ax,s_rightz[di]
		sub	ax,s_leftz[di]
		shl	eax,16
		cdq
		idiv	ecx
		mov	bp,ax
		shr	eax,16
		mov	word ptr cs:[zaddhi-2],ax

		mov	ax,s_leftz[di]
		mov	di,si
		shl	di,1
		mov	dx,32000
		inc	cx

;es:di - zbufptr
;gs:si - scrbuf
;fs - bitmap
;ax - z
;dx - zlo
;bp - z_lo_add
;=================== x cycle  ================
tml2:
		scasw
		jnl	tml1

		dec	di
		dec	di
		stosw
		mov	bh,byte ptr y256+1
		mov	bl,byte ptr x256+1
		mov	bl,fs:[bx]
		mov	gs:[si],bl
tml1:
		inc	si
		add	x256,1234h
bxadd:
		add	y256,1234h
byadd:
		add	dx,bp
		adc	ax,1234h
zaddhi:
		dec	cx
		jne	tml2
tml9:
		mov	ax,es
		add	ax,40
		mov	es,ax

		mov	ax,gs
		add	ax,20
		mov	gs,ax

		mov	di,cury
		cmp	di,1234h
endy:
		je	tml10

                inc     di
		inc	di
		mov	cury,di
		jmp	tml11
tml10:
		pop	bp
		ret	6
texturemap	endp

;======================================================================
; MACRO BMP_LINE_G
;======================================================================
bmp_line_g	macro	lab,d_z1,d_z2,d_x1,d_x2,bmp_x1,bmp_x2,d_c1,d_c2

d_y1		=	word ptr d_x1+2
d_y2		=	word ptr d_x2+2
bmp_y1		=	byte ptr bmp_x1+1
bmp_y2		=	byte ptr bmp_x2+1

		mov	cx,d_y2
		mov	di,d_y1
		sub	cx,di
		mov	ax,4747h
		jns	bmpl_&lab
		neg	cx
		mov	ax,4f4fh
bmpl_&lab:
		mov	word ptr cs:[bmpl4_&lab-2],ax
		jnz	bmpl11_&lab
		jmp	bmpl10_&lab
bmpl11_&lab:
		movzx	ecx,cx
;ebp - x
;di - y*2
;esi - z
;ecx - count
;bx - bmpy
;dx - bmpx

                mov     ax,d_c2
		mov	bp,d_c1
		mov	dcolor,bp
		sub	ax,bp
		cwd
		idiv	cx
		mov	word ptr cs:[bmpl12_&lab-2],ax

		mov	ax,d_x2
		mov	bp,d_x1
		sub	ax,bp
		shl	eax,16
		shl	ebp,16
		cdq
		idiv	ecx
		mov	dword ptr cs:[bmpl5_&lab-4],eax

                mov     ax,d_z2
		mov	si,d_z1
		sub	ax,si
		shl	eax,16
		shl	esi,16
		cdq
		idiv	ecx
		mov	dword ptr cs:[bmpl6_&lab-4],eax

		movzx	eax,bmp_y2
		movzx	ebx,bmp_y1
		xchg	ah,al
		xchg	bh,bl
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[bmpl8_&lab-2],ax

		movzx	eax,bmp_x2
		movzx	edx,bmp_x1
		xchg	ah,al
		xchg	dh,dl
		sub	eax,edx
		cdq
		idiv	ecx
		mov	word ptr cs:[bmpl7_&lab-2],ax
		mov	dh,bmp_x1
		xor	dl,dl

		shl	di,1
		inc	cx
;===================== cycle ================
bmpl9_&lab:

;=== left edge ===
		shld	eax,ebp,16
		cmp	ax,s_leftx[di]
		jnl	bmpl2_&lab

		mov	s_leftx[di],ax

		shld	eax,esi,16
		mov	s_leftz[di],ax

		mov	al,dh
		mov	ah,bh
		mov	s_left_bmpxy[di],ax

		mov	ax,dcolor
		mov	s_leftc[di],ax

		shld	eax,ebp,16
bmpl2_&lab:

;=== right edge ===
		cmp	ax,s_rightx[di]
		jng	bmpl3_&lab

		mov	s_rightx[di],ax

		shld	eax,esi,16
		mov	s_rightz[di],ax

		mov	al,dh
		mov	ah,bh
		mov	s_right_bmpxy[di],ax

		mov	ax,dcolor
		mov	s_rightc[di],ax

bmpl3_&lab:
		inc	di
		inc	di
bmpl4_&lab:
		add	ebp,12345678h
bmpl5_&lab:
		add	esi,12345678h
bmpl6_&lab:
		add	dx,1234h
bmpl7_&lab:
		add	bx,1234h
bmpl8_&lab:

		add	dcolor,1234h
bmpl12_&lab:
		dec	cx
		jne	bmpl9_&lab
bmpl10_&lab:

endm

;======================================================================
;procedure texturemap_guro(scrbuf,zbufseg,bmpbuf);
;⠫    ६
;s_poly3d,s_poly2d,s_polybmp,s_colors,s_itblseg
;======================================================================

texturemap_guro proc	far

bmpbuf		=	6
zbufseg =	8
scrbuf		=	10

		push	bp
		mov	bp,sp

		mov	ax,[bp+bmpbuf]
		mov	d_bmpseg,ax

;intitalize leftx&rightx

		mov	ax,ds
		mov	es,ax
		cld

		lea	di,s_leftx
		mov	eax,30003000h
		mov	cx,100
	rep	stosd

                lea     di,s_rightx
		mov	eax,-1
		mov	cx,100
	rep	stosd

;draw lines to buffer
		push	bp
	bmp_line_g d,s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],s_poly2d[4],s_polybmp[0],s_polybmp[2],s_colors[0],s_colors[2]
	bmp_line_g e,s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],s_poly2d[8],s_polybmp[2],s_polybmp[4],s_colors[2],s_colors[4]
        bmp_line_g f,s_poly3d[12+2],s_poly3d[0+2],s_poly2d[8],s_poly2d[0],s_polybmp[4],s_polybmp[0],s_colors[4],s_colors[0]
;        bmp_line_g f,s_poly3d[12+2],s_poly3d[18+2],s_poly2d[8],s_poly2d[12],s_polybmp[4],s_polybmp[6],s_colors[4],s_colors[6]
;        bmp_line_g g,s_poly3d[18+2],s_poly3d[0+2],s_poly2d[12],s_poly2d[0],s_polybmp[6],s_polybmp[0],s_colors[6],s_colors[0]
		pop	bp

		mov	ax,s_poly2d[2]
		mov	di,ax
		mov	si,s_poly2d[4+2]
		cmp	si,ax
		jc	_tml3
		mov	ax,si
_tml3:
		cmp	si,di
		ja	_tml4
		mov	di,si
_tml4:
		mov	si,s_poly2d[8+2]
		cmp	si,ax
		jc	_tml5
		mov	ax,si
_tml5:
		cmp	si,di
		ja	_tml6
		mov	di,si
_tml6:
;               mov     si,s_poly2d[12+2]
;                cmp     si,ax
;                jc      _tml12
;                mov     ax,si
;_tml12:
;                cmp     si,di
;                ja      _tml13
;                mov     di,si
;_tml13:
		shl	di,1
		mov	cury,di
		shl	ax,1
		mov	word ptr cs:[_endy-2],ax

		mov	bx,di
		mov	si,di
		shl	bx,1
		shl	si,3
		lea	ax,[bx+si]
		add	ax,[bp+scrbuf]
		mov	gs,ax

		lea	ax,[bx+si]
		shl	ax,1
		add	ax,[bp+zbufseg]
		mov	es,ax

;============== y cycle ===========
_tml11:
		mov	cx,s_rightx[di]
		mov	si,s_leftx[di]
		sub	cx,si
		jg	_tml7

                jmp     _tml9
_tml7:
		movzx	ecx,cx

                mov     ax,s_rightc[di]
		mov	bx,s_leftc[di]
		mov	dcolor,bx
		sub	ax,bx
		cwd
		idiv	cx
		mov	word ptr cs:[_cadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di]
		movzx	ebx,byte ptr s_left_bmpxy[di]
		xchg	ah,al
		xchg	bh,bl
		mov	x256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[_bxadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di+1]
		movzx	ebx,byte ptr s_left_bmpxy[di+1]
		xchg	ah,al
		xchg	bh,bl
		mov	y256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[_byadd-2],ax

		mov	ax,s_rightz[di]
		sub	ax,s_leftz[di]
		shl	eax,16
		cdq
		idiv	ecx
		mov	bp,ax
		shr	eax,16
		mov	word ptr cs:[_zaddhi-2],ax

		mov	ax,s_leftz[di]
		mov	di,si
		shl	di,1
		mov	dx,32000
		inc	cx

;es:di - zbufptr
;gs:si - scrbuf
;fs - bitmap/itbl
;ax - z
;dx - zlo
;bp - z_lo_add
;=================== x cycle  ================
_tml2:
                scasw
                jnl     _tml1

                dec     di
                dec     di
                stosw
		mov	bh,byte ptr y256+1
		mov	bl,byte ptr x256+1
		mov	fs,d_bmpseg
		mov	bl,fs:[bx]
                mov     bh,byte ptr dcolor+1
                mov     fs,s_itblseg
                mov     bl,fs:[bx]
		mov	gs:[si],bl
_tml1:
		inc	si
		add	x256,1234h
_bxadd:
		add	y256,1234h
_byadd:
		add	dx,bp
		adc	ax,1234h
_zaddhi:
		add	dcolor,1234h
_cadd:
		dec	cx
		jne	_tml2
_tml9:
		mov	ax,es
		add	ax,40
		mov	es,ax

		mov	ax,gs
		add	ax,20
		mov	gs,ax

		mov	di,cury
		cmp	di,1234h
_endy:
		je	_tml10

                inc     di
		inc	di
		mov	cury,di
		jmp	_tml11
_tml10:
		pop	bp
		ret	6
texturemap_guro endp

texturemap_guro4 proc    far


bmpbuf		=	6
zbufseg =	8
scrbuf		=	10

		push	bp
		mov	bp,sp

		mov	ax,[bp+bmpbuf]
		mov	d_bmpseg,ax

;intitalize leftx&rightx

		mov	ax,ds
		mov	es,ax
		cld

		lea	di,s_leftx
		mov	eax,30003000h
		mov	cx,100
	rep	stosd

                lea     di,s_rightx
		mov	eax,-1
		mov	cx,100
	rep	stosd

;draw lines to buffer
		push	bp
	bmp_line_g _d,s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],s_poly2d[4],s_polybmp[0],s_polybmp[2],s_colors[0],s_colors[2]
	bmp_line_g _e,s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],s_poly2d[8],s_polybmp[2],s_polybmp[4],s_colors[2],s_colors[4]
        bmp_line_g _f,s_poly3d[12+2],s_poly3d[18+2],s_poly2d[8],s_poly2d[12],s_polybmp[4],s_polybmp[6],s_colors[4],s_colors[6]
        bmp_line_g _g,s_poly3d[18+2],s_poly3d[0+2],s_poly2d[12],s_poly2d[0],s_polybmp[6],s_polybmp[0],s_colors[6],s_colors[0]
		pop	bp

		mov	ax,s_poly2d[2]
		mov	di,ax
		mov	si,s_poly2d[4+2]
		cmp	si,ax
		jc	f_tml3
		mov	ax,si
f_tml3:
		cmp	si,di
		ja	f_tml4
		mov	di,si
f_tml4:
		mov	si,s_poly2d[8+2]
		cmp	si,ax
		jc	f_tml5
		mov	ax,si
f_tml5:
		cmp	si,di
		ja	f_tml6
		mov	di,si
f_tml6:
                mov     si,s_poly2d[12+2]
                cmp     si,ax
                jc      f_tml12
                mov     ax,si
f_tml12:
                cmp     si,di
                ja      f_tml13
                mov     di,si
f_tml13:
		shl	di,1
		mov	cury,di
		shl	ax,1
		mov	word ptr cs:[f_endy-2],ax

		mov	bx,di
		mov	si,di
		shl	bx,1
		shl	si,3
		lea	ax,[bx+si]
		add	ax,[bp+scrbuf]
		mov	gs,ax

		lea	ax,[bx+si]
		shl	ax,1
		add	ax,[bp+zbufseg]
		mov	es,ax

;============== y cycle ===========
f_tml11:
		mov	cx,s_rightx[di]
		mov	si,s_leftx[di]
		sub	cx,si
		jg	f_tml7

                jmp     f_tml9
f_tml7:
		movzx	ecx,cx

                mov     ax,s_rightc[di]
		mov	bx,s_leftc[di]
		mov	dcolor,bx
		sub	ax,bx
		cwd
		idiv	cx
		mov	word ptr cs:[f_cadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di]
		movzx	ebx,byte ptr s_left_bmpxy[di]
		xchg	ah,al
		xchg	bh,bl
		mov	x256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[f_bxadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di+1]
		movzx	ebx,byte ptr s_left_bmpxy[di+1]
		xchg	ah,al
		xchg	bh,bl
		mov	y256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[f_byadd-2],ax

		mov	ax,s_rightz[di]
		sub	ax,s_leftz[di]
		shl	eax,16
		cdq
		idiv	ecx
		mov	bp,ax
		shr	eax,16
		mov	word ptr cs:[f_zaddhi-2],ax

		mov	ax,s_leftz[di]
		mov	di,si
		shl	di,1
		mov	dx,32000
		inc	cx

;es:di - zbufptr
;gs:si - scrbuf
;fs - bitmap/itbl
;ax - z
;dx - zlo
;bp - z_lo_add
;=================== x cycle  ================
f_tml2:
                scasw
                jnl     f_tml1

                dec     di
                dec     di
                stosw
		mov	bh,byte ptr y256+1
		mov	bl,byte ptr x256+1
		mov	fs,d_bmpseg
		mov	bl,fs:[bx]
                mov     bh,byte ptr dcolor+1
                mov     fs,s_itblseg
                mov     bl,fs:[bx]
		mov	gs:[si],bl
f_tml1:
		inc	si
		add	x256,1234h
f_bxadd:
		add	y256,1234h
f_byadd:
		add	dx,bp
		adc	ax,1234h
f_zaddhi:
		add	dcolor,1234h
f_cadd:
		dec	cx
		jne	f_tml2
f_tml9:
		mov	ax,es
		add	ax,40
		mov	es,ax

		mov	ax,gs
		add	ax,20
		mov	gs,ax

		mov	di,cury
		cmp	di,1234h
f_endy:
		je	f_tml10

                inc     di
		inc	di
		mov	cury,di
		jmp	f_tml11
f_tml10:
		pop	bp
		ret	6
texturemap_guro4 endp

texturemap_guro5 proc	far

bmpbuf		=	6
zbufseg =	8
scrbuf		=	10

		push	bp
		mov	bp,sp

		mov	ax,[bp+bmpbuf]
		mov	d_bmpseg,ax

;intitalize leftx&rightx

		mov	ax,ds
		mov	es,ax
		cld

		lea	di,s_leftx
		mov	eax,30003000h
		mov	cx,100
	rep	stosd

                lea     di,s_rightx
		mov	eax,-1
		mov	cx,100
	rep	stosd

;draw lines to buffer
		push	bp
	bmp_line_g ud,s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],s_poly2d[4],s_polybmp[0],s_polybmp[2],s_colors[0],s_colors[2]
	bmp_line_g ue,s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],s_poly2d[8],s_polybmp[2],s_polybmp[4],s_colors[2],s_colors[4]
        bmp_line_g uf,s_poly3d[12+2],s_poly3d[18+2],s_poly2d[8],s_poly2d[12],s_polybmp[4],s_polybmp[6],s_colors[4],s_colors[6]
        bmp_line_g ug,s_poly3d[18+2],s_poly3d[24+2],s_poly2d[12],s_poly2d[16],s_polybmp[6],s_polybmp[8],s_colors[6],s_colors[8]
        bmp_line_g uh,s_poly3d[24+2],s_poly3d[0+2],s_poly2d[16],s_poly2d[0],s_polybmp[8],s_polybmp[0],s_colors[8],s_colors[0]
		pop	bp

		mov	ax,s_poly2d[2]
		mov	di,ax
		mov	si,s_poly2d[4+2]
		cmp	si,ax
		jc	u_tml3
		mov	ax,si
u_tml3:
		cmp	si,di
		ja	u_tml4
		mov	di,si
u_tml4:
		mov	si,s_poly2d[8+2]
		cmp	si,ax
		jc	u_tml5
		mov	ax,si
u_tml5:
		cmp	si,di
		ja	u_tml6
		mov	di,si
u_tml6:
                mov     si,s_poly2d[12+2]
                cmp     si,ax
                jc      u_tml12
                mov     ax,si
u_tml12:
                cmp     si,di
                ja      u_tml13
                mov     di,si
u_tml13:
                mov     si,s_poly2d[16+2]
                cmp     si,ax
                jc      u_tml12a
                mov     ax,si
u_tml12a:
                cmp     si,di
                ja      u_tml13a
                mov     di,si
u_tml13a:
		shl	di,1
		mov	cury,di
		shl	ax,1
		mov	word ptr cs:[u_endy-2],ax

		mov	bx,di
		mov	si,di
		shl	bx,1
		shl	si,3
		lea	ax,[bx+si]
		add	ax,[bp+scrbuf]
		mov	gs,ax

		lea	ax,[bx+si]
		shl	ax,1
		add	ax,[bp+zbufseg]
		mov	es,ax

;============== y cycle ===========
u_tml11:
		mov	cx,s_rightx[di]
		mov	si,s_leftx[di]
		sub	cx,si
		jg	u_tml7

                jmp     u_tml9
u_tml7:
		movzx	ecx,cx

                mov     ax,s_rightc[di]
		mov	bx,s_leftc[di]
		mov	dcolor,bx
		sub	ax,bx
		cwd
		idiv	cx
		mov	word ptr cs:[u_cadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di]
		movzx	ebx,byte ptr s_left_bmpxy[di]
		xchg	ah,al
		xchg	bh,bl
		mov	x256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[u_bxadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di+1]
		movzx	ebx,byte ptr s_left_bmpxy[di+1]
		xchg	ah,al
		xchg	bh,bl
		mov	y256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[u_byadd-2],ax

		mov	ax,s_rightz[di]
		sub	ax,s_leftz[di]
		shl	eax,16
		cdq
		idiv	ecx
		mov	bp,ax
		shr	eax,16
		mov	word ptr cs:[u_zaddhi-2],ax

		mov	ax,s_leftz[di]
		mov	di,si
		shl	di,1
		mov	dx,32000
		inc	cx

;es:di - zbufptr
;gs:si - scrbuf
;fs - bitmap/itbl
;ax - z
;dx - zlo
;bp - z_lo_add
;=================== x cycle  ================
u_tml2:
                scasw
                jnl     u_tml1

                dec     di
                dec     di
                stosw
		mov	bh,byte ptr y256+1
		mov	bl,byte ptr x256+1
		mov	fs,d_bmpseg
		mov	bl,fs:[bx]
                mov     bh,byte ptr dcolor+1
                mov     fs,s_itblseg
                mov     bl,fs:[bx]
		mov	gs:[si],bl
u_tml1:
		inc	si
		add	x256,1234h
u_bxadd:
		add	y256,1234h
u_byadd:
		add	dx,bp
		adc	ax,1234h
u_zaddhi:
		add	dcolor,1234h
u_cadd:
		dec	cx
		jne	u_tml2
u_tml9:
		mov	ax,es
		add	ax,40
		mov	es,ax

		mov	ax,gs
		add	ax,20
		mov	gs,ax

		mov	di,cury
		cmp	di,1234h
u_endy:
		je	u_tml10

                inc     di
		inc	di
		mov	cury,di
		jmp	u_tml11
u_tml10:
		pop	bp
		ret	6
texturemap_guro5 endp

;======================================================================
;procedure texturemap_flat(scrbuf,zbufseg,bmpbuf);
;⠫    ६
;s_poly3d,s_poly2d,s_polybmp,s_colors,s_itblseg
;======================================================================

texturemap_flat proc	far

bmpbuf		=	6
zbufseg =	8
scrbuf		=	10

		push	bp
		mov	bp,sp

		mov	ax,[bp+bmpbuf]
		mov	d_bmpseg,ax

;intitalize leftx&rightx

		mov	ax,ds
		mov	es,ax
		cld

		lea	di,s_leftx
		mov	eax,30003000h
		mov	cx,100
	rep	stosd

                lea     di,s_rightx
		mov	eax,-1
		mov	cx,100
	rep	stosd

;draw lines to buffer
		push	bp
	bmp_line d1,s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],s_poly2d[4],s_polybmp[0],s_polybmp[2]
	bmp_line e1,s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],s_poly2d[8],s_polybmp[2],s_polybmp[4]
        bmp_line f1,s_poly3d[12+2],s_poly3d[0+2],s_poly2d[8],s_poly2d[0],s_polybmp[4],s_polybmp[0]
;        bmp_line f,s_poly3d[12+2],s_poly3d[18+2],s_poly2d[8],s_poly2d[12],s_polybmp[4],s_polybmp[6]
;        bmp_line g,s_poly3d[18+2],s_poly3d[0+2],s_poly2d[12],s_poly2d[0],s_polybmp[6],s_polybmp[0]
		pop	bp

		mov	ax,s_poly2d[2]
		mov	di,ax
		mov	si,s_poly2d[4+2]
		cmp	si,ax
		jc	@@tml3
		mov	ax,si
@@tml3:
		cmp	si,di
		ja	@@tml4
		mov	di,si
@@tml4:
		mov	si,s_poly2d[8+2]
		cmp	si,ax
		jc	@@tml5
		mov	ax,si
@@tml5:
		cmp	si,di
		ja	@@tml6
		mov	di,si
@@tml6:
;               mov     si,s_poly2d[12+2]
;                cmp     si,ax
;                jc      @@tml12
;                mov     ax,si
;@@tml12:
;                cmp     si,di
;                ja      @@tml13
;                mov     di,si
;@@tml13:
		shl	di,1
		mov	cury,di
		shl	ax,1
		mov	word ptr cs:[@@endy-2],ax

		mov	bx,di
		mov	si,di
		shl	bx,1
		shl	si,3
		lea	ax,[bx+si]
		add	ax,[bp+scrbuf]
		mov	gs,ax

		lea	ax,[bx+si]
		shl	ax,1
		add	ax,[bp+zbufseg]
		mov	es,ax

;============== y cycle ===========
@@tml11:
		mov	cx,s_rightx[di]
		mov	si,s_leftx[di]
		sub	cx,si
		jg	@@tml7

                jmp     @@tml9
@@tml7:
		movzx	ecx,cx

		movzx	eax,byte ptr s_right_bmpxy[di]
		movzx	ebx,byte ptr s_left_bmpxy[di]
		xchg	ah,al
		xchg	bh,bl
		mov	x256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[@@bxadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di+1]
		movzx	ebx,byte ptr s_left_bmpxy[di+1]
		xchg	ah,al
		xchg	bh,bl
		mov	y256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[@@byadd-2],ax

		mov	ax,s_rightz[di]
		sub	ax,s_leftz[di]
		shl	eax,16
		cdq
		idiv	ecx
		mov	bp,ax
		shr	eax,16
		mov	word ptr cs:[@@zaddhi-2],ax

		mov	ax,s_leftz[di]
		mov	di,si
		shl	di,1
		mov	dx,32000
		inc	cx

;es:di - zbufptr
;gs:si - scrbuf
;fs - bitmap/itbl
;ax - z
;dx - zlo
;bp - z_lo_add
;=================== x cycle  ================
@@tml2:
                scasw
                jnl     @@tml1

                dec     di
                dec     di
                stosw
		mov	bh,byte ptr y256+1
		mov	bl,byte ptr x256+1
		mov	fs,d_bmpseg
		mov	bl,fs:[bx]
                mov     bh,byte ptr s_colors+1
                mov     fs,s_itblseg
                mov     bl,fs:[bx]
		mov	gs:[si],bl
@@tml1:
		inc	si
		add	x256,1234h
@@bxadd:
		add	y256,1234h
@@byadd:
		add	dx,bp
		adc	ax,1234h
@@zaddhi:
		dec	cx
		jne	@@tml2
@@tml9:
		mov	ax,es
		add	ax,40
		mov	es,ax

		mov	ax,gs
		add	ax,20
		mov	gs,ax

		mov	di,cury
		cmp	di,1234h
@@endy:
		je	@@tml10

                inc     di
		inc	di
		mov	cury,di
		jmp	@@tml11
@@tml10:
		pop	bp
		ret	6
texturemap_flat endp

;=========================================================================
texturemap_flat4 proc    far

bmpbuf		=	6
zbufseg =	8
scrbuf		=	10

		push	bp
		mov	bp,sp

		mov	ax,[bp+bmpbuf]
		mov	d_bmpseg,ax

;intitalize leftx&rightx

		mov	ax,ds
		mov	es,ax
		cld

		lea	di,s_leftx
		mov	eax,30003000h
		mov	cx,100
	rep	stosd

                lea     di,s_rightx
		mov	eax,-1
		mov	cx,100
	rep	stosd

;draw lines to buffer
		push	bp
	bmp_line d4,s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],s_poly2d[4],s_polybmp[0],s_polybmp[2]
	bmp_line e4,s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],s_poly2d[8],s_polybmp[2],s_polybmp[4]
        bmp_line f4,s_poly3d[12+2],s_poly3d[18+2],s_poly2d[8],s_poly2d[12],s_polybmp[4],s_polybmp[6]
        bmp_line g4,s_poly3d[18+2],s_poly3d[0+2],s_poly2d[12],s_poly2d[0],s_polybmp[6],s_polybmp[0]
		pop	bp

		mov	ax,s_poly2d[2]
		mov	di,ax
		mov	si,s_poly2d[4+2]
		cmp	si,ax
		jc	@@tml3
		mov	ax,si
@@tml3:
		cmp	si,di
		ja	@@tml4
		mov	di,si
@@tml4:
		mov	si,s_poly2d[8+2]
		cmp	si,ax
		jc	@@tml5
		mov	ax,si
@@tml5:
		cmp	si,di
		ja	@@tml6
		mov	di,si
@@tml6:
                mov     si,s_poly2d[12+2]
                cmp     si,ax
                jc      @@tml12
                mov     ax,si
@@tml12:
                cmp     si,di
                ja      @@tml13
                mov     di,si
@@tml13:
		shl	di,1
		mov	cury,di
		shl	ax,1
		mov	word ptr cs:[@@endy-2],ax

		mov	bx,di
		mov	si,di
		shl	bx,1
		shl	si,3
		lea	ax,[bx+si]
		add	ax,[bp+scrbuf]
		mov	gs,ax

		lea	ax,[bx+si]
		shl	ax,1
		add	ax,[bp+zbufseg]
		mov	es,ax

;============== y cycle ===========
@@tml11:
		mov	cx,s_rightx[di]
		mov	si,s_leftx[di]
		sub	cx,si
		jg	@@tml7

                jmp     @@tml9
@@tml7:
		movzx	ecx,cx

		movzx	eax,byte ptr s_right_bmpxy[di]
		movzx	ebx,byte ptr s_left_bmpxy[di]
		xchg	ah,al
		xchg	bh,bl
		mov	x256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[@@bxadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di+1]
		movzx	ebx,byte ptr s_left_bmpxy[di+1]
		xchg	ah,al
		xchg	bh,bl
		mov	y256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[@@byadd-2],ax

		mov	ax,s_rightz[di]
		sub	ax,s_leftz[di]
		shl	eax,16
		cdq
		idiv	ecx
		mov	bp,ax
		shr	eax,16
		mov	word ptr cs:[@@zaddhi-2],ax

		mov	ax,s_leftz[di]
		mov	di,si
		shl	di,1
		mov	dx,32000
		inc	cx

;es:di - zbufptr
;gs:si - scrbuf
;fs - bitmap/itbl
;ax - z
;dx - zlo
;bp - z_lo_add
;=================== x cycle  ================
@@tml2:
                scasw
                jnl     @@tml1

                dec     di
                dec     di
                stosw
		mov	bh,byte ptr y256+1
		mov	bl,byte ptr x256+1
		mov	fs,d_bmpseg
		mov	bl,fs:[bx]
                mov     bh,byte ptr s_colors+1
                mov     fs,s_itblseg
                mov     bl,fs:[bx]
		mov	gs:[si],bl
@@tml1:
		inc	si
		add	x256,1234h
@@bxadd:
		add	y256,1234h
@@byadd:
		add	dx,bp
		adc	ax,1234h
@@zaddhi:
		dec	cx
		jne	@@tml2
@@tml9:
		mov	ax,es
		add	ax,40
		mov	es,ax

		mov	ax,gs
		add	ax,20
		mov	gs,ax

		mov	di,cury
		cmp	di,1234h
@@endy:
		je	@@tml10

                inc     di
		inc	di
		mov	cury,di
		jmp	@@tml11
@@tml10:
		pop	bp
		ret	6
texturemap_flat4 endp

;=======================================================================
texturemap_flat5 proc    far

bmpbuf		=	6
zbufseg =	8
scrbuf		=	10

		push	bp
		mov	bp,sp

		mov	ax,[bp+bmpbuf]
		mov	d_bmpseg,ax

;intitalize leftx&rightx

		mov	ax,ds
		mov	es,ax
		cld

		lea	di,s_leftx
		mov	eax,30003000h
		mov	cx,100
	rep	stosd

                lea     di,s_rightx
		mov	eax,-1
		mov	cx,100
	rep	stosd

;draw lines to buffer
		push	bp
	bmp_line d5,s_poly3d[0+2],s_poly3d[6+2],s_poly2d[0],s_poly2d[4],s_polybmp[0],s_polybmp[2]
	bmp_line e5,s_poly3d[6+2],s_poly3d[12+2],s_poly2d[4],s_poly2d[8],s_polybmp[2],s_polybmp[4]
        bmp_line f5,s_poly3d[12+2],s_poly3d[18+2],s_poly2d[8],s_poly2d[12],s_polybmp[4],s_polybmp[6]
        bmp_line g5,s_poly3d[18+2],s_poly3d[24+2],s_poly2d[12],s_poly2d[16],s_polybmp[6],s_polybmp[8]
        bmp_line h5,s_poly3d[24+2],s_poly3d[0+2],s_poly2d[16],s_poly2d[0],s_polybmp[8],s_polybmp[0]
		pop	bp

		mov	ax,s_poly2d[2]
		mov	di,ax
		mov	si,s_poly2d[4+2]
		cmp	si,ax
		jc	@@tml3
		mov	ax,si
@@tml3:
		cmp	si,di
		ja	@@tml4
		mov	di,si
@@tml4:
		mov	si,s_poly2d[8+2]
		cmp	si,ax
		jc	@@tml5
		mov	ax,si
@@tml5:
		cmp	si,di
		ja	@@tml6
		mov	di,si
@@tml6:
                mov     si,s_poly2d[12+2]
                cmp     si,ax
                jc      @@tml12
                mov     ax,si
@@tml12:
                cmp     si,di
                ja      @@tml13
                mov     di,si
@@tml13:
                mov     si,s_poly2d[16+2]
                cmp     si,ax
                jc      @@tml12a
                mov     ax,si
@@tml12a:
                cmp     si,di
                ja      @@tml13a
                mov     di,si
@@tml13a:
		shl	di,1
		mov	cury,di
		shl	ax,1
		mov	word ptr cs:[@@endy-2],ax

		mov	bx,di
		mov	si,di
		shl	bx,1
		shl	si,3
		lea	ax,[bx+si]
		add	ax,[bp+scrbuf]
		mov	gs,ax

		lea	ax,[bx+si]
		shl	ax,1
		add	ax,[bp+zbufseg]
		mov	es,ax

;============== y cycle ===========
@@tml11:
		mov	cx,s_rightx[di]
		mov	si,s_leftx[di]
		sub	cx,si
		jg	@@tml7

                jmp     @@tml9
@@tml7:
		movzx	ecx,cx

		movzx	eax,byte ptr s_right_bmpxy[di]
		movzx	ebx,byte ptr s_left_bmpxy[di]
		xchg	ah,al
		xchg	bh,bl
		mov	x256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[@@bxadd-2],ax

		movzx	eax,byte ptr s_right_bmpxy[di+1]
		movzx	ebx,byte ptr s_left_bmpxy[di+1]
		xchg	ah,al
		xchg	bh,bl
		mov	y256,bx
		sub	eax,ebx
		cdq
		idiv	ecx
		mov	word ptr cs:[@@byadd-2],ax

		mov	ax,s_rightz[di]
		sub	ax,s_leftz[di]
		shl	eax,16
		cdq
		idiv	ecx
		mov	bp,ax
		shr	eax,16
		mov	word ptr cs:[@@zaddhi-2],ax

		mov	ax,s_leftz[di]
		mov	di,si
		shl	di,1
		mov	dx,32000
		inc	cx

;es:di - zbufptr
;gs:si - scrbuf
;fs - bitmap/itbl
;ax - z
;dx - zlo
;bp - z_lo_add
;=================== x cycle  ================
@@tml2:
                scasw
                jnl     @@tml1

                dec     di
                dec     di
                stosw
		mov	bh,byte ptr y256+1
		mov	bl,byte ptr x256+1
		mov	fs,d_bmpseg
		mov	bl,fs:[bx]
                mov     bh,byte ptr s_colors+1
                mov     fs,s_itblseg
                mov     bl,fs:[bx]
		mov	gs:[si],bl
@@tml1:
		inc	si
		add	x256,1234h
@@bxadd:
		add	y256,1234h
@@byadd:
		add	dx,bp
		adc	ax,1234h
@@zaddhi:
		dec	cx
		jne	@@tml2
@@tml9:
		mov	ax,es
		add	ax,40
		mov	es,ax

		mov	ax,gs
		add	ax,20
		mov	gs,ax

		mov	di,cury
		cmp	di,1234h
@@endy:
		je	@@tml10

                inc     di
		inc	di
		mov	cury,di
		jmp	@@tml11
@@tml10:
		pop	bp
		ret	6
texturemap_flat5 endp


.286
code		ends

data		segment word public

		extrn	s_poly2d:word
		extrn	s_poly3d:word
		extrn	s_polybmp:byte
		extrn	s_colors: word

		extrn	s_leftx:word
		extrn	s_rightx:word

		extrn	s_leftz:word
		extrn	s_rightz:word

                extrn   s_leftc:word
		extrn	s_rightc:word

		extrn	s_left_bmpxy:word

		extrn	s_right_bmpxy:word

		extrn	s_itblseg:word

x256		dw	0
y256		dw	0
cury		dw	0
dcolor		dw	0
d_bmpseg	dw	0

data            ends
		end
