;Copyright by AX
;Texture mapping sources
;Procedure for Real&Protected Mode
;======================================================================

		public	texturemap_simple

		version m520
		locals

;==========================================
; CODE SEGMENT
;==========================================
code		segment byte public
		assume	cs:code,ds:data
.386

;======================================================================
; MACRO BMP_LINE_simple
; p 맮   gs=csalias
; p   ᨢ
;======================================================================
bmp_line_simple macro	d_x1,d_x2,bmp_x1,bmp_x2
		local	@@bmpl,@@ebxd,@@edxd,@@eaxd,@@bmpl11,@@bmpl10,@@bmpl14,@@bmpl13,@@bmpl15
		local	@@bmpl4,@@bmpl5,@@bmpl6,@@bmpl9

d_y1		=	word ptr d_x1+2
d_y2		=	word ptr d_x2+2
bmp_y1		=	byte ptr bmp_x1+1
bmp_y2		=	byte ptr bmp_x2+1

		mov	cx,d_y2
		mov	di,d_y1
		sub	cx,di
		mov	ax,4747h	;inc di, inc di
		jns	@@bmpl
		neg	cx
		mov	ax,4f4fh	;dec di, dec di
@@bmpl:
		or	cx,cx
		jnz	@@bmpl11
		jmp	@@bmpl10	;dy  = 0 -  室
@@bmpl11:
;䨪   p쭮 p  di
		mov	word ptr gs:[@@bmpl9-2],ax
		movzx	ecx,cx

;塞 xadd,xaddlo
		mov	ax,d_x2
		mov	bp,d_x1
		mov	word ptr gs:[@@eaxd-4],bp
		sub	ax,bp
		shl	eax,16
		cdq
		idiv	ecx
		rol	eax,16
		mov	esi,eax

;  p⥫쭮 rxadd
		or	esi,esi
		jns	@@bmpl14

		sub	esi,00010000h
@@bmpl14:
;塞 bmp_xadd,bmpxadd_lo

		movzx	ax,bmp_x2
		movzx	bx,bmp_x1
		mov	byte ptr gs:[@@ebxd-4],bl
		sub	ax,bx
		shl	eax,16
		cdq
		idiv	ecx
		mov	word ptr gs:[@@edxd-2],ax
		shr	eax,16
		mov	byte ptr gs:[@@edxd-4],al

;  p⥫쭮 xadd
		xor	bl,bl
		or	al,al
		jns	@@bmpl13
                mov     bl,-1
@@bmpl13:

;塞 bmp_yadd,bmp_yaddlo

		movzx	ax,bmp_y2
		movzx	dx,bmp_y1
		mov	byte ptr gs:[@@ebxd-3],dl
		sub	ax,dx
		shl	eax,16
		cdq
		idiv	ecx
		mov	bp,ax
		shl	ebp,16
		shr	eax,16
		mov	ch,al
		add	ch,bl

		movzx	edi,di
		shl	di,1
		inc	cl

		mov	eax,7fff5678h
@@eaxd:
		mov	ebx,7fff5678h
@@ebxd:
		mov	edx,12340012h
@@edxd:

;EAX -  rxlo  |  rx
;ESI -  rxload| rxadd
;EBX -   xlo  |  y:x
;EDX - xloadd |  0:xadd
;EDI -   ylo  |  ry*2
;EBP - yloadd |  0:0
;CH  - yadd
;CL - count

;===================== cycle ================
@@bmpl6:
;=== left edge ===
		cmp	s_leftx[di],ax		;x<leftx[y] ?
		jl	@@bmpl4

		mov	s_leftx[di],ax		;yes
		mov	s_left_bmpxy[di],bx
@@bmpl4:
;=== right edge ===
		cmp	s_rightx[di],ax	;x>rightx[y] ?
		jg	@@bmpl5

		mov	s_rightx[di],ax	 ;yes
		mov	s_right_bmpxy[di],bx
@@bmpl5:
		inc	di
		inc	di
@@bmpl9:
                add     eax,esi
		adc	ax,bp

		add	ebx,edx
		adc	bx,bp

		add	edi,ebp
		adc	bh,ch

		dec	cl
		jne	@@bmpl6
;========================================
@@bmpl10:

endm

;======================================================================
;procedure texturemap_simple;
;⠫    ६
;s_poly2d,s_polybmp,s_scrbuf1seg,s_bmpseg
;======================================================================

texturemap_simple proc far
		push	bp
		mov	bp,sp

		mov	gs,csalias

;intitalize leftx&rightx

		mov	ax,ds
		mov	es,ax
		cld

		lea	di,s_leftx
		mov	eax,30003000h
		mov	cx,100
	rep	stosd

                lea     di,s_rightx
		mov	eax,-1
		mov	cx,100
	rep	stosd

;draw lines to buffer
	bmp_line_simple s_poly2d[0],s_poly2d[4],s_polybmp[0],s_polybmp[2]
	bmp_line_simple s_poly2d[4],s_poly2d[8],s_polybmp[2],s_polybmp[4]
        bmp_line_simple s_poly2d[8],s_poly2d[0],s_polybmp[4],s_polybmp[0]
;        bmp_line_simple s_poly2d[8],s_poly2d[12],s_polybmp[4],s_polybmp[6]
 ;       bmp_line_simple s_poly2d[12],s_poly2d[0],s_polybmp[6],s_polybmp[0]

;---- 室 maxy  miny ---------
		mov	ax,s_poly2d[2]
		mov	di,ax
		mov	si,s_poly2d[4+2]
		cmp	si,ax
		jc	@@tml3
		mov	ax,si
@@tml3:
		cmp	si,di
		ja	@@tml4
		mov	di,si
@@tml4:
		mov	si,s_poly2d[8+2]
		cmp	si,ax
		jc	@@tml5
		mov	ax,si
@@tml5:
		cmp	si,di
		ja	@@tml6
		mov	di,si
@@tml6:
;                mov     si,s_poly2d[12+2]
;                cmp     si,ax
;                jc      @@tml5a
;                mov     ax,si
;@@tml5a:
;                cmp     si,di
;                ja      @@tml6a
;                mov     di,si
;@@tml6a:
;------------------------------------

		shl	di,1
		mov	cury,di
		shl	ax,1
		mov	word ptr gs:[@@endy-2],ax

;pp㥬 ᬥ饭  p  y (*320)

		mov	si,di
		shl	si,5
		mov	ax,si
		shl	si,2
		add	ax,si
		mov	word ptr gs:[@@yofs-2],ax

		mov	es,s_scrbuf1seg
		mov	ax,ds
		mov	fs,ax
		mov	ds,s_bmpseg
		jmp	@@tml11

@@tml9a:
		jmp	@@tml9
;============== y cycle ===========
@@tml11:
		mov	cx,fs:s_rightx[di]
		mov	si,fs:s_leftx[di]
		sub	cx,si
		jng	@@tml9a	;leftx[y]<rightx[y] ?

		movzx	ecx,cx		;yes, cx = delta x


;塞 bp_xadd,bmpxaddlo

                movzx   ax,byte ptr fs:s_right_bmpxy[di]
                movzx   bx,byte ptr fs:s_left_bmpxy[di]
		mov	byte ptr gs:[@@ebxd-4],bl
                sub     ax,bx
		shl	eax,16
                cdq
                idiv    ecx
		mov	word ptr gs:[@@esid-2],ax
		shr	eax,16
		mov	byte ptr gs:[@@edxd-4],al


;塞 bmp_yadd,bmp_yaddlo

		movzx	ax,byte ptr fs:s_right_bmpxy[di+1]
		movzx	bx,byte ptr fs:s_left_bmpxy[di+1]
		mov	byte ptr gs:[@@ecxd-4],bl
		sub	ax,bx
		shl	eax,16
		cdq
		idiv	ecx
		mov	word ptr gs:[@@edxd-2],ax
		shr	eax,16
		mov	byte ptr gs:[@@esid-4],al

		inc	cx

		lea	di,[si+1234h]
@@yofs:

		bt	di,0		;p p ?
                jnc     @@tml13_a
		dec	cx		;
@@tml13_a:

;塞 ᬥ饭  p室  ⥫ pp⮣ 横
;21=16+4+1
		mov	bp,offset @@rept_end
		shr	cx,1
		jnc	@@tml14
		mov	bp,offset @@rept1_end
@@tml14:
		sub	bp,cx
		shl	cx,2
		sub	bp,cx
		shl	cx,2
		sub	bp,cx

		mov	ebx,80000000h
@@ebxd:
		mov	ecx,80000000h
@@ecxd:
		mov	edx,0
@@edxd:
		mov	esi,0
@@esid:
		mov	bh,cl

		bt	di,0		;p p ?
		jc	@@tml13	 ;

		clc
		jmp	bp

@@tml13:
;p  p ᫮
                mov     al,[bx]
		add	ebx,edx
		adc	ecx,esi
		mov	bh,cl
		stosb
		jmp	bp

;EAX - 0  :  0 | 0   byte
;EBX - Ylo     | y   x
;ECX - xlo     | 0   y
;EDX - yloadd  : 0  xadd
;ESI - xloadd  : 0 yadd
;di - screenofs
;===================================================
; ᭮ 横 p楤p,  ⭮ ᫠ 
;===================================================
REPT 160
		mov	al,[bx]
		adc	ebx,edx
		adc	ecx,esi
		mov	bh,cl
		mov	ah,[bx]
		adc	ebx,edx
		adc	ecx,esi
		mov	bh,cl
		stosw
ENDM
;=======================================
@@rept_end:
@@tml9:
		mov	di,fs:cury
		cmp	di,1234h	;y=maxy?
@@endy:
		je	@@tml10	 ;yes

                inc     di              ;inc (y)
		inc	di
		add	word ptr gs:[@@yofs-2],320
		mov	fs:cury,di
		jmp	@@tml11

;室
@@tml10:
		mov	ax,fs
		mov	ds,ax
		pop	bp
		ret
;=======================================

;===================================================
; ᭮ 横 p楤p,  ⭮ ᫠ 
;===================================================
REPT 160
		mov	al,[bx]
		adc	ebx,edx
		adc	ecx,esi
		mov	bh,cl
		mov	ah,[bx]
		adc	ebx,edx
		adc	ecx,esi
		mov	bh,cl
		stosw
ENDM
;======================================
@@rept1_end:
		mov	al,[bx]
		stosb
		jmp	@@tml9
texturemap_simple      endp

.286
code		ends

;=========================================
; DATA SEGMENT
;=========================================

data		segment word public

		extrn	csalias:word

		extrn	s_poly2d:word
		extrn	s_polybmp:byte

		extrn	s_leftx:word
		extrn	s_rightx:word

		extrn	s_left_bmpxy:word
		extrn	s_right_bmpxy:word

		extrn	s_scrbuf1seg:word
		extrn	s_bmpseg:word

cury		dw	0
data            ends
		end
